#pragma once
#if defined VERTEX_SHADER
    #ifndef sc_TextureRenderingLayout_Regular
        #define sc_TextureRenderingLayout_Regular 0
        #define sc_TextureRenderingLayout_StereoInstancedClipped 1
        #define sc_TextureRenderingLayout_StereoMultiview 2
    #endif

#define depthToGlobal depthScreenToViewSpace

#define depthToLocal depthViewToScreenSpace

    #ifndef quantizeUV
        #define quantizeUV sc_QuantizeUV
        #define sc_platformUVFlip sc_PlatformFlipUV
    #endif

    #ifndef sc_texture2DLod
        #define sc_texture2DLod sc_InternalTextureLevel
        #define sc_textureLod sc_InternalTextureLevel
        #define sc_textureBias sc_InternalTextureBiasOrLevel
        #define sc_texture sc_InternalTexture
    #endif

#include <required2.glsl>
#include <std2_stereo_view_index.glsl>
#include <std2_texture_sub.glsl>


//SG_REFLECTION_BEGIN(100)
//SG_REFLECTION_END



vec4 sc_InternalTextureLevel(vec2 texSize,vec2 uv,float level_,highp sampler2D SPIRV_Cross_Combinedtexsmp)
{
#if (sc_CanUseTextureLod)
{
return texture2DLodEXT(SPIRV_Cross_Combinedtexsmp,uv,level_);
}
#else
{
return vec4(0.0);
}
#endif
}

vec4 sc_InternalTextureLevel(highp sampler2D combinedSmp,vec2 texSize,vec2 uv,float level_)
{
#if (sc_CanUseTextureLod)
{
return texture2DLodEXT(combinedSmp,uv,level_);
}
#else
{
return vec4(0.0);
}
#endif
}

vec4 sc_InternalTextureBiasOrLevel(vec2 texSize,vec2 uv,float biasOrLevel,highp sampler2D SPIRV_Cross_Combinedtexsmp)
{
vec2 param=texSize;
vec2 param_1=uv;
float param_2=biasOrLevel;
return sc_InternalTextureLevel(param,param_1,param_2,SPIRV_Cross_Combinedtexsmp);
}

vec4 sc_InternalTextureBiasOrLevel(highp sampler2D combinedSmp,vec2 texSize,vec2 uv,float biasOrLevel)
{
vec2 param=texSize;
vec2 param_1=uv;
float param_2=biasOrLevel;
return sc_InternalTextureLevel(combinedSmp,param,param_1,param_2);
}

vec4 sc_InternalTextureLevel(highp sampler2D combinedSmp,vec2 uv,float level_)
{
#if (sc_CanUseTextureLod)
{
return texture2DLodEXT(combinedSmp,uv,level_);
}
#else
{
return vec4(0.0);
}
#endif
}

vec4 sc_InternalTextureLevel(highp sampler2DArray combinedSmp,vec3 uv,float level_)
{
#if (sc_CanUseTextureLod)
{
return texture2DArrayLodEXT(combinedSmp,uv,level_);
}
#else
{
return vec4(0.0);
}
#endif
}

vec4 sc_InternalTextureLevel(highp sampler3D combinedSmp,vec3 uv,float level_)
{
#if (sc_CanUseTextureLod)
{
return texture3DLodEXT(combinedSmp,uv,level_);
}
#else
{
return vec4(0.0);
}
#endif
}

vec4 sc_InternalTextureLevel(highp samplerCube combinedSmp,vec3 uv,float level_)
{
#if (sc_CanUseTextureLod)
{
return textureCubeLodEXT(combinedSmp,uv,level_);
}
#else
{
return vec4(0.0);
}
#endif
}

vec4 sc_InternalTextureLevel(vec2 uv,float level_,highp sampler2D SPIRV_Cross_Combinedtexsmp)
{
#if (sc_CanUseTextureLod)
{
return texture2DLodEXT(SPIRV_Cross_Combinedtexsmp,uv,level_);
}
#else
{
return vec4(0.0);
}
#endif
}

vec4 sc_InternalTextureLevel(vec3 uv,float level_,highp sampler2DArray SPIRV_Cross_Combinedtexsmp)
{
#if (sc_CanUseTextureLod)
{
return texture2DArrayLodEXT(SPIRV_Cross_Combinedtexsmp,uv,level_);
}
#else
{
return vec4(0.0);
}
#endif
}

vec4 sc_InternalTextureLevel(vec3 uv,float level_,highp sampler3D SPIRV_Cross_Combinedtexsmp)
{
#if (sc_CanUseTextureLod)
{
return texture3DLodEXT(SPIRV_Cross_Combinedtexsmp,uv,level_);
}
#else
{
return vec4(0.0);
}
#endif
}

vec4 sc_InternalTextureLevel(vec3 uv,float level_,highp samplerCube SPIRV_Cross_Combinedtexsmp)
{
#if (sc_CanUseTextureLod)
{
return textureCubeLodEXT(SPIRV_Cross_Combinedtexsmp,uv,level_);
}
#else
{
return vec4(0.0);
}
#endif
}

vec4 sc_InternalTextureBiasOrLevel(highp sampler2D combinedSmp,vec2 uv,float biasOrLevel)
{
vec2 param=uv;
float param_1=biasOrLevel;
return sc_InternalTextureLevel(combinedSmp,param,param_1);
}

vec4 sc_InternalTextureBiasOrLevel(highp sampler2DArray combinedSmp,vec3 uv,float biasOrLevel)
{
vec3 param=uv;
float param_1=biasOrLevel;
return sc_InternalTextureLevel(combinedSmp,param,param_1);
}

vec4 sc_InternalTextureBiasOrLevel(highp sampler3D combinedSmp,vec3 uv,float biasOrLevel)
{
vec3 param=uv;
float param_1=biasOrLevel;
return sc_InternalTextureLevel(combinedSmp,param,param_1);
}

vec4 sc_InternalTextureBiasOrLevel(highp samplerCube combinedSmp,vec3 uv,float biasOrLevel)
{
vec3 param=uv;
float param_1=biasOrLevel;
return sc_InternalTextureLevel(combinedSmp,param,param_1);
}

vec4 sc_InternalTextureBiasOrLevel(vec2 uv,float biasOrLevel,highp sampler2D SPIRV_Cross_Combinedtexsmp)
{
vec2 param=uv;
float param_1=biasOrLevel;
return sc_InternalTextureLevel(param,param_1,SPIRV_Cross_Combinedtexsmp);
}

vec4 sc_InternalTextureBiasOrLevel(vec3 uv,float biasOrLevel,highp sampler2DArray SPIRV_Cross_Combinedtexsmp)
{
vec3 param=uv;
float param_1=biasOrLevel;
return sc_InternalTextureLevel(param,param_1,SPIRV_Cross_Combinedtexsmp);
}

vec4 sc_InternalTextureBiasOrLevel(vec3 uv,float biasOrLevel,highp sampler3D SPIRV_Cross_Combinedtexsmp)
{
vec3 param=uv;
float param_1=biasOrLevel;
return sc_InternalTextureLevel(param,param_1,SPIRV_Cross_Combinedtexsmp);
}

vec4 sc_InternalTextureBiasOrLevel(vec3 uv,float biasOrLevel,highp samplerCube SPIRV_Cross_Combinedtexsmp)
{
vec3 param=uv;
float param_1=biasOrLevel;
return sc_InternalTextureLevel(param,param_1,SPIRV_Cross_Combinedtexsmp);
}

vec2 sc_SamplingCoordsGlobalToView(inout vec3 uvi,int renderingLayout,int viewIndex)
{
if (renderingLayout==1)
{
uvi.y=((2.0*uvi.y)+float(viewIndex))-1.0;
}
return uvi.xy;
}

vec2 sc_ScreenCoordsGlobalToView(vec2 uv)
{
#if (sc_StereoRenderingMode==1)
{
vec3 uvi=vec3(uv,0.0);
int instancedClippedLayout=1;
int viewIndex=sc_GetStereoViewIndex();
vec3 param=vec3(uv,0.0);
int param_1=instancedClippedLayout;
int param_2=viewIndex;
vec2 _655=sc_SamplingCoordsGlobalToView(param,param_1,param_2);
return _655;
}
#else
{
return uv;
}
#endif
}

vec3 sc_SamplingCoordsViewToGlobal(vec2 uv,int renderingLayout,int viewIndex)
{
if (renderingLayout==0)
{
return vec3(uv,0.0);
}
else
{
if (renderingLayout==1)
{
return vec3(uv.x,(uv.y*0.5)+(0.5-(float(viewIndex)*0.5)),0.0);
}
else
{
return vec3(uv,float(viewIndex));
}
}
}

vec4 sc_SampleViewLevel(vec2 texSize,vec2 uv,int renderingLayout,int viewIndex,float level,highp sampler2D SPIRV_Cross_Combinedtexsmp)
{
vec2 param=uv;
int param_1=renderingLayout;
int param_2=viewIndex;
vec3 uvi=sc_SamplingCoordsViewToGlobal(param,param_1,param_2);
vec2 param_3=texSize;
vec2 param_4=uvi.xy;
float param_5=level;
return sc_InternalTextureLevel(param_3,param_4,param_5,SPIRV_Cross_Combinedtexsmp);
}

vec4 sc_SampleView(vec2 texSize,vec2 uv,int renderingLayout,int viewIndex,float bias,highp sampler2D SPIRV_Cross_Combinedtexsmp)
{
vec2 param=uv;
int param_1=renderingLayout;
int param_2=viewIndex;
vec3 uvi=sc_SamplingCoordsViewToGlobal(param,param_1,param_2);
vec2 param_3=texSize;
vec2 param_4=uvi.xy;
float param_5=bias;
return sc_InternalTextureBiasOrLevel(param_3,param_4,param_5,SPIRV_Cross_Combinedtexsmp);
}

vec4 sc_SampleViewLevel(vec2 texSize,vec2 uv,int renderingLayout,int viewIndex,float level,highp sampler2DArray SPIRV_Cross_Combinedtexsmp)
{
vec2 param=uv;
int param_1=renderingLayout;
int param_2=viewIndex;
vec3 uvi=sc_SamplingCoordsViewToGlobal(param,param_1,param_2);
vec3 param_3=uvi;
float param_4=level;
return sc_InternalTextureLevel(param_3,param_4,SPIRV_Cross_Combinedtexsmp);
}

vec4 sc_SampleView(vec2 texSize,vec2 uv,int renderingLayout,int viewIndex,float bias,highp sampler2DArray SPIRV_Cross_Combinedtexsmp)
{
vec2 param=uv;
int param_1=renderingLayout;
int param_2=viewIndex;
vec3 uvi=sc_SamplingCoordsViewToGlobal(param,param_1,param_2);
vec3 param_3=uvi;
float param_4=bias;
return sc_InternalTextureBiasOrLevel(param_3,param_4,SPIRV_Cross_Combinedtexsmp);
}

vec4 sc_SampleViewLevel(highp sampler2D combinedSmp,vec2 texSize,vec2 uv,int renderingLayout,int viewIndex,float level)
{
vec2 param=uv;
int param_1=renderingLayout;
int param_2=viewIndex;
vec3 uvi=sc_SamplingCoordsViewToGlobal(param,param_1,param_2);
vec2 param_3=texSize;
vec2 param_4=uvi.xy;
float param_5=level;
return sc_InternalTextureLevel(combinedSmp,param_3,param_4,param_5);
}

vec4 sc_SampleView(highp sampler2D combinedSmp,vec2 texSize,vec2 uv,int renderingLayout,int viewIndex,float bias)
{
vec2 param=uv;
int param_1=renderingLayout;
int param_2=viewIndex;
vec3 uvi=sc_SamplingCoordsViewToGlobal(param,param_1,param_2);
vec2 param_3=texSize;
vec2 param_4=uvi.xy;
float param_5=bias;
return sc_InternalTextureBiasOrLevel(combinedSmp,param_3,param_4,param_5);
}

vec4 sc_SampleViewLevel(highp sampler2DArray combinedSmp,vec2 texSize,vec2 uv,int renderingLayout,int viewIndex,float level)
{
vec2 param=uv;
int param_1=renderingLayout;
int param_2=viewIndex;
vec3 uvi=sc_SamplingCoordsViewToGlobal(param,param_1,param_2);
vec3 param_3=uvi;
float param_4=level;
return sc_InternalTextureLevel(combinedSmp,param_3,param_4);
}

vec4 sc_SampleView(highp sampler2DArray combinedSmp,vec2 texSize,vec2 uv,int renderingLayout,int viewIndex,float bias)
{
vec2 param=uv;
int param_1=renderingLayout;
int param_2=viewIndex;
vec3 uvi=sc_SamplingCoordsViewToGlobal(param,param_1,param_2);
vec3 param_3=uvi;
float param_4=bias;
return sc_InternalTextureBiasOrLevel(combinedSmp,param_3,param_4);
}

void sc_ClampUV(inout float value,float minValue,float maxValue,bool useClampToBorder,inout float clampToBorderFactor)
{
float clampedValue=clamp(value,minValue,maxValue);
float factor=step(abs(value-clampedValue),1e-05);
clampToBorderFactor*=(factor+((1.0-float(useClampToBorder))*(1.0-factor)));
value=clampedValue;
}

vec2 sc_PlatformFlipUV(vec2 uv)
{
return uv;
}

void sc_SoftwareWrap(inout float uv,int softwareWrapMode,bool useClampToBorder,inout float clampToBorderFactor)
{
if ((softwareWrapMode==0)||(softwareWrapMode==3))
{
float param=uv;
float param_1=0.0;
float param_2=1.0;
bool param_3=useClampToBorder;
float param_4=clampToBorderFactor;
sc_ClampUV(param,param_1,param_2,param_3,param_4);
uv=param;
clampToBorderFactor=param_4;
}
else
{
if (softwareWrapMode==1)
{
uv=fract(uv);
}
else
{
if (softwareWrapMode==2)
{
float uvFract=fract(uv);
float uvInt=uv-uvFract;
float uvOdd=step(0.25,fract(uvInt*0.5));
uv=mix(uvFract,1.0-uvFract,clamp(uvOdd,0.0,1.0));
}
}
}
}

vec2 sc_QuantizeUV(vec2 uv)
{
return uv;
}

vec4 sc_SampleTexture(highp sampler2D combined_,vec2 samplerDims,int renderingLayout,int viewIndex,vec2 uv,bool useUvTransform,mat3 uvTransform,ivec2 softwareWrapModes,bool useUvMinMax,vec4 uvMinMax,bool useClampToBorder,vec4 borderColor,float biasOrLevel)
{
vec2 _uv=uv;
float clampToBorderFactor=1.0;
bool useClampToBorderForWrap=useClampToBorder&&(!useUvMinMax);
float param=_uv.x;
int param_1=softwareWrapModes.x;
bool param_2=useClampToBorderForWrap;
float param_3=clampToBorderFactor;
sc_SoftwareWrap(param,param_1,param_2,param_3);
_uv.x=param;
clampToBorderFactor=param_3;
float param_4=_uv.y;
int param_5=softwareWrapModes.y;
bool param_6=useClampToBorderForWrap;
float param_7=clampToBorderFactor;
sc_SoftwareWrap(param_4,param_5,param_6,param_7);
_uv.y=param_4;
clampToBorderFactor=param_7;
if (useUvMinMax)
{
float param_8=_uv.x;
float param_9=uvMinMax.x;
float param_10=uvMinMax.z;
bool param_11=useClampToBorder;
float param_12=clampToBorderFactor;
sc_ClampUV(param_8,param_9,param_10,param_11,param_12);
_uv.x=param_8;
clampToBorderFactor=param_12;
float param_13=_uv.y;
float param_14=uvMinMax.y;
float param_15=uvMinMax.w;
bool param_16=useClampToBorder;
float param_17=clampToBorderFactor;
sc_ClampUV(param_13,param_14,param_15,param_16,param_17);
_uv.y=param_13;
clampToBorderFactor=param_17;
}
if (useUvTransform)
{
_uv=vec2((uvTransform*vec3(_uv,1.0)).xy);
}
vec2 param_18=_uv;
_uv=sc_QuantizeUV(param_18);
vec2 param_19=_uv;
_uv=sc_PlatformFlipUV(param_19);
vec2 param_20=samplerDims;
vec2 param_21=_uv;
int param_22=renderingLayout;
int param_23=viewIndex;
float param_24=biasOrLevel;
vec4 tex=sc_SampleView(combined_,param_20,param_21,param_22,param_23,param_24);
if (useClampToBorder)
{
tex=mix(borderColor,tex,vec4(clampToBorderFactor));
}
return tex;
}

vec4 sc_SampleTexture(highp sampler2DArray combined_,vec2 samplerDims,int renderingLayout,int viewIndex,vec2 uv,bool useUvTransform,mat3 uvTransform,ivec2 softwareWrapModes,bool useUvMinMax,vec4 uvMinMax,bool useClampToBorder,vec4 borderColor,float biasOrLevel)
{
vec2 _uv=uv;
float clampToBorderFactor=1.0;
bool useClampToBorderForWrap=useClampToBorder&&(!useUvMinMax);
float param=_uv.x;
int param_1=softwareWrapModes.x;
bool param_2=useClampToBorderForWrap;
float param_3=clampToBorderFactor;
sc_SoftwareWrap(param,param_1,param_2,param_3);
_uv.x=param;
clampToBorderFactor=param_3;
float param_4=_uv.y;
int param_5=softwareWrapModes.y;
bool param_6=useClampToBorderForWrap;
float param_7=clampToBorderFactor;
sc_SoftwareWrap(param_4,param_5,param_6,param_7);
_uv.y=param_4;
clampToBorderFactor=param_7;
if (useUvMinMax)
{
float param_8=_uv.x;
float param_9=uvMinMax.x;
float param_10=uvMinMax.z;
bool param_11=useClampToBorder;
float param_12=clampToBorderFactor;
sc_ClampUV(param_8,param_9,param_10,param_11,param_12);
_uv.x=param_8;
clampToBorderFactor=param_12;
float param_13=_uv.y;
float param_14=uvMinMax.y;
float param_15=uvMinMax.w;
bool param_16=useClampToBorder;
float param_17=clampToBorderFactor;
sc_ClampUV(param_13,param_14,param_15,param_16,param_17);
_uv.y=param_13;
clampToBorderFactor=param_17;
}
if (useUvTransform)
{
_uv=vec2((uvTransform*vec3(_uv,1.0)).xy);
}
vec2 param_18=_uv;
_uv=sc_QuantizeUV(param_18);
vec2 param_19=_uv;
_uv=sc_PlatformFlipUV(param_19);
vec2 param_20=samplerDims;
vec2 param_21=_uv;
int param_22=renderingLayout;
int param_23=viewIndex;
float param_24=biasOrLevel;
vec4 tex=sc_SampleView(combined_,param_20,param_21,param_22,param_23,param_24);
if (useClampToBorder)
{
tex=mix(borderColor,tex,vec4(clampToBorderFactor));
}
return tex;
}

vec4 sc_SampleTextureBiasOrLevel(vec2 samplerDims,int renderingLayout,int viewIndex,vec2 uv,bool useUvTransform,mat3 uvTransform,ivec2 softwareWrapModes,bool useUvMinMax,vec4 uvMinMax,bool useClampToBorder,vec4 borderColor,float biasOrLevel,highp sampler2D SPIRV_Cross_Combinedtexture_sampler_)
{
vec2 _uv=uv;
float clampToBorderFactor=1.0;
bool useClampToBorderForWrap=useClampToBorder&&(!useUvMinMax);
float param=_uv.x;
int param_1=softwareWrapModes.x;
bool param_2=useClampToBorderForWrap;
float param_3=clampToBorderFactor;
sc_SoftwareWrap(param,param_1,param_2,param_3);
_uv.x=param;
clampToBorderFactor=param_3;
float param_4=_uv.y;
int param_5=softwareWrapModes.y;
bool param_6=useClampToBorderForWrap;
float param_7=clampToBorderFactor;
sc_SoftwareWrap(param_4,param_5,param_6,param_7);
_uv.y=param_4;
clampToBorderFactor=param_7;
if (useUvMinMax)
{
float param_8=_uv.x;
float param_9=uvMinMax.x;
float param_10=uvMinMax.z;
bool param_11=useClampToBorder;
float param_12=clampToBorderFactor;
sc_ClampUV(param_8,param_9,param_10,param_11,param_12);
_uv.x=param_8;
clampToBorderFactor=param_12;
float param_13=_uv.y;
float param_14=uvMinMax.y;
float param_15=uvMinMax.w;
bool param_16=useClampToBorder;
float param_17=clampToBorderFactor;
sc_ClampUV(param_13,param_14,param_15,param_16,param_17);
_uv.y=param_13;
clampToBorderFactor=param_17;
}
if (useUvTransform)
{
_uv=vec2((uvTransform*vec3(_uv,1.0)).xy);
}
vec2 param_18=_uv;
_uv=sc_QuantizeUV(param_18);
vec2 param_19=_uv;
_uv=sc_PlatformFlipUV(param_19);
vec2 param_20=samplerDims;
vec2 param_21=_uv;
int param_22=renderingLayout;
int param_23=viewIndex;
float param_24=biasOrLevel;
vec4 tex=sc_SampleView(param_20,param_21,param_22,param_23,param_24,SPIRV_Cross_Combinedtexture_sampler_);
if (useClampToBorder)
{
tex=mix(borderColor,tex,vec4(clampToBorderFactor));
}
return tex;
}

vec4 sc_SampleTextureBiasOrLevel(vec2 samplerDims,int renderingLayout,int viewIndex,vec2 uv,bool useUvTransform,mat3 uvTransform,ivec2 softwareWrapModes,bool useUvMinMax,vec4 uvMinMax,bool useClampToBorder,vec4 borderColor,float biasOrLevel,highp sampler2DArray SPIRV_Cross_Combinedtexture_sampler_)
{
vec2 _uv=uv;
float clampToBorderFactor=1.0;
bool useClampToBorderForWrap=useClampToBorder&&(!useUvMinMax);
float param=_uv.x;
int param_1=softwareWrapModes.x;
bool param_2=useClampToBorderForWrap;
float param_3=clampToBorderFactor;
sc_SoftwareWrap(param,param_1,param_2,param_3);
_uv.x=param;
clampToBorderFactor=param_3;
float param_4=_uv.y;
int param_5=softwareWrapModes.y;
bool param_6=useClampToBorderForWrap;
float param_7=clampToBorderFactor;
sc_SoftwareWrap(param_4,param_5,param_6,param_7);
_uv.y=param_4;
clampToBorderFactor=param_7;
if (useUvMinMax)
{
float param_8=_uv.x;
float param_9=uvMinMax.x;
float param_10=uvMinMax.z;
bool param_11=useClampToBorder;
float param_12=clampToBorderFactor;
sc_ClampUV(param_8,param_9,param_10,param_11,param_12);
_uv.x=param_8;
clampToBorderFactor=param_12;
float param_13=_uv.y;
float param_14=uvMinMax.y;
float param_15=uvMinMax.w;
bool param_16=useClampToBorder;
float param_17=clampToBorderFactor;
sc_ClampUV(param_13,param_14,param_15,param_16,param_17);
_uv.y=param_13;
clampToBorderFactor=param_17;
}
if (useUvTransform)
{
_uv=vec2((uvTransform*vec3(_uv,1.0)).xy);
}
vec2 param_18=_uv;
_uv=sc_QuantizeUV(param_18);
vec2 param_19=_uv;
_uv=sc_PlatformFlipUV(param_19);
vec2 param_20=samplerDims;
vec2 param_21=_uv;
int param_22=renderingLayout;
int param_23=viewIndex;
float param_24=biasOrLevel;
vec4 tex=sc_SampleView(param_20,param_21,param_22,param_23,param_24,SPIRV_Cross_Combinedtexture_sampler_);
if (useClampToBorder)
{
tex=mix(borderColor,tex,vec4(clampToBorderFactor));
}
return tex;
}

vec4 sc_SampleTextureLevel(vec2 samplerDims,int renderingLayout,int viewIndex,vec2 uv,bool useUvTransform,mat3 uvTransform,ivec2 softwareWrapModes,bool useUvMinMax,vec4 uvMinMax,bool useClampToBorder,vec4 borderColor,float level,highp sampler2D SPIRV_Cross_Combinedtexture_sampler_)
{
vec2 _uv=uv;
float clampToBorderFactor=1.0;
bool useClampToBorderForWrap=useClampToBorder&&(!useUvMinMax);
float param=_uv.x;
int param_1=softwareWrapModes.x;
bool param_2=useClampToBorderForWrap;
float param_3=clampToBorderFactor;
sc_SoftwareWrap(param,param_1,param_2,param_3);
_uv.x=param;
clampToBorderFactor=param_3;
float param_4=_uv.y;
int param_5=softwareWrapModes.y;
bool param_6=useClampToBorderForWrap;
float param_7=clampToBorderFactor;
sc_SoftwareWrap(param_4,param_5,param_6,param_7);
_uv.y=param_4;
clampToBorderFactor=param_7;
if (useUvMinMax)
{
float param_8=_uv.x;
float param_9=uvMinMax.x;
float param_10=uvMinMax.z;
bool param_11=useClampToBorder;
float param_12=clampToBorderFactor;
sc_ClampUV(param_8,param_9,param_10,param_11,param_12);
_uv.x=param_8;
clampToBorderFactor=param_12;
float param_13=_uv.y;
float param_14=uvMinMax.y;
float param_15=uvMinMax.w;
bool param_16=useClampToBorder;
float param_17=clampToBorderFactor;
sc_ClampUV(param_13,param_14,param_15,param_16,param_17);
_uv.y=param_13;
clampToBorderFactor=param_17;
}
if (useUvTransform)
{
_uv=vec2((uvTransform*vec3(_uv,1.0)).xy);
}
vec2 param_18=_uv;
_uv=sc_QuantizeUV(param_18);
vec2 param_19=_uv;
_uv=sc_PlatformFlipUV(param_19);
vec2 param_20=samplerDims;
vec2 param_21=_uv;
int param_22=renderingLayout;
int param_23=viewIndex;
float param_24=level;
vec4 tex=sc_SampleViewLevel(param_20,param_21,param_22,param_23,param_24,SPIRV_Cross_Combinedtexture_sampler_);
if (useClampToBorder)
{
tex=mix(borderColor,tex,vec4(clampToBorderFactor));
}
return tex;
}

vec4 sc_SampleTextureLevel(vec2 samplerDims,int renderingLayout,int viewIndex,vec2 uv,bool useUvTransform,mat3 uvTransform,ivec2 softwareWrapModes,bool useUvMinMax,vec4 uvMinMax,bool useClampToBorder,vec4 borderColor,float level,highp sampler2DArray SPIRV_Cross_Combinedtexture_sampler_)
{
vec2 _uv=uv;
float clampToBorderFactor=1.0;
bool useClampToBorderForWrap=useClampToBorder&&(!useUvMinMax);
float param=_uv.x;
int param_1=softwareWrapModes.x;
bool param_2=useClampToBorderForWrap;
float param_3=clampToBorderFactor;
sc_SoftwareWrap(param,param_1,param_2,param_3);
_uv.x=param;
clampToBorderFactor=param_3;
float param_4=_uv.y;
int param_5=softwareWrapModes.y;
bool param_6=useClampToBorderForWrap;
float param_7=clampToBorderFactor;
sc_SoftwareWrap(param_4,param_5,param_6,param_7);
_uv.y=param_4;
clampToBorderFactor=param_7;
if (useUvMinMax)
{
float param_8=_uv.x;
float param_9=uvMinMax.x;
float param_10=uvMinMax.z;
bool param_11=useClampToBorder;
float param_12=clampToBorderFactor;
sc_ClampUV(param_8,param_9,param_10,param_11,param_12);
_uv.x=param_8;
clampToBorderFactor=param_12;
float param_13=_uv.y;
float param_14=uvMinMax.y;
float param_15=uvMinMax.w;
bool param_16=useClampToBorder;
float param_17=clampToBorderFactor;
sc_ClampUV(param_13,param_14,param_15,param_16,param_17);
_uv.y=param_13;
clampToBorderFactor=param_17;
}
if (useUvTransform)
{
_uv=vec2((uvTransform*vec3(_uv,1.0)).xy);
}
vec2 param_18=_uv;
_uv=sc_QuantizeUV(param_18);
vec2 param_19=_uv;
_uv=sc_PlatformFlipUV(param_19);
vec2 param_20=samplerDims;
vec2 param_21=_uv;
int param_22=renderingLayout;
int param_23=viewIndex;
float param_24=level;
vec4 tex=sc_SampleViewLevel(param_20,param_21,param_22,param_23,param_24,SPIRV_Cross_Combinedtexture_sampler_);
if (useClampToBorder)
{
tex=mix(borderColor,tex,vec4(clampToBorderFactor));
}
return tex;
}

vec4 sampleTextureWithTransform(inout vec3 uv,bool useLOD,float level,bool useUvTransform,mat3 uvTransform,highp sampler2DArray SPIRV_Cross_Combinedtexsmp)
{
if (useUvTransform)
{
vec2 _1608=vec2((uvTransform*vec3(uv.xy,1.0)).xy);
uv=vec3(_1608.x,_1608.y,uv.z);
}
vec2 param=uv.xy;
vec2 _1614=sc_QuantizeUV(param);
uv=vec3(_1614.x,_1614.y,uv.z);
vec3 param_1=uv;
float param_2=level;
return sc_InternalTextureLevel(param_1,param_2,SPIRV_Cross_Combinedtexsmp);
}

vec4 sampleTextureWithTransform(highp sampler2DArray combinedSmp,inout vec3 uv,bool useLOD,float level,bool useUvTransform,mat3 uvTransform)
{
if (useUvTransform)
{
vec2 _1636=vec2((uvTransform*vec3(uv.xy,1.0)).xy);
uv=vec3(_1636.x,_1636.y,uv.z);
}
vec2 param=uv.xy;
vec2 _1642=sc_QuantizeUV(param);
uv=vec3(_1642.x,_1642.y,uv.z);
vec3 param_1=uv;
float param_2=level;
return sc_InternalTextureLevel(combinedSmp,param_1,param_2);
}

float depthScreenToViewSpace(inout float depth,vec2 projectionMatrixTerms)
{
float m22=projectionMatrixTerms.x;
float m32=projectionMatrixTerms.y;
depth=(depth*2.0)-1.0;
return m32/((-depth)-m22);
}

float depthViewToScreenSpace(inout float depth,vec2 projectionMatrixTerms)
{
float m22=projectionMatrixTerms.x;
float m32=projectionMatrixTerms.y;
float _1677;
if (depth!=0.0)
{
_1677=(-m22)-(m32/depth);
}
else
{
_1677=0.0;
}
depth=_1677;
return (depth*0.5)+0.5;
}

vec4 sampleTextureWithTransform(inout vec2 uv,bool useUvTransform,mat3 uvTransform,highp sampler2D SPIRV_Cross_Combinedtexsmp)
{
if (useUvTransform)
{
uv=vec2((uvTransform*vec3(uv,1.0)).xy);
}
vec2 param=uv;
uv=sc_QuantizeUV(param);
vec2 param_1=uv;
float param_2=0.0;
return sc_InternalTextureBiasOrLevel(param_1,param_2,SPIRV_Cross_Combinedtexsmp);
}

vec4 sampleTextureWithTransform(highp sampler2D combinedSmp,inout vec2 uv,bool useUvTransform,mat3 uvTransform)
{
if (useUvTransform)
{
uv=vec2((uvTransform*vec3(uv,1.0)).xy);
}
vec2 param=uv;
uv=sc_QuantizeUV(param);
vec2 param_1=uv;
float param_2=0.0;
return sc_InternalTextureBiasOrLevel(combinedSmp,param_1,param_2);
}

#elif defined FRAGMENT_SHADER // #if defined VERTEX_SHADER
    #ifndef sc_TextureRenderingLayout_Regular
        #define sc_TextureRenderingLayout_Regular 0
        #define sc_TextureRenderingLayout_StereoInstancedClipped 1
        #define sc_TextureRenderingLayout_StereoMultiview 2
    #endif

#define depthToGlobal depthScreenToViewSpace

#define depthToLocal depthViewToScreenSpace

    #ifndef quantizeUV
        #define quantizeUV sc_QuantizeUV
        #define sc_platformUVFlip sc_PlatformFlipUV
    #endif

    #ifndef sc_texture2DLod
        #define sc_texture2DLod sc_InternalTextureLevel
        #define sc_textureLod sc_InternalTextureLevel
        #define sc_textureBias sc_InternalTextureBiasOrLevel
        #define sc_texture sc_InternalTexture
    #endif

#include <required2.glsl>
#include <std2_stereo_view_index.glsl>
#include <std2_texture_sub.glsl>


//SG_REFLECTION_BEGIN(100)
//SG_REFLECTION_END



float sc_InternalCalculateSampleBias(vec2 texSize,vec2 uv,float level_)
{
#if (sc_CanUseStandardDerivatives)
{
vec2 texels=uv*texSize;
float dudx=dFdx(texels.x);
float dvdx=dFdx(texels.y);
float dudy=dFdy(texels.x);
float dvdy=dFdy(texels.y);
float mu=max(abs(dudx),abs(dudy));
float mv=max(abs(dvdx),abs(dvdy));
float rho2=max(mu,mv);
float mip=log2(rho2);
float bias=level_-mip;
return bias;
}
#else
{
return 0.0;
}
#endif
}

vec4 sc_InternalTextureLevel(highp sampler2D combinedSmp,vec2 texSize,vec2 uv,float level_)
{
#if (sc_CanUseTextureLod)
{
return texture2DLodEXT(combinedSmp,uv,level_);
}
#else
{
#if (sc_CanUseStandardDerivatives)
{
vec2 param=texSize;
vec2 param_1=uv;
float param_2=level_;
float bias=sc_InternalCalculateSampleBias(param,param_1,param_2);
return texture2D(combinedSmp,uv,bias);
}
#else
{
return vec4(0.0);
}
#endif
}
#endif
}

vec4 sc_InternalTextureLevel(vec2 texSize,vec2 uv,float level_,highp sampler2D SPIRV_Cross_Combinedtexsmp)
{
#if (sc_CanUseTextureLod)
{
return texture2DLodEXT(SPIRV_Cross_Combinedtexsmp,uv,level_);
}
#else
{
#if (sc_CanUseStandardDerivatives)
{
vec2 param=texSize;
vec2 param_1=uv;
float param_2=level_;
float bias=sc_InternalCalculateSampleBias(param,param_1,param_2);
return texture2D(SPIRV_Cross_Combinedtexsmp,uv,bias);
}
#else
{
return vec4(0.0);
}
#endif
}
#endif
}

vec4 sc_InternalTextureBiasOrLevel(highp sampler2D combinedSmp,vec2 texSize,vec2 uv,float biasOrLevel)
{
return texture2D(combinedSmp,uv,biasOrLevel);
}

vec4 sc_InternalTextureBiasOrLevel(vec2 texSize,vec2 uv,float biasOrLevel,highp sampler2D SPIRV_Cross_Combinedtexsmp)
{
return texture2D(SPIRV_Cross_Combinedtexsmp,uv,biasOrLevel);
}

vec4 sc_InternalTextureLevel(highp sampler2D combinedSmp,vec2 uv,float level_)
{
#if (sc_CanUseTextureLod)
{
return texture2DLodEXT(combinedSmp,uv,level_);
}
#else
{
return vec4(0.0);
}
#endif
}

vec4 sc_InternalTextureLevel(highp sampler2DArray combinedSmp,vec3 uv,float level_)
{
#if (sc_CanUseTextureLod)
{
return texture2DArrayLodEXT(combinedSmp,uv,level_);
}
#else
{
return vec4(0.0);
}
#endif
}

vec4 sc_InternalTextureLevel(highp sampler3D combinedSmp,vec3 uv,float level_)
{
#if (sc_CanUseTextureLod)
{
return texture3DLodEXT(combinedSmp,uv,level_);
}
#else
{
return vec4(0.0);
}
#endif
}

vec4 sc_InternalTextureLevel(highp samplerCube combinedSmp,vec3 uv,float level_)
{
#if (sc_CanUseTextureLod)
{
return textureCubeLodEXT(combinedSmp,uv,level_);
}
#else
{
return vec4(0.0);
}
#endif
}

vec4 sc_InternalTextureLevel(vec2 uv,float level_,highp sampler2D SPIRV_Cross_Combinedtexsmp)
{
#if (sc_CanUseTextureLod)
{
return texture2DLodEXT(SPIRV_Cross_Combinedtexsmp,uv,level_);
}
#else
{
return vec4(0.0);
}
#endif
}

vec4 sc_InternalTextureLevel(vec3 uv,float level_,highp sampler2DArray SPIRV_Cross_Combinedtexsmp)
{
#if (sc_CanUseTextureLod)
{
return texture2DArrayLodEXT(SPIRV_Cross_Combinedtexsmp,uv,level_);
}
#else
{
return vec4(0.0);
}
#endif
}

vec4 sc_InternalTextureLevel(vec3 uv,float level_,highp sampler3D SPIRV_Cross_Combinedtexsmp)
{
#if (sc_CanUseTextureLod)
{
return texture3DLodEXT(SPIRV_Cross_Combinedtexsmp,uv,level_);
}
#else
{
return vec4(0.0);
}
#endif
}

vec4 sc_InternalTextureLevel(vec3 uv,float level_,highp samplerCube SPIRV_Cross_Combinedtexsmp)
{
#if (sc_CanUseTextureLod)
{
return textureCubeLodEXT(SPIRV_Cross_Combinedtexsmp,uv,level_);
}
#else
{
return vec4(0.0);
}
#endif
}

vec4 sc_InternalTextureBiasOrLevel(highp sampler2D combinedSmp,vec2 uv,float biasOrLevel)
{
return texture2D(combinedSmp,uv,biasOrLevel);
}

vec4 sc_InternalTextureBiasOrLevel(highp sampler2DArray combinedSmp,vec3 uv,float biasOrLevel)
{
return texture2DArray(combinedSmp,uv,biasOrLevel);
}

vec4 sc_InternalTextureBiasOrLevel(highp sampler3D combinedSmp,vec3 uv,float biasOrLevel)
{
return texture3D(combinedSmp,uv,biasOrLevel);
}

vec4 sc_InternalTextureBiasOrLevel(highp samplerCube combinedSmp,vec3 uv,float biasOrLevel)
{
return textureCube(combinedSmp,uv,biasOrLevel);
}

vec4 sc_InternalTexture(highp sampler2D combinedSmp,vec2 uv)
{
return texture2D(combinedSmp,uv);
}

vec4 sc_InternalTexture(highp sampler2DArray combinedSmp,vec3 uv)
{
return texture2DArray(combinedSmp,uv);
}

vec4 sc_InternalTexture(highp sampler3D combinedSmp,vec3 uv)
{
return texture3D(combinedSmp,uv);
}

vec4 sc_InternalTexture(highp samplerCube combinedSmp,vec3 uv)
{
return textureCube(combinedSmp,uv);
}

vec4 sc_InternalTextureBiasOrLevel(vec2 uv,float biasOrLevel,highp sampler2D SPIRV_Cross_Combinedtexsmp)
{
return texture2D(SPIRV_Cross_Combinedtexsmp,uv,biasOrLevel);
}

vec4 sc_InternalTextureBiasOrLevel(vec3 uv,float biasOrLevel,highp sampler2DArray SPIRV_Cross_Combinedtexsmp)
{
return texture2DArray(SPIRV_Cross_Combinedtexsmp,uv,biasOrLevel);
}

vec4 sc_InternalTextureBiasOrLevel(vec3 uv,float biasOrLevel,highp sampler3D SPIRV_Cross_Combinedtexsmp)
{
return texture3D(SPIRV_Cross_Combinedtexsmp,uv,biasOrLevel);
}

vec4 sc_InternalTextureBiasOrLevel(vec3 uv,float biasOrLevel,highp samplerCube SPIRV_Cross_Combinedtexsmp)
{
return textureCube(SPIRV_Cross_Combinedtexsmp,uv,biasOrLevel);
}

vec2 sc_SamplingCoordsGlobalToView(inout vec3 uvi,int renderingLayout,int viewIndex)
{
if (renderingLayout==1)
{
uvi.y=((2.0*uvi.y)+float(viewIndex))-1.0;
}
return uvi.xy;
}

vec2 sc_ScreenCoordsGlobalToView(vec2 uv)
{
#if (sc_StereoRenderingMode==1)
{
vec3 uvi=vec3(uv,0.0);
int instancedClippedLayout=1;
int viewIndex=sc_GetStereoViewIndex();
vec3 param=vec3(uv,0.0);
int param_1=instancedClippedLayout;
int param_2=viewIndex;
vec2 _786=sc_SamplingCoordsGlobalToView(param,param_1,param_2);
return _786;
}
#else
{
return uv;
}
#endif
}

vec3 sc_SamplingCoordsViewToGlobal(vec2 uv,int renderingLayout,int viewIndex)
{
if (renderingLayout==0)
{
return vec3(uv,0.0);
}
else
{
if (renderingLayout==1)
{
return vec3(uv.x,(uv.y*0.5)+(0.5-(float(viewIndex)*0.5)),0.0);
}
else
{
return vec3(uv,float(viewIndex));
}
}
}

vec4 sc_SampleViewLevel(vec2 texSize,vec2 uv,int renderingLayout,int viewIndex,float level,highp sampler2D SPIRV_Cross_Combinedtexsmp)
{
vec2 param=uv;
int param_1=renderingLayout;
int param_2=viewIndex;
vec3 uvi=sc_SamplingCoordsViewToGlobal(param,param_1,param_2);
vec2 param_3=texSize;
vec2 param_4=uvi.xy;
float param_5=level;
return sc_InternalTextureLevel(param_3,param_4,param_5,SPIRV_Cross_Combinedtexsmp);
}

vec4 sc_SampleView(vec2 texSize,vec2 uv,int renderingLayout,int viewIndex,float bias,highp sampler2D SPIRV_Cross_Combinedtexsmp)
{
vec2 param=uv;
int param_1=renderingLayout;
int param_2=viewIndex;
vec3 uvi=sc_SamplingCoordsViewToGlobal(param,param_1,param_2);
vec2 param_3=texSize;
vec2 param_4=uvi.xy;
float param_5=bias;
return sc_InternalTextureBiasOrLevel(param_3,param_4,param_5,SPIRV_Cross_Combinedtexsmp);
}

vec4 sc_SampleViewLevel(vec2 texSize,vec2 uv,int renderingLayout,int viewIndex,float level,highp sampler2DArray SPIRV_Cross_Combinedtexsmp)
{
vec2 param=uv;
int param_1=renderingLayout;
int param_2=viewIndex;
vec3 uvi=sc_SamplingCoordsViewToGlobal(param,param_1,param_2);
vec3 param_3=uvi;
float param_4=level;
return sc_InternalTextureLevel(param_3,param_4,SPIRV_Cross_Combinedtexsmp);
}

vec4 sc_SampleView(vec2 texSize,vec2 uv,int renderingLayout,int viewIndex,float bias,highp sampler2DArray SPIRV_Cross_Combinedtexsmp)
{
vec2 param=uv;
int param_1=renderingLayout;
int param_2=viewIndex;
vec3 uvi=sc_SamplingCoordsViewToGlobal(param,param_1,param_2);
vec3 param_3=uvi;
float param_4=bias;
return sc_InternalTextureBiasOrLevel(param_3,param_4,SPIRV_Cross_Combinedtexsmp);
}

vec4 sc_SampleViewLevel(highp sampler2D combinedSmp,vec2 texSize,vec2 uv,int renderingLayout,int viewIndex,float level)
{
vec2 param=uv;
int param_1=renderingLayout;
int param_2=viewIndex;
vec3 uvi=sc_SamplingCoordsViewToGlobal(param,param_1,param_2);
vec2 param_3=texSize;
vec2 param_4=uvi.xy;
float param_5=level;
return sc_InternalTextureLevel(combinedSmp,param_3,param_4,param_5);
}

vec4 sc_SampleView(highp sampler2D combinedSmp,vec2 texSize,vec2 uv,int renderingLayout,int viewIndex,float bias)
{
vec2 param=uv;
int param_1=renderingLayout;
int param_2=viewIndex;
vec3 uvi=sc_SamplingCoordsViewToGlobal(param,param_1,param_2);
vec2 param_3=texSize;
vec2 param_4=uvi.xy;
float param_5=bias;
return sc_InternalTextureBiasOrLevel(combinedSmp,param_3,param_4,param_5);
}

vec4 sc_SampleViewLevel(highp sampler2DArray combinedSmp,vec2 texSize,vec2 uv,int renderingLayout,int viewIndex,float level)
{
vec2 param=uv;
int param_1=renderingLayout;
int param_2=viewIndex;
vec3 uvi=sc_SamplingCoordsViewToGlobal(param,param_1,param_2);
vec3 param_3=uvi;
float param_4=level;
return sc_InternalTextureLevel(combinedSmp,param_3,param_4);
}

vec4 sc_SampleView(highp sampler2DArray combinedSmp,vec2 texSize,vec2 uv,int renderingLayout,int viewIndex,float bias)
{
vec2 param=uv;
int param_1=renderingLayout;
int param_2=viewIndex;
vec3 uvi=sc_SamplingCoordsViewToGlobal(param,param_1,param_2);
vec3 param_3=uvi;
float param_4=bias;
return sc_InternalTextureBiasOrLevel(combinedSmp,param_3,param_4);
}

void sc_ClampUV(inout float value,float minValue,float maxValue,bool useClampToBorder,inout float clampToBorderFactor)
{
float clampedValue=clamp(value,minValue,maxValue);
float factor=step(abs(value-clampedValue),1e-05);
clampToBorderFactor*=(factor+((1.0-float(useClampToBorder))*(1.0-factor)));
value=clampedValue;
}

vec2 sc_PlatformFlipUV(vec2 uv)
{
return uv;
}

void sc_SoftwareWrap(inout float uv,int softwareWrapMode,bool useClampToBorder,inout float clampToBorderFactor)
{
if ((softwareWrapMode==0)||(softwareWrapMode==3))
{
float param=uv;
float param_1=0.0;
float param_2=1.0;
bool param_3=useClampToBorder;
float param_4=clampToBorderFactor;
sc_ClampUV(param,param_1,param_2,param_3,param_4);
uv=param;
clampToBorderFactor=param_4;
}
else
{
if (softwareWrapMode==1)
{
uv=fract(uv);
}
else
{
if (softwareWrapMode==2)
{
float uvFract=fract(uv);
float uvInt=uv-uvFract;
float uvOdd=step(0.25,fract(uvInt*0.5));
uv=mix(uvFract,1.0-uvFract,clamp(uvOdd,0.0,1.0));
}
}
}
}

vec2 sc_QuantizeUV(vec2 uv)
{
return uv;
}

vec4 sc_SampleTexture(highp sampler2D combined_,vec2 samplerDims,int renderingLayout,int viewIndex,vec2 uv,bool useUvTransform,mat3 uvTransform,ivec2 softwareWrapModes,bool useUvMinMax,vec4 uvMinMax,bool useClampToBorder,vec4 borderColor,float biasOrLevel)
{
vec2 _uv=uv;
float clampToBorderFactor=1.0;
bool useClampToBorderForWrap=useClampToBorder&&(!useUvMinMax);
float param=_uv.x;
int param_1=softwareWrapModes.x;
bool param_2=useClampToBorderForWrap;
float param_3=clampToBorderFactor;
sc_SoftwareWrap(param,param_1,param_2,param_3);
_uv.x=param;
clampToBorderFactor=param_3;
float param_4=_uv.y;
int param_5=softwareWrapModes.y;
bool param_6=useClampToBorderForWrap;
float param_7=clampToBorderFactor;
sc_SoftwareWrap(param_4,param_5,param_6,param_7);
_uv.y=param_4;
clampToBorderFactor=param_7;
if (useUvMinMax)
{
float param_8=_uv.x;
float param_9=uvMinMax.x;
float param_10=uvMinMax.z;
bool param_11=useClampToBorder;
float param_12=clampToBorderFactor;
sc_ClampUV(param_8,param_9,param_10,param_11,param_12);
_uv.x=param_8;
clampToBorderFactor=param_12;
float param_13=_uv.y;
float param_14=uvMinMax.y;
float param_15=uvMinMax.w;
bool param_16=useClampToBorder;
float param_17=clampToBorderFactor;
sc_ClampUV(param_13,param_14,param_15,param_16,param_17);
_uv.y=param_13;
clampToBorderFactor=param_17;
}
if (useUvTransform)
{
_uv=vec2((uvTransform*vec3(_uv,1.0)).xy);
}
vec2 param_18=_uv;
_uv=sc_QuantizeUV(param_18);
vec2 param_19=_uv;
_uv=sc_PlatformFlipUV(param_19);
vec2 param_20=samplerDims;
vec2 param_21=_uv;
int param_22=renderingLayout;
int param_23=viewIndex;
float param_24=biasOrLevel;
vec4 tex=sc_SampleView(combined_,param_20,param_21,param_22,param_23,param_24);
if (useClampToBorder)
{
tex=mix(borderColor,tex,vec4(clampToBorderFactor));
}
return tex;
}

vec4 sc_SampleTexture(highp sampler2DArray combined_,vec2 samplerDims,int renderingLayout,int viewIndex,vec2 uv,bool useUvTransform,mat3 uvTransform,ivec2 softwareWrapModes,bool useUvMinMax,vec4 uvMinMax,bool useClampToBorder,vec4 borderColor,float biasOrLevel)
{
vec2 _uv=uv;
float clampToBorderFactor=1.0;
bool useClampToBorderForWrap=useClampToBorder&&(!useUvMinMax);
float param=_uv.x;
int param_1=softwareWrapModes.x;
bool param_2=useClampToBorderForWrap;
float param_3=clampToBorderFactor;
sc_SoftwareWrap(param,param_1,param_2,param_3);
_uv.x=param;
clampToBorderFactor=param_3;
float param_4=_uv.y;
int param_5=softwareWrapModes.y;
bool param_6=useClampToBorderForWrap;
float param_7=clampToBorderFactor;
sc_SoftwareWrap(param_4,param_5,param_6,param_7);
_uv.y=param_4;
clampToBorderFactor=param_7;
if (useUvMinMax)
{
float param_8=_uv.x;
float param_9=uvMinMax.x;
float param_10=uvMinMax.z;
bool param_11=useClampToBorder;
float param_12=clampToBorderFactor;
sc_ClampUV(param_8,param_9,param_10,param_11,param_12);
_uv.x=param_8;
clampToBorderFactor=param_12;
float param_13=_uv.y;
float param_14=uvMinMax.y;
float param_15=uvMinMax.w;
bool param_16=useClampToBorder;
float param_17=clampToBorderFactor;
sc_ClampUV(param_13,param_14,param_15,param_16,param_17);
_uv.y=param_13;
clampToBorderFactor=param_17;
}
if (useUvTransform)
{
_uv=vec2((uvTransform*vec3(_uv,1.0)).xy);
}
vec2 param_18=_uv;
_uv=sc_QuantizeUV(param_18);
vec2 param_19=_uv;
_uv=sc_PlatformFlipUV(param_19);
vec2 param_20=samplerDims;
vec2 param_21=_uv;
int param_22=renderingLayout;
int param_23=viewIndex;
float param_24=biasOrLevel;
vec4 tex=sc_SampleView(combined_,param_20,param_21,param_22,param_23,param_24);
if (useClampToBorder)
{
tex=mix(borderColor,tex,vec4(clampToBorderFactor));
}
return tex;
}

vec4 sc_SampleTextureBiasOrLevel(vec2 samplerDims,int renderingLayout,int viewIndex,vec2 uv,bool useUvTransform,mat3 uvTransform,ivec2 softwareWrapModes,bool useUvMinMax,vec4 uvMinMax,bool useClampToBorder,vec4 borderColor,float biasOrLevel,highp sampler2D SPIRV_Cross_Combinedtexture_sampler_)
{
vec2 _uv=uv;
float clampToBorderFactor=1.0;
bool useClampToBorderForWrap=useClampToBorder&&(!useUvMinMax);
float param=_uv.x;
int param_1=softwareWrapModes.x;
bool param_2=useClampToBorderForWrap;
float param_3=clampToBorderFactor;
sc_SoftwareWrap(param,param_1,param_2,param_3);
_uv.x=param;
clampToBorderFactor=param_3;
float param_4=_uv.y;
int param_5=softwareWrapModes.y;
bool param_6=useClampToBorderForWrap;
float param_7=clampToBorderFactor;
sc_SoftwareWrap(param_4,param_5,param_6,param_7);
_uv.y=param_4;
clampToBorderFactor=param_7;
if (useUvMinMax)
{
float param_8=_uv.x;
float param_9=uvMinMax.x;
float param_10=uvMinMax.z;
bool param_11=useClampToBorder;
float param_12=clampToBorderFactor;
sc_ClampUV(param_8,param_9,param_10,param_11,param_12);
_uv.x=param_8;
clampToBorderFactor=param_12;
float param_13=_uv.y;
float param_14=uvMinMax.y;
float param_15=uvMinMax.w;
bool param_16=useClampToBorder;
float param_17=clampToBorderFactor;
sc_ClampUV(param_13,param_14,param_15,param_16,param_17);
_uv.y=param_13;
clampToBorderFactor=param_17;
}
if (useUvTransform)
{
_uv=vec2((uvTransform*vec3(_uv,1.0)).xy);
}
vec2 param_18=_uv;
_uv=sc_QuantizeUV(param_18);
vec2 param_19=_uv;
_uv=sc_PlatformFlipUV(param_19);
vec2 param_20=samplerDims;
vec2 param_21=_uv;
int param_22=renderingLayout;
int param_23=viewIndex;
float param_24=biasOrLevel;
vec4 tex=sc_SampleView(param_20,param_21,param_22,param_23,param_24,SPIRV_Cross_Combinedtexture_sampler_);
if (useClampToBorder)
{
tex=mix(borderColor,tex,vec4(clampToBorderFactor));
}
return tex;
}

vec4 sc_SampleTextureBiasOrLevel(vec2 samplerDims,int renderingLayout,int viewIndex,vec2 uv,bool useUvTransform,mat3 uvTransform,ivec2 softwareWrapModes,bool useUvMinMax,vec4 uvMinMax,bool useClampToBorder,vec4 borderColor,float biasOrLevel,highp sampler2DArray SPIRV_Cross_Combinedtexture_sampler_)
{
vec2 _uv=uv;
float clampToBorderFactor=1.0;
bool useClampToBorderForWrap=useClampToBorder&&(!useUvMinMax);
float param=_uv.x;
int param_1=softwareWrapModes.x;
bool param_2=useClampToBorderForWrap;
float param_3=clampToBorderFactor;
sc_SoftwareWrap(param,param_1,param_2,param_3);
_uv.x=param;
clampToBorderFactor=param_3;
float param_4=_uv.y;
int param_5=softwareWrapModes.y;
bool param_6=useClampToBorderForWrap;
float param_7=clampToBorderFactor;
sc_SoftwareWrap(param_4,param_5,param_6,param_7);
_uv.y=param_4;
clampToBorderFactor=param_7;
if (useUvMinMax)
{
float param_8=_uv.x;
float param_9=uvMinMax.x;
float param_10=uvMinMax.z;
bool param_11=useClampToBorder;
float param_12=clampToBorderFactor;
sc_ClampUV(param_8,param_9,param_10,param_11,param_12);
_uv.x=param_8;
clampToBorderFactor=param_12;
float param_13=_uv.y;
float param_14=uvMinMax.y;
float param_15=uvMinMax.w;
bool param_16=useClampToBorder;
float param_17=clampToBorderFactor;
sc_ClampUV(param_13,param_14,param_15,param_16,param_17);
_uv.y=param_13;
clampToBorderFactor=param_17;
}
if (useUvTransform)
{
_uv=vec2((uvTransform*vec3(_uv,1.0)).xy);
}
vec2 param_18=_uv;
_uv=sc_QuantizeUV(param_18);
vec2 param_19=_uv;
_uv=sc_PlatformFlipUV(param_19);
vec2 param_20=samplerDims;
vec2 param_21=_uv;
int param_22=renderingLayout;
int param_23=viewIndex;
float param_24=biasOrLevel;
vec4 tex=sc_SampleView(param_20,param_21,param_22,param_23,param_24,SPIRV_Cross_Combinedtexture_sampler_);
if (useClampToBorder)
{
tex=mix(borderColor,tex,vec4(clampToBorderFactor));
}
return tex;
}

vec4 sc_SampleTextureLevel(vec2 samplerDims,int renderingLayout,int viewIndex,vec2 uv,bool useUvTransform,mat3 uvTransform,ivec2 softwareWrapModes,bool useUvMinMax,vec4 uvMinMax,bool useClampToBorder,vec4 borderColor,float level,highp sampler2D SPIRV_Cross_Combinedtexture_sampler_)
{
vec2 _uv=uv;
float clampToBorderFactor=1.0;
bool useClampToBorderForWrap=useClampToBorder&&(!useUvMinMax);
float param=_uv.x;
int param_1=softwareWrapModes.x;
bool param_2=useClampToBorderForWrap;
float param_3=clampToBorderFactor;
sc_SoftwareWrap(param,param_1,param_2,param_3);
_uv.x=param;
clampToBorderFactor=param_3;
float param_4=_uv.y;
int param_5=softwareWrapModes.y;
bool param_6=useClampToBorderForWrap;
float param_7=clampToBorderFactor;
sc_SoftwareWrap(param_4,param_5,param_6,param_7);
_uv.y=param_4;
clampToBorderFactor=param_7;
if (useUvMinMax)
{
float param_8=_uv.x;
float param_9=uvMinMax.x;
float param_10=uvMinMax.z;
bool param_11=useClampToBorder;
float param_12=clampToBorderFactor;
sc_ClampUV(param_8,param_9,param_10,param_11,param_12);
_uv.x=param_8;
clampToBorderFactor=param_12;
float param_13=_uv.y;
float param_14=uvMinMax.y;
float param_15=uvMinMax.w;
bool param_16=useClampToBorder;
float param_17=clampToBorderFactor;
sc_ClampUV(param_13,param_14,param_15,param_16,param_17);
_uv.y=param_13;
clampToBorderFactor=param_17;
}
if (useUvTransform)
{
_uv=vec2((uvTransform*vec3(_uv,1.0)).xy);
}
vec2 param_18=_uv;
_uv=sc_QuantizeUV(param_18);
vec2 param_19=_uv;
_uv=sc_PlatformFlipUV(param_19);
vec2 param_20=samplerDims;
vec2 param_21=_uv;
int param_22=renderingLayout;
int param_23=viewIndex;
float param_24=level;
vec4 tex=sc_SampleViewLevel(param_20,param_21,param_22,param_23,param_24,SPIRV_Cross_Combinedtexture_sampler_);
if (useClampToBorder)
{
tex=mix(borderColor,tex,vec4(clampToBorderFactor));
}
return tex;
}

vec4 sc_SampleTextureLevel(vec2 samplerDims,int renderingLayout,int viewIndex,vec2 uv,bool useUvTransform,mat3 uvTransform,ivec2 softwareWrapModes,bool useUvMinMax,vec4 uvMinMax,bool useClampToBorder,vec4 borderColor,float level,highp sampler2DArray SPIRV_Cross_Combinedtexture_sampler_)
{
vec2 _uv=uv;
float clampToBorderFactor=1.0;
bool useClampToBorderForWrap=useClampToBorder&&(!useUvMinMax);
float param=_uv.x;
int param_1=softwareWrapModes.x;
bool param_2=useClampToBorderForWrap;
float param_3=clampToBorderFactor;
sc_SoftwareWrap(param,param_1,param_2,param_3);
_uv.x=param;
clampToBorderFactor=param_3;
float param_4=_uv.y;
int param_5=softwareWrapModes.y;
bool param_6=useClampToBorderForWrap;
float param_7=clampToBorderFactor;
sc_SoftwareWrap(param_4,param_5,param_6,param_7);
_uv.y=param_4;
clampToBorderFactor=param_7;
if (useUvMinMax)
{
float param_8=_uv.x;
float param_9=uvMinMax.x;
float param_10=uvMinMax.z;
bool param_11=useClampToBorder;
float param_12=clampToBorderFactor;
sc_ClampUV(param_8,param_9,param_10,param_11,param_12);
_uv.x=param_8;
clampToBorderFactor=param_12;
float param_13=_uv.y;
float param_14=uvMinMax.y;
float param_15=uvMinMax.w;
bool param_16=useClampToBorder;
float param_17=clampToBorderFactor;
sc_ClampUV(param_13,param_14,param_15,param_16,param_17);
_uv.y=param_13;
clampToBorderFactor=param_17;
}
if (useUvTransform)
{
_uv=vec2((uvTransform*vec3(_uv,1.0)).xy);
}
vec2 param_18=_uv;
_uv=sc_QuantizeUV(param_18);
vec2 param_19=_uv;
_uv=sc_PlatformFlipUV(param_19);
vec2 param_20=samplerDims;
vec2 param_21=_uv;
int param_22=renderingLayout;
int param_23=viewIndex;
float param_24=level;
vec4 tex=sc_SampleViewLevel(param_20,param_21,param_22,param_23,param_24,SPIRV_Cross_Combinedtexture_sampler_);
if (useClampToBorder)
{
tex=mix(borderColor,tex,vec4(clampToBorderFactor));
}
return tex;
}

vec4 sampleTextureWithTransform(inout vec3 uv,bool useLOD,float level,bool useUvTransform,mat3 uvTransform,highp sampler2DArray SPIRV_Cross_Combinedtexsmp)
{
if (useUvTransform)
{
vec2 _1738=vec2((uvTransform*vec3(uv.xy,1.0)).xy);
uv=vec3(_1738.x,_1738.y,uv.z);
}
vec2 param=uv.xy;
vec2 _1744=sc_QuantizeUV(param);
uv=vec3(_1744.x,_1744.y,uv.z);
vec4 _1748;
if (useLOD)
{
vec3 param_1=uv;
float param_2=level;
_1748=sc_InternalTextureLevel(param_1,param_2,SPIRV_Cross_Combinedtexsmp);
}
else
{
vec3 param_3=uv;
float param_4=0.0;
_1748=sc_InternalTextureBiasOrLevel(param_3,param_4,SPIRV_Cross_Combinedtexsmp);
}
return _1748;
}

vec4 sampleTextureWithTransform(highp sampler2DArray combinedSmp,inout vec3 uv,bool useLOD,float level,bool useUvTransform,mat3 uvTransform)
{
if (useUvTransform)
{
vec2 _1776=vec2((uvTransform*vec3(uv.xy,1.0)).xy);
uv=vec3(_1776.x,_1776.y,uv.z);
}
vec2 param=uv.xy;
vec2 _1782=sc_QuantizeUV(param);
uv=vec3(_1782.x,_1782.y,uv.z);
vec4 _1786;
if (useLOD)
{
vec3 param_1=uv;
float param_2=level;
_1786=sc_InternalTextureLevel(combinedSmp,param_1,param_2);
}
else
{
vec3 param_3=uv;
float param_4=0.0;
_1786=sc_InternalTextureBiasOrLevel(combinedSmp,param_3,param_4);
}
return _1786;
}

float depthScreenToViewSpace(inout float depth,vec2 projectionMatrixTerms)
{
float m22=projectionMatrixTerms.x;
float m32=projectionMatrixTerms.y;
depth=(depth*2.0)-1.0;
return m32/((-depth)-m22);
}

float depthViewToScreenSpace(inout float depth,vec2 projectionMatrixTerms)
{
float m22=projectionMatrixTerms.x;
float m32=projectionMatrixTerms.y;
float _1827;
if (depth!=0.0)
{
_1827=(-m22)-(m32/depth);
}
else
{
_1827=0.0;
}
depth=_1827;
return (depth*0.5)+0.5;
}

vec4 sampleTextureWithTransform(inout vec2 uv,bool useUvTransform,mat3 uvTransform,highp sampler2D SPIRV_Cross_Combinedtexsmp)
{
if (useUvTransform)
{
uv=vec2((uvTransform*vec3(uv,1.0)).xy);
}
vec2 param=uv;
uv=sc_QuantizeUV(param);
vec2 param_1=uv;
float param_2=0.0;
return sc_InternalTextureBiasOrLevel(param_1,param_2,SPIRV_Cross_Combinedtexsmp);
}

vec4 sampleTextureWithTransform(highp sampler2D combinedSmp,inout vec2 uv,bool useUvTransform,mat3 uvTransform)
{
if (useUvTransform)
{
uv=vec2((uvTransform*vec3(uv,1.0)).xy);
}
vec2 param=uv;
uv=sc_QuantizeUV(param);
vec2 param_1=uv;
float param_2=0.0;
return sc_InternalTextureBiasOrLevel(combinedSmp,param_1,param_2);
}

#endif // #elif defined FRAGMENT_SHADER // #if defined VERTEX_SHADER
