#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE0 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include "std2.metal"
#include "std2_vs.metal"
#include "std2_fs.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN(100)
//ubo float UserUniforms 0:35568:432 {
//float4 originalTextureSize 0
//float4 originalTextureDims 16
//float4 originalTextureView 32
//float3x3 originalTextureTransform 48
//float4 originalTextureUvMinMax 96
//float4 originalTextureBorderColor 112
//float4 inputTextureSize 128
//float4 inputTextureDims 144
//float4 inputTextureView 160
//float3x3 inputTextureTransform 176
//float4 inputTextureUvMinMax 224
//float4 inputTextureBorderColor 240
//float4 maskTextureSize 256
//float4 maskTextureDims 272
//float4 maskTextureView 288
//float3x3 maskTextureTransform 304
//float4 maskTextureUvMinMax 352
//float4 maskTextureBorderColor 368
//float2 blurDir 384
//float3 offset 400
//float4 weight 416
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 originalTextureSize;
float4 originalTextureDims;
float4 originalTextureView;
float3x3 originalTextureTransform;
float4 originalTextureUvMinMax;
float4 originalTextureBorderColor;
float4 inputTextureSize;
float4 inputTextureDims;
float4 inputTextureView;
float3x3 inputTextureTransform;
float4 inputTextureUvMinMax;
float4 inputTextureBorderColor;
float4 maskTextureSize;
float4 maskTextureDims;
float4 maskTextureView;
float3x3 maskTextureTransform;
float4 maskTextureUvMinMax;
float4 maskTextureBorderColor;
float2 blurDir;
float3 offset;
float4 weight;
};

#ifndef originalTextureHasSwappedViews
#define originalTextureHasSwappedViews 0
#elif originalTextureHasSwappedViews==1
#undef originalTextureHasSwappedViews
#define originalTextureHasSwappedViews 1
#endif
#ifndef originalTextureLayout
#define originalTextureLayout 0
#endif
#ifndef inputTextureHasSwappedViews
#define inputTextureHasSwappedViews 0
#elif inputTextureHasSwappedViews==1
#undef inputTextureHasSwappedViews
#define inputTextureHasSwappedViews 1
#endif
#ifndef inputTextureLayout
#define inputTextureLayout 0
#endif
#ifndef maskTextureHasSwappedViews
#define maskTextureHasSwappedViews 0
#elif maskTextureHasSwappedViews==1
#undef maskTextureHasSwappedViews
#define maskTextureHasSwappedViews 1
#endif
#ifndef maskTextureLayout
#define maskTextureLayout 0
#endif
#ifndef KERNEL_SIZE
#define KERNEL_SIZE 13
#endif
#ifndef BLUR_ESTIMATION_FIRST_PASS
#define BLUR_ESTIMATION_FIRST_PASS 0
#elif BLUR_ESTIMATION_FIRST_PASS==1
#undef BLUR_ESTIMATION_FIRST_PASS
#define BLUR_ESTIMATION_FIRST_PASS 1
#endif
#ifndef originalTextureUV
#define originalTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_originalTexture
#define SC_USE_UV_TRANSFORM_originalTexture 0
#elif SC_USE_UV_TRANSFORM_originalTexture==1
#undef SC_USE_UV_TRANSFORM_originalTexture
#define SC_USE_UV_TRANSFORM_originalTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_originalTexture
#define SC_SOFTWARE_WRAP_MODE_U_originalTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_originalTexture
#define SC_SOFTWARE_WRAP_MODE_V_originalTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_originalTexture
#define SC_USE_UV_MIN_MAX_originalTexture 0
#elif SC_USE_UV_MIN_MAX_originalTexture==1
#undef SC_USE_UV_MIN_MAX_originalTexture
#define SC_USE_UV_MIN_MAX_originalTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_originalTexture
#define SC_USE_CLAMP_TO_BORDER_originalTexture 0
#elif SC_USE_CLAMP_TO_BORDER_originalTexture==1
#undef SC_USE_CLAMP_TO_BORDER_originalTexture
#define SC_USE_CLAMP_TO_BORDER_originalTexture 1
#endif
#ifndef inputTextureUV
#define inputTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_inputTexture
#define SC_USE_UV_TRANSFORM_inputTexture 0
#elif SC_USE_UV_TRANSFORM_inputTexture==1
#undef SC_USE_UV_TRANSFORM_inputTexture
#define SC_USE_UV_TRANSFORM_inputTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_inputTexture
#define SC_SOFTWARE_WRAP_MODE_U_inputTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_inputTexture
#define SC_SOFTWARE_WRAP_MODE_V_inputTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_inputTexture
#define SC_USE_UV_MIN_MAX_inputTexture 0
#elif SC_USE_UV_MIN_MAX_inputTexture==1
#undef SC_USE_UV_MIN_MAX_inputTexture
#define SC_USE_UV_MIN_MAX_inputTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_inputTexture
#define SC_USE_CLAMP_TO_BORDER_inputTexture 0
#elif SC_USE_CLAMP_TO_BORDER_inputTexture==1
#undef SC_USE_CLAMP_TO_BORDER_inputTexture
#define SC_USE_CLAMP_TO_BORDER_inputTexture 1
#endif
#ifndef maskTextureUV
#define maskTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_maskTexture
#define SC_USE_UV_TRANSFORM_maskTexture 0
#elif SC_USE_UV_TRANSFORM_maskTexture==1
#undef SC_USE_UV_TRANSFORM_maskTexture
#define SC_USE_UV_TRANSFORM_maskTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_maskTexture
#define SC_SOFTWARE_WRAP_MODE_U_maskTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_maskTexture
#define SC_SOFTWARE_WRAP_MODE_V_maskTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_maskTexture
#define SC_USE_UV_MIN_MAX_maskTexture 0
#elif SC_USE_UV_MIN_MAX_maskTexture==1
#undef SC_USE_UV_MIN_MAX_maskTexture
#define SC_USE_UV_MIN_MAX_maskTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_maskTexture
#define SC_USE_CLAMP_TO_BORDER_maskTexture 0
#elif SC_USE_CLAMP_TO_BORDER_maskTexture==1
#undef SC_USE_CLAMP_TO_BORDER_maskTexture
#define SC_USE_CLAMP_TO_BORDER_maskTexture 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

void setBlurCoordinates(thread const float2& texCoords,constant UserUniforms& userUniformsObj,thread float2 (&blurCoordinates)[(KERNEL_SIZE/2)+1])
{
float2 texStep=userUniformsObj.inputTextureSize.zw*userUniformsObj.blurDir;
blurCoordinates[0]=texCoords;
blurCoordinates[1]=texCoords+(texStep*userUniformsObj.offset.x);
blurCoordinates[2]=texCoords-(texStep*userUniformsObj.offset.x);
blurCoordinates[3]=texCoords+(texStep*userUniformsObj.offset.y);
blurCoordinates[4]=texCoords-(texStep*userUniformsObj.offset.y);
blurCoordinates[5]=texCoords+(texStep*userUniformsObj.offset.z);
blurCoordinates[6]=texCoords-(texStep*userUniformsObj.offset.z);
}

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant UserUniforms& userUniformsObj,constant LibraryUniforms& libraryUniformsObj,uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
float2 blurCoordinates[(KERNEL_SIZE/2)+1]={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
float2 _2867=((v.position.xy/float2(v.position.w))*0.5)+float2(0.5);
out.varPackedTex=float4(_2867.x,_2867.y,out.varPackedTex.z,out.varPackedTex.w);
float2 param=out.varPackedTex.xy;
setBlurCoordinates(param,userUniformsObj,blurCoordinates);
sc_Vertex_t param_1=v;
sc_ProcessVertex(param_1,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN(100)
//sampler sampler originalTextureSmpSC 0:48228
//sampler sampler inputTextureSmpSC 0:43245
//sampler sampler maskTextureSmpSC 0:35243
//texture texture2D originalTexture 0:43367:0:48228
//texture texture2D inputTexture 0:37488:0:43245
//texture texture2D maskTexture 0:38610:0:35243
//ubo float UserUniforms 0:35568:432 {
//float4 originalTextureSize 0
//float4 originalTextureDims 16
//float4 originalTextureView 32
//float3x3 originalTextureTransform 48
//float4 originalTextureUvMinMax 96
//float4 originalTextureBorderColor 112
//float4 inputTextureSize 128
//float4 inputTextureDims 144
//float4 inputTextureView 160
//float3x3 inputTextureTransform 176
//float4 inputTextureUvMinMax 224
//float4 inputTextureBorderColor 240
//float4 maskTextureSize 256
//float4 maskTextureDims 272
//float4 maskTextureView 288
//float3x3 maskTextureTransform 304
//float4 maskTextureUvMinMax 352
//float4 maskTextureBorderColor 368
//float2 blurDir 384
//float3 offset 400
//float4 weight 416
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 originalTextureSize;
float4 originalTextureDims;
float4 originalTextureView;
float3x3 originalTextureTransform;
float4 originalTextureUvMinMax;
float4 originalTextureBorderColor;
float4 inputTextureSize;
float4 inputTextureDims;
float4 inputTextureView;
float3x3 inputTextureTransform;
float4 inputTextureUvMinMax;
float4 inputTextureBorderColor;
float4 maskTextureSize;
float4 maskTextureDims;
float4 maskTextureView;
float3x3 maskTextureTransform;
float4 maskTextureUvMinMax;
float4 maskTextureBorderColor;
float2 blurDir;
float3 offset;
float4 weight;
};

#ifndef originalTextureHasSwappedViews
#define originalTextureHasSwappedViews 0
#elif originalTextureHasSwappedViews==1
#undef originalTextureHasSwappedViews
#define originalTextureHasSwappedViews 1
#endif
#ifndef originalTextureLayout
#define originalTextureLayout 0
#endif
#ifndef inputTextureHasSwappedViews
#define inputTextureHasSwappedViews 0
#elif inputTextureHasSwappedViews==1
#undef inputTextureHasSwappedViews
#define inputTextureHasSwappedViews 1
#endif
#ifndef inputTextureLayout
#define inputTextureLayout 0
#endif
#ifndef maskTextureHasSwappedViews
#define maskTextureHasSwappedViews 0
#elif maskTextureHasSwappedViews==1
#undef maskTextureHasSwappedViews
#define maskTextureHasSwappedViews 1
#endif
#ifndef maskTextureLayout
#define maskTextureLayout 0
#endif
#ifndef SC_USE_UV_TRANSFORM_inputTexture
#define SC_USE_UV_TRANSFORM_inputTexture 0
#elif SC_USE_UV_TRANSFORM_inputTexture==1
#undef SC_USE_UV_TRANSFORM_inputTexture
#define SC_USE_UV_TRANSFORM_inputTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_inputTexture
#define SC_SOFTWARE_WRAP_MODE_U_inputTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_inputTexture
#define SC_SOFTWARE_WRAP_MODE_V_inputTexture -1
#endif
constant int2 _2440=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
#ifndef SC_USE_UV_MIN_MAX_inputTexture
#define SC_USE_UV_MIN_MAX_inputTexture 0
#elif SC_USE_UV_MIN_MAX_inputTexture==1
#undef SC_USE_UV_MIN_MAX_inputTexture
#define SC_USE_UV_MIN_MAX_inputTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_inputTexture
#define SC_USE_CLAMP_TO_BORDER_inputTexture 0
#elif SC_USE_CLAMP_TO_BORDER_inputTexture==1
#undef SC_USE_CLAMP_TO_BORDER_inputTexture
#define SC_USE_CLAMP_TO_BORDER_inputTexture 1
#endif
#ifndef SC_USE_UV_TRANSFORM_maskTexture
#define SC_USE_UV_TRANSFORM_maskTexture 0
#elif SC_USE_UV_TRANSFORM_maskTexture==1
#undef SC_USE_UV_TRANSFORM_maskTexture
#define SC_USE_UV_TRANSFORM_maskTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_maskTexture
#define SC_SOFTWARE_WRAP_MODE_U_maskTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_maskTexture
#define SC_SOFTWARE_WRAP_MODE_V_maskTexture -1
#endif
constant int2 _2477=int2(SC_SOFTWARE_WRAP_MODE_U_maskTexture,SC_SOFTWARE_WRAP_MODE_V_maskTexture);
#ifndef SC_USE_UV_MIN_MAX_maskTexture
#define SC_USE_UV_MIN_MAX_maskTexture 0
#elif SC_USE_UV_MIN_MAX_maskTexture==1
#undef SC_USE_UV_MIN_MAX_maskTexture
#define SC_USE_UV_MIN_MAX_maskTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_maskTexture
#define SC_USE_CLAMP_TO_BORDER_maskTexture 0
#elif SC_USE_CLAMP_TO_BORDER_maskTexture==1
#undef SC_USE_CLAMP_TO_BORDER_maskTexture
#define SC_USE_CLAMP_TO_BORDER_maskTexture 1
#endif
#ifndef KERNEL_SIZE
#define KERNEL_SIZE 13
#endif
#ifndef BLUR_ESTIMATION_FIRST_PASS
#define BLUR_ESTIMATION_FIRST_PASS 0
#elif BLUR_ESTIMATION_FIRST_PASS==1
#undef BLUR_ESTIMATION_FIRST_PASS
#define BLUR_ESTIMATION_FIRST_PASS 1
#endif
#ifndef SC_USE_UV_TRANSFORM_originalTexture
#define SC_USE_UV_TRANSFORM_originalTexture 0
#elif SC_USE_UV_TRANSFORM_originalTexture==1
#undef SC_USE_UV_TRANSFORM_originalTexture
#define SC_USE_UV_TRANSFORM_originalTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_originalTexture
#define SC_SOFTWARE_WRAP_MODE_U_originalTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_originalTexture
#define SC_SOFTWARE_WRAP_MODE_V_originalTexture -1
#endif
constant int2 _2635=int2(SC_SOFTWARE_WRAP_MODE_U_originalTexture,SC_SOFTWARE_WRAP_MODE_V_originalTexture);
#ifndef SC_USE_UV_MIN_MAX_originalTexture
#define SC_USE_UV_MIN_MAX_originalTexture 0
#elif SC_USE_UV_MIN_MAX_originalTexture==1
#undef SC_USE_UV_MIN_MAX_originalTexture
#define SC_USE_UV_MIN_MAX_originalTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_originalTexture
#define SC_USE_CLAMP_TO_BORDER_originalTexture 0
#elif SC_USE_CLAMP_TO_BORDER_originalTexture==1
#undef SC_USE_CLAMP_TO_BORDER_originalTexture
#define SC_USE_CLAMP_TO_BORDER_originalTexture 1
#endif
#ifndef originalTextureUV
#define originalTextureUV 0
#endif
#ifndef inputTextureUV
#define inputTextureUV 0
#endif
#ifndef maskTextureUV
#define maskTextureUV 0
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float4 varPackedTex [[user(locn6)]];
};

float2 inputTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.inputTextureDims.xy;
}

int inputTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (inputTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float4 sampleInputTexture(thread const float2& uv,thread int& varStereoViewID,constant UserUniforms& userUniformsObj,thread texture2d<float> inputTexture,thread sampler inputTextureSmpSC)
{
float2 param=inputTextureGetDims2D(userUniformsObj);
int param_1=inputTextureLayout;
int param_2=inputTextureGetStereoViewIndex(varStereoViewID);
float2 param_3=uv;
bool param_4=(int(SC_USE_UV_TRANSFORM_inputTexture)!=0);
float3x3 param_5=userUniformsObj.inputTextureTransform;
int2 param_6=_2440;
bool param_7=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_8=userUniformsObj.inputTextureUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_10=userUniformsObj.inputTextureBorderColor;
float param_11=0.0;
float4 _2465=sc_SampleTextureBiasOrLevel(inputTexture,inputTextureSmpSC,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
float4 _2433=_2465;
float4 inputTextureSample=_2465;
return inputTextureSample;
}

float2 maskTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.maskTextureDims.xy;
}

int maskTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (maskTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float sampleMaskTexture(thread const float2& uv,thread int& varStereoViewID,constant UserUniforms& userUniformsObj,thread texture2d<float> maskTexture,thread sampler maskTextureSmpSC)
{
float2 param=maskTextureGetDims2D(userUniformsObj);
int param_1=maskTextureLayout;
int param_2=maskTextureGetStereoViewIndex(varStereoViewID);
float2 param_3=uv;
bool param_4=(int(SC_USE_UV_TRANSFORM_maskTexture)!=0);
float3x3 param_5=userUniformsObj.maskTextureTransform;
int2 param_6=_2477;
bool param_7=(int(SC_USE_UV_MIN_MAX_maskTexture)!=0);
float4 param_8=userUniformsObj.maskTextureUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_maskTexture)!=0);
float4 param_10=userUniformsObj.maskTextureBorderColor;
float param_11=0.0;
float4 _2501=sc_SampleTextureBiasOrLevel(maskTexture,maskTextureSmpSC,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
float4 _2470=_2501;
float4 maskTextureSample=_2501;
return maskTextureSample.x;
}

float2 originalTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.originalTextureDims.xy;
}

int originalTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (originalTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj,texture2d<float> inputTexture,texture2d<float> maskTexture,texture2d<float> originalTexture,sampler maskTextureSmpSC,sampler inputTextureSmpSC,sampler originalTextureSmpSC,float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float2 blurCoordinates[(KERNEL_SIZE/2)+1]={};
float2 param=blurCoordinates[0];
float4 blurredColor=sampleInputTexture(param,in.varStereoViewID,userUniformsObj,inputTexture,inputTextureSmpSC)*userUniformsObj.weight.x;
float2 param_1=blurCoordinates[1];
float2 param_2=blurCoordinates[2];
blurredColor+=((sampleInputTexture(param_1,in.varStereoViewID,userUniformsObj,inputTexture,inputTextureSmpSC)+sampleInputTexture(param_2,in.varStereoViewID,userUniformsObj,inputTexture,inputTextureSmpSC))*userUniformsObj.weight.y);
float2 param_3=blurCoordinates[3];
float2 param_4=blurCoordinates[4];
blurredColor+=((sampleInputTexture(param_3,in.varStereoViewID,userUniformsObj,inputTexture,inputTextureSmpSC)+sampleInputTexture(param_4,in.varStereoViewID,userUniformsObj,inputTexture,inputTextureSmpSC))*userUniformsObj.weight.z);
float2 param_5=blurCoordinates[5];
float2 param_6=blurCoordinates[6];
blurredColor+=((sampleInputTexture(param_5,in.varStereoViewID,userUniformsObj,inputTexture,inputTextureSmpSC)+sampleInputTexture(param_6,in.varStereoViewID,userUniformsObj,inputTexture,inputTextureSmpSC))*userUniformsObj.weight.w);
float2 param_7=blurCoordinates[0];
float blurredMask=userUniformsObj.weight.x*sampleMaskTexture(param_7,in.varStereoViewID,userUniformsObj,maskTexture,maskTextureSmpSC);
float2 param_8=blurCoordinates[1];
float2 param_9=blurCoordinates[2];
blurredMask+=(userUniformsObj.weight.y*(sampleMaskTexture(param_8,in.varStereoViewID,userUniformsObj,maskTexture,maskTextureSmpSC)+sampleMaskTexture(param_9,in.varStereoViewID,userUniformsObj,maskTexture,maskTextureSmpSC)));
float2 param_10=blurCoordinates[3];
float2 param_11=blurCoordinates[4];
blurredMask+=(userUniformsObj.weight.z*(sampleMaskTexture(param_10,in.varStereoViewID,userUniformsObj,maskTexture,maskTextureSmpSC)+sampleMaskTexture(param_11,in.varStereoViewID,userUniformsObj,maskTexture,maskTextureSmpSC)));
float2 param_12=blurCoordinates[5];
float2 param_13=blurCoordinates[6];
blurredMask+=(userUniformsObj.weight.w*(sampleMaskTexture(param_12,in.varStereoViewID,userUniformsObj,maskTexture,maskTextureSmpSC)+sampleMaskTexture(param_13,in.varStereoViewID,userUniformsObj,maskTexture,maskTextureSmpSC)));
#if (BLUR_ESTIMATION_FIRST_PASS)
{
float4 param_14=blurredColor;
sc_writeFragData0(param_14,FragColor);
float4 param_15=float4(blurredMask);
sc_writeFragData1(param_15,FragColor);
}
#else
{
float2 param_16=originalTextureGetDims2D(userUniformsObj);
int param_17=originalTextureLayout;
int param_18=originalTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_19=in.varPackedTex.xy;
bool param_20=(int(SC_USE_UV_TRANSFORM_originalTexture)!=0);
float3x3 param_21=userUniformsObj.originalTextureTransform;
int2 param_22=_2635;
bool param_23=(int(SC_USE_UV_MIN_MAX_originalTexture)!=0);
float4 param_24=userUniformsObj.originalTextureUvMinMax;
bool param_25=(int(SC_USE_CLAMP_TO_BORDER_originalTexture)!=0);
float4 param_26=userUniformsObj.originalTextureBorderColor;
float param_27=0.0;
float4 _2658=sc_SampleTextureBiasOrLevel(originalTexture,originalTextureSmpSC,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23,param_24,param_25,param_26,param_27);
float4 _2628=_2658;
float4 originalTextureSample=_2658;
float4 param_28=mix(originalTextureSample,blurredColor,float4(blurredMask));
sc_writeFragData0(param_28,FragColor);
}
#endif
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
