#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include "std2.metal"
#include "std2_vs.metal"
#include "std2_fs.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN(100)
//ubo float UserUniforms 0:35568:192 {
//float4 patchTextureSize 0
//float4 patchTextureDims 16
//float4 patchTextureView 32
//float3x3 patchTextureTransform 48
//float4 patchTextureUvMinMax 96
//float4 patchTextureBorderColor 112
//float4x4 modelView 128
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 patchTextureSize;
float4 patchTextureDims;
float4 patchTextureView;
float3x3 patchTextureTransform;
float4 patchTextureUvMinMax;
float4 patchTextureBorderColor;
float4x4 modelView;
};

#ifndef patchTextureHasSwappedViews
#define patchTextureHasSwappedViews 0
#elif patchTextureHasSwappedViews==1
#undef patchTextureHasSwappedViews
#define patchTextureHasSwappedViews 1
#endif
#ifndef patchTextureLayout
#define patchTextureLayout 0
#endif
#ifndef patchTextureUV
#define patchTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_patchTexture
#define SC_USE_UV_TRANSFORM_patchTexture 0
#elif SC_USE_UV_TRANSFORM_patchTexture==1
#undef SC_USE_UV_TRANSFORM_patchTexture
#define SC_USE_UV_TRANSFORM_patchTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_patchTexture
#define SC_SOFTWARE_WRAP_MODE_U_patchTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_patchTexture
#define SC_SOFTWARE_WRAP_MODE_V_patchTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_patchTexture
#define SC_USE_UV_MIN_MAX_patchTexture 0
#elif SC_USE_UV_MIN_MAX_patchTexture==1
#undef SC_USE_UV_MIN_MAX_patchTexture
#define SC_USE_UV_MIN_MAX_patchTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_patchTexture
#define SC_USE_CLAMP_TO_BORDER_patchTexture 0
#elif SC_USE_CLAMP_TO_BORDER_patchTexture==1
#undef SC_USE_CLAMP_TO_BORDER_patchTexture
#define SC_USE_CLAMP_TO_BORDER_patchTexture 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant UserUniforms& userUniformsObj,constant LibraryUniforms& libraryUniformsObj,uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
v.position=userUniformsObj.modelView*v.position;
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN(100)
//sampler sampler patchTextureSmpSC 0:34097
//texture texture2D patchTexture 0:61578:0:34097
//ubo float UserUniforms 0:35568:192 {
//float4 patchTextureSize 0
//float4 patchTextureDims 16
//float4 patchTextureView 32
//float3x3 patchTextureTransform 48
//float4 patchTextureUvMinMax 96
//float4 patchTextureBorderColor 112
//float4x4 modelView 128
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 patchTextureSize;
float4 patchTextureDims;
float4 patchTextureView;
float3x3 patchTextureTransform;
float4 patchTextureUvMinMax;
float4 patchTextureBorderColor;
float4x4 modelView;
};

#ifndef patchTextureHasSwappedViews
#define patchTextureHasSwappedViews 0
#elif patchTextureHasSwappedViews==1
#undef patchTextureHasSwappedViews
#define patchTextureHasSwappedViews 1
#endif
#ifndef patchTextureLayout
#define patchTextureLayout 0
#endif
#ifndef SC_USE_UV_TRANSFORM_patchTexture
#define SC_USE_UV_TRANSFORM_patchTexture 0
#elif SC_USE_UV_TRANSFORM_patchTexture==1
#undef SC_USE_UV_TRANSFORM_patchTexture
#define SC_USE_UV_TRANSFORM_patchTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_patchTexture
#define SC_SOFTWARE_WRAP_MODE_U_patchTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_patchTexture
#define SC_SOFTWARE_WRAP_MODE_V_patchTexture -1
#endif
constant int2 _2147=int2(SC_SOFTWARE_WRAP_MODE_U_patchTexture,SC_SOFTWARE_WRAP_MODE_V_patchTexture);
#ifndef SC_USE_UV_MIN_MAX_patchTexture
#define SC_USE_UV_MIN_MAX_patchTexture 0
#elif SC_USE_UV_MIN_MAX_patchTexture==1
#undef SC_USE_UV_MIN_MAX_patchTexture
#define SC_USE_UV_MIN_MAX_patchTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_patchTexture
#define SC_USE_CLAMP_TO_BORDER_patchTexture 0
#elif SC_USE_CLAMP_TO_BORDER_patchTexture==1
#undef SC_USE_CLAMP_TO_BORDER_patchTexture
#define SC_USE_CLAMP_TO_BORDER_patchTexture 1
#endif
#ifndef patchTextureUV
#define patchTextureUV 0
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float4 varPackedTex [[user(locn6)]];
};

float2 patchTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.patchTextureDims.xy;
}

int patchTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (patchTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj,texture2d<float> patchTexture,sampler patchTextureSmpSC,float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float2 param=patchTextureGetDims2D(userUniformsObj);
int param_1=patchTextureLayout;
int param_2=patchTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_3=in.varPackedTex.xy;
bool param_4=(int(SC_USE_UV_TRANSFORM_patchTexture)!=0);
float3x3 param_5=userUniformsObj.patchTextureTransform;
int2 param_6=_2147;
bool param_7=(int(SC_USE_UV_MIN_MAX_patchTexture)!=0);
float4 param_8=userUniformsObj.patchTextureUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_patchTexture)!=0);
float4 param_10=userUniformsObj.patchTextureBorderColor;
float param_11=0.0;
float4 _2173=sc_SampleTextureBiasOrLevel(patchTexture,patchTextureSmpSC,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
float4 _2140=_2173;
float4 patchTextureSample=_2173;
float4 param_12=float4(patchTextureSample.xyz,1.0);
sc_writeFragData0(param_12,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
