#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1

#include "std2.metal"
#include "std2_vs.metal"
#include "std2_fs.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN(100)
//SG_REFLECTION_END


struct UserUniforms
{
float4 bgTextureSize;
float4 bgTextureDims;
float4 bgTextureView;
float3x3 bgTextureTransform;
float4 bgTextureUvMinMax;
float4 bgTextureBorderColor;
float4 bgTextureAlphaSize;
float4 bgTextureAlphaDims;
float4 bgTextureAlphaView;
float3x3 bgTextureAlphaTransform;
float4 bgTextureAlphaUvMinMax;
float4 bgTextureAlphaBorderColor;
float4 bgColor;
};

#ifndef bgTextureHasSwappedViews
#define bgTextureHasSwappedViews 0
#elif bgTextureHasSwappedViews==1
#undef bgTextureHasSwappedViews
#define bgTextureHasSwappedViews 1
#endif
#ifndef bgTextureLayout
#define bgTextureLayout 0
#endif
#ifndef bgTextureAlphaHasSwappedViews
#define bgTextureAlphaHasSwappedViews 0
#elif bgTextureAlphaHasSwappedViews==1
#undef bgTextureAlphaHasSwappedViews
#define bgTextureAlphaHasSwappedViews 1
#endif
#ifndef bgTextureAlphaLayout
#define bgTextureAlphaLayout 0
#endif
#ifndef ALPHA_EXISTS
#define ALPHA_EXISTS 0
#elif ALPHA_EXISTS==1
#undef ALPHA_EXISTS
#define ALPHA_EXISTS 1
#endif
#ifndef TEXTURE_EXISTS
#define TEXTURE_EXISTS 0
#elif TEXTURE_EXISTS==1
#undef TEXTURE_EXISTS
#define TEXTURE_EXISTS 1
#endif
#ifndef bgTextureUV
#define bgTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_bgTexture
#define SC_USE_UV_TRANSFORM_bgTexture 0
#elif SC_USE_UV_TRANSFORM_bgTexture==1
#undef SC_USE_UV_TRANSFORM_bgTexture
#define SC_USE_UV_TRANSFORM_bgTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_bgTexture
#define SC_SOFTWARE_WRAP_MODE_U_bgTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_bgTexture
#define SC_SOFTWARE_WRAP_MODE_V_bgTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_bgTexture
#define SC_USE_UV_MIN_MAX_bgTexture 0
#elif SC_USE_UV_MIN_MAX_bgTexture==1
#undef SC_USE_UV_MIN_MAX_bgTexture
#define SC_USE_UV_MIN_MAX_bgTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_bgTexture
#define SC_USE_CLAMP_TO_BORDER_bgTexture 0
#elif SC_USE_CLAMP_TO_BORDER_bgTexture==1
#undef SC_USE_CLAMP_TO_BORDER_bgTexture
#define SC_USE_CLAMP_TO_BORDER_bgTexture 1
#endif
#ifndef bgTextureAlphaUV
#define bgTextureAlphaUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_bgTextureAlpha
#define SC_USE_UV_TRANSFORM_bgTextureAlpha 0
#elif SC_USE_UV_TRANSFORM_bgTextureAlpha==1
#undef SC_USE_UV_TRANSFORM_bgTextureAlpha
#define SC_USE_UV_TRANSFORM_bgTextureAlpha 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_bgTextureAlpha
#define SC_SOFTWARE_WRAP_MODE_U_bgTextureAlpha -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_bgTextureAlpha
#define SC_SOFTWARE_WRAP_MODE_V_bgTextureAlpha -1
#endif
#ifndef SC_USE_UV_MIN_MAX_bgTextureAlpha
#define SC_USE_UV_MIN_MAX_bgTextureAlpha 0
#elif SC_USE_UV_MIN_MAX_bgTextureAlpha==1
#undef SC_USE_UV_MIN_MAX_bgTextureAlpha
#define SC_USE_UV_MIN_MAX_bgTextureAlpha 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_bgTextureAlpha
#define SC_USE_CLAMP_TO_BORDER_bgTextureAlpha 0
#elif SC_USE_CLAMP_TO_BORDER_bgTextureAlpha==1
#undef SC_USE_CLAMP_TO_BORDER_bgTextureAlpha
#define SC_USE_CLAMP_TO_BORDER_bgTextureAlpha 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant LibraryUniforms& libraryUniformsObj,uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN(100)
//sampler sampler bgTextureSmpSC 0:47832
//sampler sampler bgTextureAlphaSmpSC 0:56829
//texture texture2D bgTexture 0:55806:0:47832
//texture texture2D bgTextureAlpha 0:49398:0:56829
//ubo float UserUniforms 0:35568:272 {
//float4 bgTextureSize 0
//float4 bgTextureDims 16
//float4 bgTextureView 32
//float3x3 bgTextureTransform 48
//float4 bgTextureUvMinMax 96
//float4 bgTextureBorderColor 112
//float4 bgTextureAlphaSize 128
//float4 bgTextureAlphaDims 144
//float4 bgTextureAlphaView 160
//float3x3 bgTextureAlphaTransform 176
//float4 bgTextureAlphaUvMinMax 224
//float4 bgTextureAlphaBorderColor 240
//float4 bgColor 256
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 bgTextureSize;
float4 bgTextureDims;
float4 bgTextureView;
float3x3 bgTextureTransform;
float4 bgTextureUvMinMax;
float4 bgTextureBorderColor;
float4 bgTextureAlphaSize;
float4 bgTextureAlphaDims;
float4 bgTextureAlphaView;
float3x3 bgTextureAlphaTransform;
float4 bgTextureAlphaUvMinMax;
float4 bgTextureAlphaBorderColor;
float4 bgColor;
};

#ifndef bgTextureHasSwappedViews
#define bgTextureHasSwappedViews 0
#elif bgTextureHasSwappedViews==1
#undef bgTextureHasSwappedViews
#define bgTextureHasSwappedViews 1
#endif
#ifndef bgTextureLayout
#define bgTextureLayout 0
#endif
#ifndef bgTextureAlphaHasSwappedViews
#define bgTextureAlphaHasSwappedViews 0
#elif bgTextureAlphaHasSwappedViews==1
#undef bgTextureAlphaHasSwappedViews
#define bgTextureAlphaHasSwappedViews 1
#endif
#ifndef bgTextureAlphaLayout
#define bgTextureAlphaLayout 0
#endif
#ifndef ALPHA_EXISTS
#define ALPHA_EXISTS 0
#elif ALPHA_EXISTS==1
#undef ALPHA_EXISTS
#define ALPHA_EXISTS 1
#endif
#ifndef SC_USE_UV_TRANSFORM_bgTextureAlpha
#define SC_USE_UV_TRANSFORM_bgTextureAlpha 0
#elif SC_USE_UV_TRANSFORM_bgTextureAlpha==1
#undef SC_USE_UV_TRANSFORM_bgTextureAlpha
#define SC_USE_UV_TRANSFORM_bgTextureAlpha 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_bgTextureAlpha
#define SC_SOFTWARE_WRAP_MODE_U_bgTextureAlpha -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_bgTextureAlpha
#define SC_SOFTWARE_WRAP_MODE_V_bgTextureAlpha -1
#endif
constant int2 _2294=int2(SC_SOFTWARE_WRAP_MODE_U_bgTextureAlpha,SC_SOFTWARE_WRAP_MODE_V_bgTextureAlpha);
#ifndef SC_USE_UV_MIN_MAX_bgTextureAlpha
#define SC_USE_UV_MIN_MAX_bgTextureAlpha 0
#elif SC_USE_UV_MIN_MAX_bgTextureAlpha==1
#undef SC_USE_UV_MIN_MAX_bgTextureAlpha
#define SC_USE_UV_MIN_MAX_bgTextureAlpha 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_bgTextureAlpha
#define SC_USE_CLAMP_TO_BORDER_bgTextureAlpha 0
#elif SC_USE_CLAMP_TO_BORDER_bgTextureAlpha==1
#undef SC_USE_CLAMP_TO_BORDER_bgTextureAlpha
#define SC_USE_CLAMP_TO_BORDER_bgTextureAlpha 1
#endif
#ifndef TEXTURE_EXISTS
#define TEXTURE_EXISTS 0
#elif TEXTURE_EXISTS==1
#undef TEXTURE_EXISTS
#define TEXTURE_EXISTS 1
#endif
#ifndef SC_USE_UV_TRANSFORM_bgTexture
#define SC_USE_UV_TRANSFORM_bgTexture 0
#elif SC_USE_UV_TRANSFORM_bgTexture==1
#undef SC_USE_UV_TRANSFORM_bgTexture
#define SC_USE_UV_TRANSFORM_bgTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_bgTexture
#define SC_SOFTWARE_WRAP_MODE_U_bgTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_bgTexture
#define SC_SOFTWARE_WRAP_MODE_V_bgTexture -1
#endif
constant int2 _2333=int2(SC_SOFTWARE_WRAP_MODE_U_bgTexture,SC_SOFTWARE_WRAP_MODE_V_bgTexture);
#ifndef SC_USE_UV_MIN_MAX_bgTexture
#define SC_USE_UV_MIN_MAX_bgTexture 0
#elif SC_USE_UV_MIN_MAX_bgTexture==1
#undef SC_USE_UV_MIN_MAX_bgTexture
#define SC_USE_UV_MIN_MAX_bgTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_bgTexture
#define SC_USE_CLAMP_TO_BORDER_bgTexture 0
#elif SC_USE_CLAMP_TO_BORDER_bgTexture==1
#undef SC_USE_CLAMP_TO_BORDER_bgTexture
#define SC_USE_CLAMP_TO_BORDER_bgTexture 1
#endif
#ifndef bgTextureUV
#define bgTextureUV 0
#endif
#ifndef bgTextureAlphaUV
#define bgTextureAlphaUV 0
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float4 varPackedTex [[user(locn6)]];
};

float2 bgTextureAlphaGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.bgTextureAlphaDims.xy;
}

int bgTextureAlphaGetStereoViewIndex(thread int& varStereoViewID)
{
#if (bgTextureAlphaHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 bgTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.bgTextureDims.xy;
}

int bgTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (bgTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj,texture2d<float> bgTextureAlpha,texture2d<float> bgTexture,sampler bgTextureSmpSC,sampler bgTextureAlphaSmpSC,float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float alpha=1.0;
#if (ALPHA_EXISTS)
{
float2 param=bgTextureAlphaGetDims2D(userUniformsObj);
int param_1=bgTextureAlphaLayout;
int param_2=bgTextureAlphaGetStereoViewIndex(in.varStereoViewID);
float2 param_3=in.varPackedTex.zw;
bool param_4=(int(SC_USE_UV_TRANSFORM_bgTextureAlpha)!=0);
float3x3 param_5=userUniformsObj.bgTextureAlphaTransform;
int2 param_6=_2294;
bool param_7=(int(SC_USE_UV_MIN_MAX_bgTextureAlpha)!=0);
float4 param_8=userUniformsObj.bgTextureAlphaUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_bgTextureAlpha)!=0);
float4 param_10=userUniformsObj.bgTextureAlphaBorderColor;
float param_11=0.0;
float4 _2320=sc_SampleTextureBiasOrLevel(bgTextureAlpha,bgTextureAlphaSmpSC,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
float4 _2286=_2320;
alpha=_2320.x;
}
#endif
float4 _2324;
#if (TEXTURE_EXISTS)
{
float2 param_12=bgTextureGetDims2D(userUniformsObj);
int param_13=bgTextureLayout;
int param_14=bgTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_15=in.varPackedTex.xy;
bool param_16=(int(SC_USE_UV_TRANSFORM_bgTexture)!=0);
float3x3 param_17=userUniformsObj.bgTextureTransform;
int2 param_18=_2333;
bool param_19=(int(SC_USE_UV_MIN_MAX_bgTexture)!=0);
float4 param_20=userUniformsObj.bgTextureUvMinMax;
bool param_21=(int(SC_USE_CLAMP_TO_BORDER_bgTexture)!=0);
float4 param_22=userUniformsObj.bgTextureBorderColor;
float param_23=0.0;
float4 _2358=sc_SampleTextureBiasOrLevel(bgTexture,bgTextureSmpSC,param_12,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23);
float4 _2327=_2358;
_2324=float4(_2358.xyz,alpha);
}
#else
{
_2324=userUniformsObj.bgColor;
}
#endif
float4 result=_2324;
float4 param_24=result;
sc_writeFragData0(param_24,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
