#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include "std2.metal"
#include "std2_vs.metal"
#include "std2_fs.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN(100)
//SG_REFLECTION_END


struct UserUniforms
{
float4 bgTextureSize;
float4 bgTextureDims;
float4 bgTextureView;
float3x3 bgTextureTransform;
float4 bgTextureUvMinMax;
float4 bgTextureBorderColor;
float4 lutTextureSize;
float4 lutTextureDims;
float4 lutTextureView;
float3x3 lutTextureTransform;
float4 lutTextureUvMinMax;
float4 lutTextureBorderColor;
float opacity;
};

#ifndef bgTextureHasSwappedViews
#define bgTextureHasSwappedViews 0
#elif bgTextureHasSwappedViews==1
#undef bgTextureHasSwappedViews
#define bgTextureHasSwappedViews 1
#endif
#ifndef bgTextureLayout
#define bgTextureLayout 0
#endif
#ifndef lutTextureHasSwappedViews
#define lutTextureHasSwappedViews 0
#elif lutTextureHasSwappedViews==1
#undef lutTextureHasSwappedViews
#define lutTextureHasSwappedViews 1
#endif
#ifndef lutTextureLayout
#define lutTextureLayout 0
#endif
#ifndef LINEAR_LUT
#define LINEAR_LUT 0
#elif LINEAR_LUT==1
#undef LINEAR_LUT
#define LINEAR_LUT 1
#endif
#ifndef bgTextureUV
#define bgTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_bgTexture
#define SC_USE_UV_TRANSFORM_bgTexture 0
#elif SC_USE_UV_TRANSFORM_bgTexture==1
#undef SC_USE_UV_TRANSFORM_bgTexture
#define SC_USE_UV_TRANSFORM_bgTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_bgTexture
#define SC_SOFTWARE_WRAP_MODE_U_bgTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_bgTexture
#define SC_SOFTWARE_WRAP_MODE_V_bgTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_bgTexture
#define SC_USE_UV_MIN_MAX_bgTexture 0
#elif SC_USE_UV_MIN_MAX_bgTexture==1
#undef SC_USE_UV_MIN_MAX_bgTexture
#define SC_USE_UV_MIN_MAX_bgTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_bgTexture
#define SC_USE_CLAMP_TO_BORDER_bgTexture 0
#elif SC_USE_CLAMP_TO_BORDER_bgTexture==1
#undef SC_USE_CLAMP_TO_BORDER_bgTexture
#define SC_USE_CLAMP_TO_BORDER_bgTexture 1
#endif
#ifndef lutTextureUV
#define lutTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_lutTexture
#define SC_USE_UV_TRANSFORM_lutTexture 0
#elif SC_USE_UV_TRANSFORM_lutTexture==1
#undef SC_USE_UV_TRANSFORM_lutTexture
#define SC_USE_UV_TRANSFORM_lutTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_lutTexture
#define SC_SOFTWARE_WRAP_MODE_U_lutTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_lutTexture
#define SC_SOFTWARE_WRAP_MODE_V_lutTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_lutTexture
#define SC_USE_UV_MIN_MAX_lutTexture 0
#elif SC_USE_UV_MIN_MAX_lutTexture==1
#undef SC_USE_UV_MIN_MAX_lutTexture
#define SC_USE_UV_MIN_MAX_lutTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_lutTexture
#define SC_USE_CLAMP_TO_BORDER_lutTexture 0
#elif SC_USE_CLAMP_TO_BORDER_lutTexture==1
#undef SC_USE_CLAMP_TO_BORDER_lutTexture
#define SC_USE_CLAMP_TO_BORDER_lutTexture 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant LibraryUniforms& libraryUniformsObj,uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN(100)
//sampler sampler bgTextureSmpSC 0:47832
//sampler sampler lutTextureSmpSC 0:52718
//texture texture2D bgTexture 0:55806:0:47832
//texture texture2D lutTexture 0:47955:0:52718
//ubo float UserUniforms 0:35568:260 {
//float4 bgTextureSize 0
//float4 bgTextureDims 16
//float4 bgTextureView 32
//float3x3 bgTextureTransform 48
//float4 bgTextureUvMinMax 96
//float4 bgTextureBorderColor 112
//float4 lutTextureSize 128
//float4 lutTextureDims 144
//float4 lutTextureView 160
//float3x3 lutTextureTransform 176
//float4 lutTextureUvMinMax 224
//float4 lutTextureBorderColor 240
//float opacity 256
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 bgTextureSize;
float4 bgTextureDims;
float4 bgTextureView;
float3x3 bgTextureTransform;
float4 bgTextureUvMinMax;
float4 bgTextureBorderColor;
float4 lutTextureSize;
float4 lutTextureDims;
float4 lutTextureView;
float3x3 lutTextureTransform;
float4 lutTextureUvMinMax;
float4 lutTextureBorderColor;
float opacity;
};

#ifndef bgTextureHasSwappedViews
#define bgTextureHasSwappedViews 0
#elif bgTextureHasSwappedViews==1
#undef bgTextureHasSwappedViews
#define bgTextureHasSwappedViews 1
#endif
#ifndef bgTextureLayout
#define bgTextureLayout 0
#endif
#ifndef lutTextureHasSwappedViews
#define lutTextureHasSwappedViews 0
#elif lutTextureHasSwappedViews==1
#undef lutTextureHasSwappedViews
#define lutTextureHasSwappedViews 1
#endif
#ifndef lutTextureLayout
#define lutTextureLayout 0
#endif
#ifndef LINEAR_LUT
#define LINEAR_LUT 0
#elif LINEAR_LUT==1
#undef LINEAR_LUT
#define LINEAR_LUT 1
#endif
#ifndef SC_USE_UV_TRANSFORM_lutTexture
#define SC_USE_UV_TRANSFORM_lutTexture 0
#elif SC_USE_UV_TRANSFORM_lutTexture==1
#undef SC_USE_UV_TRANSFORM_lutTexture
#define SC_USE_UV_TRANSFORM_lutTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_lutTexture
#define SC_SOFTWARE_WRAP_MODE_U_lutTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_lutTexture
#define SC_SOFTWARE_WRAP_MODE_V_lutTexture -1
#endif
constant int2 _2299=int2(SC_SOFTWARE_WRAP_MODE_U_lutTexture,SC_SOFTWARE_WRAP_MODE_V_lutTexture);
#ifndef SC_USE_UV_MIN_MAX_lutTexture
#define SC_USE_UV_MIN_MAX_lutTexture 0
#elif SC_USE_UV_MIN_MAX_lutTexture==1
#undef SC_USE_UV_MIN_MAX_lutTexture
#define SC_USE_UV_MIN_MAX_lutTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_lutTexture
#define SC_USE_CLAMP_TO_BORDER_lutTexture 0
#elif SC_USE_CLAMP_TO_BORDER_lutTexture==1
#undef SC_USE_CLAMP_TO_BORDER_lutTexture
#define SC_USE_CLAMP_TO_BORDER_lutTexture 1
#endif
constant int2 _2332=int2(SC_SOFTWARE_WRAP_MODE_U_lutTexture,SC_SOFTWARE_WRAP_MODE_V_lutTexture);
constant int2 _2360=int2(SC_SOFTWARE_WRAP_MODE_U_lutTexture,SC_SOFTWARE_WRAP_MODE_V_lutTexture);
constant int2 _2462=int2(SC_SOFTWARE_WRAP_MODE_U_lutTexture,SC_SOFTWARE_WRAP_MODE_V_lutTexture);
constant int2 _2487=int2(SC_SOFTWARE_WRAP_MODE_U_lutTexture,SC_SOFTWARE_WRAP_MODE_V_lutTexture);
#ifndef SC_USE_UV_TRANSFORM_bgTexture
#define SC_USE_UV_TRANSFORM_bgTexture 0
#elif SC_USE_UV_TRANSFORM_bgTexture==1
#undef SC_USE_UV_TRANSFORM_bgTexture
#define SC_USE_UV_TRANSFORM_bgTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_bgTexture
#define SC_SOFTWARE_WRAP_MODE_U_bgTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_bgTexture
#define SC_SOFTWARE_WRAP_MODE_V_bgTexture -1
#endif
constant int2 _2526=int2(SC_SOFTWARE_WRAP_MODE_U_bgTexture,SC_SOFTWARE_WRAP_MODE_V_bgTexture);
#ifndef SC_USE_UV_MIN_MAX_bgTexture
#define SC_USE_UV_MIN_MAX_bgTexture 0
#elif SC_USE_UV_MIN_MAX_bgTexture==1
#undef SC_USE_UV_MIN_MAX_bgTexture
#define SC_USE_UV_MIN_MAX_bgTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_bgTexture
#define SC_USE_CLAMP_TO_BORDER_bgTexture 0
#elif SC_USE_CLAMP_TO_BORDER_bgTexture==1
#undef SC_USE_CLAMP_TO_BORDER_bgTexture
#define SC_USE_CLAMP_TO_BORDER_bgTexture 1
#endif
#ifndef bgTextureUV
#define bgTextureUV 0
#endif
#ifndef lutTextureUV
#define lutTextureUV 0
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float4 varPackedTex [[user(locn6)]];
};

float2 bgTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.bgTextureDims.xy;
}

int bgTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (bgTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 lutTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.lutTextureDims.xy;
}

int lutTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (lutTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float4 lookup(thread const float4& textureColor,thread int& varStereoViewID,constant UserUniforms& userUniformsObj,thread texture2d<float> lutTexture,thread sampler lutTextureSmpSC)
{
float4 newColor;
#if (LINEAR_LUT)
{
float2 param=lutTextureGetDims2D(userUniformsObj);
int param_1=lutTextureLayout;
int param_2=lutTextureGetStereoViewIndex(varStereoViewID);
float2 param_3=float2(textureColor.z,0.5);
bool param_4=(int(SC_USE_UV_TRANSFORM_lutTexture)!=0);
float3x3 param_5=userUniformsObj.lutTextureTransform;
int2 param_6=_2299;
bool param_7=(int(SC_USE_UV_MIN_MAX_lutTexture)!=0);
float4 param_8=userUniformsObj.lutTextureUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_lutTexture)!=0);
float4 param_10=userUniformsObj.lutTextureBorderColor;
float param_11=0.0;
float4 _2323=sc_SampleTextureBiasOrLevel(lutTexture,lutTextureSmpSC,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
float4 _2289=_2323;
newColor.x=_2323.x;
float2 param_12=lutTextureGetDims2D(userUniformsObj);
int param_13=lutTextureLayout;
int param_14=lutTextureGetStereoViewIndex(varStereoViewID);
float2 param_15=float2(textureColor.y,0.5);
bool param_16=(int(SC_USE_UV_TRANSFORM_lutTexture)!=0);
float3x3 param_17=userUniformsObj.lutTextureTransform;
int2 param_18=_2332;
bool param_19=(int(SC_USE_UV_MIN_MAX_lutTexture)!=0);
float4 param_20=userUniformsObj.lutTextureUvMinMax;
bool param_21=(int(SC_USE_CLAMP_TO_BORDER_lutTexture)!=0);
float4 param_22=userUniformsObj.lutTextureBorderColor;
float param_23=0.0;
float4 _2351=sc_SampleTextureBiasOrLevel(lutTexture,lutTextureSmpSC,param_12,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23);
float4 _2326=_2351;
newColor.y=_2351.y;
float2 param_24=lutTextureGetDims2D(userUniformsObj);
int param_25=lutTextureLayout;
int param_26=lutTextureGetStereoViewIndex(varStereoViewID);
float2 param_27=float2(textureColor.x,0.5);
bool param_28=(int(SC_USE_UV_TRANSFORM_lutTexture)!=0);
float3x3 param_29=userUniformsObj.lutTextureTransform;
int2 param_30=_2360;
bool param_31=(int(SC_USE_UV_MIN_MAX_lutTexture)!=0);
float4 param_32=userUniformsObj.lutTextureUvMinMax;
bool param_33=(int(SC_USE_CLAMP_TO_BORDER_lutTexture)!=0);
float4 param_34=userUniformsObj.lutTextureBorderColor;
float param_35=0.0;
float4 _2379=sc_SampleTextureBiasOrLevel(lutTexture,lutTextureSmpSC,param_24,param_25,param_26,param_27,param_28,param_29,param_30,param_31,param_32,param_33,param_34,param_35);
float4 _2354=_2379;
newColor.z=_2379.z;
}
#else
{
float blueColor=textureColor.z*63.0;
float2 quad1;
quad1.y=floor(floor(blueColor)/8.0);
quad1.x=floor(blueColor)-(quad1.y*8.0);
float2 quad2;
quad2.y=floor(ceil(blueColor)/8.0);
quad2.x=ceil(blueColor)-(quad2.y*8.0);
float2 texPos1;
texPos1.x=((quad1.x*0.125)+0.000976562)+(0.123047*textureColor.x);
texPos1.y=((1.0-(quad1.y*0.125))-0.000976562)-(0.123047*textureColor.y);
float2 texPos2;
texPos2.x=((quad2.x*0.125)+0.000976562)+(0.123047*textureColor.x);
texPos2.y=((1.0-(quad2.y*0.125))-0.000976562)-(0.123047*textureColor.y);
float2 param_36=lutTextureGetDims2D(userUniformsObj);
int param_37=lutTextureLayout;
int param_38=lutTextureGetStereoViewIndex(varStereoViewID);
float2 param_39=texPos1;
bool param_40=(int(SC_USE_UV_TRANSFORM_lutTexture)!=0);
float3x3 param_41=userUniformsObj.lutTextureTransform;
int2 param_42=_2462;
bool param_43=(int(SC_USE_UV_MIN_MAX_lutTexture)!=0);
float4 param_44=userUniformsObj.lutTextureUvMinMax;
bool param_45=(int(SC_USE_CLAMP_TO_BORDER_lutTexture)!=0);
float4 param_46=userUniformsObj.lutTextureBorderColor;
float param_47=0.0;
float4 _2482=sc_SampleTextureBiasOrLevel(lutTexture,lutTextureSmpSC,param_36,param_37,param_38,param_39,param_40,param_41,param_42,param_43,param_44,param_45,param_46,param_47);
float4 _2459=_2482;
float4 newColor1=_2482;
float2 param_48=lutTextureGetDims2D(userUniformsObj);
int param_49=lutTextureLayout;
int param_50=lutTextureGetStereoViewIndex(varStereoViewID);
float2 param_51=texPos2;
bool param_52=(int(SC_USE_UV_TRANSFORM_lutTexture)!=0);
float3x3 param_53=userUniformsObj.lutTextureTransform;
int2 param_54=_2487;
bool param_55=(int(SC_USE_UV_MIN_MAX_lutTexture)!=0);
float4 param_56=userUniformsObj.lutTextureUvMinMax;
bool param_57=(int(SC_USE_CLAMP_TO_BORDER_lutTexture)!=0);
float4 param_58=userUniformsObj.lutTextureBorderColor;
float param_59=0.0;
float4 _2507=sc_SampleTextureBiasOrLevel(lutTexture,lutTextureSmpSC,param_48,param_49,param_50,param_51,param_52,param_53,param_54,param_55,param_56,param_57,param_58,param_59);
float4 _2484=_2507;
float4 newColor2=_2507;
float4 newColor_1=mix(newColor1,newColor2,float4(fract(blueColor)));
}
#endif
return newColor;
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj,texture2d<float> lutTexture,texture2d<float> bgTexture,sampler bgTextureSmpSC,sampler lutTextureSmpSC,float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float2 param=bgTextureGetDims2D(userUniformsObj);
int param_1=bgTextureLayout;
int param_2=bgTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_3=in.varPackedTex.xy;
bool param_4=(int(SC_USE_UV_TRANSFORM_bgTexture)!=0);
float3x3 param_5=userUniformsObj.bgTextureTransform;
int2 param_6=_2526;
bool param_7=(int(SC_USE_UV_MIN_MAX_bgTexture)!=0);
float4 param_8=userUniformsObj.bgTextureUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_bgTexture)!=0);
float4 param_10=userUniformsObj.bgTextureBorderColor;
float param_11=0.0;
float4 _2551=sc_SampleTextureBiasOrLevel(bgTexture,bgTextureSmpSC,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
float4 _2519=_2551;
float4 param_12=_2551;
float3 color=lookup(param_12,in.varStereoViewID,userUniformsObj,lutTexture,lutTextureSmpSC).xyz;
float4 param_13=float4(color,userUniformsObj.opacity);
sc_writeFragData0(param_13,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
