#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1

#include "std2.metal"
#include "std2_vs.metal"
#include "std2_fs.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN(100)
//attribute vec2 texture2 15
//SG_REFLECTION_END


struct UserUniforms
{
float4 fgTextureSize;
float4 fgTextureDims;
float4 fgTextureView;
float3x3 fgTextureTransform;
float4 fgTextureUvMinMax;
float4 fgTextureBorderColor;
float4 fgAlphaTextureSize;
float4 fgAlphaTextureDims;
float4 fgAlphaTextureView;
float3x3 fgAlphaTextureTransform;
float4 fgAlphaTextureUvMinMax;
float4 fgAlphaTextureBorderColor;
float4 bgTextureSize;
float4 bgTextureDims;
float4 bgTextureView;
float3x3 bgTextureTransform;
float4 bgTextureUvMinMax;
float4 bgTextureBorderColor;
float opacity;
};

#ifndef fgTextureHasSwappedViews
#define fgTextureHasSwappedViews 0
#elif fgTextureHasSwappedViews==1
#undef fgTextureHasSwappedViews
#define fgTextureHasSwappedViews 1
#endif
#ifndef fgTextureLayout
#define fgTextureLayout 0
#endif
#ifndef fgAlphaTextureHasSwappedViews
#define fgAlphaTextureHasSwappedViews 0
#elif fgAlphaTextureHasSwappedViews==1
#undef fgAlphaTextureHasSwappedViews
#define fgAlphaTextureHasSwappedViews 1
#endif
#ifndef fgAlphaTextureLayout
#define fgAlphaTextureLayout 0
#endif
#ifndef bgTextureHasSwappedViews
#define bgTextureHasSwappedViews 0
#elif bgTextureHasSwappedViews==1
#undef bgTextureHasSwappedViews
#define bgTextureHasSwappedViews 1
#endif
#ifndef bgTextureLayout
#define bgTextureLayout 0
#endif
#ifndef ALPHA_EXISTS
#define ALPHA_EXISTS 0
#elif ALPHA_EXISTS==1
#undef ALPHA_EXISTS
#define ALPHA_EXISTS 1
#endif
#ifndef CUSTOM_BLENDING
#define CUSTOM_BLENDING 0
#elif CUSTOM_BLENDING==1
#undef CUSTOM_BLENDING
#define CUSTOM_BLENDING 1
#endif
#ifndef NONE_BLENDING
#define NONE_BLENDING 0
#elif NONE_BLENDING==1
#undef NONE_BLENDING
#define NONE_BLENDING 1
#endif
#ifndef MULTIPLY_BLENDING
#define MULTIPLY_BLENDING 0
#elif MULTIPLY_BLENDING==1
#undef MULTIPLY_BLENDING
#define MULTIPLY_BLENDING 1
#endif
#ifndef SCREEN_BLENDING
#define SCREEN_BLENDING 0
#elif SCREEN_BLENDING==1
#undef SCREEN_BLENDING
#define SCREEN_BLENDING 1
#endif
#ifndef LIGHTEN_BLENDING
#define LIGHTEN_BLENDING 0
#elif LIGHTEN_BLENDING==1
#undef LIGHTEN_BLENDING
#define LIGHTEN_BLENDING 1
#endif
#ifndef COLOR_DODGE_BLENDING
#define COLOR_DODGE_BLENDING 0
#elif COLOR_DODGE_BLENDING==1
#undef COLOR_DODGE_BLENDING
#define COLOR_DODGE_BLENDING 1
#endif
#ifndef OVERLAY_BLENDING
#define OVERLAY_BLENDING 0
#elif OVERLAY_BLENDING==1
#undef OVERLAY_BLENDING
#define OVERLAY_BLENDING 1
#endif
#ifndef SOFT_LIGHT_BLENDING
#define SOFT_LIGHT_BLENDING 0
#elif SOFT_LIGHT_BLENDING==1
#undef SOFT_LIGHT_BLENDING
#define SOFT_LIGHT_BLENDING 1
#endif
#ifndef ADDITION_BLENDING
#define ADDITION_BLENDING 0
#elif ADDITION_BLENDING==1
#undef ADDITION_BLENDING
#define ADDITION_BLENDING 1
#endif
#ifndef VIVID_LIGHT_BLENDING
#define VIVID_LIGHT_BLENDING 0
#elif VIVID_LIGHT_BLENDING==1
#undef VIVID_LIGHT_BLENDING
#define VIVID_LIGHT_BLENDING 1
#endif
#ifndef LINEAR_LIGHT_BLENDING
#define LINEAR_LIGHT_BLENDING 0
#elif LINEAR_LIGHT_BLENDING==1
#undef LINEAR_LIGHT_BLENDING
#define LINEAR_LIGHT_BLENDING 1
#endif
#ifndef HARD_LIGHT_BLENDING
#define HARD_LIGHT_BLENDING 0
#elif HARD_LIGHT_BLENDING==1
#undef HARD_LIGHT_BLENDING
#define HARD_LIGHT_BLENDING 1
#endif
#ifndef fgTextureUV
#define fgTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_fgTexture
#define SC_USE_UV_TRANSFORM_fgTexture 0
#elif SC_USE_UV_TRANSFORM_fgTexture==1
#undef SC_USE_UV_TRANSFORM_fgTexture
#define SC_USE_UV_TRANSFORM_fgTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_fgTexture
#define SC_SOFTWARE_WRAP_MODE_U_fgTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_fgTexture
#define SC_SOFTWARE_WRAP_MODE_V_fgTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_fgTexture
#define SC_USE_UV_MIN_MAX_fgTexture 0
#elif SC_USE_UV_MIN_MAX_fgTexture==1
#undef SC_USE_UV_MIN_MAX_fgTexture
#define SC_USE_UV_MIN_MAX_fgTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_fgTexture
#define SC_USE_CLAMP_TO_BORDER_fgTexture 0
#elif SC_USE_CLAMP_TO_BORDER_fgTexture==1
#undef SC_USE_CLAMP_TO_BORDER_fgTexture
#define SC_USE_CLAMP_TO_BORDER_fgTexture 1
#endif
#ifndef fgAlphaTextureUV
#define fgAlphaTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_fgAlphaTexture
#define SC_USE_UV_TRANSFORM_fgAlphaTexture 0
#elif SC_USE_UV_TRANSFORM_fgAlphaTexture==1
#undef SC_USE_UV_TRANSFORM_fgAlphaTexture
#define SC_USE_UV_TRANSFORM_fgAlphaTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_fgAlphaTexture
#define SC_SOFTWARE_WRAP_MODE_U_fgAlphaTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_fgAlphaTexture
#define SC_SOFTWARE_WRAP_MODE_V_fgAlphaTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_fgAlphaTexture
#define SC_USE_UV_MIN_MAX_fgAlphaTexture 0
#elif SC_USE_UV_MIN_MAX_fgAlphaTexture==1
#undef SC_USE_UV_MIN_MAX_fgAlphaTexture
#define SC_USE_UV_MIN_MAX_fgAlphaTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_fgAlphaTexture
#define SC_USE_CLAMP_TO_BORDER_fgAlphaTexture 0
#elif SC_USE_CLAMP_TO_BORDER_fgAlphaTexture==1
#undef SC_USE_CLAMP_TO_BORDER_fgAlphaTexture
#define SC_USE_CLAMP_TO_BORDER_fgAlphaTexture 1
#endif
#ifndef bgTextureUV
#define bgTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_bgTexture
#define SC_USE_UV_TRANSFORM_bgTexture 0
#elif SC_USE_UV_TRANSFORM_bgTexture==1
#undef SC_USE_UV_TRANSFORM_bgTexture
#define SC_USE_UV_TRANSFORM_bgTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_bgTexture
#define SC_SOFTWARE_WRAP_MODE_U_bgTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_bgTexture
#define SC_SOFTWARE_WRAP_MODE_V_bgTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_bgTexture
#define SC_USE_UV_MIN_MAX_bgTexture 0
#elif SC_USE_UV_MIN_MAX_bgTexture==1
#undef SC_USE_UV_MIN_MAX_bgTexture
#define SC_USE_UV_MIN_MAX_bgTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_bgTexture
#define SC_USE_CLAMP_TO_BORDER_bgTexture 0
#elif SC_USE_CLAMP_TO_BORDER_bgTexture==1
#undef SC_USE_CLAMP_TO_BORDER_bgTexture
#define SC_USE_CLAMP_TO_BORDER_bgTexture 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float2 varTex2 [[user(locn10)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
float2 texture2 [[attribute(15)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant LibraryUniforms& libraryUniformsObj,uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
out.varTex2=in.texture2;
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN(100)
//sampler sampler fgTextureSmpSC 0:39770
//sampler sampler fgAlphaTextureSmpSC 0:57706
//sampler sampler bgTextureSmpSC 0:47832
//texture texture2D fgTexture 0:55252:0:39770
//texture texture2D fgAlphaTexture 0:50054:0:57706
//texture texture2D bgTexture 0:55806:0:47832
//ubo float UserUniforms 0:35568:388 {
//float4 fgTextureSize 0
//float4 fgTextureDims 16
//float4 fgTextureView 32
//float3x3 fgTextureTransform 48
//float4 fgTextureUvMinMax 96
//float4 fgTextureBorderColor 112
//float4 fgAlphaTextureSize 128
//float4 fgAlphaTextureDims 144
//float4 fgAlphaTextureView 160
//float3x3 fgAlphaTextureTransform 176
//float4 fgAlphaTextureUvMinMax 224
//float4 fgAlphaTextureBorderColor 240
//float4 bgTextureSize 256
//float4 bgTextureDims 272
//float4 bgTextureView 288
//float3x3 bgTextureTransform 304
//float4 bgTextureUvMinMax 352
//float4 bgTextureBorderColor 368
//float opacity 384
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 fgTextureSize;
float4 fgTextureDims;
float4 fgTextureView;
float3x3 fgTextureTransform;
float4 fgTextureUvMinMax;
float4 fgTextureBorderColor;
float4 fgAlphaTextureSize;
float4 fgAlphaTextureDims;
float4 fgAlphaTextureView;
float3x3 fgAlphaTextureTransform;
float4 fgAlphaTextureUvMinMax;
float4 fgAlphaTextureBorderColor;
float4 bgTextureSize;
float4 bgTextureDims;
float4 bgTextureView;
float3x3 bgTextureTransform;
float4 bgTextureUvMinMax;
float4 bgTextureBorderColor;
float opacity;
};

#ifndef fgTextureHasSwappedViews
#define fgTextureHasSwappedViews 0
#elif fgTextureHasSwappedViews==1
#undef fgTextureHasSwappedViews
#define fgTextureHasSwappedViews 1
#endif
#ifndef fgTextureLayout
#define fgTextureLayout 0
#endif
#ifndef fgAlphaTextureHasSwappedViews
#define fgAlphaTextureHasSwappedViews 0
#elif fgAlphaTextureHasSwappedViews==1
#undef fgAlphaTextureHasSwappedViews
#define fgAlphaTextureHasSwappedViews 1
#endif
#ifndef fgAlphaTextureLayout
#define fgAlphaTextureLayout 0
#endif
#ifndef bgTextureHasSwappedViews
#define bgTextureHasSwappedViews 0
#elif bgTextureHasSwappedViews==1
#undef bgTextureHasSwappedViews
#define bgTextureHasSwappedViews 1
#endif
#ifndef bgTextureLayout
#define bgTextureLayout 0
#endif
#ifndef SC_USE_UV_TRANSFORM_fgTexture
#define SC_USE_UV_TRANSFORM_fgTexture 0
#elif SC_USE_UV_TRANSFORM_fgTexture==1
#undef SC_USE_UV_TRANSFORM_fgTexture
#define SC_USE_UV_TRANSFORM_fgTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_fgTexture
#define SC_SOFTWARE_WRAP_MODE_U_fgTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_fgTexture
#define SC_SOFTWARE_WRAP_MODE_V_fgTexture -1
#endif
constant int2 _2433=int2(SC_SOFTWARE_WRAP_MODE_U_fgTexture,SC_SOFTWARE_WRAP_MODE_V_fgTexture);
#ifndef SC_USE_UV_MIN_MAX_fgTexture
#define SC_USE_UV_MIN_MAX_fgTexture 0
#elif SC_USE_UV_MIN_MAX_fgTexture==1
#undef SC_USE_UV_MIN_MAX_fgTexture
#define SC_USE_UV_MIN_MAX_fgTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_fgTexture
#define SC_USE_CLAMP_TO_BORDER_fgTexture 0
#elif SC_USE_CLAMP_TO_BORDER_fgTexture==1
#undef SC_USE_CLAMP_TO_BORDER_fgTexture
#define SC_USE_CLAMP_TO_BORDER_fgTexture 1
#endif
#ifndef ALPHA_EXISTS
#define ALPHA_EXISTS 0
#elif ALPHA_EXISTS==1
#undef ALPHA_EXISTS
#define ALPHA_EXISTS 1
#endif
#ifndef SC_USE_UV_TRANSFORM_fgAlphaTexture
#define SC_USE_UV_TRANSFORM_fgAlphaTexture 0
#elif SC_USE_UV_TRANSFORM_fgAlphaTexture==1
#undef SC_USE_UV_TRANSFORM_fgAlphaTexture
#define SC_USE_UV_TRANSFORM_fgAlphaTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_fgAlphaTexture
#define SC_SOFTWARE_WRAP_MODE_U_fgAlphaTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_fgAlphaTexture
#define SC_SOFTWARE_WRAP_MODE_V_fgAlphaTexture -1
#endif
constant int2 _2474=int2(SC_SOFTWARE_WRAP_MODE_U_fgAlphaTexture,SC_SOFTWARE_WRAP_MODE_V_fgAlphaTexture);
#ifndef SC_USE_UV_MIN_MAX_fgAlphaTexture
#define SC_USE_UV_MIN_MAX_fgAlphaTexture 0
#elif SC_USE_UV_MIN_MAX_fgAlphaTexture==1
#undef SC_USE_UV_MIN_MAX_fgAlphaTexture
#define SC_USE_UV_MIN_MAX_fgAlphaTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_fgAlphaTexture
#define SC_USE_CLAMP_TO_BORDER_fgAlphaTexture 0
#elif SC_USE_CLAMP_TO_BORDER_fgAlphaTexture==1
#undef SC_USE_CLAMP_TO_BORDER_fgAlphaTexture
#define SC_USE_CLAMP_TO_BORDER_fgAlphaTexture 1
#endif
#ifndef CUSTOM_BLENDING
#define CUSTOM_BLENDING 0
#elif CUSTOM_BLENDING==1
#undef CUSTOM_BLENDING
#define CUSTOM_BLENDING 1
#endif
#ifndef SC_USE_UV_TRANSFORM_bgTexture
#define SC_USE_UV_TRANSFORM_bgTexture 0
#elif SC_USE_UV_TRANSFORM_bgTexture==1
#undef SC_USE_UV_TRANSFORM_bgTexture
#define SC_USE_UV_TRANSFORM_bgTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_bgTexture
#define SC_SOFTWARE_WRAP_MODE_U_bgTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_bgTexture
#define SC_SOFTWARE_WRAP_MODE_V_bgTexture -1
#endif
constant int2 _2521=int2(SC_SOFTWARE_WRAP_MODE_U_bgTexture,SC_SOFTWARE_WRAP_MODE_V_bgTexture);
#ifndef SC_USE_UV_MIN_MAX_bgTexture
#define SC_USE_UV_MIN_MAX_bgTexture 0
#elif SC_USE_UV_MIN_MAX_bgTexture==1
#undef SC_USE_UV_MIN_MAX_bgTexture
#define SC_USE_UV_MIN_MAX_bgTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_bgTexture
#define SC_USE_CLAMP_TO_BORDER_bgTexture 0
#elif SC_USE_CLAMP_TO_BORDER_bgTexture==1
#undef SC_USE_CLAMP_TO_BORDER_bgTexture
#define SC_USE_CLAMP_TO_BORDER_bgTexture 1
#endif
#ifndef NONE_BLENDING
#define NONE_BLENDING 0
#elif NONE_BLENDING==1
#undef NONE_BLENDING
#define NONE_BLENDING 1
#endif
#ifndef MULTIPLY_BLENDING
#define MULTIPLY_BLENDING 0
#elif MULTIPLY_BLENDING==1
#undef MULTIPLY_BLENDING
#define MULTIPLY_BLENDING 1
#endif
#ifndef SCREEN_BLENDING
#define SCREEN_BLENDING 0
#elif SCREEN_BLENDING==1
#undef SCREEN_BLENDING
#define SCREEN_BLENDING 1
#endif
#ifndef LIGHTEN_BLENDING
#define LIGHTEN_BLENDING 0
#elif LIGHTEN_BLENDING==1
#undef LIGHTEN_BLENDING
#define LIGHTEN_BLENDING 1
#endif
#ifndef COLOR_DODGE_BLENDING
#define COLOR_DODGE_BLENDING 0
#elif COLOR_DODGE_BLENDING==1
#undef COLOR_DODGE_BLENDING
#define COLOR_DODGE_BLENDING 1
#endif
#ifndef OVERLAY_BLENDING
#define OVERLAY_BLENDING 0
#elif OVERLAY_BLENDING==1
#undef OVERLAY_BLENDING
#define OVERLAY_BLENDING 1
#endif
#ifndef SOFT_LIGHT_BLENDING
#define SOFT_LIGHT_BLENDING 0
#elif SOFT_LIGHT_BLENDING==1
#undef SOFT_LIGHT_BLENDING
#define SOFT_LIGHT_BLENDING 1
#endif
#ifndef ADDITION_BLENDING
#define ADDITION_BLENDING 0
#elif ADDITION_BLENDING==1
#undef ADDITION_BLENDING
#define ADDITION_BLENDING 1
#endif
#ifndef VIVID_LIGHT_BLENDING
#define VIVID_LIGHT_BLENDING 0
#elif VIVID_LIGHT_BLENDING==1
#undef VIVID_LIGHT_BLENDING
#define VIVID_LIGHT_BLENDING 1
#endif
#ifndef LINEAR_LIGHT_BLENDING
#define LINEAR_LIGHT_BLENDING 0
#elif LINEAR_LIGHT_BLENDING==1
#undef LINEAR_LIGHT_BLENDING
#define LINEAR_LIGHT_BLENDING 1
#endif
#ifndef HARD_LIGHT_BLENDING
#define HARD_LIGHT_BLENDING 0
#elif HARD_LIGHT_BLENDING==1
#undef HARD_LIGHT_BLENDING
#define HARD_LIGHT_BLENDING 1
#endif
#ifndef fgTextureUV
#define fgTextureUV 0
#endif
#ifndef fgAlphaTextureUV
#define fgAlphaTextureUV 0
#endif
#ifndef bgTextureUV
#define bgTextureUV 0
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float4 varPackedTex [[user(locn6)]];
float2 varTex2 [[user(locn10)]];
};

float2 fgTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.fgTextureDims.xy;
}

int fgTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (fgTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 fgAlphaTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.fgAlphaTextureDims.xy;
}

int fgAlphaTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (fgAlphaTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 bgTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.bgTextureDims.xy;
}

int bgTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (bgTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj,texture2d<float> fgAlphaTexture,texture2d<float> fgTexture,texture2d<float> bgTexture,sampler fgTextureSmpSC,sampler bgTextureSmpSC,sampler fgAlphaTextureSmpSC,float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float2 param=fgTextureGetDims2D(userUniformsObj);
int param_1=fgTextureLayout;
int param_2=fgTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_3=in.varPackedTex.xy;
bool param_4=(int(SC_USE_UV_TRANSFORM_fgTexture)!=0);
float3x3 param_5=userUniformsObj.fgTextureTransform;
int2 param_6=_2433;
bool param_7=(int(SC_USE_UV_MIN_MAX_fgTexture)!=0);
float4 param_8=userUniformsObj.fgTextureUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_fgTexture)!=0);
float4 param_10=userUniformsObj.fgTextureBorderColor;
float param_11=0.0;
float4 _2459=sc_SampleTextureBiasOrLevel(fgTexture,fgTextureSmpSC,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
float4 _2426=_2459;
float4 color=_2459;
float3 fg=color.xyz;
float alpha;
#if (ALPHA_EXISTS)
{
float2 param_12=fgAlphaTextureGetDims2D(userUniformsObj);
int param_13=fgAlphaTextureLayout;
int param_14=fgAlphaTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_15=in.varPackedTex.zw;
bool param_16=(int(SC_USE_UV_TRANSFORM_fgAlphaTexture)!=0);
float3x3 param_17=userUniformsObj.fgAlphaTextureTransform;
int2 param_18=_2474;
bool param_19=(int(SC_USE_UV_MIN_MAX_fgAlphaTexture)!=0);
float4 param_20=userUniformsObj.fgAlphaTextureUvMinMax;
bool param_21=(int(SC_USE_CLAMP_TO_BORDER_fgAlphaTexture)!=0);
float4 param_22=userUniformsObj.fgAlphaTextureBorderColor;
float param_23=0.0;
float4 _2499=sc_SampleTextureBiasOrLevel(fgAlphaTexture,fgAlphaTextureSmpSC,param_12,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23);
float4 _2467=_2499;
alpha=_2499.x;
}
#else
{
alpha=color.w;
}
#endif
alpha*=userUniformsObj.opacity;
float4 result;
#if (CUSTOM_BLENDING)
{
float2 param_24=bgTextureGetDims2D(userUniformsObj);
int param_25=bgTextureLayout;
int param_26=bgTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_27=in.varTex2;
bool param_28=(int(SC_USE_UV_TRANSFORM_bgTexture)!=0);
float3x3 param_29=userUniformsObj.bgTextureTransform;
int2 param_30=_2521;
bool param_31=(int(SC_USE_UV_MIN_MAX_bgTexture)!=0);
float4 param_32=userUniformsObj.bgTextureUvMinMax;
bool param_33=(int(SC_USE_CLAMP_TO_BORDER_bgTexture)!=0);
float4 param_34=userUniformsObj.bgTextureBorderColor;
float param_35=0.0;
float4 _2545=sc_SampleTextureBiasOrLevel(bgTexture,bgTextureSmpSC,param_24,param_25,param_26,param_27,param_28,param_29,param_30,param_31,param_32,param_33,param_34,param_35);
float4 _2513=_2545;
float3 bg=_2545.xyz;
#if (NONE_BLENDING)
{
result=float4(mix(bg,fg,float3(alpha)),alpha);
}
#else
{
#if (MULTIPLY_BLENDING)
{
result=float4(mix(bg,bg*fg,float3(alpha)),alpha);
}
#else
{
#if (SCREEN_BLENDING)
{
result=float4(mix(bg,float3(1.0)-((float3(1.0)-bg)*(float3(1.0)-fg)),float3(alpha)),alpha);
}
#else
{
#if (LIGHTEN_BLENDING)
{
result=float4(mix(bg,fast::max(bg,fg),float3(alpha)),alpha);
}
#else
{
#if (COLOR_DODGE_BLENDING)
{
result=float4(mix(bg,bg/((float3(1.0)-fg)+float3(0.01)),float3(alpha)),alpha);
}
#else
{
#if (OVERLAY_BLENDING)
{
float3 st=step(bg,float3(0.5));
float3 blendColor=mix(float3(1.0)-(((float3(1.0)-bg)*2.0)*(float3(1.0)-fg)),(bg*2.0)*fg,st);
result=float4(mix(bg,blendColor,float3(alpha)),alpha);
}
#else
{
#if (SOFT_LIGHT_BLENDING)
{
float3 blendColor_1=(fast::max(float3(1.0)-(fg*2.0),float3(0.0))*bg)*bg;
blendColor_1+=((fast::min(fg,float3(1.0)-fg)*2.0)*bg);
blendColor_1+=(fast::max((fg*2.0)-float3(1.0),float3(0.0))*sqrt(bg));
result=float4(mix(bg,blendColor_1,float3(alpha)),alpha);
}
#else
{
#if (ADDITION_BLENDING)
{
result=float4(mix(bg,fast::min(bg+fg,float3(1.0)),float3(alpha)),alpha);
}
#else
{
#if (VIVID_LIGHT_BLENDING)
{
float3 blendColor_2;
int i=0;
for (int snapLoopIndex=0; snapLoopIndex==0; snapLoopIndex+=0)
{
if (i<3)
{
if (fg[i]>0.5)
{
blendColor_2[i]=bg[i]/((2.0*(1.0-fg[i]))+0.00392157);
}
else
{
blendColor_2[i]=1.0-((1.0-bg[i])/((2.0*fg[i])+0.00392157));
}
i++;
continue;
}
else
{
break;
}
}
result=float4(mix(bg,blendColor_2,float3(alpha)),alpha);
}
#else
{
#if (LINEAR_LIGHT_BLENDING)
{
result=float4(mix(bg,(bg+(fg*2.0))-float3(1.0),float3(alpha)),alpha);
}
#else
{
#if (HARD_LIGHT_BLENDING)
{
float3 st_1=step(fg,float3(0.5));
float3 blendColor_3=mix(float3(1.0)-(((float3(1.0)-bg)*2.0)*(float3(1.0)-fg)),(bg*2.0)*fg,st_1);
result=float4(mix(bg,blendColor_3,float3(alpha)),alpha);
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#else
{
result=float4(fg,alpha);
}
#endif
float4 param_36=result;
sc_writeFragData0(param_36,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
