#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1

#include "std2.metal"
#include "std2_vs.metal"
#include "std2_fs.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN(100)
//SG_REFLECTION_END


struct UserUniforms
{
float4 assetTextureSize;
float4 assetTextureDims;
float4 assetTextureView;
float3x3 assetTextureTransform;
float4 assetTextureUvMinMax;
float4 assetTextureBorderColor;
float4 alphaTextureSize;
float4 alphaTextureDims;
float4 alphaTextureView;
float3x3 alphaTextureTransform;
float4 alphaTextureUvMinMax;
float4 alphaTextureBorderColor;
int alphaChannel;
float3 bodyMedian;
float3 deviationRatio;
float3 faceMedian;
};

#ifndef assetTextureHasSwappedViews
#define assetTextureHasSwappedViews 0
#elif assetTextureHasSwappedViews==1
#undef assetTextureHasSwappedViews
#define assetTextureHasSwappedViews 1
#endif
#ifndef assetTextureLayout
#define assetTextureLayout 0
#endif
#ifndef alphaTextureHasSwappedViews
#define alphaTextureHasSwappedViews 0
#elif alphaTextureHasSwappedViews==1
#undef alphaTextureHasSwappedViews
#define alphaTextureHasSwappedViews 1
#endif
#ifndef alphaTextureLayout
#define alphaTextureLayout 0
#endif
#ifndef assetTextureUV
#define assetTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_assetTexture
#define SC_USE_UV_TRANSFORM_assetTexture 0
#elif SC_USE_UV_TRANSFORM_assetTexture==1
#undef SC_USE_UV_TRANSFORM_assetTexture
#define SC_USE_UV_TRANSFORM_assetTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_assetTexture
#define SC_SOFTWARE_WRAP_MODE_U_assetTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_assetTexture
#define SC_SOFTWARE_WRAP_MODE_V_assetTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_assetTexture
#define SC_USE_UV_MIN_MAX_assetTexture 0
#elif SC_USE_UV_MIN_MAX_assetTexture==1
#undef SC_USE_UV_MIN_MAX_assetTexture
#define SC_USE_UV_MIN_MAX_assetTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_assetTexture
#define SC_USE_CLAMP_TO_BORDER_assetTexture 0
#elif SC_USE_CLAMP_TO_BORDER_assetTexture==1
#undef SC_USE_CLAMP_TO_BORDER_assetTexture
#define SC_USE_CLAMP_TO_BORDER_assetTexture 1
#endif
#ifndef alphaTextureUV
#define alphaTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_alphaTexture
#define SC_USE_UV_TRANSFORM_alphaTexture 0
#elif SC_USE_UV_TRANSFORM_alphaTexture==1
#undef SC_USE_UV_TRANSFORM_alphaTexture
#define SC_USE_UV_TRANSFORM_alphaTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_alphaTexture
#define SC_SOFTWARE_WRAP_MODE_U_alphaTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_alphaTexture
#define SC_SOFTWARE_WRAP_MODE_V_alphaTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_alphaTexture
#define SC_USE_UV_MIN_MAX_alphaTexture 0
#elif SC_USE_UV_MIN_MAX_alphaTexture==1
#undef SC_USE_UV_MIN_MAX_alphaTexture
#define SC_USE_UV_MIN_MAX_alphaTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_alphaTexture
#define SC_USE_CLAMP_TO_BORDER_alphaTexture 0
#elif SC_USE_CLAMP_TO_BORDER_alphaTexture==1
#undef SC_USE_CLAMP_TO_BORDER_alphaTexture
#define SC_USE_CLAMP_TO_BORDER_alphaTexture 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant LibraryUniforms& libraryUniformsObj,uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN(100)
//sampler sampler assetTextureSmpSC 0:44854
//sampler sampler alphaTextureSmpSC 0:43650
//texture texture2D assetTexture 0:45715:0:44854
//texture texture2D alphaTexture 0:56772:0:43650
//ubo float UserUniforms 0:35568:320 {
//float4 assetTextureSize 0
//float4 assetTextureDims 16
//float4 assetTextureView 32
//float3x3 assetTextureTransform 48
//float4 assetTextureUvMinMax 96
//float4 assetTextureBorderColor 112
//float4 alphaTextureSize 128
//float4 alphaTextureDims 144
//float4 alphaTextureView 160
//float3x3 alphaTextureTransform 176
//float4 alphaTextureUvMinMax 224
//float4 alphaTextureBorderColor 240
//int alphaChannel 256
//float3 bodyMedian 272
//float3 deviationRatio 288
//float3 faceMedian 304
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 assetTextureSize;
float4 assetTextureDims;
float4 assetTextureView;
float3x3 assetTextureTransform;
float4 assetTextureUvMinMax;
float4 assetTextureBorderColor;
float4 alphaTextureSize;
float4 alphaTextureDims;
float4 alphaTextureView;
float3x3 alphaTextureTransform;
float4 alphaTextureUvMinMax;
float4 alphaTextureBorderColor;
int alphaChannel;
float3 bodyMedian;
float3 deviationRatio;
float3 faceMedian;
};

#ifndef assetTextureHasSwappedViews
#define assetTextureHasSwappedViews 0
#elif assetTextureHasSwappedViews==1
#undef assetTextureHasSwappedViews
#define assetTextureHasSwappedViews 1
#endif
#ifndef assetTextureLayout
#define assetTextureLayout 0
#endif
#ifndef alphaTextureHasSwappedViews
#define alphaTextureHasSwappedViews 0
#elif alphaTextureHasSwappedViews==1
#undef alphaTextureHasSwappedViews
#define alphaTextureHasSwappedViews 1
#endif
#ifndef alphaTextureLayout
#define alphaTextureLayout 0
#endif
#ifndef SC_USE_UV_TRANSFORM_assetTexture
#define SC_USE_UV_TRANSFORM_assetTexture 0
#elif SC_USE_UV_TRANSFORM_assetTexture==1
#undef SC_USE_UV_TRANSFORM_assetTexture
#define SC_USE_UV_TRANSFORM_assetTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_assetTexture
#define SC_SOFTWARE_WRAP_MODE_U_assetTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_assetTexture
#define SC_SOFTWARE_WRAP_MODE_V_assetTexture -1
#endif
constant int2 _2440=int2(SC_SOFTWARE_WRAP_MODE_U_assetTexture,SC_SOFTWARE_WRAP_MODE_V_assetTexture);
#ifndef SC_USE_UV_MIN_MAX_assetTexture
#define SC_USE_UV_MIN_MAX_assetTexture 0
#elif SC_USE_UV_MIN_MAX_assetTexture==1
#undef SC_USE_UV_MIN_MAX_assetTexture
#define SC_USE_UV_MIN_MAX_assetTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_assetTexture
#define SC_USE_CLAMP_TO_BORDER_assetTexture 0
#elif SC_USE_CLAMP_TO_BORDER_assetTexture==1
#undef SC_USE_CLAMP_TO_BORDER_assetTexture
#define SC_USE_CLAMP_TO_BORDER_assetTexture 1
#endif
#ifndef SC_USE_UV_TRANSFORM_alphaTexture
#define SC_USE_UV_TRANSFORM_alphaTexture 0
#elif SC_USE_UV_TRANSFORM_alphaTexture==1
#undef SC_USE_UV_TRANSFORM_alphaTexture
#define SC_USE_UV_TRANSFORM_alphaTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_alphaTexture
#define SC_SOFTWARE_WRAP_MODE_U_alphaTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_alphaTexture
#define SC_SOFTWARE_WRAP_MODE_V_alphaTexture -1
#endif
constant int2 _2476=int2(SC_SOFTWARE_WRAP_MODE_U_alphaTexture,SC_SOFTWARE_WRAP_MODE_V_alphaTexture);
#ifndef SC_USE_UV_MIN_MAX_alphaTexture
#define SC_USE_UV_MIN_MAX_alphaTexture 0
#elif SC_USE_UV_MIN_MAX_alphaTexture==1
#undef SC_USE_UV_MIN_MAX_alphaTexture
#define SC_USE_UV_MIN_MAX_alphaTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_alphaTexture
#define SC_USE_CLAMP_TO_BORDER_alphaTexture 0
#elif SC_USE_CLAMP_TO_BORDER_alphaTexture==1
#undef SC_USE_CLAMP_TO_BORDER_alphaTexture
#define SC_USE_CLAMP_TO_BORDER_alphaTexture 1
#endif
#ifndef assetTextureUV
#define assetTextureUV 0
#endif
#ifndef alphaTextureUV
#define alphaTextureUV 0
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float4 varPackedTex [[user(locn6)]];
};

float2 assetTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.assetTextureDims.xy;
}

int assetTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (assetTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 alphaTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.alphaTextureDims.xy;
}

int alphaTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (alphaTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float3 rgb2srgb(thread const float3& rgb)
{
return pow((rgb+float3(0.055))*0.947867,float3(2.4));
}

float3 rgb2lab(thread float3& rgb)
{
float3 param=rgb;
rgb=rgb2srgb(param);
float3 xyz=float3x3(float3(0.433953,0.212671,0.017758),float3(0.376219,0.71516,0.109477),float3(0.189828,0.072169,0.872766))*rgb;
float3 f=pow(xyz,float3(0.333333));
float L=(116.0*f.y)-16.0;
float a=500.0*(f.x-f.y);
float b=200.0*(f.y-f.z);
return float3(L/100.0,(a+128.0)/255.0,(b+128.0)/255.0);
}

float3 srgb2rgb(thread const float3& srgb)
{
return (pow(srgb,float3(0.416667))*1.055)-float3(0.055);
}

float3 lab2rgb(thread const float3& lab)
{
float L=lab.x*100.0;
float a=(lab.y*255.0)-128.0;
float b=(lab.z*255.0)-128.0;
float3 f;
f.y=(L+16.0)/116.0;
f.x=(a/500.0)+f.y;
f.z=(b/(-200.0))+f.y;
float3 xyz=pow(f,float3(3.0));
float3 param=float3x3(float3(3.07994,-0.921234,0.05289),float3(-1.53715,1.87599,-0.204041),float3(-0.542783,0.045244,1.15115))*xyz;
return srgb2rgb(param);
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj,texture2d<float> assetTexture,texture2d<float> alphaTexture,sampler alphaTextureSmpSC,sampler assetTextureSmpSC,float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float2 param=assetTextureGetDims2D(userUniformsObj);
int param_1=assetTextureLayout;
int param_2=assetTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_3=in.varPackedTex.xy;
bool param_4=(int(SC_USE_UV_TRANSFORM_assetTexture)!=0);
float3x3 param_5=userUniformsObj.assetTextureTransform;
int2 param_6=_2440;
bool param_7=(int(SC_USE_UV_MIN_MAX_assetTexture)!=0);
float4 param_8=userUniformsObj.assetTextureUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_assetTexture)!=0);
float4 param_10=userUniformsObj.assetTextureBorderColor;
float param_11=0.0;
float4 _2466=sc_SampleTextureBiasOrLevel(assetTexture,assetTextureSmpSC,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
float4 _2433=_2466;
float3 assetColor=_2466.xyz;
float2 param_12=alphaTextureGetDims2D(userUniformsObj);
int param_13=alphaTextureLayout;
int param_14=alphaTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_15=in.varPackedTex.zw;
bool param_16=(int(SC_USE_UV_TRANSFORM_alphaTexture)!=0);
float3x3 param_17=userUniformsObj.alphaTextureTransform;
int2 param_18=_2476;
bool param_19=(int(SC_USE_UV_MIN_MAX_alphaTexture)!=0);
float4 param_20=userUniformsObj.alphaTextureUvMinMax;
bool param_21=(int(SC_USE_CLAMP_TO_BORDER_alphaTexture)!=0);
float4 param_22=userUniformsObj.alphaTextureBorderColor;
float param_23=0.0;
float4 _2501=sc_SampleTextureBiasOrLevel(alphaTexture,alphaTextureSmpSC,param_12,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23);
float4 _2469=_2501;
float alpha=_2501[userUniformsObj.alphaChannel];
float3 param_24=assetColor;
float3 _2510=rgb2lab(param_24);
float3 lab=_2510;
lab=mix(lab,((lab-userUniformsObj.bodyMedian)*userUniformsObj.deviationRatio)+userUniformsObj.faceMedian,float3(alpha));
float3 param_25=lab;
float4 param_26=float4(lab2rgb(param_25),1.0);
sc_writeFragData0(param_26,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
