#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include "std2.metal"
#include "std2_vs.metal"
#include "std2_fs.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN(100)
//SG_REFLECTION_END


struct UserUniforms
{
float4 targetTextureSize;
float4 targetTextureDims;
float4 targetTextureView;
float3x3 targetTextureTransform;
float4 targetTextureUvMinMax;
float4 targetTextureBorderColor;
float4 alphaTextureSize;
float4 alphaTextureDims;
float4 alphaTextureView;
float3x3 alphaTextureTransform;
float4 alphaTextureUvMinMax;
float4 alphaTextureBorderColor;
float opacity;
float2 inverseScreenSize;
};

#ifndef targetTextureHasSwappedViews
#define targetTextureHasSwappedViews 0
#elif targetTextureHasSwappedViews==1
#undef targetTextureHasSwappedViews
#define targetTextureHasSwappedViews 1
#endif
#ifndef targetTextureLayout
#define targetTextureLayout 0
#endif
#ifndef alphaTextureHasSwappedViews
#define alphaTextureHasSwappedViews 0
#elif alphaTextureHasSwappedViews==1
#undef alphaTextureHasSwappedViews
#define alphaTextureHasSwappedViews 1
#endif
#ifndef alphaTextureLayout
#define alphaTextureLayout 0
#endif
#ifndef ALPHA_PATCH
#define ALPHA_PATCH 0
#elif ALPHA_PATCH==1
#undef ALPHA_PATCH
#define ALPHA_PATCH 1
#endif
#ifndef targetTextureUV
#define targetTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_targetTexture
#define SC_USE_UV_TRANSFORM_targetTexture 0
#elif SC_USE_UV_TRANSFORM_targetTexture==1
#undef SC_USE_UV_TRANSFORM_targetTexture
#define SC_USE_UV_TRANSFORM_targetTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_targetTexture
#define SC_SOFTWARE_WRAP_MODE_U_targetTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_targetTexture
#define SC_SOFTWARE_WRAP_MODE_V_targetTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_targetTexture
#define SC_USE_UV_MIN_MAX_targetTexture 0
#elif SC_USE_UV_MIN_MAX_targetTexture==1
#undef SC_USE_UV_MIN_MAX_targetTexture
#define SC_USE_UV_MIN_MAX_targetTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_targetTexture
#define SC_USE_CLAMP_TO_BORDER_targetTexture 0
#elif SC_USE_CLAMP_TO_BORDER_targetTexture==1
#undef SC_USE_CLAMP_TO_BORDER_targetTexture
#define SC_USE_CLAMP_TO_BORDER_targetTexture 1
#endif
#ifndef alphaTextureUV
#define alphaTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_alphaTexture
#define SC_USE_UV_TRANSFORM_alphaTexture 0
#elif SC_USE_UV_TRANSFORM_alphaTexture==1
#undef SC_USE_UV_TRANSFORM_alphaTexture
#define SC_USE_UV_TRANSFORM_alphaTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_alphaTexture
#define SC_SOFTWARE_WRAP_MODE_U_alphaTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_alphaTexture
#define SC_SOFTWARE_WRAP_MODE_V_alphaTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_alphaTexture
#define SC_USE_UV_MIN_MAX_alphaTexture 0
#elif SC_USE_UV_MIN_MAX_alphaTexture==1
#undef SC_USE_UV_MIN_MAX_alphaTexture
#define SC_USE_UV_MIN_MAX_alphaTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_alphaTexture
#define SC_USE_CLAMP_TO_BORDER_alphaTexture 0
#elif SC_USE_CLAMP_TO_BORDER_alphaTexture==1
#undef SC_USE_CLAMP_TO_BORDER_alphaTexture
#define SC_USE_CLAMP_TO_BORDER_alphaTexture 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant LibraryUniforms& libraryUniformsObj,uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN(100)
//sampler sampler targetTextureSmpSC 0:54729
//sampler sampler alphaTextureSmpSC 0:43650
//texture texture2D targetTexture 0:42328:0:54729
//texture texture2D alphaTexture 0:56772:0:43650
//ubo float UserUniforms 0:35568:272 {
//float4 targetTextureSize 0
//float4 targetTextureDims 16
//float4 targetTextureView 32
//float3x3 targetTextureTransform 48
//float4 targetTextureUvMinMax 96
//float4 targetTextureBorderColor 112
//float4 alphaTextureSize 128
//float4 alphaTextureDims 144
//float4 alphaTextureView 160
//float3x3 alphaTextureTransform 176
//float4 alphaTextureUvMinMax 224
//float4 alphaTextureBorderColor 240
//float opacity 256
//float2 inverseScreenSize 264
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 targetTextureSize;
float4 targetTextureDims;
float4 targetTextureView;
float3x3 targetTextureTransform;
float4 targetTextureUvMinMax;
float4 targetTextureBorderColor;
float4 alphaTextureSize;
float4 alphaTextureDims;
float4 alphaTextureView;
float3x3 alphaTextureTransform;
float4 alphaTextureUvMinMax;
float4 alphaTextureBorderColor;
float opacity;
float2 inverseScreenSize;
};

#ifndef targetTextureHasSwappedViews
#define targetTextureHasSwappedViews 0
#elif targetTextureHasSwappedViews==1
#undef targetTextureHasSwappedViews
#define targetTextureHasSwappedViews 1
#endif
#ifndef targetTextureLayout
#define targetTextureLayout 0
#endif
#ifndef alphaTextureHasSwappedViews
#define alphaTextureHasSwappedViews 0
#elif alphaTextureHasSwappedViews==1
#undef alphaTextureHasSwappedViews
#define alphaTextureHasSwappedViews 1
#endif
#ifndef alphaTextureLayout
#define alphaTextureLayout 0
#endif
#ifndef SC_USE_UV_TRANSFORM_targetTexture
#define SC_USE_UV_TRANSFORM_targetTexture 0
#elif SC_USE_UV_TRANSFORM_targetTexture==1
#undef SC_USE_UV_TRANSFORM_targetTexture
#define SC_USE_UV_TRANSFORM_targetTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_targetTexture
#define SC_SOFTWARE_WRAP_MODE_U_targetTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_targetTexture
#define SC_SOFTWARE_WRAP_MODE_V_targetTexture -1
#endif
constant int2 _2290=int2(SC_SOFTWARE_WRAP_MODE_U_targetTexture,SC_SOFTWARE_WRAP_MODE_V_targetTexture);
#ifndef SC_USE_UV_MIN_MAX_targetTexture
#define SC_USE_UV_MIN_MAX_targetTexture 0
#elif SC_USE_UV_MIN_MAX_targetTexture==1
#undef SC_USE_UV_MIN_MAX_targetTexture
#define SC_USE_UV_MIN_MAX_targetTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_targetTexture
#define SC_USE_CLAMP_TO_BORDER_targetTexture 0
#elif SC_USE_CLAMP_TO_BORDER_targetTexture==1
#undef SC_USE_CLAMP_TO_BORDER_targetTexture
#define SC_USE_CLAMP_TO_BORDER_targetTexture 1
#endif
#ifndef ALPHA_PATCH
#define ALPHA_PATCH 0
#elif ALPHA_PATCH==1
#undef ALPHA_PATCH
#define ALPHA_PATCH 1
#endif
#ifndef SC_USE_UV_TRANSFORM_alphaTexture
#define SC_USE_UV_TRANSFORM_alphaTexture 0
#elif SC_USE_UV_TRANSFORM_alphaTexture==1
#undef SC_USE_UV_TRANSFORM_alphaTexture
#define SC_USE_UV_TRANSFORM_alphaTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_alphaTexture
#define SC_SOFTWARE_WRAP_MODE_U_alphaTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_alphaTexture
#define SC_SOFTWARE_WRAP_MODE_V_alphaTexture -1
#endif
constant int2 _2335=int2(SC_SOFTWARE_WRAP_MODE_U_alphaTexture,SC_SOFTWARE_WRAP_MODE_V_alphaTexture);
#ifndef SC_USE_UV_MIN_MAX_alphaTexture
#define SC_USE_UV_MIN_MAX_alphaTexture 0
#elif SC_USE_UV_MIN_MAX_alphaTexture==1
#undef SC_USE_UV_MIN_MAX_alphaTexture
#define SC_USE_UV_MIN_MAX_alphaTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_alphaTexture
#define SC_USE_CLAMP_TO_BORDER_alphaTexture 0
#elif SC_USE_CLAMP_TO_BORDER_alphaTexture==1
#undef SC_USE_CLAMP_TO_BORDER_alphaTexture
#define SC_USE_CLAMP_TO_BORDER_alphaTexture 1
#endif
#ifndef targetTextureUV
#define targetTextureUV 0
#endif
#ifndef alphaTextureUV
#define alphaTextureUV 0
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float4 varPackedTex [[user(locn6)]];
};

float2 targetTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.targetTextureDims.xy;
}

int targetTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (targetTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 alphaTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.alphaTextureDims.xy;
}

int alphaTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (alphaTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj,texture2d<float> targetTexture,texture2d<float> alphaTexture,sampler alphaTextureSmpSC,sampler targetTextureSmpSC,float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float2 param=targetTextureGetDims2D(userUniformsObj);
int param_1=targetTextureLayout;
int param_2=targetTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_3=in.varPackedTex.xy;
bool param_4=(int(SC_USE_UV_TRANSFORM_targetTexture)!=0);
float3x3 param_5=userUniformsObj.targetTextureTransform;
int2 param_6=_2290;
bool param_7=(int(SC_USE_UV_MIN_MAX_targetTexture)!=0);
float4 param_8=userUniformsObj.targetTextureUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_targetTexture)!=0);
float4 param_10=userUniformsObj.targetTextureBorderColor;
float param_11=0.0;
float4 _2316=sc_SampleTextureBiasOrLevel(targetTexture,targetTextureSmpSC,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
float4 _2283=_2316;
float4 warpedColor=_2316;
float alpha=1.0;
#if (ALPHA_PATCH)
{
float2 param_12=alphaTextureGetDims2D(userUniformsObj);
int param_13=alphaTextureLayout;
int param_14=alphaTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_15=gl_FragCoord.xy*userUniformsObj.inverseScreenSize;
bool param_16=(int(SC_USE_UV_TRANSFORM_alphaTexture)!=0);
float3x3 param_17=userUniformsObj.alphaTextureTransform;
int2 param_18=_2335;
bool param_19=(int(SC_USE_UV_MIN_MAX_alphaTexture)!=0);
float4 param_20=userUniformsObj.alphaTextureUvMinMax;
bool param_21=(int(SC_USE_CLAMP_TO_BORDER_alphaTexture)!=0);
float4 param_22=userUniformsObj.alphaTextureBorderColor;
float param_23=0.0;
float4 _2358=sc_SampleTextureBiasOrLevel(alphaTexture,alphaTextureSmpSC,param_12,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23);
float4 _2321=_2358;
alpha=_2358.x;
}
#endif
float4 param_24=float4(warpedColor.xyz,(warpedColor.w*alpha)*userUniformsObj.opacity);
sc_writeFragData0(param_24,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
