#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include "std2.metal"
#include "std2_vs.metal"
#include "std2_fs.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN(100)
//ubo float UserUniforms 0:35568:128 {
//float4 mainTextureSize 0
//float4 mainTextureDims 16
//float4 mainTextureView 32
//float3x3 mainTextureTransform 48
//float4 mainTextureUvMinMax 96
//float4 mainTextureBorderColor 112
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 mainTextureSize;
float4 mainTextureDims;
float4 mainTextureView;
float3x3 mainTextureTransform;
float4 mainTextureUvMinMax;
float4 mainTextureBorderColor;
};

#ifndef mainTextureHasSwappedViews
#define mainTextureHasSwappedViews 0
#elif mainTextureHasSwappedViews==1
#undef mainTextureHasSwappedViews
#define mainTextureHasSwappedViews 1
#endif
#ifndef mainTextureLayout
#define mainTextureLayout 0
#endif
#ifndef DEPTH_BLUR
#define DEPTH_BLUR 0
#elif DEPTH_BLUR==1
#undef DEPTH_BLUR
#define DEPTH_BLUR 1
#endif
#ifndef mainTextureUV
#define mainTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_mainTexture
#define SC_USE_UV_TRANSFORM_mainTexture 0
#elif SC_USE_UV_TRANSFORM_mainTexture==1
#undef SC_USE_UV_TRANSFORM_mainTexture
#define SC_USE_UV_TRANSFORM_mainTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_mainTexture
#define SC_SOFTWARE_WRAP_MODE_U_mainTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_mainTexture
#define SC_SOFTWARE_WRAP_MODE_V_mainTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_mainTexture
#define SC_USE_UV_MIN_MAX_mainTexture 0
#elif SC_USE_UV_MIN_MAX_mainTexture==1
#undef SC_USE_UV_MIN_MAX_mainTexture
#define SC_USE_UV_MIN_MAX_mainTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_mainTexture
#define SC_USE_CLAMP_TO_BORDER_mainTexture 0
#elif SC_USE_CLAMP_TO_BORDER_mainTexture==1
#undef SC_USE_CLAMP_TO_BORDER_mainTexture
#define SC_USE_CLAMP_TO_BORDER_mainTexture 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float2 blurCoordinates_0 [[user(locn10)]];
float2 blurCoordinates_1 [[user(locn11)]];
float2 blurCoordinates_2 [[user(locn12)]];
float2 blurCoordinates_3 [[user(locn13)]];
float2 blurCoordinates_4 [[user(locn14)]];
float2 blurCoordinates_5 [[user(locn15)]];
float2 blurCoordinates_6 [[user(locn16)]];
float2 blurCoordinates_7 [[user(locn17)]];
float2 blurCoordinates_8 [[user(locn18)]];
float2 blurCoordinates_9 [[user(locn19)]];
float2 blurCoordinates_10 [[user(locn20)]];
float2 blurCoordinates_11 [[user(locn21)]];
float2 blurCoordinates_12 [[user(locn22)]];
float2 blurCoordinates_13 [[user(locn23)]];
float2 blurCoordinates_14 [[user(locn24)]];
float2 blurCoordinates_15 [[user(locn25)]];
float2 blurCoordinates_16 [[user(locn26)]];
float2 blurCoordinates_17 [[user(locn27)]];
float2 blurCoordinates_18 [[user(locn28)]];
float2 blurCoordinates_19 [[user(locn29)]];
float2 blurCoordinates_20 [[user(locn30)]];
float2 blurCoordinates_21 [[user(locn31)]];
float2 blurCoordinates_22 [[user(locn32)]];
float2 blurCoordinates_23 [[user(locn33)]];
float2 blurCoordinates_24 [[user(locn34)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

void setBlurCoordinates(thread const float2& texCoords,thread const float4& size,thread float2 (&blurCoordinates)[25])
{
blurCoordinates[0]=texCoords+float2((-10.0)*size.z,(-10.0)*size.w);
blurCoordinates[1]=texCoords+float2((-10.0)*size.z,(-5.0)*size.w);
blurCoordinates[2]=texCoords+float2((-10.0)*size.z,0.0*size.w);
blurCoordinates[3]=texCoords+float2((-10.0)*size.z,5.0*size.w);
blurCoordinates[4]=texCoords+float2((-10.0)*size.z,10.0*size.w);
blurCoordinates[5]=texCoords+float2((-5.0)*size.z,(-10.0)*size.w);
blurCoordinates[6]=texCoords+float2((-5.0)*size.z,(-5.0)*size.w);
blurCoordinates[7]=texCoords+float2((-5.0)*size.z,0.0*size.w);
blurCoordinates[8]=texCoords+float2((-5.0)*size.z,5.0*size.w);
blurCoordinates[9]=texCoords+float2((-5.0)*size.z,10.0*size.w);
blurCoordinates[10]=texCoords+float2(0.0*size.z,(-10.0)*size.w);
blurCoordinates[11]=texCoords+float2(0.0*size.z,(-5.0)*size.w);
blurCoordinates[12]=texCoords+float2(0.0*size.z,0.0*size.w);
blurCoordinates[13]=texCoords+float2(0.0*size.z,5.0*size.w);
blurCoordinates[14]=texCoords+float2(0.0*size.z,10.0*size.w);
blurCoordinates[15]=texCoords+float2(5.0*size.z,(-10.0)*size.w);
blurCoordinates[16]=texCoords+float2(5.0*size.z,(-5.0)*size.w);
blurCoordinates[17]=texCoords+float2(5.0*size.z,0.0*size.w);
blurCoordinates[18]=texCoords+float2(5.0*size.z,5.0*size.w);
blurCoordinates[19]=texCoords+float2(5.0*size.z,10.0*size.w);
blurCoordinates[20]=texCoords+float2(10.0*size.z,(-10.0)*size.w);
blurCoordinates[21]=texCoords+float2(10.0*size.z,(-5.0)*size.w);
blurCoordinates[22]=texCoords+float2(10.0*size.z,0.0*size.w);
blurCoordinates[23]=texCoords+float2(10.0*size.z,5.0*size.w);
blurCoordinates[24]=texCoords+float2(10.0*size.z,10.0*size.w);
}

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant UserUniforms& userUniformsObj,constant LibraryUniforms& libraryUniformsObj,uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
float2 blurCoordinates[25]={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
float2 param=v.texture0;
float4 param_1=userUniformsObj.mainTextureSize;
setBlurCoordinates(param,param_1,blurCoordinates);
sc_Vertex_t param_2=v;
sc_ProcessVertex(param_2,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
out.blurCoordinates_0=blurCoordinates[0];
out.blurCoordinates_1=blurCoordinates[1];
out.blurCoordinates_2=blurCoordinates[2];
out.blurCoordinates_3=blurCoordinates[3];
out.blurCoordinates_4=blurCoordinates[4];
out.blurCoordinates_5=blurCoordinates[5];
out.blurCoordinates_6=blurCoordinates[6];
out.blurCoordinates_7=blurCoordinates[7];
out.blurCoordinates_8=blurCoordinates[8];
out.blurCoordinates_9=blurCoordinates[9];
out.blurCoordinates_10=blurCoordinates[10];
out.blurCoordinates_11=blurCoordinates[11];
out.blurCoordinates_12=blurCoordinates[12];
out.blurCoordinates_13=blurCoordinates[13];
out.blurCoordinates_14=blurCoordinates[14];
out.blurCoordinates_15=blurCoordinates[15];
out.blurCoordinates_16=blurCoordinates[16];
out.blurCoordinates_17=blurCoordinates[17];
out.blurCoordinates_18=blurCoordinates[18];
out.blurCoordinates_19=blurCoordinates[19];
out.blurCoordinates_20=blurCoordinates[20];
out.blurCoordinates_21=blurCoordinates[21];
out.blurCoordinates_22=blurCoordinates[22];
out.blurCoordinates_23=blurCoordinates[23];
out.blurCoordinates_24=blurCoordinates[24];
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN(100)
//sampler sampler mainTextureSmpSC 0:43517
//texture texture2D mainTexture 0:61325:0:43517
//ubo float UserUniforms 0:35568:128 {
//float4 mainTextureSize 0
//float4 mainTextureDims 16
//float4 mainTextureView 32
//float3x3 mainTextureTransform 48
//float4 mainTextureUvMinMax 96
//float4 mainTextureBorderColor 112
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 mainTextureSize;
float4 mainTextureDims;
float4 mainTextureView;
float3x3 mainTextureTransform;
float4 mainTextureUvMinMax;
float4 mainTextureBorderColor;
};

#ifndef mainTextureHasSwappedViews
#define mainTextureHasSwappedViews 0
#elif mainTextureHasSwappedViews==1
#undef mainTextureHasSwappedViews
#define mainTextureHasSwappedViews 1
#endif
#ifndef mainTextureLayout
#define mainTextureLayout 0
#endif
#ifndef SC_USE_UV_TRANSFORM_mainTexture
#define SC_USE_UV_TRANSFORM_mainTexture 0
#elif SC_USE_UV_TRANSFORM_mainTexture==1
#undef SC_USE_UV_TRANSFORM_mainTexture
#define SC_USE_UV_TRANSFORM_mainTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_mainTexture
#define SC_SOFTWARE_WRAP_MODE_U_mainTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_mainTexture
#define SC_SOFTWARE_WRAP_MODE_V_mainTexture -1
#endif
constant int2 _2212=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
#ifndef SC_USE_UV_MIN_MAX_mainTexture
#define SC_USE_UV_MIN_MAX_mainTexture 0
#elif SC_USE_UV_MIN_MAX_mainTexture==1
#undef SC_USE_UV_MIN_MAX_mainTexture
#define SC_USE_UV_MIN_MAX_mainTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_mainTexture
#define SC_USE_CLAMP_TO_BORDER_mainTexture 0
#elif SC_USE_CLAMP_TO_BORDER_mainTexture==1
#undef SC_USE_CLAMP_TO_BORDER_mainTexture
#define SC_USE_CLAMP_TO_BORDER_mainTexture 1
#endif
constant int2 _2247=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2278=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2309=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2340=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2371=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2403=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2435=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2467=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2499=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2531=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2563=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2595=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2627=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2659=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2691=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2723=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2755=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2787=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2819=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2851=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2883=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2915=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2947=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2979=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3019=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3046=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3075=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3104=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3133=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3162=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3191=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3220=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3249=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3278=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3307=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3336=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3365=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3394=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3423=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3452=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3481=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3510=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3539=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3568=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3597=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3626=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3655=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3684=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3713=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
#ifndef DEPTH_BLUR
#define DEPTH_BLUR 0
#elif DEPTH_BLUR==1
#undef DEPTH_BLUR
#define DEPTH_BLUR 1
#endif
#ifndef mainTextureUV
#define mainTextureUV 0
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float2 blurCoordinates_0 [[user(locn10)]];
float2 blurCoordinates_1 [[user(locn11)]];
float2 blurCoordinates_2 [[user(locn12)]];
float2 blurCoordinates_3 [[user(locn13)]];
float2 blurCoordinates_4 [[user(locn14)]];
float2 blurCoordinates_5 [[user(locn15)]];
float2 blurCoordinates_6 [[user(locn16)]];
float2 blurCoordinates_7 [[user(locn17)]];
float2 blurCoordinates_8 [[user(locn18)]];
float2 blurCoordinates_9 [[user(locn19)]];
float2 blurCoordinates_10 [[user(locn20)]];
float2 blurCoordinates_11 [[user(locn21)]];
float2 blurCoordinates_12 [[user(locn22)]];
float2 blurCoordinates_13 [[user(locn23)]];
float2 blurCoordinates_14 [[user(locn24)]];
float2 blurCoordinates_15 [[user(locn25)]];
float2 blurCoordinates_16 [[user(locn26)]];
float2 blurCoordinates_17 [[user(locn27)]];
float2 blurCoordinates_18 [[user(locn28)]];
float2 blurCoordinates_19 [[user(locn29)]];
float2 blurCoordinates_20 [[user(locn30)]];
float2 blurCoordinates_21 [[user(locn31)]];
float2 blurCoordinates_22 [[user(locn32)]];
float2 blurCoordinates_23 [[user(locn33)]];
float2 blurCoordinates_24 [[user(locn34)]];
};

float2 mainTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.mainTextureDims.xy;
}

int mainTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (mainTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float decode2(thread const float2& rg)
{
return dot(rg,float2(1.0,0.00392157));
}

float2 decodeSample(thread const float4& sampleValue)
{
float2 param=sampleValue.xy;
float2 param_1=sampleValue.zw;
return float2(decode2(param),decode2(param_1));
}

float2 blur_x_depth(thread int& varStereoViewID,constant UserUniforms& userUniformsObj,thread texture2d<float> mainTexture,thread sampler mainTextureSmpSC,thread float2 (&blurCoordinates)[25])
{
float2 param=mainTextureGetDims2D(userUniformsObj);
int param_1=mainTextureLayout;
int param_2=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_3=blurCoordinates[0];
bool param_4=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_5=userUniformsObj.mainTextureTransform;
int2 param_6=_2212;
bool param_7=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_8=userUniformsObj.mainTextureUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_10=userUniformsObj.mainTextureBorderColor;
float param_11=0.0;
float4 _2238=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
float4 _2202=_2238;
float4 param_12=_2238;
float2 blurredColor=decodeSample(param_12)/float2(25.0);
float2 param_13=mainTextureGetDims2D(userUniformsObj);
int param_14=mainTextureLayout;
int param_15=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_16=blurCoordinates[1];
bool param_17=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_18=userUniformsObj.mainTextureTransform;
int2 param_19=_2247;
bool param_20=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_21=userUniformsObj.mainTextureUvMinMax;
bool param_22=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_23=userUniformsObj.mainTextureBorderColor;
float param_24=0.0;
float4 _2268=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23,param_24);
float4 _2244=_2268;
float4 param_25=_2268;
blurredColor+=(decodeSample(param_25)/float2(25.0));
float2 param_26=mainTextureGetDims2D(userUniformsObj);
int param_27=mainTextureLayout;
int param_28=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_29=blurCoordinates[2];
bool param_30=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_31=userUniformsObj.mainTextureTransform;
int2 param_32=_2278;
bool param_33=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_34=userUniformsObj.mainTextureUvMinMax;
bool param_35=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_36=userUniformsObj.mainTextureBorderColor;
float param_37=0.0;
float4 _2299=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_26,param_27,param_28,param_29,param_30,param_31,param_32,param_33,param_34,param_35,param_36,param_37);
float4 _2275=_2299;
float4 param_38=_2299;
blurredColor+=(decodeSample(param_38)/float2(25.0));
float2 param_39=mainTextureGetDims2D(userUniformsObj);
int param_40=mainTextureLayout;
int param_41=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_42=blurCoordinates[3];
bool param_43=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_44=userUniformsObj.mainTextureTransform;
int2 param_45=_2309;
bool param_46=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_47=userUniformsObj.mainTextureUvMinMax;
bool param_48=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_49=userUniformsObj.mainTextureBorderColor;
float param_50=0.0;
float4 _2330=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_39,param_40,param_41,param_42,param_43,param_44,param_45,param_46,param_47,param_48,param_49,param_50);
float4 _2306=_2330;
float4 param_51=_2330;
blurredColor+=(decodeSample(param_51)/float2(25.0));
float2 param_52=mainTextureGetDims2D(userUniformsObj);
int param_53=mainTextureLayout;
int param_54=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_55=blurCoordinates[4];
bool param_56=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_57=userUniformsObj.mainTextureTransform;
int2 param_58=_2340;
bool param_59=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_60=userUniformsObj.mainTextureUvMinMax;
bool param_61=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_62=userUniformsObj.mainTextureBorderColor;
float param_63=0.0;
float4 _2361=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_52,param_53,param_54,param_55,param_56,param_57,param_58,param_59,param_60,param_61,param_62,param_63);
float4 _2337=_2361;
float4 param_64=_2361;
blurredColor+=(decodeSample(param_64)/float2(25.0));
float2 param_65=mainTextureGetDims2D(userUniformsObj);
int param_66=mainTextureLayout;
int param_67=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_68=blurCoordinates[5];
bool param_69=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_70=userUniformsObj.mainTextureTransform;
int2 param_71=_2371;
bool param_72=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_73=userUniformsObj.mainTextureUvMinMax;
bool param_74=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_75=userUniformsObj.mainTextureBorderColor;
float param_76=0.0;
float4 _2392=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_65,param_66,param_67,param_68,param_69,param_70,param_71,param_72,param_73,param_74,param_75,param_76);
float4 _2368=_2392;
float4 param_77=_2392;
blurredColor+=(decodeSample(param_77)/float2(25.0));
float2 param_78=mainTextureGetDims2D(userUniformsObj);
int param_79=mainTextureLayout;
int param_80=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_81=blurCoordinates[6];
bool param_82=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_83=userUniformsObj.mainTextureTransform;
int2 param_84=_2403;
bool param_85=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_86=userUniformsObj.mainTextureUvMinMax;
bool param_87=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_88=userUniformsObj.mainTextureBorderColor;
float param_89=0.0;
float4 _2424=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_78,param_79,param_80,param_81,param_82,param_83,param_84,param_85,param_86,param_87,param_88,param_89);
float4 _2399=_2424;
float4 param_90=_2424;
blurredColor+=(decodeSample(param_90)/float2(25.0));
float2 param_91=mainTextureGetDims2D(userUniformsObj);
int param_92=mainTextureLayout;
int param_93=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_94=blurCoordinates[7];
bool param_95=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_96=userUniformsObj.mainTextureTransform;
int2 param_97=_2435;
bool param_98=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_99=userUniformsObj.mainTextureUvMinMax;
bool param_100=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_101=userUniformsObj.mainTextureBorderColor;
float param_102=0.0;
float4 _2456=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_91,param_92,param_93,param_94,param_95,param_96,param_97,param_98,param_99,param_100,param_101,param_102);
float4 _2431=_2456;
float4 param_103=_2456;
blurredColor+=(decodeSample(param_103)/float2(25.0));
float2 param_104=mainTextureGetDims2D(userUniformsObj);
int param_105=mainTextureLayout;
int param_106=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_107=blurCoordinates[8];
bool param_108=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_109=userUniformsObj.mainTextureTransform;
int2 param_110=_2467;
bool param_111=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_112=userUniformsObj.mainTextureUvMinMax;
bool param_113=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_114=userUniformsObj.mainTextureBorderColor;
float param_115=0.0;
float4 _2488=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_104,param_105,param_106,param_107,param_108,param_109,param_110,param_111,param_112,param_113,param_114,param_115);
float4 _2463=_2488;
float4 param_116=_2488;
blurredColor+=(decodeSample(param_116)/float2(25.0));
float2 param_117=mainTextureGetDims2D(userUniformsObj);
int param_118=mainTextureLayout;
int param_119=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_120=blurCoordinates[9];
bool param_121=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_122=userUniformsObj.mainTextureTransform;
int2 param_123=_2499;
bool param_124=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_125=userUniformsObj.mainTextureUvMinMax;
bool param_126=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_127=userUniformsObj.mainTextureBorderColor;
float param_128=0.0;
float4 _2520=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_117,param_118,param_119,param_120,param_121,param_122,param_123,param_124,param_125,param_126,param_127,param_128);
float4 _2495=_2520;
float4 param_129=_2520;
blurredColor+=(decodeSample(param_129)/float2(25.0));
float2 param_130=mainTextureGetDims2D(userUniformsObj);
int param_131=mainTextureLayout;
int param_132=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_133=blurCoordinates[10];
bool param_134=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_135=userUniformsObj.mainTextureTransform;
int2 param_136=_2531;
bool param_137=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_138=userUniformsObj.mainTextureUvMinMax;
bool param_139=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_140=userUniformsObj.mainTextureBorderColor;
float param_141=0.0;
float4 _2552=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_130,param_131,param_132,param_133,param_134,param_135,param_136,param_137,param_138,param_139,param_140,param_141);
float4 _2527=_2552;
float4 param_142=_2552;
blurredColor+=(decodeSample(param_142)/float2(25.0));
float2 param_143=mainTextureGetDims2D(userUniformsObj);
int param_144=mainTextureLayout;
int param_145=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_146=blurCoordinates[11];
bool param_147=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_148=userUniformsObj.mainTextureTransform;
int2 param_149=_2563;
bool param_150=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_151=userUniformsObj.mainTextureUvMinMax;
bool param_152=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_153=userUniformsObj.mainTextureBorderColor;
float param_154=0.0;
float4 _2584=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_143,param_144,param_145,param_146,param_147,param_148,param_149,param_150,param_151,param_152,param_153,param_154);
float4 _2559=_2584;
float4 param_155=_2584;
blurredColor+=(decodeSample(param_155)/float2(25.0));
float2 param_156=mainTextureGetDims2D(userUniformsObj);
int param_157=mainTextureLayout;
int param_158=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_159=blurCoordinates[12];
bool param_160=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_161=userUniformsObj.mainTextureTransform;
int2 param_162=_2595;
bool param_163=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_164=userUniformsObj.mainTextureUvMinMax;
bool param_165=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_166=userUniformsObj.mainTextureBorderColor;
float param_167=0.0;
float4 _2616=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_156,param_157,param_158,param_159,param_160,param_161,param_162,param_163,param_164,param_165,param_166,param_167);
float4 _2591=_2616;
float4 param_168=_2616;
blurredColor+=(decodeSample(param_168)/float2(25.0));
float2 param_169=mainTextureGetDims2D(userUniformsObj);
int param_170=mainTextureLayout;
int param_171=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_172=blurCoordinates[13];
bool param_173=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_174=userUniformsObj.mainTextureTransform;
int2 param_175=_2627;
bool param_176=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_177=userUniformsObj.mainTextureUvMinMax;
bool param_178=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_179=userUniformsObj.mainTextureBorderColor;
float param_180=0.0;
float4 _2648=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_169,param_170,param_171,param_172,param_173,param_174,param_175,param_176,param_177,param_178,param_179,param_180);
float4 _2623=_2648;
float4 param_181=_2648;
blurredColor+=(decodeSample(param_181)/float2(25.0));
float2 param_182=mainTextureGetDims2D(userUniformsObj);
int param_183=mainTextureLayout;
int param_184=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_185=blurCoordinates[14];
bool param_186=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_187=userUniformsObj.mainTextureTransform;
int2 param_188=_2659;
bool param_189=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_190=userUniformsObj.mainTextureUvMinMax;
bool param_191=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_192=userUniformsObj.mainTextureBorderColor;
float param_193=0.0;
float4 _2680=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_182,param_183,param_184,param_185,param_186,param_187,param_188,param_189,param_190,param_191,param_192,param_193);
float4 _2655=_2680;
float4 param_194=_2680;
blurredColor+=(decodeSample(param_194)/float2(25.0));
float2 param_195=mainTextureGetDims2D(userUniformsObj);
int param_196=mainTextureLayout;
int param_197=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_198=blurCoordinates[15];
bool param_199=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_200=userUniformsObj.mainTextureTransform;
int2 param_201=_2691;
bool param_202=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_203=userUniformsObj.mainTextureUvMinMax;
bool param_204=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_205=userUniformsObj.mainTextureBorderColor;
float param_206=0.0;
float4 _2712=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_195,param_196,param_197,param_198,param_199,param_200,param_201,param_202,param_203,param_204,param_205,param_206);
float4 _2687=_2712;
float4 param_207=_2712;
blurredColor+=(decodeSample(param_207)/float2(25.0));
float2 param_208=mainTextureGetDims2D(userUniformsObj);
int param_209=mainTextureLayout;
int param_210=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_211=blurCoordinates[16];
bool param_212=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_213=userUniformsObj.mainTextureTransform;
int2 param_214=_2723;
bool param_215=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_216=userUniformsObj.mainTextureUvMinMax;
bool param_217=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_218=userUniformsObj.mainTextureBorderColor;
float param_219=0.0;
float4 _2744=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_208,param_209,param_210,param_211,param_212,param_213,param_214,param_215,param_216,param_217,param_218,param_219);
float4 _2719=_2744;
float4 param_220=_2744;
blurredColor+=(decodeSample(param_220)/float2(25.0));
float2 param_221=mainTextureGetDims2D(userUniformsObj);
int param_222=mainTextureLayout;
int param_223=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_224=blurCoordinates[17];
bool param_225=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_226=userUniformsObj.mainTextureTransform;
int2 param_227=_2755;
bool param_228=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_229=userUniformsObj.mainTextureUvMinMax;
bool param_230=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_231=userUniformsObj.mainTextureBorderColor;
float param_232=0.0;
float4 _2776=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_221,param_222,param_223,param_224,param_225,param_226,param_227,param_228,param_229,param_230,param_231,param_232);
float4 _2751=_2776;
float4 param_233=_2776;
blurredColor+=(decodeSample(param_233)/float2(25.0));
float2 param_234=mainTextureGetDims2D(userUniformsObj);
int param_235=mainTextureLayout;
int param_236=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_237=blurCoordinates[18];
bool param_238=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_239=userUniformsObj.mainTextureTransform;
int2 param_240=_2787;
bool param_241=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_242=userUniformsObj.mainTextureUvMinMax;
bool param_243=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_244=userUniformsObj.mainTextureBorderColor;
float param_245=0.0;
float4 _2808=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_234,param_235,param_236,param_237,param_238,param_239,param_240,param_241,param_242,param_243,param_244,param_245);
float4 _2783=_2808;
float4 param_246=_2808;
blurredColor+=(decodeSample(param_246)/float2(25.0));
float2 param_247=mainTextureGetDims2D(userUniformsObj);
int param_248=mainTextureLayout;
int param_249=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_250=blurCoordinates[19];
bool param_251=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_252=userUniformsObj.mainTextureTransform;
int2 param_253=_2819;
bool param_254=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_255=userUniformsObj.mainTextureUvMinMax;
bool param_256=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_257=userUniformsObj.mainTextureBorderColor;
float param_258=0.0;
float4 _2840=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_247,param_248,param_249,param_250,param_251,param_252,param_253,param_254,param_255,param_256,param_257,param_258);
float4 _2815=_2840;
float4 param_259=_2840;
blurredColor+=(decodeSample(param_259)/float2(25.0));
float2 param_260=mainTextureGetDims2D(userUniformsObj);
int param_261=mainTextureLayout;
int param_262=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_263=blurCoordinates[20];
bool param_264=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_265=userUniformsObj.mainTextureTransform;
int2 param_266=_2851;
bool param_267=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_268=userUniformsObj.mainTextureUvMinMax;
bool param_269=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_270=userUniformsObj.mainTextureBorderColor;
float param_271=0.0;
float4 _2872=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_260,param_261,param_262,param_263,param_264,param_265,param_266,param_267,param_268,param_269,param_270,param_271);
float4 _2847=_2872;
float4 param_272=_2872;
blurredColor+=(decodeSample(param_272)/float2(25.0));
float2 param_273=mainTextureGetDims2D(userUniformsObj);
int param_274=mainTextureLayout;
int param_275=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_276=blurCoordinates[21];
bool param_277=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_278=userUniformsObj.mainTextureTransform;
int2 param_279=_2883;
bool param_280=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_281=userUniformsObj.mainTextureUvMinMax;
bool param_282=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_283=userUniformsObj.mainTextureBorderColor;
float param_284=0.0;
float4 _2904=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_273,param_274,param_275,param_276,param_277,param_278,param_279,param_280,param_281,param_282,param_283,param_284);
float4 _2879=_2904;
float4 param_285=_2904;
blurredColor+=(decodeSample(param_285)/float2(25.0));
float2 param_286=mainTextureGetDims2D(userUniformsObj);
int param_287=mainTextureLayout;
int param_288=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_289=blurCoordinates[22];
bool param_290=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_291=userUniformsObj.mainTextureTransform;
int2 param_292=_2915;
bool param_293=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_294=userUniformsObj.mainTextureUvMinMax;
bool param_295=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_296=userUniformsObj.mainTextureBorderColor;
float param_297=0.0;
float4 _2936=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_286,param_287,param_288,param_289,param_290,param_291,param_292,param_293,param_294,param_295,param_296,param_297);
float4 _2911=_2936;
float4 param_298=_2936;
blurredColor+=(decodeSample(param_298)/float2(25.0));
float2 param_299=mainTextureGetDims2D(userUniformsObj);
int param_300=mainTextureLayout;
int param_301=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_302=blurCoordinates[23];
bool param_303=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_304=userUniformsObj.mainTextureTransform;
int2 param_305=_2947;
bool param_306=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_307=userUniformsObj.mainTextureUvMinMax;
bool param_308=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_309=userUniformsObj.mainTextureBorderColor;
float param_310=0.0;
float4 _2968=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_299,param_300,param_301,param_302,param_303,param_304,param_305,param_306,param_307,param_308,param_309,param_310);
float4 _2943=_2968;
float4 param_311=_2968;
blurredColor+=(decodeSample(param_311)/float2(25.0));
float2 param_312=mainTextureGetDims2D(userUniformsObj);
int param_313=mainTextureLayout;
int param_314=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_315=blurCoordinates[24];
bool param_316=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_317=userUniformsObj.mainTextureTransform;
int2 param_318=_2979;
bool param_319=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_320=userUniformsObj.mainTextureUvMinMax;
bool param_321=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_322=userUniformsObj.mainTextureBorderColor;
float param_323=0.0;
float4 _3000=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_312,param_313,param_314,param_315,param_316,param_317,param_318,param_319,param_320,param_321,param_322,param_323);
float4 _2975=_3000;
float4 param_324=_3000;
blurredColor+=(decodeSample(param_324)/float2(25.0));
blurredColor=fast::clamp(blurredColor,float2(0.0),float2(0.99999));
return blurredColor;
}

float2 encode2(thread const float& v)
{
float2 enc=fract(float2(1.0,255.0)*v);
enc.x-=(enc.y/255.0);
return enc;
}

float4 blur_x(thread int& varStereoViewID,constant UserUniforms& userUniformsObj,thread texture2d<float> mainTexture,thread sampler mainTextureSmpSC,thread float2 (&blurCoordinates)[25])
{
float2 param=mainTextureGetDims2D(userUniformsObj);
int param_1=mainTextureLayout;
int param_2=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_3=blurCoordinates[0];
bool param_4=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_5=userUniformsObj.mainTextureTransform;
int2 param_6=_3019;
bool param_7=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_8=userUniformsObj.mainTextureUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_10=userUniformsObj.mainTextureBorderColor;
float param_11=0.0;
float4 _3040=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
float4 _3016=_3040;
float4 blurredColor=_3040/float4(25.0);
float2 param_12=mainTextureGetDims2D(userUniformsObj);
int param_13=mainTextureLayout;
int param_14=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_15=blurCoordinates[1];
bool param_16=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_17=userUniformsObj.mainTextureTransform;
int2 param_18=_3046;
bool param_19=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_20=userUniformsObj.mainTextureUvMinMax;
bool param_21=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_22=userUniformsObj.mainTextureBorderColor;
float param_23=0.0;
float4 _3067=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_12,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23);
float4 _3043=_3067;
blurredColor+=(_3067/float4(25.0));
float2 param_24=mainTextureGetDims2D(userUniformsObj);
int param_25=mainTextureLayout;
int param_26=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_27=blurCoordinates[2];
bool param_28=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_29=userUniformsObj.mainTextureTransform;
int2 param_30=_3075;
bool param_31=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_32=userUniformsObj.mainTextureUvMinMax;
bool param_33=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_34=userUniformsObj.mainTextureBorderColor;
float param_35=0.0;
float4 _3096=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_24,param_25,param_26,param_27,param_28,param_29,param_30,param_31,param_32,param_33,param_34,param_35);
float4 _3072=_3096;
blurredColor+=(_3096/float4(25.0));
float2 param_36=mainTextureGetDims2D(userUniformsObj);
int param_37=mainTextureLayout;
int param_38=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_39=blurCoordinates[3];
bool param_40=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_41=userUniformsObj.mainTextureTransform;
int2 param_42=_3104;
bool param_43=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_44=userUniformsObj.mainTextureUvMinMax;
bool param_45=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_46=userUniformsObj.mainTextureBorderColor;
float param_47=0.0;
float4 _3125=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_36,param_37,param_38,param_39,param_40,param_41,param_42,param_43,param_44,param_45,param_46,param_47);
float4 _3101=_3125;
blurredColor+=(_3125/float4(25.0));
float2 param_48=mainTextureGetDims2D(userUniformsObj);
int param_49=mainTextureLayout;
int param_50=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_51=blurCoordinates[4];
bool param_52=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_53=userUniformsObj.mainTextureTransform;
int2 param_54=_3133;
bool param_55=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_56=userUniformsObj.mainTextureUvMinMax;
bool param_57=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_58=userUniformsObj.mainTextureBorderColor;
float param_59=0.0;
float4 _3154=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_48,param_49,param_50,param_51,param_52,param_53,param_54,param_55,param_56,param_57,param_58,param_59);
float4 _3130=_3154;
blurredColor+=(_3154/float4(25.0));
float2 param_60=mainTextureGetDims2D(userUniformsObj);
int param_61=mainTextureLayout;
int param_62=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_63=blurCoordinates[5];
bool param_64=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_65=userUniformsObj.mainTextureTransform;
int2 param_66=_3162;
bool param_67=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_68=userUniformsObj.mainTextureUvMinMax;
bool param_69=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_70=userUniformsObj.mainTextureBorderColor;
float param_71=0.0;
float4 _3183=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_60,param_61,param_62,param_63,param_64,param_65,param_66,param_67,param_68,param_69,param_70,param_71);
float4 _3159=_3183;
blurredColor+=(_3183/float4(25.0));
float2 param_72=mainTextureGetDims2D(userUniformsObj);
int param_73=mainTextureLayout;
int param_74=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_75=blurCoordinates[6];
bool param_76=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_77=userUniformsObj.mainTextureTransform;
int2 param_78=_3191;
bool param_79=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_80=userUniformsObj.mainTextureUvMinMax;
bool param_81=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_82=userUniformsObj.mainTextureBorderColor;
float param_83=0.0;
float4 _3212=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_72,param_73,param_74,param_75,param_76,param_77,param_78,param_79,param_80,param_81,param_82,param_83);
float4 _3188=_3212;
blurredColor+=(_3212/float4(25.0));
float2 param_84=mainTextureGetDims2D(userUniformsObj);
int param_85=mainTextureLayout;
int param_86=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_87=blurCoordinates[7];
bool param_88=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_89=userUniformsObj.mainTextureTransform;
int2 param_90=_3220;
bool param_91=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_92=userUniformsObj.mainTextureUvMinMax;
bool param_93=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_94=userUniformsObj.mainTextureBorderColor;
float param_95=0.0;
float4 _3241=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_84,param_85,param_86,param_87,param_88,param_89,param_90,param_91,param_92,param_93,param_94,param_95);
float4 _3217=_3241;
blurredColor+=(_3241/float4(25.0));
float2 param_96=mainTextureGetDims2D(userUniformsObj);
int param_97=mainTextureLayout;
int param_98=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_99=blurCoordinates[8];
bool param_100=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_101=userUniformsObj.mainTextureTransform;
int2 param_102=_3249;
bool param_103=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_104=userUniformsObj.mainTextureUvMinMax;
bool param_105=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_106=userUniformsObj.mainTextureBorderColor;
float param_107=0.0;
float4 _3270=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_96,param_97,param_98,param_99,param_100,param_101,param_102,param_103,param_104,param_105,param_106,param_107);
float4 _3246=_3270;
blurredColor+=(_3270/float4(25.0));
float2 param_108=mainTextureGetDims2D(userUniformsObj);
int param_109=mainTextureLayout;
int param_110=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_111=blurCoordinates[9];
bool param_112=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_113=userUniformsObj.mainTextureTransform;
int2 param_114=_3278;
bool param_115=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_116=userUniformsObj.mainTextureUvMinMax;
bool param_117=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_118=userUniformsObj.mainTextureBorderColor;
float param_119=0.0;
float4 _3299=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_108,param_109,param_110,param_111,param_112,param_113,param_114,param_115,param_116,param_117,param_118,param_119);
float4 _3275=_3299;
blurredColor+=(_3299/float4(25.0));
float2 param_120=mainTextureGetDims2D(userUniformsObj);
int param_121=mainTextureLayout;
int param_122=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_123=blurCoordinates[10];
bool param_124=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_125=userUniformsObj.mainTextureTransform;
int2 param_126=_3307;
bool param_127=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_128=userUniformsObj.mainTextureUvMinMax;
bool param_129=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_130=userUniformsObj.mainTextureBorderColor;
float param_131=0.0;
float4 _3328=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_120,param_121,param_122,param_123,param_124,param_125,param_126,param_127,param_128,param_129,param_130,param_131);
float4 _3304=_3328;
blurredColor+=(_3328/float4(25.0));
float2 param_132=mainTextureGetDims2D(userUniformsObj);
int param_133=mainTextureLayout;
int param_134=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_135=blurCoordinates[11];
bool param_136=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_137=userUniformsObj.mainTextureTransform;
int2 param_138=_3336;
bool param_139=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_140=userUniformsObj.mainTextureUvMinMax;
bool param_141=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_142=userUniformsObj.mainTextureBorderColor;
float param_143=0.0;
float4 _3357=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_132,param_133,param_134,param_135,param_136,param_137,param_138,param_139,param_140,param_141,param_142,param_143);
float4 _3333=_3357;
blurredColor+=(_3357/float4(25.0));
float2 param_144=mainTextureGetDims2D(userUniformsObj);
int param_145=mainTextureLayout;
int param_146=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_147=blurCoordinates[12];
bool param_148=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_149=userUniformsObj.mainTextureTransform;
int2 param_150=_3365;
bool param_151=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_152=userUniformsObj.mainTextureUvMinMax;
bool param_153=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_154=userUniformsObj.mainTextureBorderColor;
float param_155=0.0;
float4 _3386=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_144,param_145,param_146,param_147,param_148,param_149,param_150,param_151,param_152,param_153,param_154,param_155);
float4 _3362=_3386;
blurredColor+=(_3386/float4(25.0));
float2 param_156=mainTextureGetDims2D(userUniformsObj);
int param_157=mainTextureLayout;
int param_158=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_159=blurCoordinates[13];
bool param_160=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_161=userUniformsObj.mainTextureTransform;
int2 param_162=_3394;
bool param_163=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_164=userUniformsObj.mainTextureUvMinMax;
bool param_165=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_166=userUniformsObj.mainTextureBorderColor;
float param_167=0.0;
float4 _3415=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_156,param_157,param_158,param_159,param_160,param_161,param_162,param_163,param_164,param_165,param_166,param_167);
float4 _3391=_3415;
blurredColor+=(_3415/float4(25.0));
float2 param_168=mainTextureGetDims2D(userUniformsObj);
int param_169=mainTextureLayout;
int param_170=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_171=blurCoordinates[14];
bool param_172=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_173=userUniformsObj.mainTextureTransform;
int2 param_174=_3423;
bool param_175=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_176=userUniformsObj.mainTextureUvMinMax;
bool param_177=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_178=userUniformsObj.mainTextureBorderColor;
float param_179=0.0;
float4 _3444=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_168,param_169,param_170,param_171,param_172,param_173,param_174,param_175,param_176,param_177,param_178,param_179);
float4 _3420=_3444;
blurredColor+=(_3444/float4(25.0));
float2 param_180=mainTextureGetDims2D(userUniformsObj);
int param_181=mainTextureLayout;
int param_182=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_183=blurCoordinates[15];
bool param_184=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_185=userUniformsObj.mainTextureTransform;
int2 param_186=_3452;
bool param_187=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_188=userUniformsObj.mainTextureUvMinMax;
bool param_189=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_190=userUniformsObj.mainTextureBorderColor;
float param_191=0.0;
float4 _3473=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_180,param_181,param_182,param_183,param_184,param_185,param_186,param_187,param_188,param_189,param_190,param_191);
float4 _3449=_3473;
blurredColor+=(_3473/float4(25.0));
float2 param_192=mainTextureGetDims2D(userUniformsObj);
int param_193=mainTextureLayout;
int param_194=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_195=blurCoordinates[16];
bool param_196=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_197=userUniformsObj.mainTextureTransform;
int2 param_198=_3481;
bool param_199=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_200=userUniformsObj.mainTextureUvMinMax;
bool param_201=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_202=userUniformsObj.mainTextureBorderColor;
float param_203=0.0;
float4 _3502=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_192,param_193,param_194,param_195,param_196,param_197,param_198,param_199,param_200,param_201,param_202,param_203);
float4 _3478=_3502;
blurredColor+=(_3502/float4(25.0));
float2 param_204=mainTextureGetDims2D(userUniformsObj);
int param_205=mainTextureLayout;
int param_206=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_207=blurCoordinates[17];
bool param_208=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_209=userUniformsObj.mainTextureTransform;
int2 param_210=_3510;
bool param_211=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_212=userUniformsObj.mainTextureUvMinMax;
bool param_213=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_214=userUniformsObj.mainTextureBorderColor;
float param_215=0.0;
float4 _3531=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_204,param_205,param_206,param_207,param_208,param_209,param_210,param_211,param_212,param_213,param_214,param_215);
float4 _3507=_3531;
blurredColor+=(_3531/float4(25.0));
float2 param_216=mainTextureGetDims2D(userUniformsObj);
int param_217=mainTextureLayout;
int param_218=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_219=blurCoordinates[18];
bool param_220=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_221=userUniformsObj.mainTextureTransform;
int2 param_222=_3539;
bool param_223=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_224=userUniformsObj.mainTextureUvMinMax;
bool param_225=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_226=userUniformsObj.mainTextureBorderColor;
float param_227=0.0;
float4 _3560=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_216,param_217,param_218,param_219,param_220,param_221,param_222,param_223,param_224,param_225,param_226,param_227);
float4 _3536=_3560;
blurredColor+=(_3560/float4(25.0));
float2 param_228=mainTextureGetDims2D(userUniformsObj);
int param_229=mainTextureLayout;
int param_230=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_231=blurCoordinates[19];
bool param_232=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_233=userUniformsObj.mainTextureTransform;
int2 param_234=_3568;
bool param_235=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_236=userUniformsObj.mainTextureUvMinMax;
bool param_237=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_238=userUniformsObj.mainTextureBorderColor;
float param_239=0.0;
float4 _3589=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_228,param_229,param_230,param_231,param_232,param_233,param_234,param_235,param_236,param_237,param_238,param_239);
float4 _3565=_3589;
blurredColor+=(_3589/float4(25.0));
float2 param_240=mainTextureGetDims2D(userUniformsObj);
int param_241=mainTextureLayout;
int param_242=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_243=blurCoordinates[20];
bool param_244=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_245=userUniformsObj.mainTextureTransform;
int2 param_246=_3597;
bool param_247=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_248=userUniformsObj.mainTextureUvMinMax;
bool param_249=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_250=userUniformsObj.mainTextureBorderColor;
float param_251=0.0;
float4 _3618=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_240,param_241,param_242,param_243,param_244,param_245,param_246,param_247,param_248,param_249,param_250,param_251);
float4 _3594=_3618;
blurredColor+=(_3618/float4(25.0));
float2 param_252=mainTextureGetDims2D(userUniformsObj);
int param_253=mainTextureLayout;
int param_254=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_255=blurCoordinates[21];
bool param_256=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_257=userUniformsObj.mainTextureTransform;
int2 param_258=_3626;
bool param_259=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_260=userUniformsObj.mainTextureUvMinMax;
bool param_261=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_262=userUniformsObj.mainTextureBorderColor;
float param_263=0.0;
float4 _3647=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_252,param_253,param_254,param_255,param_256,param_257,param_258,param_259,param_260,param_261,param_262,param_263);
float4 _3623=_3647;
blurredColor+=(_3647/float4(25.0));
float2 param_264=mainTextureGetDims2D(userUniformsObj);
int param_265=mainTextureLayout;
int param_266=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_267=blurCoordinates[22];
bool param_268=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_269=userUniformsObj.mainTextureTransform;
int2 param_270=_3655;
bool param_271=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_272=userUniformsObj.mainTextureUvMinMax;
bool param_273=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_274=userUniformsObj.mainTextureBorderColor;
float param_275=0.0;
float4 _3676=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_264,param_265,param_266,param_267,param_268,param_269,param_270,param_271,param_272,param_273,param_274,param_275);
float4 _3652=_3676;
blurredColor+=(_3676/float4(25.0));
float2 param_276=mainTextureGetDims2D(userUniformsObj);
int param_277=mainTextureLayout;
int param_278=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_279=blurCoordinates[23];
bool param_280=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_281=userUniformsObj.mainTextureTransform;
int2 param_282=_3684;
bool param_283=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_284=userUniformsObj.mainTextureUvMinMax;
bool param_285=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_286=userUniformsObj.mainTextureBorderColor;
float param_287=0.0;
float4 _3705=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_276,param_277,param_278,param_279,param_280,param_281,param_282,param_283,param_284,param_285,param_286,param_287);
float4 _3681=_3705;
blurredColor+=(_3705/float4(25.0));
float2 param_288=mainTextureGetDims2D(userUniformsObj);
int param_289=mainTextureLayout;
int param_290=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_291=blurCoordinates[24];
bool param_292=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_293=userUniformsObj.mainTextureTransform;
int2 param_294=_3713;
bool param_295=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_296=userUniformsObj.mainTextureUvMinMax;
bool param_297=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_298=userUniformsObj.mainTextureBorderColor;
float param_299=0.0;
float4 _3734=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_288,param_289,param_290,param_291,param_292,param_293,param_294,param_295,param_296,param_297,param_298,param_299);
float4 _3710=_3734;
blurredColor+=(_3734/float4(25.0));
blurredColor=fast::clamp(blurredColor,float4(0.0),float4(0.99999));
return blurredColor;
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj,texture2d<float> mainTexture,sampler mainTextureSmpSC,float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float2 blurCoordinates[25]={};
blurCoordinates[0]=in.blurCoordinates_0;
blurCoordinates[1]=in.blurCoordinates_1;
blurCoordinates[2]=in.blurCoordinates_2;
blurCoordinates[3]=in.blurCoordinates_3;
blurCoordinates[4]=in.blurCoordinates_4;
blurCoordinates[5]=in.blurCoordinates_5;
blurCoordinates[6]=in.blurCoordinates_6;
blurCoordinates[7]=in.blurCoordinates_7;
blurCoordinates[8]=in.blurCoordinates_8;
blurCoordinates[9]=in.blurCoordinates_9;
blurCoordinates[10]=in.blurCoordinates_10;
blurCoordinates[11]=in.blurCoordinates_11;
blurCoordinates[12]=in.blurCoordinates_12;
blurCoordinates[13]=in.blurCoordinates_13;
blurCoordinates[14]=in.blurCoordinates_14;
blurCoordinates[15]=in.blurCoordinates_15;
blurCoordinates[16]=in.blurCoordinates_16;
blurCoordinates[17]=in.blurCoordinates_17;
blurCoordinates[18]=in.blurCoordinates_18;
blurCoordinates[19]=in.blurCoordinates_19;
blurCoordinates[20]=in.blurCoordinates_20;
blurCoordinates[21]=in.blurCoordinates_21;
blurCoordinates[22]=in.blurCoordinates_22;
blurCoordinates[23]=in.blurCoordinates_23;
blurCoordinates[24]=in.blurCoordinates_24;
float4 result;
#if (DEPTH_BLUR)
{
float2 blurValue=blur_x_depth(in.varStereoViewID,userUniformsObj,mainTexture,mainTextureSmpSC,blurCoordinates);
float param=blurValue.x;
float param_1=blurValue.y;
result=float4(encode2(param),encode2(param_1));
}
#else
{
result=blur_x(in.varStereoViewID,userUniformsObj,mainTexture,mainTextureSmpSC,blurCoordinates);
}
#endif
float4 param_2=result;
sc_writeFragData0(param_2,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
