#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include "std2.metal"
#include "std2_vs.metal"
#include "std2_fs.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN(100)
//ubo float UserUniforms 0:35568:128 {
//float4 mainTextureSize 0
//float4 mainTextureDims 16
//float4 mainTextureView 32
//float3x3 mainTextureTransform 48
//float4 mainTextureUvMinMax 96
//float4 mainTextureBorderColor 112
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 mainTextureSize;
float4 mainTextureDims;
float4 mainTextureView;
float3x3 mainTextureTransform;
float4 mainTextureUvMinMax;
float4 mainTextureBorderColor;
};

#ifndef mainTextureHasSwappedViews
#define mainTextureHasSwappedViews 0
#elif mainTextureHasSwappedViews==1
#undef mainTextureHasSwappedViews
#define mainTextureHasSwappedViews 1
#endif
#ifndef mainTextureLayout
#define mainTextureLayout 0
#endif
#ifndef DEPTH_BLUR
#define DEPTH_BLUR 0
#elif DEPTH_BLUR==1
#undef DEPTH_BLUR
#define DEPTH_BLUR 1
#endif
#ifndef mainTextureUV
#define mainTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_mainTexture
#define SC_USE_UV_TRANSFORM_mainTexture 0
#elif SC_USE_UV_TRANSFORM_mainTexture==1
#undef SC_USE_UV_TRANSFORM_mainTexture
#define SC_USE_UV_TRANSFORM_mainTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_mainTexture
#define SC_SOFTWARE_WRAP_MODE_U_mainTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_mainTexture
#define SC_SOFTWARE_WRAP_MODE_V_mainTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_mainTexture
#define SC_USE_UV_MIN_MAX_mainTexture 0
#elif SC_USE_UV_MIN_MAX_mainTexture==1
#undef SC_USE_UV_MIN_MAX_mainTexture
#define SC_USE_UV_MIN_MAX_mainTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_mainTexture
#define SC_USE_CLAMP_TO_BORDER_mainTexture 0
#elif SC_USE_CLAMP_TO_BORDER_mainTexture==1
#undef SC_USE_CLAMP_TO_BORDER_mainTexture
#define SC_USE_CLAMP_TO_BORDER_mainTexture 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float2 blurCoordinates_0 [[user(locn10)]];
float2 blurCoordinates_1 [[user(locn11)]];
float2 blurCoordinates_2 [[user(locn12)]];
float2 blurCoordinates_3 [[user(locn13)]];
float2 blurCoordinates_4 [[user(locn14)]];
float2 blurCoordinates_5 [[user(locn15)]];
float2 blurCoordinates_6 [[user(locn16)]];
float2 blurCoordinates_7 [[user(locn17)]];
float2 blurCoordinates_8 [[user(locn18)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

void setBlurCoordinates(thread const float2& texCoords,thread const float4& size,thread float2 (&blurCoordinates)[9])
{
blurCoordinates[0]=texCoords+float2(0.0*size.z,0.0*size.w);
blurCoordinates[1]=texCoords+float2(1.18243*size.z,0.0*size.w);
blurCoordinates[2]=texCoords+float2(0.0*size.z,1.18243*size.w);
blurCoordinates[3]=texCoords+float2((-1.18243)*size.z,0.0*size.w);
blurCoordinates[4]=texCoords+float2(0.0*size.z,(-1.18243)*size.w);
blurCoordinates[5]=texCoords+float2(1.18243*size.z,1.18243*size.w);
blurCoordinates[6]=texCoords+float2((-1.18243)*size.z,1.18243*size.w);
blurCoordinates[7]=texCoords+float2((-1.18243)*size.z,(-1.18243)*size.w);
blurCoordinates[8]=texCoords+float2(1.18243*size.z,(-1.18243)*size.w);
}

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant UserUniforms& userUniformsObj,constant LibraryUniforms& libraryUniformsObj,uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
float2 blurCoordinates[9]={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
float2 param=v.texture0;
float4 param_1=userUniformsObj.mainTextureSize;
setBlurCoordinates(param,param_1,blurCoordinates);
sc_Vertex_t param_2=v;
sc_ProcessVertex(param_2,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
out.blurCoordinates_0=blurCoordinates[0];
out.blurCoordinates_1=blurCoordinates[1];
out.blurCoordinates_2=blurCoordinates[2];
out.blurCoordinates_3=blurCoordinates[3];
out.blurCoordinates_4=blurCoordinates[4];
out.blurCoordinates_5=blurCoordinates[5];
out.blurCoordinates_6=blurCoordinates[6];
out.blurCoordinates_7=blurCoordinates[7];
out.blurCoordinates_8=blurCoordinates[8];
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN(100)
//sampler sampler mainTextureSmpSC 0:43517
//texture texture2D mainTexture 0:61325:0:43517
//ubo float UserUniforms 0:35568:128 {
//float4 mainTextureSize 0
//float4 mainTextureDims 16
//float4 mainTextureView 32
//float3x3 mainTextureTransform 48
//float4 mainTextureUvMinMax 96
//float4 mainTextureBorderColor 112
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 mainTextureSize;
float4 mainTextureDims;
float4 mainTextureView;
float3x3 mainTextureTransform;
float4 mainTextureUvMinMax;
float4 mainTextureBorderColor;
};

#ifndef mainTextureHasSwappedViews
#define mainTextureHasSwappedViews 0
#elif mainTextureHasSwappedViews==1
#undef mainTextureHasSwappedViews
#define mainTextureHasSwappedViews 1
#endif
#ifndef mainTextureLayout
#define mainTextureLayout 0
#endif
#ifndef SC_USE_UV_TRANSFORM_mainTexture
#define SC_USE_UV_TRANSFORM_mainTexture 0
#elif SC_USE_UV_TRANSFORM_mainTexture==1
#undef SC_USE_UV_TRANSFORM_mainTexture
#define SC_USE_UV_TRANSFORM_mainTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_mainTexture
#define SC_SOFTWARE_WRAP_MODE_U_mainTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_mainTexture
#define SC_SOFTWARE_WRAP_MODE_V_mainTexture -1
#endif
constant int2 _2212=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
#ifndef SC_USE_UV_MIN_MAX_mainTexture
#define SC_USE_UV_MIN_MAX_mainTexture 0
#elif SC_USE_UV_MIN_MAX_mainTexture==1
#undef SC_USE_UV_MIN_MAX_mainTexture
#define SC_USE_UV_MIN_MAX_mainTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_mainTexture
#define SC_USE_CLAMP_TO_BORDER_mainTexture 0
#elif SC_USE_CLAMP_TO_BORDER_mainTexture==1
#undef SC_USE_CLAMP_TO_BORDER_mainTexture
#define SC_USE_CLAMP_TO_BORDER_mainTexture 1
#endif
constant int2 _2246=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2273=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2301=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2329=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2361=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2389=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2418=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2447=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2482=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2508=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2533=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2559=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2585=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2614=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2639=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2665=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _2691=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
#ifndef DEPTH_BLUR
#define DEPTH_BLUR 0
#elif DEPTH_BLUR==1
#undef DEPTH_BLUR
#define DEPTH_BLUR 1
#endif
#ifndef mainTextureUV
#define mainTextureUV 0
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float2 blurCoordinates_0 [[user(locn10)]];
float2 blurCoordinates_1 [[user(locn11)]];
float2 blurCoordinates_2 [[user(locn12)]];
float2 blurCoordinates_3 [[user(locn13)]];
float2 blurCoordinates_4 [[user(locn14)]];
float2 blurCoordinates_5 [[user(locn15)]];
float2 blurCoordinates_6 [[user(locn16)]];
float2 blurCoordinates_7 [[user(locn17)]];
float2 blurCoordinates_8 [[user(locn18)]];
};

float2 mainTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.mainTextureDims.xy;
}

int mainTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (mainTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float decode2(thread const float2& rg)
{
return dot(rg,float2(1.0,0.00392157));
}

float2 decodeSample(thread const float4& sampleValue)
{
float2 param=sampleValue.xy;
float2 param_1=sampleValue.zw;
return float2(decode2(param),decode2(param_1));
}

float2 blur_x_depth(thread int& varStereoViewID,constant UserUniforms& userUniformsObj,thread texture2d<float> mainTexture,thread sampler mainTextureSmpSC,thread float2 (&blurCoordinates)[9])
{
float2 param=mainTextureGetDims2D(userUniformsObj);
int param_1=mainTextureLayout;
int param_2=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_3=blurCoordinates[0];
bool param_4=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_5=userUniformsObj.mainTextureTransform;
int2 param_6=_2212;
bool param_7=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_8=userUniformsObj.mainTextureUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_10=userUniformsObj.mainTextureBorderColor;
float param_11=0.0;
float4 _2238=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
float4 _2203=_2238;
float4 param_12=_2238;
float2 blurredColor=decodeSample(param_12)*0.162103;
float2 param_13=mainTextureGetDims2D(userUniformsObj);
int param_14=mainTextureLayout;
int param_15=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_16=blurCoordinates[1];
bool param_17=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_18=userUniformsObj.mainTextureTransform;
int2 param_19=_2246;
bool param_20=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_21=userUniformsObj.mainTextureUvMinMax;
bool param_22=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_23=userUniformsObj.mainTextureBorderColor;
float param_24=0.0;
float4 _2267=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23,param_24);
float4 _2243=_2267;
float4 param_25=_2267;
float2 param_26=mainTextureGetDims2D(userUniformsObj);
int param_27=mainTextureLayout;
int param_28=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_29=blurCoordinates[2];
bool param_30=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_31=userUniformsObj.mainTextureTransform;
int2 param_32=_2273;
bool param_33=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_34=userUniformsObj.mainTextureUvMinMax;
bool param_35=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_36=userUniformsObj.mainTextureBorderColor;
float param_37=0.0;
float4 _2294=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_26,param_27,param_28,param_29,param_30,param_31,param_32,param_33,param_34,param_35,param_36,param_37);
float4 _2270=_2294;
float4 param_38=_2294;
float2 param_39=mainTextureGetDims2D(userUniformsObj);
int param_40=mainTextureLayout;
int param_41=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_42=blurCoordinates[3];
bool param_43=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_44=userUniformsObj.mainTextureTransform;
int2 param_45=_2301;
bool param_46=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_47=userUniformsObj.mainTextureUvMinMax;
bool param_48=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_49=userUniformsObj.mainTextureBorderColor;
float param_50=0.0;
float4 _2322=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_39,param_40,param_41,param_42,param_43,param_44,param_45,param_46,param_47,param_48,param_49,param_50);
float4 _2298=_2322;
float4 param_51=_2322;
float2 param_52=mainTextureGetDims2D(userUniformsObj);
int param_53=mainTextureLayout;
int param_54=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_55=blurCoordinates[4];
bool param_56=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_57=userUniformsObj.mainTextureTransform;
int2 param_58=_2329;
bool param_59=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_60=userUniformsObj.mainTextureUvMinMax;
bool param_61=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_62=userUniformsObj.mainTextureBorderColor;
float param_63=0.0;
float4 _2350=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_52,param_53,param_54,param_55,param_56,param_57,param_58,param_59,param_60,param_61,param_62,param_63);
float4 _2326=_2350;
float4 param_64=_2350;
blurredColor+=((((decodeSample(param_25)+decodeSample(param_38))+decodeSample(param_51))+decodeSample(param_64))*0.120259);
float2 param_65=mainTextureGetDims2D(userUniformsObj);
int param_66=mainTextureLayout;
int param_67=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_68=blurCoordinates[5];
bool param_69=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_70=userUniformsObj.mainTextureTransform;
int2 param_71=_2361;
bool param_72=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_73=userUniformsObj.mainTextureUvMinMax;
bool param_74=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_75=userUniformsObj.mainTextureBorderColor;
float param_76=0.0;
float4 _2382=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_65,param_66,param_67,param_68,param_69,param_70,param_71,param_72,param_73,param_74,param_75,param_76);
float4 _2358=_2382;
float4 param_77=_2382;
float2 param_78=mainTextureGetDims2D(userUniformsObj);
int param_79=mainTextureLayout;
int param_80=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_81=blurCoordinates[6];
bool param_82=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_83=userUniformsObj.mainTextureTransform;
int2 param_84=_2389;
bool param_85=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_86=userUniformsObj.mainTextureUvMinMax;
bool param_87=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_88=userUniformsObj.mainTextureBorderColor;
float param_89=0.0;
float4 _2410=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_78,param_79,param_80,param_81,param_82,param_83,param_84,param_85,param_86,param_87,param_88,param_89);
float4 _2385=_2410;
float4 param_90=_2410;
float2 param_91=mainTextureGetDims2D(userUniformsObj);
int param_92=mainTextureLayout;
int param_93=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_94=blurCoordinates[7];
bool param_95=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_96=userUniformsObj.mainTextureTransform;
int2 param_97=_2418;
bool param_98=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_99=userUniformsObj.mainTextureUvMinMax;
bool param_100=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_101=userUniformsObj.mainTextureBorderColor;
float param_102=0.0;
float4 _2439=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_91,param_92,param_93,param_94,param_95,param_96,param_97,param_98,param_99,param_100,param_101,param_102);
float4 _2414=_2439;
float4 param_103=_2439;
float2 param_104=mainTextureGetDims2D(userUniformsObj);
int param_105=mainTextureLayout;
int param_106=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_107=blurCoordinates[8];
bool param_108=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_109=userUniformsObj.mainTextureTransform;
int2 param_110=_2447;
bool param_111=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_112=userUniformsObj.mainTextureUvMinMax;
bool param_113=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_114=userUniformsObj.mainTextureBorderColor;
float param_115=0.0;
float4 _2468=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_104,param_105,param_106,param_107,param_108,param_109,param_110,param_111,param_112,param_113,param_114,param_115);
float4 _2443=_2468;
float4 param_116=_2468;
blurredColor+=((((decodeSample(param_77)+decodeSample(param_90))+decodeSample(param_103))+decodeSample(param_116))*0.089216);
return blurredColor;
}

float2 encode2(thread const float& v)
{
float2 enc=fract(float2(1.0,255.0)*v);
enc.x-=(enc.y/255.0);
return enc;
}

float4 blur_x(thread int& varStereoViewID,constant UserUniforms& userUniformsObj,thread texture2d<float> mainTexture,thread sampler mainTextureSmpSC,thread float2 (&blurCoordinates)[9])
{
float2 param=mainTextureGetDims2D(userUniformsObj);
int param_1=mainTextureLayout;
int param_2=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_3=blurCoordinates[0];
bool param_4=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_5=userUniformsObj.mainTextureTransform;
int2 param_6=_2482;
bool param_7=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_8=userUniformsObj.mainTextureUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_10=userUniformsObj.mainTextureBorderColor;
float param_11=0.0;
float4 _2503=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
float4 _2479=_2503;
float4 blurredColor=_2503*0.162103;
float2 param_12=mainTextureGetDims2D(userUniformsObj);
int param_13=mainTextureLayout;
int param_14=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_15=blurCoordinates[1];
bool param_16=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_17=userUniformsObj.mainTextureTransform;
int2 param_18=_2508;
bool param_19=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_20=userUniformsObj.mainTextureUvMinMax;
bool param_21=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_22=userUniformsObj.mainTextureBorderColor;
float param_23=0.0;
float4 _2529=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_12,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23);
float4 _2505=_2529;
float2 param_24=mainTextureGetDims2D(userUniformsObj);
int param_25=mainTextureLayout;
int param_26=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_27=blurCoordinates[2];
bool param_28=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_29=userUniformsObj.mainTextureTransform;
int2 param_30=_2533;
bool param_31=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_32=userUniformsObj.mainTextureUvMinMax;
bool param_33=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_34=userUniformsObj.mainTextureBorderColor;
float param_35=0.0;
float4 _2554=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_24,param_25,param_26,param_27,param_28,param_29,param_30,param_31,param_32,param_33,param_34,param_35);
float4 _2530=_2554;
float2 param_36=mainTextureGetDims2D(userUniformsObj);
int param_37=mainTextureLayout;
int param_38=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_39=blurCoordinates[3];
bool param_40=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_41=userUniformsObj.mainTextureTransform;
int2 param_42=_2559;
bool param_43=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_44=userUniformsObj.mainTextureUvMinMax;
bool param_45=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_46=userUniformsObj.mainTextureBorderColor;
float param_47=0.0;
float4 _2580=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_36,param_37,param_38,param_39,param_40,param_41,param_42,param_43,param_44,param_45,param_46,param_47);
float4 _2556=_2580;
float2 param_48=mainTextureGetDims2D(userUniformsObj);
int param_49=mainTextureLayout;
int param_50=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_51=blurCoordinates[4];
bool param_52=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_53=userUniformsObj.mainTextureTransform;
int2 param_54=_2585;
bool param_55=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_56=userUniformsObj.mainTextureUvMinMax;
bool param_57=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_58=userUniformsObj.mainTextureBorderColor;
float param_59=0.0;
float4 _2606=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_48,param_49,param_50,param_51,param_52,param_53,param_54,param_55,param_56,param_57,param_58,param_59);
float4 _2582=_2606;
blurredColor+=((((_2529+_2554)+_2580)+_2606)*0.120259);
float2 param_60=mainTextureGetDims2D(userUniformsObj);
int param_61=mainTextureLayout;
int param_62=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_63=blurCoordinates[5];
bool param_64=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_65=userUniformsObj.mainTextureTransform;
int2 param_66=_2614;
bool param_67=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_68=userUniformsObj.mainTextureUvMinMax;
bool param_69=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_70=userUniformsObj.mainTextureBorderColor;
float param_71=0.0;
float4 _2635=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_60,param_61,param_62,param_63,param_64,param_65,param_66,param_67,param_68,param_69,param_70,param_71);
float4 _2611=_2635;
float2 param_72=mainTextureGetDims2D(userUniformsObj);
int param_73=mainTextureLayout;
int param_74=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_75=blurCoordinates[6];
bool param_76=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_77=userUniformsObj.mainTextureTransform;
int2 param_78=_2639;
bool param_79=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_80=userUniformsObj.mainTextureUvMinMax;
bool param_81=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_82=userUniformsObj.mainTextureBorderColor;
float param_83=0.0;
float4 _2660=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_72,param_73,param_74,param_75,param_76,param_77,param_78,param_79,param_80,param_81,param_82,param_83);
float4 _2636=_2660;
float2 param_84=mainTextureGetDims2D(userUniformsObj);
int param_85=mainTextureLayout;
int param_86=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_87=blurCoordinates[7];
bool param_88=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_89=userUniformsObj.mainTextureTransform;
int2 param_90=_2665;
bool param_91=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_92=userUniformsObj.mainTextureUvMinMax;
bool param_93=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_94=userUniformsObj.mainTextureBorderColor;
float param_95=0.0;
float4 _2686=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_84,param_85,param_86,param_87,param_88,param_89,param_90,param_91,param_92,param_93,param_94,param_95);
float4 _2662=_2686;
float2 param_96=mainTextureGetDims2D(userUniformsObj);
int param_97=mainTextureLayout;
int param_98=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_99=blurCoordinates[8];
bool param_100=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_101=userUniformsObj.mainTextureTransform;
int2 param_102=_2691;
bool param_103=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_104=userUniformsObj.mainTextureUvMinMax;
bool param_105=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_106=userUniformsObj.mainTextureBorderColor;
float param_107=0.0;
float4 _2712=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_96,param_97,param_98,param_99,param_100,param_101,param_102,param_103,param_104,param_105,param_106,param_107);
float4 _2688=_2712;
blurredColor+=((((_2635+_2660)+_2686)+_2712)*0.089216);
return blurredColor;
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj,texture2d<float> mainTexture,sampler mainTextureSmpSC,float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float2 blurCoordinates[9]={};
blurCoordinates[0]=in.blurCoordinates_0;
blurCoordinates[1]=in.blurCoordinates_1;
blurCoordinates[2]=in.blurCoordinates_2;
blurCoordinates[3]=in.blurCoordinates_3;
blurCoordinates[4]=in.blurCoordinates_4;
blurCoordinates[5]=in.blurCoordinates_5;
blurCoordinates[6]=in.blurCoordinates_6;
blurCoordinates[7]=in.blurCoordinates_7;
blurCoordinates[8]=in.blurCoordinates_8;
float4 result;
#if (DEPTH_BLUR)
{
float2 blurValue=blur_x_depth(in.varStereoViewID,userUniformsObj,mainTexture,mainTextureSmpSC,blurCoordinates);
float param=blurValue.x;
float param_1=blurValue.y;
result=float4(encode2(param),encode2(param_1));
}
#else
{
result=blur_x(in.varStereoViewID,userUniformsObj,mainTexture,mainTextureSmpSC,blurCoordinates);
}
#endif
float4 param_2=result;
sc_writeFragData0(param_2,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
