#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include "std2.metal"
#include "std2_vs.metal"
#include "std2_fs.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN(100)
//SG_REFLECTION_END


struct UserUniforms
{
float4 tex_RY_GYSize;
float4 tex_RY_GYDims;
float4 tex_RY_GYView;
float3x3 tex_RY_GYTransform;
float4 tex_RY_GYUvMinMax;
float4 tex_RY_GYBorderColor;
float4 tex_BY_YSize;
float4 tex_BY_YDims;
float4 tex_BY_YView;
float3x3 tex_BY_YTransform;
float4 tex_BY_YUvMinMax;
float4 tex_BY_YBorderColor;
float4 tex_R_G_BSize;
float4 tex_R_G_BDims;
float4 tex_R_G_BView;
float3x3 tex_R_G_BTransform;
float4 tex_R_G_BUvMinMax;
float4 tex_R_G_BBorderColor;
float4 tex_RR_GG_BBSize;
float4 tex_RR_GG_BBDims;
float4 tex_RR_GG_BBView;
float3x3 tex_RR_GG_BBTransform;
float4 tex_RR_GG_BBUvMinMax;
float4 tex_RR_GG_BBBorderColor;
float4 tex_RG_RB_GBSize;
float4 tex_RG_RB_GBDims;
float4 tex_RG_RB_GBView;
float3x3 tex_RG_RB_GBTransform;
float4 tex_RG_RB_GBUvMinMax;
float4 tex_RG_RB_GBBorderColor;
float4 mainTextureSize;
float4 mainTextureDims;
float4 mainTextureView;
float3x3 mainTextureTransform;
float4 mainTextureUvMinMax;
float4 mainTextureBorderColor;
float epsilon;
};

#ifndef tex_RY_GYHasSwappedViews
#define tex_RY_GYHasSwappedViews 0
#elif tex_RY_GYHasSwappedViews==1
#undef tex_RY_GYHasSwappedViews
#define tex_RY_GYHasSwappedViews 1
#endif
#ifndef tex_RY_GYLayout
#define tex_RY_GYLayout 0
#endif
#ifndef tex_BY_YHasSwappedViews
#define tex_BY_YHasSwappedViews 0
#elif tex_BY_YHasSwappedViews==1
#undef tex_BY_YHasSwappedViews
#define tex_BY_YHasSwappedViews 1
#endif
#ifndef tex_BY_YLayout
#define tex_BY_YLayout 0
#endif
#ifndef tex_R_G_BHasSwappedViews
#define tex_R_G_BHasSwappedViews 0
#elif tex_R_G_BHasSwappedViews==1
#undef tex_R_G_BHasSwappedViews
#define tex_R_G_BHasSwappedViews 1
#endif
#ifndef tex_R_G_BLayout
#define tex_R_G_BLayout 0
#endif
#ifndef tex_RR_GG_BBHasSwappedViews
#define tex_RR_GG_BBHasSwappedViews 0
#elif tex_RR_GG_BBHasSwappedViews==1
#undef tex_RR_GG_BBHasSwappedViews
#define tex_RR_GG_BBHasSwappedViews 1
#endif
#ifndef tex_RR_GG_BBLayout
#define tex_RR_GG_BBLayout 0
#endif
#ifndef tex_RG_RB_GBHasSwappedViews
#define tex_RG_RB_GBHasSwappedViews 0
#elif tex_RG_RB_GBHasSwappedViews==1
#undef tex_RG_RB_GBHasSwappedViews
#define tex_RG_RB_GBHasSwappedViews 1
#endif
#ifndef tex_RG_RB_GBLayout
#define tex_RG_RB_GBLayout 0
#endif
#ifndef mainTextureHasSwappedViews
#define mainTextureHasSwappedViews 0
#elif mainTextureHasSwappedViews==1
#undef mainTextureHasSwappedViews
#define mainTextureHasSwappedViews 1
#endif
#ifndef mainTextureLayout
#define mainTextureLayout 0
#endif
#ifndef CAMEOS_MATTING
#define CAMEOS_MATTING 0
#elif CAMEOS_MATTING==1
#undef CAMEOS_MATTING
#define CAMEOS_MATTING 1
#endif
#ifndef tex_RY_GYUV
#define tex_RY_GYUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_tex_RY_GY
#define SC_USE_UV_TRANSFORM_tex_RY_GY 0
#elif SC_USE_UV_TRANSFORM_tex_RY_GY==1
#undef SC_USE_UV_TRANSFORM_tex_RY_GY
#define SC_USE_UV_TRANSFORM_tex_RY_GY 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_tex_RY_GY
#define SC_SOFTWARE_WRAP_MODE_U_tex_RY_GY -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_tex_RY_GY
#define SC_SOFTWARE_WRAP_MODE_V_tex_RY_GY -1
#endif
#ifndef SC_USE_UV_MIN_MAX_tex_RY_GY
#define SC_USE_UV_MIN_MAX_tex_RY_GY 0
#elif SC_USE_UV_MIN_MAX_tex_RY_GY==1
#undef SC_USE_UV_MIN_MAX_tex_RY_GY
#define SC_USE_UV_MIN_MAX_tex_RY_GY 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_tex_RY_GY
#define SC_USE_CLAMP_TO_BORDER_tex_RY_GY 0
#elif SC_USE_CLAMP_TO_BORDER_tex_RY_GY==1
#undef SC_USE_CLAMP_TO_BORDER_tex_RY_GY
#define SC_USE_CLAMP_TO_BORDER_tex_RY_GY 1
#endif
#ifndef tex_BY_YUV
#define tex_BY_YUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_tex_BY_Y
#define SC_USE_UV_TRANSFORM_tex_BY_Y 0
#elif SC_USE_UV_TRANSFORM_tex_BY_Y==1
#undef SC_USE_UV_TRANSFORM_tex_BY_Y
#define SC_USE_UV_TRANSFORM_tex_BY_Y 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_tex_BY_Y
#define SC_SOFTWARE_WRAP_MODE_U_tex_BY_Y -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_tex_BY_Y
#define SC_SOFTWARE_WRAP_MODE_V_tex_BY_Y -1
#endif
#ifndef SC_USE_UV_MIN_MAX_tex_BY_Y
#define SC_USE_UV_MIN_MAX_tex_BY_Y 0
#elif SC_USE_UV_MIN_MAX_tex_BY_Y==1
#undef SC_USE_UV_MIN_MAX_tex_BY_Y
#define SC_USE_UV_MIN_MAX_tex_BY_Y 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_tex_BY_Y
#define SC_USE_CLAMP_TO_BORDER_tex_BY_Y 0
#elif SC_USE_CLAMP_TO_BORDER_tex_BY_Y==1
#undef SC_USE_CLAMP_TO_BORDER_tex_BY_Y
#define SC_USE_CLAMP_TO_BORDER_tex_BY_Y 1
#endif
#ifndef tex_R_G_BUV
#define tex_R_G_BUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_tex_R_G_B
#define SC_USE_UV_TRANSFORM_tex_R_G_B 0
#elif SC_USE_UV_TRANSFORM_tex_R_G_B==1
#undef SC_USE_UV_TRANSFORM_tex_R_G_B
#define SC_USE_UV_TRANSFORM_tex_R_G_B 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_tex_R_G_B
#define SC_SOFTWARE_WRAP_MODE_U_tex_R_G_B -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_tex_R_G_B
#define SC_SOFTWARE_WRAP_MODE_V_tex_R_G_B -1
#endif
#ifndef SC_USE_UV_MIN_MAX_tex_R_G_B
#define SC_USE_UV_MIN_MAX_tex_R_G_B 0
#elif SC_USE_UV_MIN_MAX_tex_R_G_B==1
#undef SC_USE_UV_MIN_MAX_tex_R_G_B
#define SC_USE_UV_MIN_MAX_tex_R_G_B 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_tex_R_G_B
#define SC_USE_CLAMP_TO_BORDER_tex_R_G_B 0
#elif SC_USE_CLAMP_TO_BORDER_tex_R_G_B==1
#undef SC_USE_CLAMP_TO_BORDER_tex_R_G_B
#define SC_USE_CLAMP_TO_BORDER_tex_R_G_B 1
#endif
#ifndef tex_RR_GG_BBUV
#define tex_RR_GG_BBUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_tex_RR_GG_BB
#define SC_USE_UV_TRANSFORM_tex_RR_GG_BB 0
#elif SC_USE_UV_TRANSFORM_tex_RR_GG_BB==1
#undef SC_USE_UV_TRANSFORM_tex_RR_GG_BB
#define SC_USE_UV_TRANSFORM_tex_RR_GG_BB 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_tex_RR_GG_BB
#define SC_SOFTWARE_WRAP_MODE_U_tex_RR_GG_BB -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_tex_RR_GG_BB
#define SC_SOFTWARE_WRAP_MODE_V_tex_RR_GG_BB -1
#endif
#ifndef SC_USE_UV_MIN_MAX_tex_RR_GG_BB
#define SC_USE_UV_MIN_MAX_tex_RR_GG_BB 0
#elif SC_USE_UV_MIN_MAX_tex_RR_GG_BB==1
#undef SC_USE_UV_MIN_MAX_tex_RR_GG_BB
#define SC_USE_UV_MIN_MAX_tex_RR_GG_BB 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_tex_RR_GG_BB
#define SC_USE_CLAMP_TO_BORDER_tex_RR_GG_BB 0
#elif SC_USE_CLAMP_TO_BORDER_tex_RR_GG_BB==1
#undef SC_USE_CLAMP_TO_BORDER_tex_RR_GG_BB
#define SC_USE_CLAMP_TO_BORDER_tex_RR_GG_BB 1
#endif
#ifndef tex_RG_RB_GBUV
#define tex_RG_RB_GBUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_tex_RG_RB_GB
#define SC_USE_UV_TRANSFORM_tex_RG_RB_GB 0
#elif SC_USE_UV_TRANSFORM_tex_RG_RB_GB==1
#undef SC_USE_UV_TRANSFORM_tex_RG_RB_GB
#define SC_USE_UV_TRANSFORM_tex_RG_RB_GB 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_tex_RG_RB_GB
#define SC_SOFTWARE_WRAP_MODE_U_tex_RG_RB_GB -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_tex_RG_RB_GB
#define SC_SOFTWARE_WRAP_MODE_V_tex_RG_RB_GB -1
#endif
#ifndef SC_USE_UV_MIN_MAX_tex_RG_RB_GB
#define SC_USE_UV_MIN_MAX_tex_RG_RB_GB 0
#elif SC_USE_UV_MIN_MAX_tex_RG_RB_GB==1
#undef SC_USE_UV_MIN_MAX_tex_RG_RB_GB
#define SC_USE_UV_MIN_MAX_tex_RG_RB_GB 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_tex_RG_RB_GB
#define SC_USE_CLAMP_TO_BORDER_tex_RG_RB_GB 0
#elif SC_USE_CLAMP_TO_BORDER_tex_RG_RB_GB==1
#undef SC_USE_CLAMP_TO_BORDER_tex_RG_RB_GB
#define SC_USE_CLAMP_TO_BORDER_tex_RG_RB_GB 1
#endif
#ifndef mainTextureUV
#define mainTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_mainTexture
#define SC_USE_UV_TRANSFORM_mainTexture 0
#elif SC_USE_UV_TRANSFORM_mainTexture==1
#undef SC_USE_UV_TRANSFORM_mainTexture
#define SC_USE_UV_TRANSFORM_mainTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_mainTexture
#define SC_SOFTWARE_WRAP_MODE_U_mainTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_mainTexture
#define SC_SOFTWARE_WRAP_MODE_V_mainTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_mainTexture
#define SC_USE_UV_MIN_MAX_mainTexture 0
#elif SC_USE_UV_MIN_MAX_mainTexture==1
#undef SC_USE_UV_MIN_MAX_mainTexture
#define SC_USE_UV_MIN_MAX_mainTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_mainTexture
#define SC_USE_CLAMP_TO_BORDER_mainTexture 0
#elif SC_USE_CLAMP_TO_BORDER_mainTexture==1
#undef SC_USE_CLAMP_TO_BORDER_mainTexture
#define SC_USE_CLAMP_TO_BORDER_mainTexture 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant LibraryUniforms& libraryUniformsObj,uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN(100)
//sampler sampler tex_RY_GYSmpSC 0:33195
//sampler sampler tex_BY_YSmpSC 0:53626
//sampler sampler tex_RR_GG_BBSmpSC 0:42709
//sampler sampler tex_RG_RB_GBSmpSC 0:38993
//sampler sampler mainTextureSmpSC 0:43517
//texture texture2D tex_RY_GY 0:33333:0:33195
//texture texture2D tex_BY_Y 0:44988:0:53626
//texture texture2D tex_RR_GG_BB 0:58564:0:42709
//texture texture2D tex_RG_RB_GB 0:38237:0:38993
//texture texture2D mainTexture 0:61325:0:43517
//ubo float UserUniforms 0:35568:772 {
//float4 tex_RY_GYSize 0
//float4 tex_RY_GYDims 16
//float4 tex_RY_GYView 32
//float3x3 tex_RY_GYTransform 48
//float4 tex_RY_GYUvMinMax 96
//float4 tex_RY_GYBorderColor 112
//float4 tex_BY_YSize 128
//float4 tex_BY_YDims 144
//float4 tex_BY_YView 160
//float3x3 tex_BY_YTransform 176
//float4 tex_BY_YUvMinMax 224
//float4 tex_BY_YBorderColor 240
//float4 tex_R_G_BSize 256
//float4 tex_R_G_BDims 272
//float4 tex_R_G_BView 288
//float3x3 tex_R_G_BTransform 304
//float4 tex_R_G_BUvMinMax 352
//float4 tex_R_G_BBorderColor 368
//float4 tex_RR_GG_BBSize 384
//float4 tex_RR_GG_BBDims 400
//float4 tex_RR_GG_BBView 416
//float3x3 tex_RR_GG_BBTransform 432
//float4 tex_RR_GG_BBUvMinMax 480
//float4 tex_RR_GG_BBBorderColor 496
//float4 tex_RG_RB_GBSize 512
//float4 tex_RG_RB_GBDims 528
//float4 tex_RG_RB_GBView 544
//float3x3 tex_RG_RB_GBTransform 560
//float4 tex_RG_RB_GBUvMinMax 608
//float4 tex_RG_RB_GBBorderColor 624
//float4 mainTextureSize 640
//float4 mainTextureDims 656
//float4 mainTextureView 672
//float3x3 mainTextureTransform 688
//float4 mainTextureUvMinMax 736
//float4 mainTextureBorderColor 752
//float epsilon 768
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 tex_RY_GYSize;
float4 tex_RY_GYDims;
float4 tex_RY_GYView;
float3x3 tex_RY_GYTransform;
float4 tex_RY_GYUvMinMax;
float4 tex_RY_GYBorderColor;
float4 tex_BY_YSize;
float4 tex_BY_YDims;
float4 tex_BY_YView;
float3x3 tex_BY_YTransform;
float4 tex_BY_YUvMinMax;
float4 tex_BY_YBorderColor;
float4 tex_R_G_BSize;
float4 tex_R_G_BDims;
float4 tex_R_G_BView;
float3x3 tex_R_G_BTransform;
float4 tex_R_G_BUvMinMax;
float4 tex_R_G_BBorderColor;
float4 tex_RR_GG_BBSize;
float4 tex_RR_GG_BBDims;
float4 tex_RR_GG_BBView;
float3x3 tex_RR_GG_BBTransform;
float4 tex_RR_GG_BBUvMinMax;
float4 tex_RR_GG_BBBorderColor;
float4 tex_RG_RB_GBSize;
float4 tex_RG_RB_GBDims;
float4 tex_RG_RB_GBView;
float3x3 tex_RG_RB_GBTransform;
float4 tex_RG_RB_GBUvMinMax;
float4 tex_RG_RB_GBBorderColor;
float4 mainTextureSize;
float4 mainTextureDims;
float4 mainTextureView;
float3x3 mainTextureTransform;
float4 mainTextureUvMinMax;
float4 mainTextureBorderColor;
float epsilon;
};

#ifndef tex_RY_GYHasSwappedViews
#define tex_RY_GYHasSwappedViews 0
#elif tex_RY_GYHasSwappedViews==1
#undef tex_RY_GYHasSwappedViews
#define tex_RY_GYHasSwappedViews 1
#endif
#ifndef tex_RY_GYLayout
#define tex_RY_GYLayout 0
#endif
#ifndef tex_BY_YHasSwappedViews
#define tex_BY_YHasSwappedViews 0
#elif tex_BY_YHasSwappedViews==1
#undef tex_BY_YHasSwappedViews
#define tex_BY_YHasSwappedViews 1
#endif
#ifndef tex_BY_YLayout
#define tex_BY_YLayout 0
#endif
#ifndef tex_R_G_BHasSwappedViews
#define tex_R_G_BHasSwappedViews 0
#elif tex_R_G_BHasSwappedViews==1
#undef tex_R_G_BHasSwappedViews
#define tex_R_G_BHasSwappedViews 1
#endif
#ifndef tex_R_G_BLayout
#define tex_R_G_BLayout 0
#endif
#ifndef tex_RR_GG_BBHasSwappedViews
#define tex_RR_GG_BBHasSwappedViews 0
#elif tex_RR_GG_BBHasSwappedViews==1
#undef tex_RR_GG_BBHasSwappedViews
#define tex_RR_GG_BBHasSwappedViews 1
#endif
#ifndef tex_RR_GG_BBLayout
#define tex_RR_GG_BBLayout 0
#endif
#ifndef tex_RG_RB_GBHasSwappedViews
#define tex_RG_RB_GBHasSwappedViews 0
#elif tex_RG_RB_GBHasSwappedViews==1
#undef tex_RG_RB_GBHasSwappedViews
#define tex_RG_RB_GBHasSwappedViews 1
#endif
#ifndef tex_RG_RB_GBLayout
#define tex_RG_RB_GBLayout 0
#endif
#ifndef mainTextureHasSwappedViews
#define mainTextureHasSwappedViews 0
#elif mainTextureHasSwappedViews==1
#undef mainTextureHasSwappedViews
#define mainTextureHasSwappedViews 1
#endif
#ifndef mainTextureLayout
#define mainTextureLayout 0
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_tex_RY_GY
#define SC_SOFTWARE_WRAP_MODE_U_tex_RY_GY -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_tex_RY_GY
#define SC_SOFTWARE_WRAP_MODE_V_tex_RY_GY -1
#endif
constant int2 _3014=int2(SC_SOFTWARE_WRAP_MODE_U_tex_RY_GY,SC_SOFTWARE_WRAP_MODE_V_tex_RY_GY);
#ifndef SC_USE_UV_MIN_MAX_tex_RY_GY
#define SC_USE_UV_MIN_MAX_tex_RY_GY 0
#elif SC_USE_UV_MIN_MAX_tex_RY_GY==1
#undef SC_USE_UV_MIN_MAX_tex_RY_GY
#define SC_USE_UV_MIN_MAX_tex_RY_GY 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_tex_RY_GY
#define SC_USE_CLAMP_TO_BORDER_tex_RY_GY 0
#elif SC_USE_CLAMP_TO_BORDER_tex_RY_GY==1
#undef SC_USE_CLAMP_TO_BORDER_tex_RY_GY
#define SC_USE_CLAMP_TO_BORDER_tex_RY_GY 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_tex_BY_Y
#define SC_SOFTWARE_WRAP_MODE_U_tex_BY_Y -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_tex_BY_Y
#define SC_SOFTWARE_WRAP_MODE_V_tex_BY_Y -1
#endif
constant int2 _3044=int2(SC_SOFTWARE_WRAP_MODE_U_tex_BY_Y,SC_SOFTWARE_WRAP_MODE_V_tex_BY_Y);
#ifndef SC_USE_UV_MIN_MAX_tex_BY_Y
#define SC_USE_UV_MIN_MAX_tex_BY_Y 0
#elif SC_USE_UV_MIN_MAX_tex_BY_Y==1
#undef SC_USE_UV_MIN_MAX_tex_BY_Y
#define SC_USE_UV_MIN_MAX_tex_BY_Y 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_tex_BY_Y
#define SC_USE_CLAMP_TO_BORDER_tex_BY_Y 0
#elif SC_USE_CLAMP_TO_BORDER_tex_BY_Y==1
#undef SC_USE_CLAMP_TO_BORDER_tex_BY_Y
#define SC_USE_CLAMP_TO_BORDER_tex_BY_Y 1
#endif
constant int2 _3084=int2(SC_SOFTWARE_WRAP_MODE_U_tex_RY_GY,SC_SOFTWARE_WRAP_MODE_V_tex_RY_GY);
#ifndef SC_SOFTWARE_WRAP_MODE_U_tex_RR_GG_BB
#define SC_SOFTWARE_WRAP_MODE_U_tex_RR_GG_BB -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_tex_RR_GG_BB
#define SC_SOFTWARE_WRAP_MODE_V_tex_RR_GG_BB -1
#endif
constant int2 _3113=int2(SC_SOFTWARE_WRAP_MODE_U_tex_RR_GG_BB,SC_SOFTWARE_WRAP_MODE_V_tex_RR_GG_BB);
#ifndef SC_USE_UV_MIN_MAX_tex_RR_GG_BB
#define SC_USE_UV_MIN_MAX_tex_RR_GG_BB 0
#elif SC_USE_UV_MIN_MAX_tex_RR_GG_BB==1
#undef SC_USE_UV_MIN_MAX_tex_RR_GG_BB
#define SC_USE_UV_MIN_MAX_tex_RR_GG_BB 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_tex_RR_GG_BB
#define SC_USE_CLAMP_TO_BORDER_tex_RR_GG_BB 0
#elif SC_USE_CLAMP_TO_BORDER_tex_RR_GG_BB==1
#undef SC_USE_CLAMP_TO_BORDER_tex_RR_GG_BB
#define SC_USE_CLAMP_TO_BORDER_tex_RR_GG_BB 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_tex_RG_RB_GB
#define SC_SOFTWARE_WRAP_MODE_U_tex_RG_RB_GB -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_tex_RG_RB_GB
#define SC_SOFTWARE_WRAP_MODE_V_tex_RG_RB_GB -1
#endif
constant int2 _3146=int2(SC_SOFTWARE_WRAP_MODE_U_tex_RG_RB_GB,SC_SOFTWARE_WRAP_MODE_V_tex_RG_RB_GB);
#ifndef SC_USE_UV_MIN_MAX_tex_RG_RB_GB
#define SC_USE_UV_MIN_MAX_tex_RG_RB_GB 0
#elif SC_USE_UV_MIN_MAX_tex_RG_RB_GB==1
#undef SC_USE_UV_MIN_MAX_tex_RG_RB_GB
#define SC_USE_UV_MIN_MAX_tex_RG_RB_GB 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_tex_RG_RB_GB
#define SC_USE_CLAMP_TO_BORDER_tex_RG_RB_GB 0
#elif SC_USE_CLAMP_TO_BORDER_tex_RG_RB_GB==1
#undef SC_USE_CLAMP_TO_BORDER_tex_RG_RB_GB
#define SC_USE_CLAMP_TO_BORDER_tex_RG_RB_GB 1
#endif
#ifndef SC_USE_UV_TRANSFORM_mainTexture
#define SC_USE_UV_TRANSFORM_mainTexture 0
#elif SC_USE_UV_TRANSFORM_mainTexture==1
#undef SC_USE_UV_TRANSFORM_mainTexture
#define SC_USE_UV_TRANSFORM_mainTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_mainTexture
#define SC_SOFTWARE_WRAP_MODE_U_mainTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_mainTexture
#define SC_SOFTWARE_WRAP_MODE_V_mainTexture -1
#endif
constant int2 _3239=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
#ifndef SC_USE_UV_MIN_MAX_mainTexture
#define SC_USE_UV_MIN_MAX_mainTexture 0
#elif SC_USE_UV_MIN_MAX_mainTexture==1
#undef SC_USE_UV_MIN_MAX_mainTexture
#define SC_USE_UV_MIN_MAX_mainTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_mainTexture
#define SC_USE_CLAMP_TO_BORDER_mainTexture 0
#elif SC_USE_CLAMP_TO_BORDER_mainTexture==1
#undef SC_USE_CLAMP_TO_BORDER_mainTexture
#define SC_USE_CLAMP_TO_BORDER_mainTexture 1
#endif
#ifndef CAMEOS_MATTING
#define CAMEOS_MATTING 0
#elif CAMEOS_MATTING==1
#undef CAMEOS_MATTING
#define CAMEOS_MATTING 1
#endif
#ifndef tex_RY_GYUV
#define tex_RY_GYUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_tex_RY_GY
#define SC_USE_UV_TRANSFORM_tex_RY_GY 0
#elif SC_USE_UV_TRANSFORM_tex_RY_GY==1
#undef SC_USE_UV_TRANSFORM_tex_RY_GY
#define SC_USE_UV_TRANSFORM_tex_RY_GY 1
#endif
#ifndef tex_BY_YUV
#define tex_BY_YUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_tex_BY_Y
#define SC_USE_UV_TRANSFORM_tex_BY_Y 0
#elif SC_USE_UV_TRANSFORM_tex_BY_Y==1
#undef SC_USE_UV_TRANSFORM_tex_BY_Y
#define SC_USE_UV_TRANSFORM_tex_BY_Y 1
#endif
#ifndef tex_R_G_BUV
#define tex_R_G_BUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_tex_R_G_B
#define SC_USE_UV_TRANSFORM_tex_R_G_B 0
#elif SC_USE_UV_TRANSFORM_tex_R_G_B==1
#undef SC_USE_UV_TRANSFORM_tex_R_G_B
#define SC_USE_UV_TRANSFORM_tex_R_G_B 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_tex_R_G_B
#define SC_SOFTWARE_WRAP_MODE_U_tex_R_G_B -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_tex_R_G_B
#define SC_SOFTWARE_WRAP_MODE_V_tex_R_G_B -1
#endif
#ifndef SC_USE_UV_MIN_MAX_tex_R_G_B
#define SC_USE_UV_MIN_MAX_tex_R_G_B 0
#elif SC_USE_UV_MIN_MAX_tex_R_G_B==1
#undef SC_USE_UV_MIN_MAX_tex_R_G_B
#define SC_USE_UV_MIN_MAX_tex_R_G_B 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_tex_R_G_B
#define SC_USE_CLAMP_TO_BORDER_tex_R_G_B 0
#elif SC_USE_CLAMP_TO_BORDER_tex_R_G_B==1
#undef SC_USE_CLAMP_TO_BORDER_tex_R_G_B
#define SC_USE_CLAMP_TO_BORDER_tex_R_G_B 1
#endif
#ifndef tex_RR_GG_BBUV
#define tex_RR_GG_BBUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_tex_RR_GG_BB
#define SC_USE_UV_TRANSFORM_tex_RR_GG_BB 0
#elif SC_USE_UV_TRANSFORM_tex_RR_GG_BB==1
#undef SC_USE_UV_TRANSFORM_tex_RR_GG_BB
#define SC_USE_UV_TRANSFORM_tex_RR_GG_BB 1
#endif
#ifndef tex_RG_RB_GBUV
#define tex_RG_RB_GBUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_tex_RG_RB_GB
#define SC_USE_UV_TRANSFORM_tex_RG_RB_GB 0
#elif SC_USE_UV_TRANSFORM_tex_RG_RB_GB==1
#undef SC_USE_UV_TRANSFORM_tex_RG_RB_GB
#define SC_USE_UV_TRANSFORM_tex_RG_RB_GB 1
#endif
#ifndef mainTextureUV
#define mainTextureUV 0
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float4 varPackedTex [[user(locn6)]];
};

float2 tex_RY_GYGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.tex_RY_GYDims.xy;
}

int tex_RY_GYGetStereoViewIndex(thread int& varStereoViewID)
{
#if (tex_RY_GYHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 tex_BY_YGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.tex_BY_YDims.xy;
}

int tex_BY_YGetStereoViewIndex(thread int& varStereoViewID)
{
#if (tex_BY_YHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float decode2(thread const float2& rg)
{
return dot(rg,float2(1.0,0.00392157));
}

float2 decodeSample(thread const float4& sampleValue)
{
float2 param=sampleValue.xy;
float2 param_1=sampleValue.zw;
return float2(decode2(param),decode2(param_1));
}

float2 tex_RR_GG_BBGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.tex_RR_GG_BBDims.xy;
}

int tex_RR_GG_BBGetStereoViewIndex(thread int& varStereoViewID)
{
#if (tex_RR_GG_BBHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 tex_RG_RB_GBGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.tex_RG_RB_GBDims.xy;
}

int tex_RG_RB_GBGetStereoViewIndex(thread int& varStereoViewID)
{
#if (tex_RG_RB_GBHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float3 inverseSymMul(thread const float& m00,thread const float& m11,thread const float& m22,thread const float& m01,thread const float& m02,thread const float& m12,thread const float3& A)
{
float a00=(m22*m11)-(m12*m12);
float a01=(m02*m12)-(m22*m01);
float a02=(m01*m12)-(m02*m11);
float a11=(m22*m00)-(m02*m02);
float a12=(m01*m02)-(m00*m12);
float a22=(m00*m11)-(m01*m01);
float D=dot(float3(m00,m01,m02),float3(a00,a01,a02));
float3x3 Inv=float3x3(float3(a00,a01,a02),float3(a01,a11,a12),float3(a02,a12,a22));
return (Inv*A)/float3(D);
}

float2 mainTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.mainTextureDims.xy;
}

int mainTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (mainTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 encode2(thread const float& v)
{
float2 enc=fract(float2(1.0,255.0)*v);
enc.x-=(enc.y/255.0);
return enc;
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj,texture2d<float> tex_RY_GY,texture2d<float> tex_RG_RB_GB,texture2d<float> tex_BY_Y,texture2d<float> tex_RR_GG_BB,texture2d<float> mainTexture,sampler tex_RY_GYSmpSC,sampler tex_RG_RB_GBSmpSC,sampler tex_RR_GG_BBSmpSC,sampler mainTextureSmpSC,sampler tex_BY_YSmpSC,float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float2 param=tex_RY_GYGetDims2D(userUniformsObj);
int param_1=tex_RY_GYLayout;
int param_2=tex_RY_GYGetStereoViewIndex(in.varStereoViewID);
float2 param_3=in.varPackedTex.xy;
bool param_4=false;
float3x3 param_5=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_6=_3014;
bool param_7=(int(SC_USE_UV_MIN_MAX_tex_RY_GY)!=0);
float4 param_8=userUniformsObj.tex_RY_GYUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_tex_RY_GY)!=0);
float4 param_10=userUniformsObj.tex_RY_GYBorderColor;
float param_11=0.0;
float4 _3037=sc_SampleTextureBiasOrLevel(tex_RY_GY,tex_RY_GYSmpSC,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
float4 _3003=_3037;
float4 tex_RY_GYSample=_3037;
float2 param_12=tex_BY_YGetDims2D(userUniformsObj);
int param_13=tex_BY_YLayout;
int param_14=tex_BY_YGetStereoViewIndex(in.varStereoViewID);
float2 param_15=in.varPackedTex.xy;
bool param_16=false;
float3x3 param_17=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_18=_3044;
bool param_19=(int(SC_USE_UV_MIN_MAX_tex_BY_Y)!=0);
float4 param_20=userUniformsObj.tex_BY_YUvMinMax;
bool param_21=(int(SC_USE_CLAMP_TO_BORDER_tex_BY_Y)!=0);
float4 param_22=userUniformsObj.tex_BY_YBorderColor;
float param_23=0.0;
float4 _3067=sc_SampleTextureBiasOrLevel(tex_BY_Y,tex_BY_YSmpSC,param_12,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23);
float4 _3039=_3067;
float4 tex_BY_YSample=_3067;
float4 param_24=tex_RY_GYSample;
float4 param_25=tex_BY_YSample;
float4 RY_GY_BY_Y=float4(decodeSample(param_24),decodeSample(param_25));
float2 param_26=tex_RY_GYGetDims2D(userUniformsObj);
int param_27=tex_RY_GYLayout;
int param_28=tex_RY_GYGetStereoViewIndex(in.varStereoViewID);
float2 param_29=in.varPackedTex.xy;
bool param_30=false;
float3x3 param_31=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_32=_3084;
bool param_33=(int(SC_USE_UV_MIN_MAX_tex_RY_GY)!=0);
float4 param_34=userUniformsObj.tex_RY_GYUvMinMax;
bool param_35=(int(SC_USE_CLAMP_TO_BORDER_tex_RY_GY)!=0);
float4 param_36=userUniformsObj.tex_RY_GYBorderColor;
float param_37=0.0;
float4 _3103=sc_SampleTextureBiasOrLevel(tex_RY_GY,tex_RY_GYSmpSC,param_26,param_27,param_28,param_29,param_30,param_31,param_32,param_33,param_34,param_35,param_36,param_37);
float4 _3081=_3103;
float4 tex_RY_GYSample_1=_3103;
float3 R_G_B=tex_RY_GYSample_1.xyz;
float2 param_38=tex_RR_GG_BBGetDims2D(userUniformsObj);
int param_39=tex_RR_GG_BBLayout;
int param_40=tex_RR_GG_BBGetStereoViewIndex(in.varStereoViewID);
float2 param_41=in.varPackedTex.xy;
bool param_42=false;
float3x3 param_43=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_44=_3113;
bool param_45=(int(SC_USE_UV_MIN_MAX_tex_RR_GG_BB)!=0);
float4 param_46=userUniformsObj.tex_RR_GG_BBUvMinMax;
bool param_47=(int(SC_USE_CLAMP_TO_BORDER_tex_RR_GG_BB)!=0);
float4 param_48=userUniformsObj.tex_RR_GG_BBBorderColor;
float param_49=0.0;
float4 _3136=sc_SampleTextureBiasOrLevel(tex_RR_GG_BB,tex_RR_GG_BBSmpSC,param_38,param_39,param_40,param_41,param_42,param_43,param_44,param_45,param_46,param_47,param_48,param_49);
float4 _3108=_3136;
float4 tex_RR_GG_BBSample=_3136;
float3 RR_GG_BB=tex_RR_GG_BBSample.xyz;
float2 param_50=tex_RG_RB_GBGetDims2D(userUniformsObj);
int param_51=tex_RG_RB_GBLayout;
int param_52=tex_RG_RB_GBGetStereoViewIndex(in.varStereoViewID);
float2 param_53=in.varPackedTex.xy;
bool param_54=false;
float3x3 param_55=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_56=_3146;
bool param_57=(int(SC_USE_UV_MIN_MAX_tex_RG_RB_GB)!=0);
float4 param_58=userUniformsObj.tex_RG_RB_GBUvMinMax;
bool param_59=(int(SC_USE_CLAMP_TO_BORDER_tex_RG_RB_GB)!=0);
float4 param_60=userUniformsObj.tex_RG_RB_GBBorderColor;
float param_61=0.0;
float4 _3169=sc_SampleTextureBiasOrLevel(tex_RG_RB_GB,tex_RG_RB_GBSmpSC,param_50,param_51,param_52,param_53,param_54,param_55,param_56,param_57,param_58,param_59,param_60,param_61);
float4 _3141=_3169;
float4 tex_RG_RB_GBSample=_3169;
float3 RG_RB_GB=tex_RG_RB_GBSample.xyz;
float3 covd=abs(RR_GG_BB-(R_G_B*R_G_B))+float3(userUniformsObj.epsilon*userUniformsObj.epsilon);
float3 covo=RG_RB_GB-(R_G_B.xxy*R_G_B.yzz);
float param_62=covd.x;
float param_63=covd.y;
float param_64=covd.z;
float param_65=covo.x;
float param_66=covo.y;
float param_67=covo.z;
float3 param_68=RY_GY_BY_Y.xyz-(R_G_B*RY_GY_BY_Y.w);
float3 A=inverseSymMul(param_62,param_63,param_64,param_65,param_66,param_67,param_68);
float b=RY_GY_BY_Y.w-dot(A,R_G_B);
float2 param_69=mainTextureGetDims2D(userUniformsObj);
int param_70=mainTextureLayout;
int param_71=mainTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_72=in.varPackedTex.xy;
bool param_73=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_74=userUniformsObj.mainTextureTransform;
int2 param_75=_3239;
bool param_76=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_77=userUniformsObj.mainTextureUvMinMax;
bool param_78=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_79=userUniformsObj.mainTextureBorderColor;
float param_80=0.0;
float4 _3263=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_69,param_70,param_71,param_72,param_73,param_74,param_75,param_76,param_77,param_78,param_79,param_80);
float4 _3232=_3263;
float3 hr_RGB=_3263.xyz;
float mask=dot(A,hr_RGB)+b;
float4 result;
#if (CAMEOS_MATTING)
{
result=float4(mask,0.0,0.0,1.0);
}
#else
{
float param_81=mask;
result=float4(encode2(param_81),0.0,1.0);
}
#endif
float4 param_82=result;
sc_writeFragData0(param_82,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
