#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include "std2_vs.metal"
#include "std2_fs.metal"
#include "std2_texture.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN(100)
//SG_REFLECTION_END


struct UserUniforms
{
float4 depthTextureSize;
float4 depthTextureDims;
float4 depthTextureView;
float3x3 depthTextureTransform;
float4 depthTextureUvMinMax;
float4 depthTextureBorderColor;
float depthScale;
float depthToDisparityNumerator;
};

#ifndef depthTextureHasSwappedViews
#define depthTextureHasSwappedViews 0
#elif depthTextureHasSwappedViews==1
#undef depthTextureHasSwappedViews
#define depthTextureHasSwappedViews 1
#endif
#ifndef depthTextureLayout
#define depthTextureLayout 0
#endif
#ifndef PACKED_DISPARITY
#define PACKED_DISPARITY 0
#elif PACKED_DISPARITY==1
#undef PACKED_DISPARITY
#define PACKED_DISPARITY 1
#endif
#ifndef depthTextureUV
#define depthTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_depthTexture
#define SC_USE_UV_TRANSFORM_depthTexture 0
#elif SC_USE_UV_TRANSFORM_depthTexture==1
#undef SC_USE_UV_TRANSFORM_depthTexture
#define SC_USE_UV_TRANSFORM_depthTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_depthTexture
#define SC_SOFTWARE_WRAP_MODE_U_depthTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_depthTexture
#define SC_SOFTWARE_WRAP_MODE_V_depthTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_depthTexture
#define SC_USE_UV_MIN_MAX_depthTexture 0
#elif SC_USE_UV_MIN_MAX_depthTexture==1
#undef SC_USE_UV_MIN_MAX_depthTexture
#define SC_USE_UV_MIN_MAX_depthTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_depthTexture
#define SC_USE_CLAMP_TO_BORDER_depthTexture 0
#elif SC_USE_CLAMP_TO_BORDER_depthTexture==1
#undef SC_USE_CLAMP_TO_BORDER_depthTexture
#define SC_USE_CLAMP_TO_BORDER_depthTexture 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant LibraryUniforms& libraryUniformsObj,uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN(100)
//sampler sampler depthTextureSmpSC 0:61784
//texture texture2D depthTexture 0:54250:0:61784
//ubo float UserUniforms 0:35568:136 {
//float4 depthTextureSize 0
//float4 depthTextureDims 16
//float4 depthTextureView 32
//float3x3 depthTextureTransform 48
//float4 depthTextureUvMinMax 96
//float4 depthTextureBorderColor 112
//float depthScale 128
//float depthToDisparityNumerator 132
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 depthTextureSize;
float4 depthTextureDims;
float4 depthTextureView;
float3x3 depthTextureTransform;
float4 depthTextureUvMinMax;
float4 depthTextureBorderColor;
float depthScale;
float depthToDisparityNumerator;
};

#ifndef depthTextureHasSwappedViews
#define depthTextureHasSwappedViews 0
#elif depthTextureHasSwappedViews==1
#undef depthTextureHasSwappedViews
#define depthTextureHasSwappedViews 1
#endif
#ifndef depthTextureLayout
#define depthTextureLayout 0
#endif
#ifndef SC_USE_UV_TRANSFORM_depthTexture
#define SC_USE_UV_TRANSFORM_depthTexture 0
#elif SC_USE_UV_TRANSFORM_depthTexture==1
#undef SC_USE_UV_TRANSFORM_depthTexture
#define SC_USE_UV_TRANSFORM_depthTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_depthTexture
#define SC_SOFTWARE_WRAP_MODE_U_depthTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_depthTexture
#define SC_SOFTWARE_WRAP_MODE_V_depthTexture -1
#endif
constant int2 _2214=int2(SC_SOFTWARE_WRAP_MODE_U_depthTexture,SC_SOFTWARE_WRAP_MODE_V_depthTexture);
#ifndef SC_USE_UV_MIN_MAX_depthTexture
#define SC_USE_UV_MIN_MAX_depthTexture 0
#elif SC_USE_UV_MIN_MAX_depthTexture==1
#undef SC_USE_UV_MIN_MAX_depthTexture
#define SC_USE_UV_MIN_MAX_depthTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_depthTexture
#define SC_USE_CLAMP_TO_BORDER_depthTexture 0
#elif SC_USE_CLAMP_TO_BORDER_depthTexture==1
#undef SC_USE_CLAMP_TO_BORDER_depthTexture
#define SC_USE_CLAMP_TO_BORDER_depthTexture 1
#endif
#ifndef PACKED_DISPARITY
#define PACKED_DISPARITY 0
#elif PACKED_DISPARITY==1
#undef PACKED_DISPARITY
#define PACKED_DISPARITY 1
#endif
#ifndef depthTextureUV
#define depthTextureUV 0
#endif

struct main_frag_out
{
float gl_FragDepth [[depth(any)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float4 varPackedTex [[user(locn6)]];
};

float2 depthTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.depthTextureDims.xy;
}

int depthTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (depthTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float decode2(thread const float2& rg)
{
return dot(rg,float2(1.0,0.00392157));
}

float disparityToDepth(thread const float& disparity,thread const float& numerator)
{
return numerator/(disparity+1e-05);
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj,constant LibraryUniforms& libraryUniformsObj,texture2d<float> depthTexture,sampler depthTextureSmpSC,float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float2 param=depthTextureGetDims2D(userUniformsObj);
int param_1=depthTextureLayout;
int param_2=depthTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_3=in.varPackedTex.xy;
bool param_4=(int(SC_USE_UV_TRANSFORM_depthTexture)!=0);
float3x3 param_5=userUniformsObj.depthTextureTransform;
int2 param_6=_2214;
bool param_7=(int(SC_USE_UV_MIN_MAX_depthTexture)!=0);
float4 param_8=userUniformsObj.depthTextureUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_depthTexture)!=0);
float4 param_10=userUniformsObj.depthTextureBorderColor;
float param_11=0.0;
float4 _2240=sc_SampleTextureBiasOrLevel(depthTexture,depthTextureSmpSC,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
float4 _2207=_2240;
float4 depthTextureSample=_2240;
float depth=0.0;
#if (PACKED_DISPARITY)
{
float2 disparityPacked=depthTextureSample.xy;
float2 param_12=disparityPacked;
float param_13=decode2(param_12);
float param_14=userUniformsObj.depthToDisparityNumerator;
depth=disparityToDepth(param_13,param_14)*userUniformsObj.depthScale;
}
#else
{
depth=depthTextureSample.x*userUniformsObj.depthScale;
}
#endif
float fragDepth=0.0;
float _2268=depth;
bool _2270=!isinf(_2268);
bool _2276;
if (_2270)
{
_2276=!isnan(depth);
}
else
{
_2276=_2270;
}
if (_2276)
{
float4 projSpace=libraryUniformsObj.sc_ProjectionMatrixArray[sc_GetStereoViewIndex(in.varStereoViewID)]*float4(0.0,0.0,-depth,1.0);
fragDepth=((0.5*projSpace.z)/projSpace.w)+0.5;
}
out.gl_FragDepth=fragDepth;
return out;
}

} // FRAGMENT SHADER
