#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include "std2.metal"
#include "std2_vs.metal"
#include "std2_fs.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN(100)
//ubo float UserUniforms 0:35568:504 {
//float4 inputTextureSize 0
//float4 inputTextureDims 16
//float4 inputTextureView 32
//float3x3 inputTextureTransform 48
//float4 inputTextureUvMinMax 96
//float4 inputTextureBorderColor 112
//float4 maskTextureSize 128
//float4 maskTextureDims 144
//float4 maskTextureView 160
//float3x3 maskTextureTransform 176
//float4 maskTextureUvMinMax 224
//float4 maskTextureBorderColor 240
//float4 backTextureSize 256
//float4 backTextureDims 272
//float4 backTextureView 288
//float3x3 backTextureTransform 304
//float4 backTextureUvMinMax 352
//float4 backTextureBorderColor 368
//float3x3 maskTransform 384
//float3x3 backTransform 432
//float4 backColorMult 480
//float2 inputTextureScale 496
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 inputTextureSize;
float4 inputTextureDims;
float4 inputTextureView;
float3x3 inputTextureTransform;
float4 inputTextureUvMinMax;
float4 inputTextureBorderColor;
float4 maskTextureSize;
float4 maskTextureDims;
float4 maskTextureView;
float3x3 maskTextureTransform;
float4 maskTextureUvMinMax;
float4 maskTextureBorderColor;
float4 backTextureSize;
float4 backTextureDims;
float4 backTextureView;
float3x3 backTextureTransform;
float4 backTextureUvMinMax;
float4 backTextureBorderColor;
float3x3 maskTransform;
float3x3 backTransform;
float4 backColorMult;
float2 inputTextureScale;
};

#ifndef inputTextureHasSwappedViews
#define inputTextureHasSwappedViews 0
#elif inputTextureHasSwappedViews==1
#undef inputTextureHasSwappedViews
#define inputTextureHasSwappedViews 1
#endif
#ifndef inputTextureLayout
#define inputTextureLayout 0
#endif
#ifndef maskTextureHasSwappedViews
#define maskTextureHasSwappedViews 0
#elif maskTextureHasSwappedViews==1
#undef maskTextureHasSwappedViews
#define maskTextureHasSwappedViews 1
#endif
#ifndef maskTextureLayout
#define maskTextureLayout 0
#endif
#ifndef backTextureHasSwappedViews
#define backTextureHasSwappedViews 0
#elif backTextureHasSwappedViews==1
#undef backTextureHasSwappedViews
#define backTextureHasSwappedViews 1
#endif
#ifndef backTextureLayout
#define backTextureLayout 0
#endif
#ifndef FXAA
#define FXAA 0
#elif FXAA==1
#undef FXAA
#define FXAA 1
#endif
#ifndef MASK
#define MASK 0
#elif MASK==1
#undef MASK
#define MASK 1
#endif
#ifndef MASK_CHANNEL
#define MASK_CHANNEL 0
#endif
#ifndef inputTextureUV
#define inputTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_inputTexture
#define SC_USE_UV_TRANSFORM_inputTexture 0
#elif SC_USE_UV_TRANSFORM_inputTexture==1
#undef SC_USE_UV_TRANSFORM_inputTexture
#define SC_USE_UV_TRANSFORM_inputTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_inputTexture
#define SC_SOFTWARE_WRAP_MODE_U_inputTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_inputTexture
#define SC_SOFTWARE_WRAP_MODE_V_inputTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_inputTexture
#define SC_USE_UV_MIN_MAX_inputTexture 0
#elif SC_USE_UV_MIN_MAX_inputTexture==1
#undef SC_USE_UV_MIN_MAX_inputTexture
#define SC_USE_UV_MIN_MAX_inputTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_inputTexture
#define SC_USE_CLAMP_TO_BORDER_inputTexture 0
#elif SC_USE_CLAMP_TO_BORDER_inputTexture==1
#undef SC_USE_CLAMP_TO_BORDER_inputTexture
#define SC_USE_CLAMP_TO_BORDER_inputTexture 1
#endif
#ifndef maskTextureUV
#define maskTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_maskTexture
#define SC_USE_UV_TRANSFORM_maskTexture 0
#elif SC_USE_UV_TRANSFORM_maskTexture==1
#undef SC_USE_UV_TRANSFORM_maskTexture
#define SC_USE_UV_TRANSFORM_maskTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_maskTexture
#define SC_SOFTWARE_WRAP_MODE_U_maskTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_maskTexture
#define SC_SOFTWARE_WRAP_MODE_V_maskTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_maskTexture
#define SC_USE_UV_MIN_MAX_maskTexture 0
#elif SC_USE_UV_MIN_MAX_maskTexture==1
#undef SC_USE_UV_MIN_MAX_maskTexture
#define SC_USE_UV_MIN_MAX_maskTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_maskTexture
#define SC_USE_CLAMP_TO_BORDER_maskTexture 0
#elif SC_USE_CLAMP_TO_BORDER_maskTexture==1
#undef SC_USE_CLAMP_TO_BORDER_maskTexture
#define SC_USE_CLAMP_TO_BORDER_maskTexture 1
#endif
#ifndef backTextureUV
#define backTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_backTexture
#define SC_USE_UV_TRANSFORM_backTexture 0
#elif SC_USE_UV_TRANSFORM_backTexture==1
#undef SC_USE_UV_TRANSFORM_backTexture
#define SC_USE_UV_TRANSFORM_backTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_backTexture
#define SC_SOFTWARE_WRAP_MODE_U_backTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_backTexture
#define SC_SOFTWARE_WRAP_MODE_V_backTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_backTexture
#define SC_USE_UV_MIN_MAX_backTexture 0
#elif SC_USE_UV_MIN_MAX_backTexture==1
#undef SC_USE_UV_MIN_MAX_backTexture
#define SC_USE_UV_MIN_MAX_backTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_backTexture
#define SC_USE_CLAMP_TO_BORDER_backTexture 0
#elif SC_USE_CLAMP_TO_BORDER_backTexture==1
#undef SC_USE_CLAMP_TO_BORDER_backTexture
#define SC_USE_CLAMP_TO_BORDER_backTexture 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float4 varTexMaskAndBack [[user(locn10)]];
float4 varTex12 [[user(locn11)]];
float4 varTex34 [[user(locn12)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant UserUniforms& userUniformsObj,constant LibraryUniforms& libraryUniformsObj,uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
float3 origTex0=float3(v.texture0,1.0);
v.texture0=float2((userUniformsObj.inputTextureTransform*origTex0).xy);
#if (FXAA)
{
float2 _2819=v.texture0+(float2(-1.0)*userUniformsObj.inputTextureScale);
out.varTex12=float4(_2819.x,_2819.y,out.varTex12.z,out.varTex12.w);
float2 _2828=v.texture0+(float2(1.0,-1.0)*userUniformsObj.inputTextureScale);
out.varTex12=float4(out.varTex12.x,out.varTex12.y,_2828.x,_2828.y);
float2 _2838=v.texture0+(float2(-1.0,1.0)*userUniformsObj.inputTextureScale);
out.varTex34=float4(_2838.x,_2838.y,out.varTex34.z,out.varTex34.w);
float2 _2847=v.texture0+(float2(1.0)*userUniformsObj.inputTextureScale);
out.varTex34=float4(out.varTex34.x,out.varTex34.y,_2847.x,_2847.y);
}
#endif
#if (MASK)
{
float2 _2861=float2((userUniformsObj.maskTransform*origTex0).xy);
out.varTexMaskAndBack=float4(_2861.x,_2861.y,out.varTexMaskAndBack.z,out.varTexMaskAndBack.w);
float2 _2871=float2((userUniformsObj.backTransform*origTex0).xy);
out.varTexMaskAndBack=float4(out.varTexMaskAndBack.x,out.varTexMaskAndBack.y,_2871.x,_2871.y);
}
#endif
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN(100)
//sampler sampler inputTextureSmpSC 0:43245
//sampler sampler maskTextureSmpSC 0:35243
//sampler sampler backTextureSmpSC 0:53076
//texture texture2D inputTexture 0:37488:0:43245
//texture texture2D maskTexture 0:38610:0:35243
//texture texture2D backTexture 0:40663:0:53076
//ubo float UserUniforms 0:35568:504 {
//float4 inputTextureSize 0
//float4 inputTextureDims 16
//float4 inputTextureView 32
//float3x3 inputTextureTransform 48
//float4 inputTextureUvMinMax 96
//float4 inputTextureBorderColor 112
//float4 maskTextureSize 128
//float4 maskTextureDims 144
//float4 maskTextureView 160
//float3x3 maskTextureTransform 176
//float4 maskTextureUvMinMax 224
//float4 maskTextureBorderColor 240
//float4 backTextureSize 256
//float4 backTextureDims 272
//float4 backTextureView 288
//float3x3 backTextureTransform 304
//float4 backTextureUvMinMax 352
//float4 backTextureBorderColor 368
//float3x3 maskTransform 384
//float3x3 backTransform 432
//float4 backColorMult 480
//float2 inputTextureScale 496
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 inputTextureSize;
float4 inputTextureDims;
float4 inputTextureView;
float3x3 inputTextureTransform;
float4 inputTextureUvMinMax;
float4 inputTextureBorderColor;
float4 maskTextureSize;
float4 maskTextureDims;
float4 maskTextureView;
float3x3 maskTextureTransform;
float4 maskTextureUvMinMax;
float4 maskTextureBorderColor;
float4 backTextureSize;
float4 backTextureDims;
float4 backTextureView;
float3x3 backTextureTransform;
float4 backTextureUvMinMax;
float4 backTextureBorderColor;
float3x3 maskTransform;
float3x3 backTransform;
float4 backColorMult;
float2 inputTextureScale;
};

#ifndef inputTextureHasSwappedViews
#define inputTextureHasSwappedViews 0
#elif inputTextureHasSwappedViews==1
#undef inputTextureHasSwappedViews
#define inputTextureHasSwappedViews 1
#endif
#ifndef inputTextureLayout
#define inputTextureLayout 0
#endif
#ifndef maskTextureHasSwappedViews
#define maskTextureHasSwappedViews 0
#elif maskTextureHasSwappedViews==1
#undef maskTextureHasSwappedViews
#define maskTextureHasSwappedViews 1
#endif
#ifndef maskTextureLayout
#define maskTextureLayout 0
#endif
#ifndef backTextureHasSwappedViews
#define backTextureHasSwappedViews 0
#elif backTextureHasSwappedViews==1
#undef backTextureHasSwappedViews
#define backTextureHasSwappedViews 1
#endif
#ifndef backTextureLayout
#define backTextureLayout 0
#endif
#ifndef FXAA
#define FXAA 0
#elif FXAA==1
#undef FXAA
#define FXAA 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_inputTexture
#define SC_SOFTWARE_WRAP_MODE_U_inputTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_inputTexture
#define SC_SOFTWARE_WRAP_MODE_V_inputTexture -1
#endif
constant int2 _2447=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
#ifndef SC_USE_UV_MIN_MAX_inputTexture
#define SC_USE_UV_MIN_MAX_inputTexture 0
#elif SC_USE_UV_MIN_MAX_inputTexture==1
#undef SC_USE_UV_MIN_MAX_inputTexture
#define SC_USE_UV_MIN_MAX_inputTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_inputTexture
#define SC_USE_CLAMP_TO_BORDER_inputTexture 0
#elif SC_USE_CLAMP_TO_BORDER_inputTexture==1
#undef SC_USE_CLAMP_TO_BORDER_inputTexture
#define SC_USE_CLAMP_TO_BORDER_inputTexture 1
#endif
constant int2 _2478=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2506=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2533=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2561=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2701=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2732=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2762=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2791=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2841=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
#ifndef MASK
#define MASK 0
#elif MASK==1
#undef MASK
#define MASK 1
#endif
#ifndef MASK_CHANNEL
#define MASK_CHANNEL 0
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_maskTexture
#define SC_SOFTWARE_WRAP_MODE_U_maskTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_maskTexture
#define SC_SOFTWARE_WRAP_MODE_V_maskTexture -1
#endif
constant int2 _2877=int2(SC_SOFTWARE_WRAP_MODE_U_maskTexture,SC_SOFTWARE_WRAP_MODE_V_maskTexture);
#ifndef SC_USE_UV_MIN_MAX_maskTexture
#define SC_USE_UV_MIN_MAX_maskTexture 0
#elif SC_USE_UV_MIN_MAX_maskTexture==1
#undef SC_USE_UV_MIN_MAX_maskTexture
#define SC_USE_UV_MIN_MAX_maskTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_maskTexture
#define SC_USE_CLAMP_TO_BORDER_maskTexture 0
#elif SC_USE_CLAMP_TO_BORDER_maskTexture==1
#undef SC_USE_CLAMP_TO_BORDER_maskTexture
#define SC_USE_CLAMP_TO_BORDER_maskTexture 1
#endif
constant int2 _2911=int2(SC_SOFTWARE_WRAP_MODE_U_maskTexture,SC_SOFTWARE_WRAP_MODE_V_maskTexture);
constant int2 _2940=int2(SC_SOFTWARE_WRAP_MODE_U_maskTexture,SC_SOFTWARE_WRAP_MODE_V_maskTexture);
#ifndef SC_SOFTWARE_WRAP_MODE_U_backTexture
#define SC_SOFTWARE_WRAP_MODE_U_backTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_backTexture
#define SC_SOFTWARE_WRAP_MODE_V_backTexture -1
#endif
constant int2 _2968=int2(SC_SOFTWARE_WRAP_MODE_U_backTexture,SC_SOFTWARE_WRAP_MODE_V_backTexture);
#ifndef SC_USE_UV_MIN_MAX_backTexture
#define SC_USE_UV_MIN_MAX_backTexture 0
#elif SC_USE_UV_MIN_MAX_backTexture==1
#undef SC_USE_UV_MIN_MAX_backTexture
#define SC_USE_UV_MIN_MAX_backTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_backTexture
#define SC_USE_CLAMP_TO_BORDER_backTexture 0
#elif SC_USE_CLAMP_TO_BORDER_backTexture==1
#undef SC_USE_CLAMP_TO_BORDER_backTexture
#define SC_USE_CLAMP_TO_BORDER_backTexture 1
#endif
#ifndef inputTextureUV
#define inputTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_inputTexture
#define SC_USE_UV_TRANSFORM_inputTexture 0
#elif SC_USE_UV_TRANSFORM_inputTexture==1
#undef SC_USE_UV_TRANSFORM_inputTexture
#define SC_USE_UV_TRANSFORM_inputTexture 1
#endif
#ifndef maskTextureUV
#define maskTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_maskTexture
#define SC_USE_UV_TRANSFORM_maskTexture 0
#elif SC_USE_UV_TRANSFORM_maskTexture==1
#undef SC_USE_UV_TRANSFORM_maskTexture
#define SC_USE_UV_TRANSFORM_maskTexture 1
#endif
#ifndef backTextureUV
#define backTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_backTexture
#define SC_USE_UV_TRANSFORM_backTexture 0
#elif SC_USE_UV_TRANSFORM_backTexture==1
#undef SC_USE_UV_TRANSFORM_backTexture
#define SC_USE_UV_TRANSFORM_backTexture 1
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float4 varPackedTex [[user(locn6)]];
float4 varTexMaskAndBack [[user(locn10)]];
float4 varTex12 [[user(locn11)]];
float4 varTex34 [[user(locn12)]];
};

float2 inputTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.inputTextureDims.xy;
}

int inputTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (inputTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 maskTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.maskTextureDims.xy;
}

int maskTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (maskTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 backTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.backTextureDims.xy;
}

int backTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (backTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj,texture2d<float> inputTexture,texture2d<float> maskTexture,texture2d<float> backTexture,sampler maskTextureSmpSC,sampler inputTextureSmpSC,sampler backTextureSmpSC,float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float4 result=float4(0.0);
#if (FXAA)
{
float FXAA_SPAN_MAX=8.0;
float FXAA_REDUCE_MUL=0.125;
float FXAA_REDUCE_MIN=0.0078125;
float2 param=inputTextureGetDims2D(userUniformsObj);
int param_1=inputTextureLayout;
int param_2=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_3=in.varTex12.xy;
bool param_4=false;
float3x3 param_5=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_6=_2447;
bool param_7=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_8=userUniformsObj.inputTextureUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_10=userUniformsObj.inputTextureBorderColor;
float param_11=0.0;
float4 _2470=sc_SampleTextureBiasOrLevel(inputTexture,inputTextureSmpSC,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
float4 _2436=_2470;
float4 inputTextureSample=_2470;
float3 rgbNW=inputTextureSample.xyz;
float2 param_12=inputTextureGetDims2D(userUniformsObj);
int param_13=inputTextureLayout;
int param_14=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_15=in.varTex12.zw;
bool param_16=false;
float3x3 param_17=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_18=_2478;
bool param_19=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_20=userUniformsObj.inputTextureUvMinMax;
bool param_21=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_22=userUniformsObj.inputTextureBorderColor;
float param_23=0.0;
float4 _2497=sc_SampleTextureBiasOrLevel(inputTexture,inputTextureSmpSC,param_12,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23);
float4 _2475=_2497;
float4 inputTextureSample_1=_2497;
float3 rgbNE=inputTextureSample_1.xyz;
float2 param_24=inputTextureGetDims2D(userUniformsObj);
int param_25=inputTextureLayout;
int param_26=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_27=in.varTex34.xy;
bool param_28=false;
float3x3 param_29=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_30=_2506;
bool param_31=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_32=userUniformsObj.inputTextureUvMinMax;
bool param_33=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_34=userUniformsObj.inputTextureBorderColor;
float param_35=0.0;
float4 _2525=sc_SampleTextureBiasOrLevel(inputTexture,inputTextureSmpSC,param_24,param_25,param_26,param_27,param_28,param_29,param_30,param_31,param_32,param_33,param_34,param_35);
float4 _2502=_2525;
float4 inputTextureSample_2=_2525;
float3 rgbSW=inputTextureSample_2.xyz;
float2 param_36=inputTextureGetDims2D(userUniformsObj);
int param_37=inputTextureLayout;
int param_38=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_39=in.varTex34.zw;
bool param_40=false;
float3x3 param_41=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_42=_2533;
bool param_43=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_44=userUniformsObj.inputTextureUvMinMax;
bool param_45=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_46=userUniformsObj.inputTextureBorderColor;
float param_47=0.0;
float4 _2552=sc_SampleTextureBiasOrLevel(inputTexture,inputTextureSmpSC,param_36,param_37,param_38,param_39,param_40,param_41,param_42,param_43,param_44,param_45,param_46,param_47);
float4 _2530=_2552;
float4 inputTextureSample_3=_2552;
float3 rgbSE=inputTextureSample_3.xyz;
float2 param_48=inputTextureGetDims2D(userUniformsObj);
int param_49=inputTextureLayout;
int param_50=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_51=in.varPackedTex.xy;
bool param_52=false;
float3x3 param_53=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_54=_2561;
bool param_55=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_56=userUniformsObj.inputTextureUvMinMax;
bool param_57=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_58=userUniformsObj.inputTextureBorderColor;
float param_59=0.0;
float4 _2580=sc_SampleTextureBiasOrLevel(inputTexture,inputTextureSmpSC,param_48,param_49,param_50,param_51,param_52,param_53,param_54,param_55,param_56,param_57,param_58,param_59);
float4 _2557=_2580;
float4 inputTextureSample_4=_2580;
float3 rgbM=inputTextureSample_4.xyz;
float3 luma=float3(0.299,0.587,0.114);
float lumaNW=dot(rgbNW,luma);
float lumaNE=dot(rgbNE,luma);
float lumaSW=dot(rgbSW,luma);
float lumaSE=dot(rgbSE,luma);
float lumaM=dot(rgbM,luma);
float lumaMin=fast::min(lumaM,fast::min(fast::min(lumaNW,lumaNE),fast::min(lumaSW,lumaSE)));
float lumaMax=fast::max(lumaM,fast::max(fast::max(lumaNW,lumaNE),fast::max(lumaSW,lumaSE)));
float2 dir;
dir.x=-((lumaNW+lumaNE)-(lumaSW+lumaSE));
dir.y=(lumaNW+lumaSW)-(lumaNE+lumaSE);
float dirReduce=fast::max((((lumaNW+lumaNE)+lumaSW)+lumaSE)*(0.25*FXAA_REDUCE_MUL),FXAA_REDUCE_MIN);
float rcpDirMin=1.0/(fast::min(abs(dir.x),abs(dir.y))+dirReduce);
dir=fast::min(float2(FXAA_SPAN_MAX,FXAA_SPAN_MAX),fast::max(float2(-FXAA_SPAN_MAX,-FXAA_SPAN_MAX),dir*rcpDirMin))*userUniformsObj.inputTextureScale;
float2 param_60=inputTextureGetDims2D(userUniformsObj);
int param_61=inputTextureLayout;
int param_62=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_63=in.varPackedTex.xy-((dir*1.0)/float2(6.0));
bool param_64=false;
float3x3 param_65=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_66=_2701;
bool param_67=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_68=userUniformsObj.inputTextureUvMinMax;
bool param_69=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_70=userUniformsObj.inputTextureBorderColor;
float param_71=0.0;
float4 _2718=sc_SampleTextureBiasOrLevel(inputTexture,inputTextureSmpSC,param_60,param_61,param_62,param_63,param_64,param_65,param_66,param_67,param_68,param_69,param_70,param_71);
float4 _2690=_2718;
float4 inputTextureSample_5=_2718;
float4 colorA=inputTextureSample_5;
float2 param_72=inputTextureGetDims2D(userUniformsObj);
int param_73=inputTextureLayout;
int param_74=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_75=in.varPackedTex.xy+((dir*1.0)/float2(6.0));
bool param_76=false;
float3x3 param_77=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_78=_2732;
bool param_79=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_80=userUniformsObj.inputTextureUvMinMax;
bool param_81=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_82=userUniformsObj.inputTextureBorderColor;
float param_83=0.0;
float4 _2749=sc_SampleTextureBiasOrLevel(inputTexture,inputTextureSmpSC,param_72,param_73,param_74,param_75,param_76,param_77,param_78,param_79,param_80,param_81,param_82,param_83);
float4 _2722=_2749;
float4 inputTextureSample_6=_2749;
colorA+=inputTextureSample_6;
float2 param_84=inputTextureGetDims2D(userUniformsObj);
int param_85=inputTextureLayout;
int param_86=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_87=in.varPackedTex.xy-(dir*0.5);
bool param_88=false;
float3x3 param_89=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_90=_2762;
bool param_91=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_92=userUniformsObj.inputTextureUvMinMax;
bool param_93=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_94=userUniformsObj.inputTextureBorderColor;
float param_95=0.0;
float4 _2779=sc_SampleTextureBiasOrLevel(inputTexture,inputTextureSmpSC,param_84,param_85,param_86,param_87,param_88,param_89,param_90,param_91,param_92,param_93,param_94,param_95);
float4 _2754=_2779;
float4 inputTextureSample_7=_2779;
float4 colorB=inputTextureSample_7;
float2 param_96=inputTextureGetDims2D(userUniformsObj);
int param_97=inputTextureLayout;
int param_98=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_99=in.varPackedTex.xy+(dir*0.5);
bool param_100=false;
float3x3 param_101=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_102=_2791;
bool param_103=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_104=userUniformsObj.inputTextureUvMinMax;
bool param_105=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_106=userUniformsObj.inputTextureBorderColor;
float param_107=0.0;
float4 _2808=sc_SampleTextureBiasOrLevel(inputTexture,inputTextureSmpSC,param_96,param_97,param_98,param_99,param_100,param_101,param_102,param_103,param_104,param_105,param_106,param_107);
float4 _2783=_2808;
float4 inputTextureSample_8=_2808;
colorB+=inputTextureSample_8;
colorA*=0.5;
colorB=(colorA*0.5)+(colorB*0.25);
float lumaB=dot(colorB.xyz,luma);
if ((lumaB<lumaMin)||(lumaB>lumaMax))
{
result=colorA;
}
else
{
result=colorB;
}
}
#else
{
float2 param_108=inputTextureGetDims2D(userUniformsObj);
int param_109=inputTextureLayout;
int param_110=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_111=in.varPackedTex.xy;
bool param_112=false;
float3x3 param_113=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_114=_2841;
bool param_115=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_116=userUniformsObj.inputTextureUvMinMax;
bool param_117=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_118=userUniformsObj.inputTextureBorderColor;
float param_119=0.0;
float4 _2860=sc_SampleTextureBiasOrLevel(inputTexture,inputTextureSmpSC,param_108,param_109,param_110,param_111,param_112,param_113,param_114,param_115,param_116,param_117,param_118,param_119);
float4 _2838=_2860;
float4 inputTextureSample_9=_2860;
result=inputTextureSample_9;
}
#endif
#if (MASK)
{
float4 mask=float4(0.0);
#if (MASK_CHANNEL==0)
{
float2 param_120=maskTextureGetDims2D(userUniformsObj);
int param_121=maskTextureLayout;
int param_122=maskTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_123=in.varTexMaskAndBack.xy;
bool param_124=false;
float3x3 param_125=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_126=_2877;
bool param_127=(int(SC_USE_UV_MIN_MAX_maskTexture)!=0);
float4 param_128=userUniformsObj.maskTextureUvMinMax;
bool param_129=(int(SC_USE_CLAMP_TO_BORDER_maskTexture)!=0);
float4 param_130=userUniformsObj.maskTextureBorderColor;
float param_131=0.0;
float4 _2900=sc_SampleTextureBiasOrLevel(maskTexture,maskTextureSmpSC,param_120,param_121,param_122,param_123,param_124,param_125,param_126,param_127,param_128,param_129,param_130,param_131);
float4 _2871=_2900;
float4 maskTextureSample=_2900;
mask=maskTextureSample.xxxx;
}
#else
{
#if (MASK_CHANNEL==1)
{
float2 param_132=maskTextureGetDims2D(userUniformsObj);
int param_133=maskTextureLayout;
int param_134=maskTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_135=in.varTexMaskAndBack.xy;
bool param_136=false;
float3x3 param_137=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_138=_2911;
bool param_139=(int(SC_USE_UV_MIN_MAX_maskTexture)!=0);
float4 param_140=userUniformsObj.maskTextureUvMinMax;
bool param_141=(int(SC_USE_CLAMP_TO_BORDER_maskTexture)!=0);
float4 param_142=userUniformsObj.maskTextureBorderColor;
float param_143=0.0;
float4 _2930=sc_SampleTextureBiasOrLevel(maskTexture,maskTextureSmpSC,param_132,param_133,param_134,param_135,param_136,param_137,param_138,param_139,param_140,param_141,param_142,param_143);
float4 _2908=_2930;
float4 maskTextureSample_1=_2930;
mask=maskTextureSample_1;
}
#else
{
#if (MASK_CHANNEL==2)
{
float2 param_144=maskTextureGetDims2D(userUniformsObj);
int param_145=maskTextureLayout;
int param_146=maskTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_147=in.varTexMaskAndBack.xy;
bool param_148=false;
float3x3 param_149=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_150=_2940;
bool param_151=(int(SC_USE_UV_MIN_MAX_maskTexture)!=0);
float4 param_152=userUniformsObj.maskTextureUvMinMax;
bool param_153=(int(SC_USE_CLAMP_TO_BORDER_maskTexture)!=0);
float4 param_154=userUniformsObj.maskTextureBorderColor;
float param_155=0.0;
float4 _2959=sc_SampleTextureBiasOrLevel(maskTexture,maskTextureSmpSC,param_144,param_145,param_146,param_147,param_148,param_149,param_150,param_151,param_152,param_153,param_154,param_155);
float4 _2937=_2959;
float4 maskTextureSample_2=_2959;
mask=maskTextureSample_2.wwww;
}
#endif
}
#endif
}
#endif
float2 param_156=backTextureGetDims2D(userUniformsObj);
int param_157=backTextureLayout;
int param_158=backTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_159=in.varTexMaskAndBack.zw;
bool param_160=false;
float3x3 param_161=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_162=_2968;
bool param_163=(int(SC_USE_UV_MIN_MAX_backTexture)!=0);
float4 param_164=userUniformsObj.backTextureUvMinMax;
bool param_165=(int(SC_USE_CLAMP_TO_BORDER_backTexture)!=0);
float4 param_166=userUniformsObj.backTextureBorderColor;
float param_167=0.0;
float4 _2991=sc_SampleTextureBiasOrLevel(backTexture,backTextureSmpSC,param_156,param_157,param_158,param_159,param_160,param_161,param_162,param_163,param_164,param_165,param_166,param_167);
float4 _2963=_2991;
float4 backTextureSample=_2991;
float4 back=backTextureSample*userUniformsObj.backColorMult;
result=mix(back,result,mask);
}
#endif
float4 param_168=result;
sc_writeFragData0(param_168,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
