#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_TANGENT 1

#include "required2.metal"
#include "std2_fs.metal"
#include "std2_texture.metal"
#include "std2_vs.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN(100)
//ubo float UserUniforms 0:35568:416 {
//float4x4 script_modelMatrix 0
//float4x4 script_viewProjectionMatrix 64
//float3 uniSphereCenter 128
//float3 uniCameraPos 144
//float4 baseTexSize 160
//float4 baseTexDims 176
//float4 baseTexView 192
//float3x3 baseTexTransform 208
//float4 baseTexUvMinMax 256
//float4 baseTexBorderColor 272
//float4 borderTexSize 288
//float4 borderTexDims 304
//float4 borderTexView 320
//float3x3 borderTexTransform 336
//float4 borderTexUvMinMax 384
//float4 borderTexBorderColor 400
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4x4 script_modelMatrix;
float4x4 script_viewProjectionMatrix;
float3 uniSphereCenter;
float3 uniCameraPos;
float4 baseTexSize;
float4 baseTexDims;
float4 baseTexView;
float3x3 baseTexTransform;
float4 baseTexUvMinMax;
float4 baseTexBorderColor;
float4 borderTexSize;
float4 borderTexDims;
float4 borderTexView;
float3x3 borderTexTransform;
float4 borderTexUvMinMax;
float4 borderTexBorderColor;
};

#ifndef baseTexHasSwappedViews
#define baseTexHasSwappedViews 0
#elif baseTexHasSwappedViews==1
#undef baseTexHasSwappedViews
#define baseTexHasSwappedViews 1
#endif
#ifndef baseTexLayout
#define baseTexLayout 0
#endif
#ifndef borderTexHasSwappedViews
#define borderTexHasSwappedViews 0
#elif borderTexHasSwappedViews==1
#undef borderTexHasSwappedViews
#define borderTexHasSwappedViews 1
#endif
#ifndef borderTexLayout
#define borderTexLayout 0
#endif
#ifndef baseTexUV
#define baseTexUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_baseTex
#define SC_USE_UV_TRANSFORM_baseTex 0
#elif SC_USE_UV_TRANSFORM_baseTex==1
#undef SC_USE_UV_TRANSFORM_baseTex
#define SC_USE_UV_TRANSFORM_baseTex 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_baseTex
#define SC_SOFTWARE_WRAP_MODE_U_baseTex -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_baseTex
#define SC_SOFTWARE_WRAP_MODE_V_baseTex -1
#endif
#ifndef SC_USE_UV_MIN_MAX_baseTex
#define SC_USE_UV_MIN_MAX_baseTex 0
#elif SC_USE_UV_MIN_MAX_baseTex==1
#undef SC_USE_UV_MIN_MAX_baseTex
#define SC_USE_UV_MIN_MAX_baseTex 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_baseTex
#define SC_USE_CLAMP_TO_BORDER_baseTex 0
#elif SC_USE_CLAMP_TO_BORDER_baseTex==1
#undef SC_USE_CLAMP_TO_BORDER_baseTex
#define SC_USE_CLAMP_TO_BORDER_baseTex 1
#endif
#ifndef borderTexUV
#define borderTexUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_borderTex
#define SC_USE_UV_TRANSFORM_borderTex 0
#elif SC_USE_UV_TRANSFORM_borderTex==1
#undef SC_USE_UV_TRANSFORM_borderTex
#define SC_USE_UV_TRANSFORM_borderTex 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_borderTex
#define SC_SOFTWARE_WRAP_MODE_U_borderTex -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_borderTex
#define SC_SOFTWARE_WRAP_MODE_V_borderTex -1
#endif
#ifndef SC_USE_UV_MIN_MAX_borderTex
#define SC_USE_UV_MIN_MAX_borderTex 0
#elif SC_USE_UV_MIN_MAX_borderTex==1
#undef SC_USE_UV_MIN_MAX_borderTex
#define SC_USE_UV_MIN_MAX_borderTex 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_borderTex
#define SC_USE_CLAMP_TO_BORDER_borderTex 0
#elif SC_USE_CLAMP_TO_BORDER_borderTex==1
#undef SC_USE_CLAMP_TO_BORDER_borderTex
#define SC_USE_CLAMP_TO_BORDER_borderTex 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant UserUniforms& userUniformsObj,constant LibraryUniforms& libraryUniformsObj,uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
v.position=float4(((in.texture0*1.002)*2.0)-float2(1.0),0.0,1.0);
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
float4x4 rotationMatrix=float4x4(float4(1.0,0.0,0.0,0.0),float4(0.0,1.0,0.0,0.0),float4(0.0,0.0,1.0,0.0),float4(0.0,0.0,0.0,1.0));
rotationMatrix[0]=float4(0.0,0.0,1.0,0.0);
rotationMatrix[2]=float4(-1.0,0.0,0.0,0.0);
float4 newPosition=rotationMatrix*in.position;
float4x4 scaleMatrix=float4x4(float4(12.0,0.0,0.0,0.0),float4(0.0,12.0,0.0,0.0),float4(0.0,0.0,12.0,0.0),float4(0.0,0.0,0.0,12.0));
scaleMatrix[3].w=1.0;
newPosition=scaleMatrix*newPosition;
out.varPos=(userUniformsObj.script_modelMatrix*newPosition).xyz;
float3 normal=normalize(in.position.xyz);
out.varNormal=normalize(((userUniformsObj.script_modelMatrix*rotationMatrix)*float4(normal,0.0)).xyz);
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN(100)
//sampler sampler baseTexSmpSC 0:43599
//sampler sampler borderTexSmpSC 0:64580
//texture texture2D baseTex 0:54554:0:43599
//texture texture2D borderTex 0:47544:0:64580
//ubo float UserUniforms 0:35568:416 {
//float4x4 script_modelMatrix 0
//float4x4 script_viewProjectionMatrix 64
//float3 uniSphereCenter 128
//float3 uniCameraPos 144
//float4 baseTexSize 160
//float4 baseTexDims 176
//float4 baseTexView 192
//float3x3 baseTexTransform 208
//float4 baseTexUvMinMax 256
//float4 baseTexBorderColor 272
//float4 borderTexSize 288
//float4 borderTexDims 304
//float4 borderTexView 320
//float3x3 borderTexTransform 336
//float4 borderTexUvMinMax 384
//float4 borderTexBorderColor 400
//}
//SG_REFLECTION_END

struct twoPoints
{
float3 p1;
float3 p2;
};


struct UserUniforms
{
float4x4 script_modelMatrix;
float4x4 script_viewProjectionMatrix;
float3 uniSphereCenter;
float3 uniCameraPos;
float4 baseTexSize;
float4 baseTexDims;
float4 baseTexView;
float3x3 baseTexTransform;
float4 baseTexUvMinMax;
float4 baseTexBorderColor;
float4 borderTexSize;
float4 borderTexDims;
float4 borderTexView;
float3x3 borderTexTransform;
float4 borderTexUvMinMax;
float4 borderTexBorderColor;
};

#ifndef baseTexHasSwappedViews
#define baseTexHasSwappedViews 0
#elif baseTexHasSwappedViews==1
#undef baseTexHasSwappedViews
#define baseTexHasSwappedViews 1
#endif
#ifndef baseTexLayout
#define baseTexLayout 0
#endif
#ifndef borderTexHasSwappedViews
#define borderTexHasSwappedViews 0
#elif borderTexHasSwappedViews==1
#undef borderTexHasSwappedViews
#define borderTexHasSwappedViews 1
#endif
#ifndef borderTexLayout
#define borderTexLayout 0
#endif
#ifndef SC_USE_UV_TRANSFORM_borderTex
#define SC_USE_UV_TRANSFORM_borderTex 0
#elif SC_USE_UV_TRANSFORM_borderTex==1
#undef SC_USE_UV_TRANSFORM_borderTex
#define SC_USE_UV_TRANSFORM_borderTex 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_borderTex
#define SC_SOFTWARE_WRAP_MODE_U_borderTex -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_borderTex
#define SC_SOFTWARE_WRAP_MODE_V_borderTex -1
#endif
constant int2 _3409=int2(SC_SOFTWARE_WRAP_MODE_U_borderTex,SC_SOFTWARE_WRAP_MODE_V_borderTex);
#ifndef SC_USE_UV_MIN_MAX_borderTex
#define SC_USE_UV_MIN_MAX_borderTex 0
#elif SC_USE_UV_MIN_MAX_borderTex==1
#undef SC_USE_UV_MIN_MAX_borderTex
#define SC_USE_UV_MIN_MAX_borderTex 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_borderTex
#define SC_USE_CLAMP_TO_BORDER_borderTex 0
#elif SC_USE_CLAMP_TO_BORDER_borderTex==1
#undef SC_USE_CLAMP_TO_BORDER_borderTex
#define SC_USE_CLAMP_TO_BORDER_borderTex 1
#endif
constant int2 _3461=int2(SC_SOFTWARE_WRAP_MODE_U_borderTex,SC_SOFTWARE_WRAP_MODE_V_borderTex);
#ifndef SC_USE_UV_TRANSFORM_baseTex
#define SC_USE_UV_TRANSFORM_baseTex 0
#elif SC_USE_UV_TRANSFORM_baseTex==1
#undef SC_USE_UV_TRANSFORM_baseTex
#define SC_USE_UV_TRANSFORM_baseTex 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_baseTex
#define SC_SOFTWARE_WRAP_MODE_U_baseTex -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_baseTex
#define SC_SOFTWARE_WRAP_MODE_V_baseTex -1
#endif
constant int2 _3501=int2(SC_SOFTWARE_WRAP_MODE_U_baseTex,SC_SOFTWARE_WRAP_MODE_V_baseTex);
#ifndef SC_USE_UV_MIN_MAX_baseTex
#define SC_USE_UV_MIN_MAX_baseTex 0
#elif SC_USE_UV_MIN_MAX_baseTex==1
#undef SC_USE_UV_MIN_MAX_baseTex
#define SC_USE_UV_MIN_MAX_baseTex 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_baseTex
#define SC_USE_CLAMP_TO_BORDER_baseTex 0
#elif SC_USE_CLAMP_TO_BORDER_baseTex==1
#undef SC_USE_CLAMP_TO_BORDER_baseTex
#define SC_USE_CLAMP_TO_BORDER_baseTex 1
#endif
#ifndef baseTexUV
#define baseTexUV 0
#endif
#ifndef borderTexUV
#define borderTexUV 0
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float3 varNormal [[user(locn4)]];
};

void easyLineSphereIntersection(thread const float3& lineDir,thread const float3& sphereCenter,thread const float& sphereRadius,thread twoPoints& intersections)
{
float3 nLineDir=normalize(lineDir);
nLineDir*=sphereRadius;
intersections.p1=sphereCenter+nLineDir;
intersections.p2=sphereCenter-nLineDir;
}

float ensureIsNotZero(thread const float& num)
{
float add0=1.0-fast::max(abs(sign(num)),0.999);
return num+add0;
}

void getLineSphereIntersection(thread const float3& p1,thread const float3& p2,thread const float3& shpereCenter,thread const float& sphereRadius,thread twoPoints& intersections)
{
float3 d=p2-p1;
float a=dot(d,d);
float b=2.0*dot(d,p1-shpereCenter);
float c=((dot(shpereCenter,shpereCenter)+dot(p1,p1))-(2.0*dot(shpereCenter,p1)))-(sphereRadius*sphereRadius);
float disc=(b*b)-((4.0*a)*c);
intersections.p1=float3(10000.0,10000.0,0.0);
intersections.p2=float3(10000.0,10000.0,0.0);
if (disc>=0.0)
{
float sqrtdisc=sqrt(disc);
float param=2.0*a;
float divisor=ensureIsNotZero(param);
float u=((-b)-sqrtdisc)/divisor;
intersections.p1=p1+((p2-p1)*u);
u=((-b)+sqrtdisc)/divisor;
intersections.p2=p1+((p2-p1)*u);
}
}

float2 borderTexGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.borderTexDims.xy;
}

int borderTexGetStereoViewIndex(thread int& varStereoViewID)
{
#if (borderTexHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 baseTexGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.baseTexDims.xy;
}

int baseTexGetStereoViewIndex(thread int& varStereoViewID)
{
#if (baseTexHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj,texture2d<float> borderTex,texture2d<float> baseTex,sampler baseTexSmpSC,sampler borderTexSmpSC,float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float3 captureDirection=in.varNormal;
float smallSphereRadius=100.0;
float sphereRadius=fast::max(length(userUniformsObj.uniCameraPos-userUniformsObj.uniSphereCenter),smallSphereRadius);
float3 param=captureDirection;
float3 param_1=userUniformsObj.uniSphereCenter;
float param_2=sphereRadius;
twoPoints bigSphereIntersections;
twoPoints param_3=bigSphereIntersections;
easyLineSphereIntersection(param,param_1,param_2,param_3);
bigSphereIntersections=param_3;
float3 bigSphereIntersectionPoint=bigSphereIntersections.p1;
float3 virtualSetupIntersectionPoint=bigSphereIntersectionPoint;
float4 screenPosition=userUniformsObj.script_viewProjectionMatrix*float4(virtualSetupIntersectionPoint,1.0);
float param_4=screenPosition.w;
screenPosition=(screenPosition/float4(ensureIsNotZero(param_4)))*sign(screenPosition.w);
float3 test=float3(abs(screenPosition.x),abs(screenPosition.y),abs(screenPosition.z));
float isInsideNDC=(step(test.x,1.0)*step(test.y,1.0))*step(test.z,1.0);
float2 texCoord=(screenPosition.xy*0.5)+float2(0.5);
float3 centerCameraPixelNormal=normalize((float3(0.0,0.0,-1.0)*sphereRadius)-userUniformsObj.uniSphereCenter);
float3 param_5=userUniformsObj.uniCameraPos;
float3 param_6=userUniformsObj.uniCameraPos+float3(0.0,0.0,-1.0);
float3 param_7=userUniformsObj.uniSphereCenter;
float param_8=sphereRadius;
twoPoints cameraForwardBigSphereInt;
twoPoints param_9=cameraForwardBigSphereInt;
getLineSphereIntersection(param_5,param_6,param_7,param_8,param_9);
cameraForwardBigSphereInt=param_9;
float chooseP1=step(cameraForwardBigSphereInt.p1.z,userUniformsObj.uniSphereCenter.z);
float3 forwardBigSphereInt=mix(cameraForwardBigSphereInt.p2,cameraForwardBigSphereInt.p1,float3(chooseP1));
float2 borderTexCoord=float2((userUniformsObj.borderTexTransform*float3(texCoord,1.0)).xy);
float2 fromCenter=borderTexCoord-float2(0.5);
fromCenter/=float2(fast::max(abs(fromCenter.x),abs(fromCenter.y))*2.0);
borderTexCoord=fromCenter+float2(0.5);
texCoord=fast::clamp(texCoord,float2(0.002),float2(0.998));
float2 baseTexCoord=float2((userUniformsObj.baseTexTransform*float3(texCoord,1.0)).xy);
float angleOfInterest=acos(dot(normalize(forwardBigSphereInt-userUniformsObj.uniSphereCenter),normalize(virtualSetupIntersectionPoint-userUniformsObj.uniSphereCenter)));
float MIPf=fast::min(log2(fast::max((angleOfInterest-0.78539)/0.04909,1.0)),8.0);
float2 param_10=borderTexGetDims2D(userUniformsObj);
int param_11=borderTexLayout;
int param_12=borderTexGetStereoViewIndex(in.varStereoViewID);
float2 param_13=borderTexCoord;
bool param_14=(int(SC_USE_UV_TRANSFORM_borderTex)!=0);
float3x3 param_15=userUniformsObj.borderTexTransform;
int2 param_16=_3409;
bool param_17=(int(SC_USE_UV_MIN_MAX_borderTex)!=0);
float4 param_18=userUniformsObj.borderTexUvMinMax;
bool param_19=(int(SC_USE_CLAMP_TO_BORDER_borderTex)!=0);
float4 param_20=userUniformsObj.borderTexBorderColor;
float param_21=MIPf;
float4 _3434=sc_SampleTextureBiasOrLevel(borderTex,borderTexSmpSC,param_10,param_11,param_12,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21);
float4 _3403=_3434;
float4 borderSample=_3434;
float complimentaryAngle=fast::max(angleOfInterest-1.57079,0.0);
float complimentaryMixAmount=0.5*smoothstep(0.0,1.57079,complimentaryAngle);
float complimentaryMIPf=fast::min(log2(fast::max((2.35617+(1.57079-complimentaryAngle))/0.04909,1.0)),8.0);
float2 complimentaryTexCoord=(-fromCenter)+float2(0.5);
float2 param_22=borderTexGetDims2D(userUniformsObj);
int param_23=borderTexLayout;
int param_24=borderTexGetStereoViewIndex(in.varStereoViewID);
float2 param_25=complimentaryTexCoord;
bool param_26=(int(SC_USE_UV_TRANSFORM_borderTex)!=0);
float3x3 param_27=userUniformsObj.borderTexTransform;
int2 param_28=_3461;
bool param_29=(int(SC_USE_UV_MIN_MAX_borderTex)!=0);
float4 param_30=userUniformsObj.borderTexUvMinMax;
bool param_31=(int(SC_USE_CLAMP_TO_BORDER_borderTex)!=0);
float4 param_32=userUniformsObj.borderTexBorderColor;
float param_33=complimentaryMIPf;
float4 _3482=sc_SampleTextureBiasOrLevel(borderTex,borderTexSmpSC,param_22,param_23,param_24,param_25,param_26,param_27,param_28,param_29,param_30,param_31,param_32,param_33);
float4 _3458=_3482;
float4 complimentarySample=_3482;
complimentaryMixAmount*=2.0;
complimentaryMixAmount=sqrt(complimentaryMixAmount);
complimentaryMixAmount*=0.5;
borderSample=mix(borderSample,complimentarySample,float4(complimentaryMixAmount));
float2 param_34=baseTexGetDims2D(userUniformsObj);
int param_35=baseTexLayout;
int param_36=baseTexGetStereoViewIndex(in.varStereoViewID);
float2 param_37=baseTexCoord;
bool param_38=(int(SC_USE_UV_TRANSFORM_baseTex)!=0);
float3x3 param_39=userUniformsObj.baseTexTransform;
int2 param_40=_3501;
bool param_41=(int(SC_USE_UV_MIN_MAX_baseTex)!=0);
float4 param_42=userUniformsObj.baseTexUvMinMax;
bool param_43=(int(SC_USE_CLAMP_TO_BORDER_baseTex)!=0);
float4 param_44=userUniformsObj.baseTexBorderColor;
float param_45=0.0;
float4 _3525=sc_SampleTextureBiasOrLevel(baseTex,baseTexSmpSC,param_34,param_35,param_36,param_37,param_38,param_39,param_40,param_41,param_42,param_43,param_44,param_45);
float4 _3495=_3525;
float4 finColor=_3525;
finColor=mix(borderSample,finColor,float4(isInsideNDC));
float4 param_46=finColor;
sc_writeFragData0(param_46,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
