#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include "required2.metal"
#include "std2_fs.metal"
#include "std2_texture.metal"
#include "std2_vs.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN(100)
//ubo float UserUniforms 0:35568:192 {
//float4x4 script_modelMatrix 0
//float4 baseTexSize 64
//float4 baseTexDims 80
//float4 baseTexView 96
//float3x3 baseTexTransform 112
//float4 baseTexUvMinMax 160
//float4 baseTexBorderColor 176
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4x4 script_modelMatrix;
float4 baseTexSize;
float4 baseTexDims;
float4 baseTexView;
float3x3 baseTexTransform;
float4 baseTexUvMinMax;
float4 baseTexBorderColor;
};

#ifndef baseTexHasSwappedViews
#define baseTexHasSwappedViews 0
#elif baseTexHasSwappedViews==1
#undef baseTexHasSwappedViews
#define baseTexHasSwappedViews 1
#endif
#ifndef baseTexLayout
#define baseTexLayout 0
#endif
#ifndef baseTexUV
#define baseTexUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_baseTex
#define SC_USE_UV_TRANSFORM_baseTex 0
#elif SC_USE_UV_TRANSFORM_baseTex==1
#undef SC_USE_UV_TRANSFORM_baseTex
#define SC_USE_UV_TRANSFORM_baseTex 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_baseTex
#define SC_SOFTWARE_WRAP_MODE_U_baseTex -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_baseTex
#define SC_SOFTWARE_WRAP_MODE_V_baseTex -1
#endif
#ifndef SC_USE_UV_MIN_MAX_baseTex
#define SC_USE_UV_MIN_MAX_baseTex 0
#elif SC_USE_UV_MIN_MAX_baseTex==1
#undef SC_USE_UV_MIN_MAX_baseTex
#define SC_USE_UV_MIN_MAX_baseTex 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_baseTex
#define SC_USE_CLAMP_TO_BORDER_baseTex 0
#elif SC_USE_CLAMP_TO_BORDER_baseTex==1
#undef SC_USE_CLAMP_TO_BORDER_baseTex
#define SC_USE_CLAMP_TO_BORDER_baseTex 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant UserUniforms& userUniformsObj,constant LibraryUniforms& libraryUniformsObj,uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
float4x4 rotationMatrix=float4x4(float4(1.0,0.0,0.0,0.0),float4(0.0,1.0,0.0,0.0),float4(0.0,0.0,1.0,0.0),float4(0.0,0.0,0.0,1.0));
rotationMatrix[0]=float4(0.0,0.0,1.0,0.0);
rotationMatrix[2]=float4(-1.0,0.0,0.0,0.0);
float3 normal=normalize(in.position.xyz);
v.normal=normalize(((userUniformsObj.script_modelMatrix*rotationMatrix)*float4(normal,0.0)).xyz);
float2 modifiedTexCoords=in.texture0*1.002;
v.position=float4((modifiedTexCoords*2.0)-float2(1.0),0.0,1.0);
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN(100)
//sampler sampler baseTexSmpSC 0:43599
//texture texture2D baseTex 0:54554:0:43599
//ubo float UserUniforms 0:35568:192 {
//float4x4 script_modelMatrix 0
//float4 baseTexSize 64
//float4 baseTexDims 80
//float4 baseTexView 96
//float3x3 baseTexTransform 112
//float4 baseTexUvMinMax 160
//float4 baseTexBorderColor 176
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4x4 script_modelMatrix;
float4 baseTexSize;
float4 baseTexDims;
float4 baseTexView;
float3x3 baseTexTransform;
float4 baseTexUvMinMax;
float4 baseTexBorderColor;
};

#ifndef baseTexHasSwappedViews
#define baseTexHasSwappedViews 0
#elif baseTexHasSwappedViews==1
#undef baseTexHasSwappedViews
#define baseTexHasSwappedViews 1
#endif
#ifndef baseTexLayout
#define baseTexLayout 0
#endif
#ifndef SC_USE_UV_TRANSFORM_baseTex
#define SC_USE_UV_TRANSFORM_baseTex 0
#elif SC_USE_UV_TRANSFORM_baseTex==1
#undef SC_USE_UV_TRANSFORM_baseTex
#define SC_USE_UV_TRANSFORM_baseTex 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_baseTex
#define SC_SOFTWARE_WRAP_MODE_U_baseTex -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_baseTex
#define SC_SOFTWARE_WRAP_MODE_V_baseTex -1
#endif
constant int2 _2970=int2(SC_SOFTWARE_WRAP_MODE_U_baseTex,SC_SOFTWARE_WRAP_MODE_V_baseTex);
#ifndef SC_USE_UV_MIN_MAX_baseTex
#define SC_USE_UV_MIN_MAX_baseTex 0
#elif SC_USE_UV_MIN_MAX_baseTex==1
#undef SC_USE_UV_MIN_MAX_baseTex
#define SC_USE_UV_MIN_MAX_baseTex 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_baseTex
#define SC_USE_CLAMP_TO_BORDER_baseTex 0
#elif SC_USE_CLAMP_TO_BORDER_baseTex==1
#undef SC_USE_CLAMP_TO_BORDER_baseTex
#define SC_USE_CLAMP_TO_BORDER_baseTex 1
#endif
#ifndef baseTexUV
#define baseTexUV 0
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float3 varNormal [[user(locn4)]];
};

float2 calculateEnvmapScreenToCube(thread float3& V)
{
V.y=-V.y;
V.z=abs(V.z);
float3 vAbs=abs(V);
float _2474=vAbs.z;
float _2476=vAbs.x;
bool _2477=_2474>=_2476;
bool _2485;
if (_2477)
{
_2485=vAbs.z>=vAbs.y;
}
else
{
_2485=_2477;
}
float2 uv;
if (_2485)
{
float ma=0.5/vAbs.z;
uv=float2(V.x,V.y)*ma;
uv=(uv*0.5)+float2(0.5);
}
else
{
if (vAbs.y>=vAbs.x)
{
float ma_1=0.5/vAbs.y;
uv=float2(V.x,-V.z)*ma_1;
uv.x*=mix(0.5,1.0,1.0-(abs(uv.y)*2.0));
uv.x+=0.5;
uv.y*=0.5;
uv.y=abs(uv.y);
if (V.y>0.0)
{
uv.y=1.0-uv.y;
}
}
else
{
float ma_2=0.5/vAbs.x;
float _2563;
if (V.x<0.0)
{
_2563=V.z;
}
else
{
_2563=-V.z;
}
uv=float2(_2563,V.y)*ma_2;
uv.y*=mix(0.5,1.0,1.0-(abs(uv.x)*2.0));
uv.y+=0.5;
uv.x*=0.5;
uv.x=abs(uv.x);
if (V.x>0.0)
{
uv.x=1.0-uv.x;
}
}
}
return uv;
}

float2 baseTexGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.baseTexDims.xy;
}

int baseTexGetStereoViewIndex(thread int& varStereoViewID)
{
#if (baseTexHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj,texture2d<float> baseTex,sampler baseTexSmpSC,float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float4 cameraCubeColor=float4(0.0);
float3 param=-in.varNormal;
float2 _2956=calculateEnvmapScreenToCube(param);
float2 cubeCoord=_2956;
cubeCoord=fast::clamp(cubeCoord,float2(0.002),float2(0.998));
float2 param_1=baseTexGetDims2D(userUniformsObj);
int param_2=baseTexLayout;
int param_3=baseTexGetStereoViewIndex(in.varStereoViewID);
float2 param_4=cubeCoord;
bool param_5=(int(SC_USE_UV_TRANSFORM_baseTex)!=0);
float3x3 param_6=userUniformsObj.baseTexTransform;
int2 param_7=_2970;
bool param_8=(int(SC_USE_UV_MIN_MAX_baseTex)!=0);
float4 param_9=userUniformsObj.baseTexUvMinMax;
bool param_10=(int(SC_USE_CLAMP_TO_BORDER_baseTex)!=0);
float4 param_11=userUniformsObj.baseTexBorderColor;
float param_12=0.0;
float4 _2995=sc_SampleTextureBiasOrLevel(baseTex,baseTexSmpSC,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11,param_12);
float4 _2963=_2995;
cameraCubeColor=_2995;
cameraCubeColor.w=1.0;
float4 param_13=cameraCubeColor;
sc_writeFragData0(param_13,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
