#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include "required2.metal"
#include "std2_fs.metal"
#include "std2_texture.metal"
#include "std2_vs.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN(100)
//SG_REFLECTION_END

#ifndef SAMPLE_COUNT
#define SAMPLE_COUNT 0
#endif

struct UserUniforms
{
float4 baseTexSize;
float4 baseTexDims;
float4 baseTexView;
float3x3 baseTexTransform;
float4 baseTexUvMinMax;
float4 baseTexBorderColor;
float mipLevel;
float3 lightVec[SAMPLE_COUNT];
float4x4 fMipLevelsMat[SAMPLE_COUNT/16];
};

#ifndef baseTexHasSwappedViews
#define baseTexHasSwappedViews 0
#elif baseTexHasSwappedViews==1
#undef baseTexHasSwappedViews
#define baseTexHasSwappedViews 1
#endif
#ifndef baseTexLayout
#define baseTexLayout 0
#endif
#ifndef baseTexUV
#define baseTexUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_baseTex
#define SC_USE_UV_TRANSFORM_baseTex 0
#elif SC_USE_UV_TRANSFORM_baseTex==1
#undef SC_USE_UV_TRANSFORM_baseTex
#define SC_USE_UV_TRANSFORM_baseTex 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_baseTex
#define SC_SOFTWARE_WRAP_MODE_U_baseTex -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_baseTex
#define SC_SOFTWARE_WRAP_MODE_V_baseTex -1
#endif
#ifndef SC_USE_UV_MIN_MAX_baseTex
#define SC_USE_UV_MIN_MAX_baseTex 0
#elif SC_USE_UV_MIN_MAX_baseTex==1
#undef SC_USE_UV_MIN_MAX_baseTex
#define SC_USE_UV_MIN_MAX_baseTex 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_baseTex
#define SC_USE_CLAMP_TO_BORDER_baseTex 0
#elif SC_USE_CLAMP_TO_BORDER_baseTex==1
#undef SC_USE_CLAMP_TO_BORDER_baseTex
#define SC_USE_CLAMP_TO_BORDER_baseTex 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant LibraryUniforms& libraryUniformsObj,uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
v.position=float4((in.texture0*2.0)-float2(1.0),0.0,1.0);
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN(100)
//sampler sampler baseTexSmpSC 0:43599
//texture texture2D baseTex 0:54554:0:43599
//ubo float UserUniforms 0:35568 {
//float4 baseTexSize 0
//float4 baseTexDims 16
//float4 baseTexView 32
//float3x3 baseTexTransform 48
//float4 baseTexUvMinMax 96
//float4 baseTexBorderColor 112
//float mipLevel 128
//float3 lightVec 144:[]:16
//float4x4 fMipLevelsMat :[]:64
//}
//SG_REFLECTION_END

#ifndef SAMPLE_COUNT
#define SAMPLE_COUNT 0
#endif

struct UserUniforms
{
float4 baseTexSize;
float4 baseTexDims;
float4 baseTexView;
float3x3 baseTexTransform;
float4 baseTexUvMinMax;
float4 baseTexBorderColor;
float mipLevel;
float3 lightVec[SAMPLE_COUNT];
float4x4 fMipLevelsMat[SAMPLE_COUNT/16];
};

#ifndef baseTexHasSwappedViews
#define baseTexHasSwappedViews 0
#elif baseTexHasSwappedViews==1
#undef baseTexHasSwappedViews
#define baseTexHasSwappedViews 1
#endif
#ifndef baseTexLayout
#define baseTexLayout 0
#endif
#ifndef SC_USE_UV_TRANSFORM_baseTex
#define SC_USE_UV_TRANSFORM_baseTex 0
#elif SC_USE_UV_TRANSFORM_baseTex==1
#undef SC_USE_UV_TRANSFORM_baseTex
#define SC_USE_UV_TRANSFORM_baseTex 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_baseTex
#define SC_SOFTWARE_WRAP_MODE_U_baseTex -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_baseTex
#define SC_SOFTWARE_WRAP_MODE_V_baseTex -1
#endif
constant int2 _3076=int2(SC_SOFTWARE_WRAP_MODE_U_baseTex,SC_SOFTWARE_WRAP_MODE_V_baseTex);
#ifndef SC_USE_UV_MIN_MAX_baseTex
#define SC_USE_UV_MIN_MAX_baseTex 0
#elif SC_USE_UV_MIN_MAX_baseTex==1
#undef SC_USE_UV_MIN_MAX_baseTex
#define SC_USE_UV_MIN_MAX_baseTex 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_baseTex
#define SC_USE_CLAMP_TO_BORDER_baseTex 0
#elif SC_USE_CLAMP_TO_BORDER_baseTex==1
#undef SC_USE_CLAMP_TO_BORDER_baseTex
#define SC_USE_CLAMP_TO_BORDER_baseTex 1
#endif
#ifndef baseTexUV
#define baseTexUV 0
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float4 varPackedTex [[user(locn6)]];
};

float2 stretchCoordToOne(thread float2& uv,thread const float2& origTexturePxSize,thread const float& lod)
{
float2 a=uv-float2(0.5);
float2 b=origTexturePxSize*exp2(lod);
uv=(float2(0.5)+a)+((sign(a)*b)*0.5);
return uv;
}

float3 calcDirFromPanoramicTexCoords(thread const float2& uv)
{
float a=6.28319*uv.x;
float b=3.14159*uv.y;
float x=sin(a)*sin(b);
float y=cos(b);
float z=cos(a)*sin(b);
return float3(z,y,x);
}

float saturate0(thread const float& value)
{
return fast::clamp(value,0.0,1.0);
}

float _atan2(thread const float& x,thread const float& y)
{
float signx=(x<0.0) ? (-1.0) : 1.0;
return signx*acos(fast::clamp(y/length(float2(x,y)),-1.0,1.0));
}

float2 calcPanoramicTexCoordsFromDir(thread const float3& reflDir)
{
float3 R=normalize(reflDir);
float param=R.x;
float param_1=-R.z;
float2 uv;
uv.x=_atan2(param,param_1)-1.5708;
uv.y=acos(R.y);
uv/=float2(6.28319,3.14159);
return uv;
}

float getMat4ValByIndex(thread const float4x4& mat,thread const int& index)
{
int row=index/4;
int col=index-(row*4);
return mat[row][col];
}

float getMipLevel(thread const int& index,constant UserUniforms& userUniformsObj)
{
int indexMat=index/16;
int indexVal=index-(indexMat*16);
float4x4 param=userUniformsObj.fMipLevelsMat[indexMat];
int param_1=indexVal;
return getMat4ValByIndex(param,param_1);
}

float2 calcSeamlessPanoramicUvsForConvolution(thread const float2& uv,thread const float2& topMipRes,thread const float& lod)
{
float2 thisMipRes=fast::max(float2(1.0),topMipRes/float2(exp2(lod)));
return ((uv*thisMipRes)-float2(0.5))/(thisMipRes-float2(1.0));
}

float2 baseTexGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.baseTexDims.xy;
}

int baseTexGetStereoViewIndex(thread int& varStereoViewID)
{
#if (baseTexHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float3 decodeRGBD(thread const float4& rgbd)
{
return rgbd.xyz*(1.0/rgbd.w);
}

float4 encodeRGBD(thread const float3& rgb)
{
float maxRGB=fast::max(1.0,fast::max(rgb.x,fast::max(rgb.y,rgb.z)));
float D=1.0/maxRGB;
return float4(rgb*D,D);
}

float4 filterEnvmap1(thread const float3& targetN,thread int& varStereoViewID,constant UserUniforms& userUniformsObj,thread texture2d<float> baseTex,thread sampler baseTexSmpSC)
{
float fTotalWeight=0.0;
float3 vPrefilteredColor=float3(0.0);
int i=0;
for (int snapLoopIndex=0; snapLoopIndex==0; snapLoopIndex+=0)
{
if (i<SAMPLE_COUNT)
{
float3 vLight=userUniformsObj.lightVec[i];
float param=vLight.y;
float NoL=saturate0(param);
bool3 _3028=bool3(abs(targetN.y)<0.999);
float3 UpVector=float3(_3028.x ? float3(0.0,1.0,0.0).x : float3(0.0,0.0,1.0).x,_3028.y ? float3(0.0,1.0,0.0).y : float3(0.0,0.0,1.0).y,_3028.z ? float3(0.0,1.0,0.0).z : float3(0.0,0.0,1.0).z);
float3 TangentX=normalize(cross(UpVector,targetN));
float3 TangentZ=cross(targetN,TangentX);
vLight=((TangentX*vLight.x)+(targetN*vLight.y))+(TangentZ*vLight.z);
float3 param_1=vLight;
float2 uv=calcPanoramicTexCoordsFromDir(param_1);
int param_2=i;
float fMipLevel=getMipLevel(param_2,userUniformsObj);
float2 param_3=uv;
float2 param_4=userUniformsObj.baseTexSize.xy;
float param_5=fMipLevel;
uv=calcSeamlessPanoramicUvsForConvolution(param_3,param_4,param_5);
float2 param_6=baseTexGetDims2D(userUniformsObj);
int param_7=baseTexLayout;
int param_8=baseTexGetStereoViewIndex(varStereoViewID);
float2 param_9=uv;
bool param_10=(int(SC_USE_UV_TRANSFORM_baseTex)!=0);
float3x3 param_11=userUniformsObj.baseTexTransform;
int2 param_12=_3076;
bool param_13=(int(SC_USE_UV_MIN_MAX_baseTex)!=0);
float4 param_14=userUniformsObj.baseTexUvMinMax;
bool param_15=(int(SC_USE_CLAMP_TO_BORDER_baseTex)!=0);
float4 param_16=userUniformsObj.baseTexBorderColor;
float param_17=fMipLevel;
float4 _3101=sc_SampleTextureBiasOrLevel(baseTex,baseTexSmpSC,param_6,param_7,param_8,param_9,param_10,param_11,param_12,param_13,param_14,param_15,param_16,param_17);
float4 _3070=_3101;
float4 param_18=_3101;
vPrefilteredColor+=(decodeRGBD(param_18)*NoL);
fTotalWeight+=NoL;
i++;
continue;
}
else
{
break;
}
}
float3 param_19=vPrefilteredColor/float3(fTotalWeight);
return encodeRGBD(param_19);
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj,texture2d<float> baseTex,sampler baseTexSmpSC,float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float2 param=in.varPackedTex.xy;
float2 param_1=userUniformsObj.baseTexSize.zw;
float param_2=userUniformsObj.mipLevel;
float2 _3134=stretchCoordToOne(param,param_1,param_2);
float2 param_3=_3134;
float3 targetN=normalize(calcDirFromPanoramicTexCoords(param_3));
float3 param_4=targetN;
float4 param_5=filterEnvmap1(param_4,in.varStereoViewID,userUniformsObj,baseTex,baseTexSmpSC);
sc_writeFragData0(param_5,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
