#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include "required2.metal"
#include "std2_fs.metal"
#include "std2_texture.metal"
#include "std2_vs.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN(100)
//ubo float UserUniforms 0:35568:128 {
//float4 baseTexSize 0
//float4 baseTexDims 16
//float4 baseTexView 32
//float3x3 baseTexTransform 48
//float4 baseTexUvMinMax 96
//float4 baseTexBorderColor 112
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 baseTexSize;
float4 baseTexDims;
float4 baseTexView;
float3x3 baseTexTransform;
float4 baseTexUvMinMax;
float4 baseTexBorderColor;
};

#ifndef baseTexHasSwappedViews
#define baseTexHasSwappedViews 0
#elif baseTexHasSwappedViews==1
#undef baseTexHasSwappedViews
#define baseTexHasSwappedViews 1
#endif
#ifndef baseTexLayout
#define baseTexLayout 0
#endif
#ifndef baseTexUV
#define baseTexUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_baseTex
#define SC_USE_UV_TRANSFORM_baseTex 0
#elif SC_USE_UV_TRANSFORM_baseTex==1
#undef SC_USE_UV_TRANSFORM_baseTex
#define SC_USE_UV_TRANSFORM_baseTex 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_baseTex
#define SC_SOFTWARE_WRAP_MODE_U_baseTex -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_baseTex
#define SC_SOFTWARE_WRAP_MODE_V_baseTex -1
#endif
#ifndef SC_USE_UV_MIN_MAX_baseTex
#define SC_USE_UV_MIN_MAX_baseTex 0
#elif SC_USE_UV_MIN_MAX_baseTex==1
#undef SC_USE_UV_MIN_MAX_baseTex
#define SC_USE_UV_MIN_MAX_baseTex 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_baseTex
#define SC_USE_CLAMP_TO_BORDER_baseTex 0
#elif SC_USE_CLAMP_TO_BORDER_baseTex==1
#undef SC_USE_CLAMP_TO_BORDER_baseTex
#define SC_USE_CLAMP_TO_BORDER_baseTex 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float2 varTex_0 [[user(locn10)]];
float2 varTex_1 [[user(locn11)]];
float2 varTex_2 [[user(locn12)]];
float2 varTex_3 [[user(locn13)]];
float2 varTex_4 [[user(locn14)]];
float2 varTex_5 [[user(locn15)]];
float2 varTex_6 [[user(locn16)]];
float2 varTex_7 [[user(locn17)]];
float2 varTex_8 [[user(locn18)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant UserUniforms& userUniformsObj,constant LibraryUniforms& libraryUniformsObj,uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
float2 varTex[9]={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
float PX_SIZE=userUniformsObj.baseTexSize.z;
float2 texCoo=(v.position.xy*0.5)+float2(0.5);
varTex[0]=texCoo;
varTex[1]=texCoo+float2(0.0,userUniformsObj.baseTexSize.w);
varTex[2]=texCoo+float2(userUniformsObj.baseTexSize.z,userUniformsObj.baseTexSize.w);
varTex[3]=texCoo+float2(userUniformsObj.baseTexSize.z,0.0);
varTex[4]=texCoo+float2(-userUniformsObj.baseTexSize.z,userUniformsObj.baseTexSize.w);
varTex[5]=texCoo+float2(-userUniformsObj.baseTexSize.z,0.0);
varTex[6]=texCoo+float2(-userUniformsObj.baseTexSize.z,-userUniformsObj.baseTexSize.w);
varTex[7]=texCoo+float2(0.0,-userUniformsObj.baseTexSize.w);
varTex[8]=texCoo+float2(userUniformsObj.baseTexSize.z,-userUniformsObj.baseTexSize.w);
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
out.varTex_0=varTex[0];
out.varTex_1=varTex[1];
out.varTex_2=varTex[2];
out.varTex_3=varTex[3];
out.varTex_4=varTex[4];
out.varTex_5=varTex[5];
out.varTex_6=varTex[6];
out.varTex_7=varTex[7];
out.varTex_8=varTex[8];
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN(100)
//sampler sampler baseTexSmpSC 0:43599
//texture texture2D baseTex 0:54554:0:43599
//ubo float UserUniforms 0:35568:128 {
//float4 baseTexSize 0
//float4 baseTexDims 16
//float4 baseTexView 32
//float3x3 baseTexTransform 48
//float4 baseTexUvMinMax 96
//float4 baseTexBorderColor 112
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 baseTexSize;
float4 baseTexDims;
float4 baseTexView;
float3x3 baseTexTransform;
float4 baseTexUvMinMax;
float4 baseTexBorderColor;
};

#ifndef baseTexHasSwappedViews
#define baseTexHasSwappedViews 0
#elif baseTexHasSwappedViews==1
#undef baseTexHasSwappedViews
#define baseTexHasSwappedViews 1
#endif
#ifndef baseTexLayout
#define baseTexLayout 0
#endif
#ifndef SC_USE_UV_TRANSFORM_baseTex
#define SC_USE_UV_TRANSFORM_baseTex 0
#elif SC_USE_UV_TRANSFORM_baseTex==1
#undef SC_USE_UV_TRANSFORM_baseTex
#define SC_USE_UV_TRANSFORM_baseTex 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_baseTex
#define SC_SOFTWARE_WRAP_MODE_U_baseTex -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_baseTex
#define SC_SOFTWARE_WRAP_MODE_V_baseTex -1
#endif
constant int2 _2173=int2(SC_SOFTWARE_WRAP_MODE_U_baseTex,SC_SOFTWARE_WRAP_MODE_V_baseTex);
#ifndef SC_USE_UV_MIN_MAX_baseTex
#define SC_USE_UV_MIN_MAX_baseTex 0
#elif SC_USE_UV_MIN_MAX_baseTex==1
#undef SC_USE_UV_MIN_MAX_baseTex
#define SC_USE_UV_MIN_MAX_baseTex 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_baseTex
#define SC_USE_CLAMP_TO_BORDER_baseTex 0
#elif SC_USE_CLAMP_TO_BORDER_baseTex==1
#undef SC_USE_CLAMP_TO_BORDER_baseTex
#define SC_USE_CLAMP_TO_BORDER_baseTex 1
#endif
#ifndef baseTexUV
#define baseTexUV 0
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float2 varTex_0 [[user(locn10)]];
float2 varTex_1 [[user(locn11)]];
float2 varTex_2 [[user(locn12)]];
float2 varTex_3 [[user(locn13)]];
float2 varTex_4 [[user(locn14)]];
float2 varTex_5 [[user(locn15)]];
float2 varTex_6 [[user(locn16)]];
float2 varTex_7 [[user(locn17)]];
float2 varTex_8 [[user(locn18)]];
};

float2 baseTexGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.baseTexDims.xy;
}

int baseTexGetStereoViewIndex(thread int& varStereoViewID)
{
#if (baseTexHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float luma(thread const float3& c)
{
return dot(c,float3(0.299,0.587,0.114));
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj,texture2d<float> baseTex,sampler baseTexSmpSC,float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float2 varTex[9]={};
varTex[0]=in.varTex_0;
varTex[1]=in.varTex_1;
varTex[2]=in.varTex_2;
varTex[3]=in.varTex_3;
varTex[4]=in.varTex_4;
varTex[5]=in.varTex_5;
varTex[6]=in.varTex_6;
varTex[7]=in.varTex_7;
varTex[8]=in.varTex_8;
float countColorsBreachedTreshold=0.0;
float overallColors=0.0;
int i=0;
for (int snapLoopIndex=0; snapLoopIndex==0; snapLoopIndex+=0)
{
if (i<9)
{
float2 param=baseTexGetDims2D(userUniformsObj);
int param_1=baseTexLayout;
int param_2=baseTexGetStereoViewIndex(in.varStereoViewID);
float2 param_3=varTex[i];
bool param_4=(int(SC_USE_UV_TRANSFORM_baseTex)!=0);
float3x3 param_5=userUniformsObj.baseTexTransform;
int2 param_6=_2173;
bool param_7=(int(SC_USE_UV_MIN_MAX_baseTex)!=0);
float4 param_8=userUniformsObj.baseTexUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_baseTex)!=0);
float4 param_10=userUniformsObj.baseTexBorderColor;
float param_11=0.0;
float4 _2199=sc_SampleTextureBiasOrLevel(baseTex,baseTexSmpSC,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
float4 _2163=_2199;
float3 colori=_2199.xyz;
float3 param_12=colori;
float lumai=luma(param_12);
float flag=step(0.9,lumai);
countColorsBreachedTreshold+=flag;
overallColors=float(i);
i++;
continue;
}
else
{
break;
}
}
float4 param_13=float4(countColorsBreachedTreshold/overallColors,0.0,0.0,1.0);
sc_writeFragData0(param_13,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
