#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include "std2.metal"
#include "std2_vs.metal"
#include "std2_fs.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN(100)
//ubo float UserUniforms 0:35568:128 {
//float4 baseTexSize 0
//float4 baseTexDims 16
//float4 baseTexView 32
//float3x3 baseTexTransform 48
//float4 baseTexUvMinMax 96
//float4 baseTexBorderColor 112
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 baseTexSize;
float4 baseTexDims;
float4 baseTexView;
float3x3 baseTexTransform;
float4 baseTexUvMinMax;
float4 baseTexBorderColor;
};

#ifndef baseTexHasSwappedViews
#define baseTexHasSwappedViews 0
#elif baseTexHasSwappedViews==1
#undef baseTexHasSwappedViews
#define baseTexHasSwappedViews 1
#endif
#ifndef baseTexLayout
#define baseTexLayout 0
#endif
#ifndef baseTexUV
#define baseTexUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_baseTex
#define SC_USE_UV_TRANSFORM_baseTex 0
#elif SC_USE_UV_TRANSFORM_baseTex==1
#undef SC_USE_UV_TRANSFORM_baseTex
#define SC_USE_UV_TRANSFORM_baseTex 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_baseTex
#define SC_SOFTWARE_WRAP_MODE_U_baseTex -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_baseTex
#define SC_SOFTWARE_WRAP_MODE_V_baseTex -1
#endif
#ifndef SC_USE_UV_MIN_MAX_baseTex
#define SC_USE_UV_MIN_MAX_baseTex 0
#elif SC_USE_UV_MIN_MAX_baseTex==1
#undef SC_USE_UV_MIN_MAX_baseTex
#define SC_USE_UV_MIN_MAX_baseTex 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_baseTex
#define SC_USE_CLAMP_TO_BORDER_baseTex 0
#elif SC_USE_CLAMP_TO_BORDER_baseTex==1
#undef SC_USE_CLAMP_TO_BORDER_baseTex
#define SC_USE_CLAMP_TO_BORDER_baseTex 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant UserUniforms& userUniformsObj,constant LibraryUniforms& libraryUniformsObj,uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
v.position=float4((v.texture0*2.0)-float2(1.0),0.0,1.0);
float2 _3334=float2((userUniformsObj.baseTexTransform*float3(v.texture0,1.0)).xy);
out.varPackedTex=float4(out.varPackedTex.x,out.varPackedTex.y,_3334.x,_3334.y);
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN(100)
//sampler sampler baseTexSmpSC 0:43599
//texture texture2D baseTex 0:54554:0:43599
//ubo float UserUniforms 0:35568:128 {
//float4 baseTexSize 0
//float4 baseTexDims 16
//float4 baseTexView 32
//float3x3 baseTexTransform 48
//float4 baseTexUvMinMax 96
//float4 baseTexBorderColor 112
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 baseTexSize;
float4 baseTexDims;
float4 baseTexView;
float3x3 baseTexTransform;
float4 baseTexUvMinMax;
float4 baseTexBorderColor;
};

#ifndef baseTexHasSwappedViews
#define baseTexHasSwappedViews 0
#elif baseTexHasSwappedViews==1
#undef baseTexHasSwappedViews
#define baseTexHasSwappedViews 1
#endif
#ifndef baseTexLayout
#define baseTexLayout 0
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_baseTex
#define SC_SOFTWARE_WRAP_MODE_U_baseTex -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_baseTex
#define SC_SOFTWARE_WRAP_MODE_V_baseTex -1
#endif
constant int2 _3165=int2(SC_SOFTWARE_WRAP_MODE_U_baseTex,SC_SOFTWARE_WRAP_MODE_V_baseTex);
#ifndef SC_USE_UV_MIN_MAX_baseTex
#define SC_USE_UV_MIN_MAX_baseTex 0
#elif SC_USE_UV_MIN_MAX_baseTex==1
#undef SC_USE_UV_MIN_MAX_baseTex
#define SC_USE_UV_MIN_MAX_baseTex 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_baseTex
#define SC_USE_CLAMP_TO_BORDER_baseTex 0
#elif SC_USE_CLAMP_TO_BORDER_baseTex==1
#undef SC_USE_CLAMP_TO_BORDER_baseTex
#define SC_USE_CLAMP_TO_BORDER_baseTex 1
#endif
#ifndef baseTexUV
#define baseTexUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_baseTex
#define SC_USE_UV_TRANSFORM_baseTex 0
#elif SC_USE_UV_TRANSFORM_baseTex==1
#undef SC_USE_UV_TRANSFORM_baseTex
#define SC_USE_UV_TRANSFORM_baseTex 1
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float4 varPackedTex [[user(locn6)]];
};

float2 stretchCoordToOne(thread float2& uv,thread const float2& origTexturePxSize,thread const float& lod)
{
float2 a=uv-float2(0.5);
float2 b=origTexturePxSize*exp2(lod);
uv=(float2(0.5)+a)+((sign(a)*b)*0.5);
return uv;
}

float3 calcDirFromPanoramicTexCoords(thread const float2& uv)
{
float a=6.28319*uv.x;
float b=3.14159*uv.y;
float x=sin(a)*sin(b);
float y=cos(b);
float z=cos(a)*sin(b);
return float3(z,y,x);
}

float random(thread const float2& st)
{
return fract(sin(dot(st,float2(12.9898,78.233)))*43758.5);
}

float _atan2(thread const float& x,thread const float& y)
{
float signx=(x<0.0) ? (-1.0) : 1.0;
return signx*acos(fast::clamp(y/length(float2(x,y)),-1.0,1.0));
}

float2 calcPanoramicTexCoordsFromDir(thread const float3& reflDir)
{
float3 R=normalize(reflDir);
float param=R.x;
float param_1=-R.z;
float2 uv;
uv.x=_atan2(param,param_1)-1.5708;
uv.y=acos(R.y);
uv/=float2(6.28319,3.14159);
return uv;
}

float2 baseTexGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.baseTexDims.xy;
}

int baseTexGetStereoViewIndex(thread int& varStereoViewID)
{
#if (baseTexHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float3 decodeRGBD(thread const float4& rgbd)
{
return rgbd.xyz*(1.0/rgbd.w);
}

float4 encodeRGBD(thread const float3& rgb)
{
float maxRGB=fast::max(1.0,fast::max(rgb.x,fast::max(rgb.y,rgb.z)));
float D=1.0/maxRGB;
return float4(rgb*D,D);
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj,texture2d<float> baseTex,sampler baseTexSmpSC,float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float2 param=in.varPackedTex.zw;
float2 param_1=userUniformsObj.baseTexSize.zw;
float param_2=0.0;
float2 _2974=stretchCoordToOne(param,param_1,param_2);
float2 uv=_2974;
float2 param_3=uv;
float3 vecNormal=calcDirFromPanoramicTexCoords(param_3);
vecNormal=normalize(vecNormal);
float2 pixelUpwardsShift=float2(0.0,1.0/userUniformsObj.baseTexSize.y);
float2 texCoord=uv;
float2 upShiftTexCoord=texCoord+pixelUpwardsShift;
float2 downShiftTexCoord=texCoord-pixelUpwardsShift;
float _2998=upShiftTexCoord.y;
bool _2999=_2998>0.0;
bool _3005;
if (_2999)
{
_3005=upShiftTexCoord.y<1.0;
}
else
{
_3005=_2999;
}
bool2 _3009=bool2(_3005);
float2 shiftedCoordToUse=float2(_3009.x ? upShiftTexCoord.x : downShiftTexCoord.x,_3009.y ? upShiftTexCoord.y : downShiftTexCoord.y);
float2 param_4=shiftedCoordToUse;
float3 vecShifted=calcDirFromPanoramicTexCoords(param_4);
vecShifted=normalize(vecShifted);
float shiftAngle=3.14159/userUniformsObj.baseTexSize.y;
float normLength=cos(shiftAngle);
float shiftLength=sin(shiftAngle);
float3 upShiftVec=vecShifted-(vecNormal*normLength);
float3 TangentY=normalize(upShiftVec);
float3 TangentX=normalize(cross(vecNormal,TangentY));
float3 TangentZ=vecNormal;
upShiftVec=vecNormal+((TangentY*shiftLength)*(-1.0));
float3 shiftY=TangentY*shiftLength;
float3 shiftX=TangentX*shiftLength;
float coeff=0.707107;
float2 param_5=uv;
float rand=random(param_5);
float3 start=vecNormal+mix(shiftX*0.1,shiftY*0.1,float3(rand));
float3 shiftedVectors[9];
shiftedVectors[0]=start;
shiftedVectors[1]=start+shiftX;
shiftedVectors[2]=start+shiftY;
shiftedVectors[3]=start-shiftX;
shiftedVectors[4]=start-shiftY;
shiftedVectors[5]=(start+(shiftY*coeff))+(shiftX*coeff);
shiftedVectors[6]=(start-(shiftY*coeff))-(shiftX*coeff);
shiftedVectors[7]=(start+(shiftY*coeff))-(shiftX*coeff);
shiftedVectors[8]=(start-(shiftY*coeff))+(shiftX*coeff);
float3 accumColor=float3(0.0);
int i=0;
for (int snapLoopIndex=0; snapLoopIndex==0; snapLoopIndex+=0)
{
if (i<9)
{
float3 param_6=shiftedVectors[i];
float2 shiftedCoord=calcPanoramicTexCoordsFromDir(param_6);
float2 param_7=baseTexGetDims2D(userUniformsObj);
int param_8=baseTexLayout;
int param_9=baseTexGetStereoViewIndex(in.varStereoViewID);
float2 param_10=shiftedCoord;
bool param_11=false;
float3x3 param_12=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_13=_3165;
bool param_14=(int(SC_USE_UV_MIN_MAX_baseTex)!=0);
float4 param_15=userUniformsObj.baseTexUvMinMax;
bool param_16=(int(SC_USE_CLAMP_TO_BORDER_baseTex)!=0);
float4 param_17=userUniformsObj.baseTexBorderColor;
float param_18=0.0;
float4 _3185=sc_SampleTextureBiasOrLevel(baseTex,baseTexSmpSC,param_7,param_8,param_9,param_10,param_11,param_12,param_13,param_14,param_15,param_16,param_17,param_18);
float4 _3157=_3185;
float4 baseTexSample=_3185;
float4 param_19=baseTexSample;
accumColor+=decodeRGBD(param_19);
i++;
continue;
}
else
{
break;
}
}
float3 param_20=accumColor/float3(9.0);
float4 finColor=encodeRGBD(param_20);
float4 param_21=finColor;
sc_writeFragData0(param_21,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
