#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include "std2.metal"
#include "std2_fs.metal"
#include "std2_vs.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN(100)
//ubo float UserUniforms 0:35568:424 {
//float4x4 script_modelMatrix 0
//float4x4 script_viewProjectionMatrix 64
//float3 uniSphereCenter 128
//float3 uniCameraPos 144
//float4 baseTexSize 160
//float4 baseTexDims 176
//float4 baseTexView 192
//float3x3 baseTexTransform 208
//float4 baseTexUvMinMax 256
//float4 baseTexBorderColor 272
//float4 prevTexSize 288
//float4 prevTexDims 304
//float4 prevTexView 320
//float3x3 prevTexTransform 336
//float4 prevTexUvMinMax 384
//float4 prevTexBorderColor 400
//float stopCapture 416
//float blendInFactor 420
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4x4 script_modelMatrix;
float4x4 script_viewProjectionMatrix;
float3 uniSphereCenter;
float3 uniCameraPos;
float4 baseTexSize;
float4 baseTexDims;
float4 baseTexView;
float3x3 baseTexTransform;
float4 baseTexUvMinMax;
float4 baseTexBorderColor;
float4 prevTexSize;
float4 prevTexDims;
float4 prevTexView;
float3x3 prevTexTransform;
float4 prevTexUvMinMax;
float4 prevTexBorderColor;
float stopCapture;
float blendInFactor;
};

#ifndef baseTexHasSwappedViews
#define baseTexHasSwappedViews 0
#elif baseTexHasSwappedViews==1
#undef baseTexHasSwappedViews
#define baseTexHasSwappedViews 1
#endif
#ifndef baseTexLayout
#define baseTexLayout 0
#endif
#ifndef prevTexHasSwappedViews
#define prevTexHasSwappedViews 0
#elif prevTexHasSwappedViews==1
#undef prevTexHasSwappedViews
#define prevTexHasSwappedViews 1
#endif
#ifndef prevTexLayout
#define prevTexLayout 0
#endif
#ifndef baseTexUV
#define baseTexUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_baseTex
#define SC_USE_UV_TRANSFORM_baseTex 0
#elif SC_USE_UV_TRANSFORM_baseTex==1
#undef SC_USE_UV_TRANSFORM_baseTex
#define SC_USE_UV_TRANSFORM_baseTex 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_baseTex
#define SC_SOFTWARE_WRAP_MODE_U_baseTex -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_baseTex
#define SC_SOFTWARE_WRAP_MODE_V_baseTex -1
#endif
#ifndef SC_USE_UV_MIN_MAX_baseTex
#define SC_USE_UV_MIN_MAX_baseTex 0
#elif SC_USE_UV_MIN_MAX_baseTex==1
#undef SC_USE_UV_MIN_MAX_baseTex
#define SC_USE_UV_MIN_MAX_baseTex 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_baseTex
#define SC_USE_CLAMP_TO_BORDER_baseTex 0
#elif SC_USE_CLAMP_TO_BORDER_baseTex==1
#undef SC_USE_CLAMP_TO_BORDER_baseTex
#define SC_USE_CLAMP_TO_BORDER_baseTex 1
#endif
#ifndef prevTexUV
#define prevTexUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_prevTex
#define SC_USE_UV_TRANSFORM_prevTex 0
#elif SC_USE_UV_TRANSFORM_prevTex==1
#undef SC_USE_UV_TRANSFORM_prevTex
#define SC_USE_UV_TRANSFORM_prevTex 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_prevTex
#define SC_SOFTWARE_WRAP_MODE_U_prevTex -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_prevTex
#define SC_SOFTWARE_WRAP_MODE_V_prevTex -1
#endif
#ifndef SC_USE_UV_MIN_MAX_prevTex
#define SC_USE_UV_MIN_MAX_prevTex 0
#elif SC_USE_UV_MIN_MAX_prevTex==1
#undef SC_USE_UV_MIN_MAX_prevTex
#define SC_USE_UV_MIN_MAX_prevTex 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_prevTex
#define SC_USE_CLAMP_TO_BORDER_prevTex 0
#elif SC_USE_CLAMP_TO_BORDER_prevTex==1
#undef SC_USE_CLAMP_TO_BORDER_prevTex
#define SC_USE_CLAMP_TO_BORDER_prevTex 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float3 varCustomPos [[user(locn10)]];
float3 varCustomNormal [[user(locn11)]];
float2 varCustomTex0 [[user(locn12)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant UserUniforms& userUniformsObj,constant LibraryUniforms& libraryUniformsObj,uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
float4x4 rotationMatrix=float4x4(float4(1.0,0.0,0.0,0.0),float4(0.0,1.0,0.0,0.0),float4(0.0,0.0,1.0,0.0),float4(0.0,0.0,0.0,1.0));
rotationMatrix[0]=float4(0.0,0.0,1.0,0.0);
rotationMatrix[1]=float4(0.0,-1.0,0.0,0.0);
rotationMatrix[2]=float4(-1.0,0.0,0.0,0.0);
float4 newPosition=rotationMatrix*v.position;
float4x4 scaleMatrix=float4x4(float4(12.0,0.0,0.0,0.0),float4(0.0,12.0,0.0,0.0),float4(0.0,0.0,12.0,0.0),float4(0.0,0.0,0.0,12.0));
scaleMatrix[3].w=1.0;
newPosition=scaleMatrix*newPosition;
out.varCustomPos=(userUniformsObj.script_modelMatrix*newPosition).xyz;
float3 normal=normalize(in.position.xyz);
out.varCustomNormal=normalize(((userUniformsObj.script_modelMatrix*rotationMatrix)*float4(normal,0.0)).xyz);
float2 modifiedTexCoords=v.texture0*1.002;
out.varCustomTex0=float2((userUniformsObj.prevTexTransform*float3(modifiedTexCoords,1.0)).xy);
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
out.gl_Position=float4((modifiedTexCoords*2.0)-float2(1.0),0.0,1.0);
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN(100)
//sampler sampler baseTexSmpSC 0:43599
//sampler sampler prevTexSmpSC 0:54652
//texture texture2D baseTex 0:54554:0:43599
//texture texture2D prevTex 0:53912:0:54652
//ubo float UserUniforms 0:35568:424 {
//float4x4 script_modelMatrix 0
//float4x4 script_viewProjectionMatrix 64
//float3 uniSphereCenter 128
//float3 uniCameraPos 144
//float4 baseTexSize 160
//float4 baseTexDims 176
//float4 baseTexView 192
//float3x3 baseTexTransform 208
//float4 baseTexUvMinMax 256
//float4 baseTexBorderColor 272
//float4 prevTexSize 288
//float4 prevTexDims 304
//float4 prevTexView 320
//float3x3 prevTexTransform 336
//float4 prevTexUvMinMax 384
//float4 prevTexBorderColor 400
//float stopCapture 416
//float blendInFactor 420
//}
//SG_REFLECTION_END

struct twoPoints
{
float3 p1;
float3 p2;
};


struct UserUniforms
{
float4x4 script_modelMatrix;
float4x4 script_viewProjectionMatrix;
float3 uniSphereCenter;
float3 uniCameraPos;
float4 baseTexSize;
float4 baseTexDims;
float4 baseTexView;
float3x3 baseTexTransform;
float4 baseTexUvMinMax;
float4 baseTexBorderColor;
float4 prevTexSize;
float4 prevTexDims;
float4 prevTexView;
float3x3 prevTexTransform;
float4 prevTexUvMinMax;
float4 prevTexBorderColor;
float stopCapture;
float blendInFactor;
};

#ifndef baseTexHasSwappedViews
#define baseTexHasSwappedViews 0
#elif baseTexHasSwappedViews==1
#undef baseTexHasSwappedViews
#define baseTexHasSwappedViews 1
#endif
#ifndef baseTexLayout
#define baseTexLayout 0
#endif
#ifndef prevTexHasSwappedViews
#define prevTexHasSwappedViews 0
#elif prevTexHasSwappedViews==1
#undef prevTexHasSwappedViews
#define prevTexHasSwappedViews 1
#endif
#ifndef prevTexLayout
#define prevTexLayout 0
#endif
#ifndef SC_USE_UV_TRANSFORM_baseTex
#define SC_USE_UV_TRANSFORM_baseTex 0
#elif SC_USE_UV_TRANSFORM_baseTex==1
#undef SC_USE_UV_TRANSFORM_baseTex
#define SC_USE_UV_TRANSFORM_baseTex 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_baseTex
#define SC_SOFTWARE_WRAP_MODE_U_baseTex -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_baseTex
#define SC_SOFTWARE_WRAP_MODE_V_baseTex -1
#endif
constant int2 _3333=int2(SC_SOFTWARE_WRAP_MODE_U_baseTex,SC_SOFTWARE_WRAP_MODE_V_baseTex);
#ifndef SC_USE_UV_MIN_MAX_baseTex
#define SC_USE_UV_MIN_MAX_baseTex 0
#elif SC_USE_UV_MIN_MAX_baseTex==1
#undef SC_USE_UV_MIN_MAX_baseTex
#define SC_USE_UV_MIN_MAX_baseTex 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_baseTex
#define SC_USE_CLAMP_TO_BORDER_baseTex 0
#elif SC_USE_CLAMP_TO_BORDER_baseTex==1
#undef SC_USE_CLAMP_TO_BORDER_baseTex
#define SC_USE_CLAMP_TO_BORDER_baseTex 1
#endif
constant int2 _3412=int2(SC_SOFTWARE_WRAP_MODE_U_baseTex,SC_SOFTWARE_WRAP_MODE_V_baseTex);
#ifndef SC_USE_UV_TRANSFORM_prevTex
#define SC_USE_UV_TRANSFORM_prevTex 0
#elif SC_USE_UV_TRANSFORM_prevTex==1
#undef SC_USE_UV_TRANSFORM_prevTex
#define SC_USE_UV_TRANSFORM_prevTex 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_prevTex
#define SC_SOFTWARE_WRAP_MODE_U_prevTex -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_prevTex
#define SC_SOFTWARE_WRAP_MODE_V_prevTex -1
#endif
constant int2 _3454=int2(SC_SOFTWARE_WRAP_MODE_U_prevTex,SC_SOFTWARE_WRAP_MODE_V_prevTex);
#ifndef SC_USE_UV_MIN_MAX_prevTex
#define SC_USE_UV_MIN_MAX_prevTex 0
#elif SC_USE_UV_MIN_MAX_prevTex==1
#undef SC_USE_UV_MIN_MAX_prevTex
#define SC_USE_UV_MIN_MAX_prevTex 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_prevTex
#define SC_USE_CLAMP_TO_BORDER_prevTex 0
#elif SC_USE_CLAMP_TO_BORDER_prevTex==1
#undef SC_USE_CLAMP_TO_BORDER_prevTex
#define SC_USE_CLAMP_TO_BORDER_prevTex 1
#endif
#ifndef baseTexUV
#define baseTexUV 0
#endif
#ifndef prevTexUV
#define prevTexUV 0
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float3 varCustomPos [[user(locn10)]];
float3 varCustomNormal [[user(locn11)]];
float2 varCustomTex0 [[user(locn12)]];
};

float ensureIsNotZero(thread const float& num)
{
float add0=1.0-fast::max(abs(sign(num)),0.999);
return num+add0;
}

void getLineSphereIntersection(thread const float3& p1,thread const float3& p2,thread const float3& shpereCenter,thread const float& sphereRadius,thread twoPoints& intersections)
{
float3 d=p2-p1;
float a=dot(d,d);
float b=2.0*dot(d,p1-shpereCenter);
float c=((dot(shpereCenter,shpereCenter)+dot(p1,p1))-(2.0*dot(shpereCenter,p1)))-(sphereRadius*sphereRadius);
float disc=(b*b)-((4.0*a)*c);
float sqrtdisc=sqrt(disc);
float param=2.0*a;
float divisor=ensureIsNotZero(param);
float u=((-b)-sqrtdisc)/divisor;
intersections.p1=p1+((p2-p1)*u);
u=((-b)+sqrtdisc)/divisor;
intersections.p2=p1+((p2-p1)*u);
}

float2 baseTexGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.baseTexDims.xy;
}

int baseTexGetStereoViewIndex(thread int& varStereoViewID)
{
#if (baseTexHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 calculateEnvmapScreenToCube(thread float3& V)
{
V.y=-V.y;
V.z=abs(V.z);
float3 vAbs=abs(V);
float _2184=vAbs.z;
float _2186=vAbs.x;
bool _2187=_2184>=_2186;
bool _2195;
if (_2187)
{
_2195=vAbs.z>=vAbs.y;
}
else
{
_2195=_2187;
}
float2 uv;
if (_2195)
{
float ma=0.5/vAbs.z;
uv=float2(V.x,V.y)*ma;
uv=(uv*0.5)+float2(0.5);
}
else
{
if (vAbs.y>=vAbs.x)
{
float ma_1=0.5/vAbs.y;
uv=float2(V.x,-V.z)*ma_1;
uv.x*=mix(0.5,1.0,1.0-(abs(uv.y)*2.0));
uv.x+=0.5;
uv.y*=0.5;
uv.y=abs(uv.y);
if (V.y>0.0)
{
uv.y=1.0-uv.y;
}
}
else
{
float ma_2=0.5/vAbs.x;
float _2272;
if (V.x<0.0)
{
_2272=V.z;
}
else
{
_2272=-V.z;
}
uv=float2(_2272,V.y)*ma_2;
uv.y*=mix(0.5,1.0,1.0-(abs(uv.x)*2.0));
uv.y+=0.5;
uv.x*=0.5;
uv.x=abs(uv.x);
if (V.x>0.0)
{
uv.x=1.0-uv.x;
}
}
}
return uv;
}

float2 prevTexGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.prevTexDims.xy;
}

int prevTexGetStereoViewIndex(thread int& varStereoViewID)
{
#if (prevTexHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj,texture2d<float> prevTex,texture2d<float> baseTex,sampler baseTexSmpSC,sampler prevTexSmpSC,float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float3 captureDirection=in.varCustomNormal;
float groundPointY=0.0;
float param=captureDirection.y;
float nCoeffToReachGround=(in.varCustomPos.y-groundPointY)/ensureIsNotZero(param);
float3 nGroundIntersection=in.varCustomPos+((captureDirection*nCoeffToReachGround)*(-1.0));
float groundIntersectionFlag1=step(nCoeffToReachGround,0.0);
nGroundIntersection=mix(float3(0.0,0.0,10000.0),nGroundIntersection,float3(groundIntersectionFlag1));
float sphereRadius=fast::max(length(userUniformsObj.uniCameraPos-userUniformsObj.uniSphereCenter),100.0);
float3 param_1=in.varCustomPos;
float3 param_2=in.varCustomPos+captureDirection;
float3 param_3=userUniformsObj.uniSphereCenter;
float param_4=sphereRadius;
twoPoints sphereIntersections;
twoPoints param_5=sphereIntersections;
getLineSphereIntersection(param_1,param_2,param_3,param_4,param_5);
sphereIntersections=param_5;
float3 stepIntersection=step(float3(0.0),(sphereIntersections.p1-in.varCustomPos)/captureDirection);
float mixIntersections=fast::min(stepIntersection.x,stepIntersection.y);
mixIntersections=fast::min(mixIntersections,stepIntersection.z);
float3 sphereIntersectionPoint=mix(sphereIntersections.p2,sphereIntersections.p1,float3(mixIntersections));
float maxNCoeffToReachGround=(-1.0)*sphereRadius;
float groundIntersectionFlag2=step(maxNCoeffToReachGround,nCoeffToReachGround);
float groundIntersectionCommonFlag=groundIntersectionFlag1*groundIntersectionFlag2;
float3 virtualSetupIntersectionPoint=mix(sphereIntersectionPoint,nGroundIntersection,float3(groundIntersectionCommonFlag));
float4 screenPosition=userUniformsObj.script_viewProjectionMatrix*float4(virtualSetupIntersectionPoint,1.0);
float isInsideNDC=step(abs(screenPosition.z/screenPosition.w),1.0);
float param_6=screenPosition.w;
float2 texCoord=((screenPosition.xy/float2(ensureIsNotZero(param_6)))*0.5)+float2(0.5);
texCoord=float2((userUniformsObj.baseTexTransform*float3(texCoord,1.0)).xy);
float4 finColor=float4(0.0);
float2 param_7=baseTexGetDims2D(userUniformsObj);
int param_8=baseTexLayout;
int param_9=baseTexGetStereoViewIndex(in.varStereoViewID);
float2 param_10=texCoord;
bool param_11=(int(SC_USE_UV_TRANSFORM_baseTex)!=0);
float3x3 param_12=userUniformsObj.baseTexTransform;
int2 param_13=_3333;
bool param_14=(int(SC_USE_UV_MIN_MAX_baseTex)!=0);
float4 param_15=userUniformsObj.baseTexUvMinMax;
bool param_16=(int(SC_USE_CLAMP_TO_BORDER_baseTex)!=0);
float4 param_17=userUniformsObj.baseTexBorderColor;
float param_18=0.0;
float4 _3357=sc_SampleTextureBiasOrLevel(baseTex,baseTexSmpSC,param_7,param_8,param_9,param_10,param_11,param_12,param_13,param_14,param_15,param_16,param_17,param_18);
float4 _3327=_3357;
float4 baseTexSample=_3357;
finColor=baseTexSample;
texCoord=abs(fast::clamp(texCoord,float2(0.0),float2(1.0))-float2(0.5));
float alphaVal0=fast::max(texCoord.x,texCoord.y)*2.0;
alphaVal0=1.0-(alphaVal0*alphaVal0);
alphaVal0*=userUniformsObj.blendInFactor;
finColor.w=alphaVal0*isInsideNDC;
float4 cameraCubeColor=float4(0.0);
float3 param_19=-in.varCustomNormal;
float2 _3391=calculateEnvmapScreenToCube(param_19);
float2 cubeCoord=_3391;
cubeCoord=float2((userUniformsObj.baseTexTransform*float3(cubeCoord,1.0)).xy);
cubeCoord=fast::clamp(cubeCoord,float2(0.002),float2(0.998));
float2 param_20=baseTexGetDims2D(userUniformsObj);
int param_21=baseTexLayout;
int param_22=baseTexGetStereoViewIndex(in.varStereoViewID);
float2 param_23=cubeCoord;
bool param_24=(int(SC_USE_UV_TRANSFORM_baseTex)!=0);
float3x3 param_25=userUniformsObj.baseTexTransform;
int2 param_26=_3412;
bool param_27=(int(SC_USE_UV_MIN_MAX_baseTex)!=0);
float4 param_28=userUniformsObj.baseTexUvMinMax;
bool param_29=(int(SC_USE_CLAMP_TO_BORDER_baseTex)!=0);
float4 param_30=userUniformsObj.baseTexBorderColor;
float param_31=0.0;
float4 _3432=sc_SampleTextureBiasOrLevel(baseTex,baseTexSmpSC,param_20,param_21,param_22,param_23,param_24,param_25,param_26,param_27,param_28,param_29,param_30,param_31);
float4 _3409=_3432;
float4 baseTexSample_1=_3432;
cameraCubeColor=baseTexSample_1;
cameraCubeColor.w=1.0;
finColor=mix(cameraCubeColor,finColor,float4(userUniformsObj.stopCapture));
alphaVal0=finColor.w;
float4 prevColor=float4(0.0);
float2 param_32=prevTexGetDims2D(userUniformsObj);
int param_33=prevTexLayout;
int param_34=prevTexGetStereoViewIndex(in.varStereoViewID);
float2 param_35=in.varCustomTex0;
bool param_36=(int(SC_USE_UV_TRANSFORM_prevTex)!=0);
float3x3 param_37=userUniformsObj.prevTexTransform;
int2 param_38=_3454;
bool param_39=(int(SC_USE_UV_MIN_MAX_prevTex)!=0);
float4 param_40=userUniformsObj.prevTexUvMinMax;
bool param_41=(int(SC_USE_CLAMP_TO_BORDER_prevTex)!=0);
float4 param_42=userUniformsObj.prevTexBorderColor;
float param_43=0.0;
float4 _3478=sc_SampleTextureBiasOrLevel(prevTex,prevTexSmpSC,param_32,param_33,param_34,param_35,param_36,param_37,param_38,param_39,param_40,param_41,param_42,param_43);
float4 _3446=_3478;
float4 prevTexSample=_3478;
prevColor=prevTexSample;
finColor=mix(prevColor,finColor,float4(alphaVal0));
float4 param_44=finColor;
sc_writeFragData0(param_44,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
