#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE0 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include "std2_vs.metal"
#include "std2_fs.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN(100)
//ubo float UserUniforms 0:35568:136 {
//float4 texMainSize 0
//float4 texMainDims 16
//float4 texMainView 32
//float3x3 texMainTransform 48
//float4 texMainUvMinMax 96
//float4 texMainBorderColor 112
//float2 blurVector 128
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 texMainSize;
float4 texMainDims;
float4 texMainView;
float3x3 texMainTransform;
float4 texMainUvMinMax;
float4 texMainBorderColor;
float2 blurVector;
};

#ifndef texMainHasSwappedViews
#define texMainHasSwappedViews 0
#elif texMainHasSwappedViews==1
#undef texMainHasSwappedViews
#define texMainHasSwappedViews 1
#endif
#ifndef texMainLayout
#define texMainLayout 0
#endif
#ifndef texMainUV
#define texMainUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_texMain
#define SC_USE_UV_TRANSFORM_texMain 0
#elif SC_USE_UV_TRANSFORM_texMain==1
#undef SC_USE_UV_TRANSFORM_texMain
#define SC_USE_UV_TRANSFORM_texMain 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_texMain
#define SC_SOFTWARE_WRAP_MODE_U_texMain -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_texMain
#define SC_SOFTWARE_WRAP_MODE_V_texMain -1
#endif
#ifndef SC_USE_UV_MIN_MAX_texMain
#define SC_USE_UV_MIN_MAX_texMain 0
#elif SC_USE_UV_MIN_MAX_texMain==1
#undef SC_USE_UV_MIN_MAX_texMain
#define SC_USE_UV_MIN_MAX_texMain 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_texMain
#define SC_USE_CLAMP_TO_BORDER_texMain 0
#elif SC_USE_CLAMP_TO_BORDER_texMain==1
#undef SC_USE_CLAMP_TO_BORDER_texMain
#define SC_USE_CLAMP_TO_BORDER_texMain 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float2 blurCoordinates_0 [[user(locn10)]];
float2 blurCoordinates_1 [[user(locn11)]];
float2 blurCoordinates_2 [[user(locn12)]];
float2 blurCoordinates_3 [[user(locn13)]];
float2 blurCoordinates_4 [[user(locn14)]];
float2 blurCoordinates_5 [[user(locn15)]];
float2 blurCoordinates_6 [[user(locn16)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant UserUniforms& userUniformsObj,constant LibraryUniforms& libraryUniformsObj,uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
float2 blurCoordinates[7]={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
float2 coordsTex=(v.position.xy*0.5)+float2(0.5);
float2 blurStep=userUniformsObj.texMainSize.zw*userUniformsObj.blurVector;
blurCoordinates[0]=coordsTex;
blurCoordinates[1]=coordsTex+(blurStep*1.45843);
blurCoordinates[2]=coordsTex-(blurStep*1.45843);
blurCoordinates[3]=coordsTex+(blurStep*3.40399);
blurCoordinates[4]=coordsTex-(blurStep*3.40399);
blurCoordinates[5]=coordsTex+(blurStep*5.35181);
blurCoordinates[6]=coordsTex-(blurStep*5.35181);
out.blurCoordinates_0=blurCoordinates[0];
out.blurCoordinates_1=blurCoordinates[1];
out.blurCoordinates_2=blurCoordinates[2];
out.blurCoordinates_3=blurCoordinates[3];
out.blurCoordinates_4=blurCoordinates[4];
out.blurCoordinates_5=blurCoordinates[5];
out.blurCoordinates_6=blurCoordinates[6];
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN(100)
//sampler sampler texMainSmpSC 0:44918
//texture texture2D texMain 0:54310:0:44918
//ubo float UserUniforms 0:35568:136 {
//float4 texMainSize 0
//float4 texMainDims 16
//float4 texMainView 32
//float3x3 texMainTransform 48
//float4 texMainUvMinMax 96
//float4 texMainBorderColor 112
//float2 blurVector 128
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 texMainSize;
float4 texMainDims;
float4 texMainView;
float3x3 texMainTransform;
float4 texMainUvMinMax;
float4 texMainBorderColor;
float2 blurVector;
};

#ifndef texMainHasSwappedViews
#define texMainHasSwappedViews 0
#elif texMainHasSwappedViews==1
#undef texMainHasSwappedViews
#define texMainHasSwappedViews 1
#endif
#ifndef texMainLayout
#define texMainLayout 0
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_texMain
#define SC_SOFTWARE_WRAP_MODE_U_texMain -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_texMain
#define SC_SOFTWARE_WRAP_MODE_V_texMain -1
#endif
constant int2 _2153=int2(SC_SOFTWARE_WRAP_MODE_U_texMain,SC_SOFTWARE_WRAP_MODE_V_texMain);
#ifndef SC_USE_UV_MIN_MAX_texMain
#define SC_USE_UV_MIN_MAX_texMain 0
#elif SC_USE_UV_MIN_MAX_texMain==1
#undef SC_USE_UV_MIN_MAX_texMain
#define SC_USE_UV_MIN_MAX_texMain 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_texMain
#define SC_USE_CLAMP_TO_BORDER_texMain 0
#elif SC_USE_CLAMP_TO_BORDER_texMain==1
#undef SC_USE_CLAMP_TO_BORDER_texMain
#define SC_USE_CLAMP_TO_BORDER_texMain 1
#endif
#ifndef texMainUV
#define texMainUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_texMain
#define SC_USE_UV_TRANSFORM_texMain 0
#elif SC_USE_UV_TRANSFORM_texMain==1
#undef SC_USE_UV_TRANSFORM_texMain
#define SC_USE_UV_TRANSFORM_texMain 1
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float2 blurCoordinates_0 [[user(locn10)]];
float2 blurCoordinates_1 [[user(locn11)]];
float2 blurCoordinates_2 [[user(locn12)]];
float2 blurCoordinates_3 [[user(locn13)]];
float2 blurCoordinates_4 [[user(locn14)]];
float2 blurCoordinates_5 [[user(locn15)]];
float2 blurCoordinates_6 [[user(locn16)]];
};

float2 texMainGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.texMainDims.xy;
}

int texMainGetStereoViewIndex(thread int& varStereoViewID)
{
#if (texMainHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float4 sampleMainTex(thread const float2& uv,thread int& varStereoViewID,constant UserUniforms& userUniformsObj,thread texture2d<float> texMain,thread sampler texMainSmpSC)
{
float2 param=texMainGetDims2D(userUniformsObj);
int param_1=texMainLayout;
int param_2=texMainGetStereoViewIndex(varStereoViewID);
float2 param_3=uv;
bool param_4=false;
float3x3 param_5=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_6=_2153;
bool param_7=(int(SC_USE_UV_MIN_MAX_texMain)!=0);
float4 param_8=userUniformsObj.texMainUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_texMain)!=0);
float4 param_10=userUniformsObj.texMainBorderColor;
float param_11=0.0;
float4 _2175=sc_SampleTextureBiasOrLevel(texMain,texMainSmpSC,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
float4 _2143=_2175;
float4 texMainSample=_2175;
return texMainSample;
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj,texture2d<float> texMain,sampler texMainSmpSC,float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float2 blurCoordinates[7]={};
blurCoordinates[0]=in.blurCoordinates_0;
blurCoordinates[1]=in.blurCoordinates_1;
blurCoordinates[2]=in.blurCoordinates_2;
blurCoordinates[3]=in.blurCoordinates_3;
blurCoordinates[4]=in.blurCoordinates_4;
blurCoordinates[5]=in.blurCoordinates_5;
blurCoordinates[6]=in.blurCoordinates_6;
float2 param=blurCoordinates[0];
float4 blurredColor=sampleMainTex(param,in.varStereoViewID,userUniformsObj,texMain,texMainSmpSC)*0.137023;
float2 param_1=blurCoordinates[1];
float2 param_2=blurCoordinates[2];
blurredColor+=((sampleMainTex(param_1,in.varStereoViewID,userUniformsObj,texMain,texMainSmpSC)+sampleMainTex(param_2,in.varStereoViewID,userUniformsObj,texMain,texMainSmpSC))*0.239337);
float2 param_3=blurCoordinates[3];
float2 param_4=blurCoordinates[4];
blurredColor+=((sampleMainTex(param_3,in.varStereoViewID,userUniformsObj,texMain,texMainSmpSC)+sampleMainTex(param_4,in.varStereoViewID,userUniformsObj,texMain,texMainSmpSC))*0.13944);
float2 param_5=blurCoordinates[5];
float2 param_6=blurCoordinates[6];
blurredColor+=((sampleMainTex(param_5,in.varStereoViewID,userUniformsObj,texMain,texMainSmpSC)+sampleMainTex(param_6,in.varStereoViewID,userUniformsObj,texMain,texMainSmpSC))*0.052711);
float4 param_7=blurredColor;
sc_writeFragData0(param_7,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
