#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE0 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include "std2.metal"
#include "std2_vs.metal"
#include "std2_fs.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN(100)
//SG_REFLECTION_END


struct UserUniforms
{
float4 texAbSize;
float4 texAbDims;
float4 texAbView;
float3x3 texAbTransform;
float4 texAbUvMinMax;
float4 texAbBorderColor;
float4 texMainSize;
float4 texMainDims;
float4 texMainView;
float3x3 texMainTransform;
float4 texMainUvMinMax;
float4 texMainBorderColor;
float epsilonSq;
float maskScaleMultiplier;
};

#ifndef texAbHasSwappedViews
#define texAbHasSwappedViews 0
#elif texAbHasSwappedViews==1
#undef texAbHasSwappedViews
#define texAbHasSwappedViews 1
#endif
#ifndef texAbLayout
#define texAbLayout 0
#endif
#ifndef texMainHasSwappedViews
#define texMainHasSwappedViews 0
#elif texMainHasSwappedViews==1
#undef texMainHasSwappedViews
#define texMainHasSwappedViews 1
#endif
#ifndef texMainLayout
#define texMainLayout 0
#endif
#ifndef MASK_PROCESSING_MULTIPLICATION
#define MASK_PROCESSING_MULTIPLICATION 0
#elif MASK_PROCESSING_MULTIPLICATION==1
#undef MASK_PROCESSING_MULTIPLICATION
#define MASK_PROCESSING_MULTIPLICATION 1
#endif
#ifndef MASK_PROCESSING_SMOOTH_STEP
#define MASK_PROCESSING_SMOOTH_STEP 0
#elif MASK_PROCESSING_SMOOTH_STEP==1
#undef MASK_PROCESSING_SMOOTH_STEP
#define MASK_PROCESSING_SMOOTH_STEP 1
#endif
#ifndef MASK_PROCESSING_SCALE
#define MASK_PROCESSING_SCALE 0
#elif MASK_PROCESSING_SCALE==1
#undef MASK_PROCESSING_SCALE
#define MASK_PROCESSING_SCALE 1
#endif
#ifndef texAbUV
#define texAbUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_texAb
#define SC_USE_UV_TRANSFORM_texAb 0
#elif SC_USE_UV_TRANSFORM_texAb==1
#undef SC_USE_UV_TRANSFORM_texAb
#define SC_USE_UV_TRANSFORM_texAb 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_texAb
#define SC_SOFTWARE_WRAP_MODE_U_texAb -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_texAb
#define SC_SOFTWARE_WRAP_MODE_V_texAb -1
#endif
#ifndef SC_USE_UV_MIN_MAX_texAb
#define SC_USE_UV_MIN_MAX_texAb 0
#elif SC_USE_UV_MIN_MAX_texAb==1
#undef SC_USE_UV_MIN_MAX_texAb
#define SC_USE_UV_MIN_MAX_texAb 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_texAb
#define SC_USE_CLAMP_TO_BORDER_texAb 0
#elif SC_USE_CLAMP_TO_BORDER_texAb==1
#undef SC_USE_CLAMP_TO_BORDER_texAb
#define SC_USE_CLAMP_TO_BORDER_texAb 1
#endif
#ifndef texMainUV
#define texMainUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_texMain
#define SC_USE_UV_TRANSFORM_texMain 0
#elif SC_USE_UV_TRANSFORM_texMain==1
#undef SC_USE_UV_TRANSFORM_texMain
#define SC_USE_UV_TRANSFORM_texMain 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_texMain
#define SC_SOFTWARE_WRAP_MODE_U_texMain -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_texMain
#define SC_SOFTWARE_WRAP_MODE_V_texMain -1
#endif
#ifndef SC_USE_UV_MIN_MAX_texMain
#define SC_USE_UV_MIN_MAX_texMain 0
#elif SC_USE_UV_MIN_MAX_texMain==1
#undef SC_USE_UV_MIN_MAX_texMain
#define SC_USE_UV_MIN_MAX_texMain 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_texMain
#define SC_USE_CLAMP_TO_BORDER_texMain 0
#elif SC_USE_CLAMP_TO_BORDER_texMain==1
#undef SC_USE_CLAMP_TO_BORDER_texMain
#define SC_USE_CLAMP_TO_BORDER_texMain 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant LibraryUniforms& libraryUniformsObj,uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
float2 texpos=(v.position.xy*0.5)+float2(0.5);
texpos.y=1.0-texpos.y;
out.varPackedTex=float4(texpos.x,texpos.y,out.varPackedTex.z,out.varPackedTex.w);
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN(100)
//sampler sampler texAbSmpSC 0:35653
//sampler sampler texMainSmpSC 0:44918
//texture texture2D texAb 0:50343:0:35653
//texture texture2D texMain 0:54310:0:44918
//ubo float UserUniforms 0:35568:264 {
//float4 texAbSize 0
//float4 texAbDims 16
//float4 texAbView 32
//float3x3 texAbTransform 48
//float4 texAbUvMinMax 96
//float4 texAbBorderColor 112
//float4 texMainSize 128
//float4 texMainDims 144
//float4 texMainView 160
//float3x3 texMainTransform 176
//float4 texMainUvMinMax 224
//float4 texMainBorderColor 240
//float epsilonSq 256
//float maskScaleMultiplier 260
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 texAbSize;
float4 texAbDims;
float4 texAbView;
float3x3 texAbTransform;
float4 texAbUvMinMax;
float4 texAbBorderColor;
float4 texMainSize;
float4 texMainDims;
float4 texMainView;
float3x3 texMainTransform;
float4 texMainUvMinMax;
float4 texMainBorderColor;
float epsilonSq;
float maskScaleMultiplier;
};

#ifndef texAbHasSwappedViews
#define texAbHasSwappedViews 0
#elif texAbHasSwappedViews==1
#undef texAbHasSwappedViews
#define texAbHasSwappedViews 1
#endif
#ifndef texAbLayout
#define texAbLayout 0
#endif
#ifndef texMainHasSwappedViews
#define texMainHasSwappedViews 0
#elif texMainHasSwappedViews==1
#undef texMainHasSwappedViews
#define texMainHasSwappedViews 1
#endif
#ifndef texMainLayout
#define texMainLayout 0
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_texAb
#define SC_SOFTWARE_WRAP_MODE_U_texAb -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_texAb
#define SC_SOFTWARE_WRAP_MODE_V_texAb -1
#endif
constant int2 _2306=int2(SC_SOFTWARE_WRAP_MODE_U_texAb,SC_SOFTWARE_WRAP_MODE_V_texAb);
#ifndef SC_USE_UV_MIN_MAX_texAb
#define SC_USE_UV_MIN_MAX_texAb 0
#elif SC_USE_UV_MIN_MAX_texAb==1
#undef SC_USE_UV_MIN_MAX_texAb
#define SC_USE_UV_MIN_MAX_texAb 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_texAb
#define SC_USE_CLAMP_TO_BORDER_texAb 0
#elif SC_USE_CLAMP_TO_BORDER_texAb==1
#undef SC_USE_CLAMP_TO_BORDER_texAb
#define SC_USE_CLAMP_TO_BORDER_texAb 1
#endif
#ifndef SC_USE_UV_TRANSFORM_texMain
#define SC_USE_UV_TRANSFORM_texMain 0
#elif SC_USE_UV_TRANSFORM_texMain==1
#undef SC_USE_UV_TRANSFORM_texMain
#define SC_USE_UV_TRANSFORM_texMain 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_texMain
#define SC_SOFTWARE_WRAP_MODE_U_texMain -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_texMain
#define SC_SOFTWARE_WRAP_MODE_V_texMain -1
#endif
constant int2 _2342=int2(SC_SOFTWARE_WRAP_MODE_U_texMain,SC_SOFTWARE_WRAP_MODE_V_texMain);
#ifndef SC_USE_UV_MIN_MAX_texMain
#define SC_USE_UV_MIN_MAX_texMain 0
#elif SC_USE_UV_MIN_MAX_texMain==1
#undef SC_USE_UV_MIN_MAX_texMain
#define SC_USE_UV_MIN_MAX_texMain 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_texMain
#define SC_USE_CLAMP_TO_BORDER_texMain 0
#elif SC_USE_CLAMP_TO_BORDER_texMain==1
#undef SC_USE_CLAMP_TO_BORDER_texMain
#define SC_USE_CLAMP_TO_BORDER_texMain 1
#endif
#ifndef MASK_PROCESSING_MULTIPLICATION
#define MASK_PROCESSING_MULTIPLICATION 0
#elif MASK_PROCESSING_MULTIPLICATION==1
#undef MASK_PROCESSING_MULTIPLICATION
#define MASK_PROCESSING_MULTIPLICATION 1
#endif
#ifndef MASK_PROCESSING_SMOOTH_STEP
#define MASK_PROCESSING_SMOOTH_STEP 0
#elif MASK_PROCESSING_SMOOTH_STEP==1
#undef MASK_PROCESSING_SMOOTH_STEP
#define MASK_PROCESSING_SMOOTH_STEP 1
#endif
#ifndef MASK_PROCESSING_SCALE
#define MASK_PROCESSING_SCALE 0
#elif MASK_PROCESSING_SCALE==1
#undef MASK_PROCESSING_SCALE
#define MASK_PROCESSING_SCALE 1
#endif
#ifndef texAbUV
#define texAbUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_texAb
#define SC_USE_UV_TRANSFORM_texAb 0
#elif SC_USE_UV_TRANSFORM_texAb==1
#undef SC_USE_UV_TRANSFORM_texAb
#define SC_USE_UV_TRANSFORM_texAb 1
#endif
#ifndef texMainUV
#define texMainUV 0
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float4 varPackedTex [[user(locn6)]];
};

float2 texAbGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.texAbDims.xy;
}

int texAbGetStereoViewIndex(thread int& varStereoViewID)
{
#if (texAbHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 texMainGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.texMainDims.xy;
}

int texMainGetStereoViewIndex(thread int& varStereoViewID)
{
#if (texMainHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float grayscale(thread const float3& color)
{
return dot(color,float3(0.2126,0.7152,0.0722));
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj,texture2d<float> texAb,texture2d<float> texMain,sampler texAbSmpSC,sampler texMainSmpSC,float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float2 param=texAbGetDims2D(userUniformsObj);
int param_1=texAbLayout;
int param_2=texAbGetStereoViewIndex(in.varStereoViewID);
float2 param_3=in.varPackedTex.xy;
bool param_4=false;
float3x3 param_5=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_6=_2306;
bool param_7=(int(SC_USE_UV_MIN_MAX_texAb)!=0);
float4 param_8=userUniformsObj.texAbUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_texAb)!=0);
float4 param_10=userUniformsObj.texAbBorderColor;
float param_11=0.0;
float4 _2329=sc_SampleTextureBiasOrLevel(texAb,texAbSmpSC,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
float4 _2295=_2329;
float4 texAbSample=_2329;
float2 param_12=in.varPackedTex.xy;
float2 param_13=texMainGetDims2D(userUniformsObj);
int param_14=texMainLayout;
int param_15=texMainGetStereoViewIndex(in.varStereoViewID);
float2 param_16=sc_PlatformFlipUV(param_12);
bool param_17=(int(SC_USE_UV_TRANSFORM_texMain)!=0);
float3x3 param_18=userUniformsObj.texMainTransform;
int2 param_19=_2342;
bool param_20=(int(SC_USE_UV_MIN_MAX_texMain)!=0);
float4 param_21=userUniformsObj.texMainUvMinMax;
bool param_22=(int(SC_USE_CLAMP_TO_BORDER_texMain)!=0);
float4 param_23=userUniformsObj.texMainBorderColor;
float param_24=0.0;
float4 _2366=sc_SampleTextureBiasOrLevel(texMain,texMainSmpSC,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23,param_24);
float4 _2331=_2366;
float4 texMainSample=_2366;
float3 param_25=texMainSample.xyz;
float hr_x=grayscale(param_25);
float4 box=texAbSample;
float2 cov_var=box.zw-(box.xx*box.yx);
float A=cov_var.x/(cov_var.y+userUniformsObj.epsilonSq);
float mask=(A*(hr_x-box.x))+box.y;
#if (MASK_PROCESSING_MULTIPLICATION)
{
mask*=mask;
}
#else
{
#if (MASK_PROCESSING_SMOOTH_STEP)
{
mask=smoothstep(0.157,0.502,mask);
}
#else
{
#if (MASK_PROCESSING_SCALE)
{
mask*=userUniformsObj.maskScaleMultiplier;
}
#endif
}
#endif
}
#endif
float4 param_26=float4(mask,mask,mask,1.0);
sc_writeFragData0(param_26,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
