#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include "std2.metal"
#include "std2_vs.metal"
#include "std2_fs.metal"
#include "std2_texture.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN(100)
//SG_REFLECTION_END


struct UserUniforms
{
float4 cropTextureSize;
float4 cropTextureDims;
float4 cropTextureView;
float3x3 cropTextureTransform;
float4 cropTextureUvMinMax;
float4 cropTextureBorderColor;
float4 confidenceTextureSize;
float4 confidenceTextureDims;
float4 confidenceTextureView;
float3x3 confidenceTextureTransform;
float4 confidenceTextureUvMinMax;
float4 confidenceTextureBorderColor;
float3x3 screenToCropTransform;
float2 depthProjectionMatrixTerms;
float minimumConfidence;
};

#ifndef cropTextureHasSwappedViews
#define cropTextureHasSwappedViews 0
#elif cropTextureHasSwappedViews==1
#undef cropTextureHasSwappedViews
#define cropTextureHasSwappedViews 1
#endif
#ifndef cropTextureLayout
#define cropTextureLayout 0
#endif
#ifndef confidenceTextureHasSwappedViews
#define confidenceTextureHasSwappedViews 0
#elif confidenceTextureHasSwappedViews==1
#undef confidenceTextureHasSwappedViews
#define confidenceTextureHasSwappedViews 1
#endif
#ifndef confidenceTextureLayout
#define confidenceTextureLayout 0
#endif
#ifndef cropTextureUV
#define cropTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_cropTexture
#define SC_USE_UV_TRANSFORM_cropTexture 0
#elif SC_USE_UV_TRANSFORM_cropTexture==1
#undef SC_USE_UV_TRANSFORM_cropTexture
#define SC_USE_UV_TRANSFORM_cropTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_cropTexture
#define SC_SOFTWARE_WRAP_MODE_U_cropTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_cropTexture
#define SC_SOFTWARE_WRAP_MODE_V_cropTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_cropTexture
#define SC_USE_UV_MIN_MAX_cropTexture 0
#elif SC_USE_UV_MIN_MAX_cropTexture==1
#undef SC_USE_UV_MIN_MAX_cropTexture
#define SC_USE_UV_MIN_MAX_cropTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_cropTexture
#define SC_USE_CLAMP_TO_BORDER_cropTexture 0
#elif SC_USE_CLAMP_TO_BORDER_cropTexture==1
#undef SC_USE_CLAMP_TO_BORDER_cropTexture
#define SC_USE_CLAMP_TO_BORDER_cropTexture 1
#endif
#ifndef confidenceTextureUV
#define confidenceTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_confidenceTexture
#define SC_USE_UV_TRANSFORM_confidenceTexture 0
#elif SC_USE_UV_TRANSFORM_confidenceTexture==1
#undef SC_USE_UV_TRANSFORM_confidenceTexture
#define SC_USE_UV_TRANSFORM_confidenceTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_confidenceTexture
#define SC_SOFTWARE_WRAP_MODE_U_confidenceTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_confidenceTexture
#define SC_SOFTWARE_WRAP_MODE_V_confidenceTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_confidenceTexture
#define SC_USE_UV_MIN_MAX_confidenceTexture 0
#elif SC_USE_UV_MIN_MAX_confidenceTexture==1
#undef SC_USE_UV_MIN_MAX_confidenceTexture
#define SC_USE_UV_MIN_MAX_confidenceTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_confidenceTexture
#define SC_USE_CLAMP_TO_BORDER_confidenceTexture 0
#elif SC_USE_CLAMP_TO_BORDER_confidenceTexture==1
#undef SC_USE_CLAMP_TO_BORDER_confidenceTexture
#define SC_USE_CLAMP_TO_BORDER_confidenceTexture 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant LibraryUniforms& libraryUniformsObj,uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN(100)
//sampler sampler cropTextureSmpSC 0:62166
//sampler sampler confidenceTextureSmpSC 0:60738
//texture texture2D cropTexture 0:40623:0:62166
//texture texture2D confidenceTexture 0:40564:0:60738
//ubo float UserUniforms 0:35568:316 {
//float4 cropTextureSize 0
//float4 cropTextureDims 16
//float4 cropTextureView 32
//float3x3 cropTextureTransform 48
//float4 cropTextureUvMinMax 96
//float4 cropTextureBorderColor 112
//float4 confidenceTextureSize 128
//float4 confidenceTextureDims 144
//float4 confidenceTextureView 160
//float3x3 confidenceTextureTransform 176
//float4 confidenceTextureUvMinMax 224
//float4 confidenceTextureBorderColor 240
//float3x3 screenToCropTransform 256
//float2 depthProjectionMatrixTerms 304
//float minimumConfidence 312
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 cropTextureSize;
float4 cropTextureDims;
float4 cropTextureView;
float3x3 cropTextureTransform;
float4 cropTextureUvMinMax;
float4 cropTextureBorderColor;
float4 confidenceTextureSize;
float4 confidenceTextureDims;
float4 confidenceTextureView;
float3x3 confidenceTextureTransform;
float4 confidenceTextureUvMinMax;
float4 confidenceTextureBorderColor;
float3x3 screenToCropTransform;
float2 depthProjectionMatrixTerms;
float minimumConfidence;
};

#ifndef cropTextureHasSwappedViews
#define cropTextureHasSwappedViews 0
#elif cropTextureHasSwappedViews==1
#undef cropTextureHasSwappedViews
#define cropTextureHasSwappedViews 1
#endif
#ifndef cropTextureLayout
#define cropTextureLayout 0
#endif
#ifndef confidenceTextureHasSwappedViews
#define confidenceTextureHasSwappedViews 0
#elif confidenceTextureHasSwappedViews==1
#undef confidenceTextureHasSwappedViews
#define confidenceTextureHasSwappedViews 1
#endif
#ifndef confidenceTextureLayout
#define confidenceTextureLayout 0
#endif
#ifndef SC_USE_UV_TRANSFORM_confidenceTexture
#define SC_USE_UV_TRANSFORM_confidenceTexture 0
#elif SC_USE_UV_TRANSFORM_confidenceTexture==1
#undef SC_USE_UV_TRANSFORM_confidenceTexture
#define SC_USE_UV_TRANSFORM_confidenceTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_confidenceTexture
#define SC_SOFTWARE_WRAP_MODE_U_confidenceTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_confidenceTexture
#define SC_SOFTWARE_WRAP_MODE_V_confidenceTexture -1
#endif
constant int2 _2329=int2(SC_SOFTWARE_WRAP_MODE_U_confidenceTexture,SC_SOFTWARE_WRAP_MODE_V_confidenceTexture);
#ifndef SC_USE_UV_MIN_MAX_confidenceTexture
#define SC_USE_UV_MIN_MAX_confidenceTexture 0
#elif SC_USE_UV_MIN_MAX_confidenceTexture==1
#undef SC_USE_UV_MIN_MAX_confidenceTexture
#define SC_USE_UV_MIN_MAX_confidenceTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_confidenceTexture
#define SC_USE_CLAMP_TO_BORDER_confidenceTexture 0
#elif SC_USE_CLAMP_TO_BORDER_confidenceTexture==1
#undef SC_USE_CLAMP_TO_BORDER_confidenceTexture
#define SC_USE_CLAMP_TO_BORDER_confidenceTexture 1
#endif
#ifndef SC_USE_UV_TRANSFORM_cropTexture
#define SC_USE_UV_TRANSFORM_cropTexture 0
#elif SC_USE_UV_TRANSFORM_cropTexture==1
#undef SC_USE_UV_TRANSFORM_cropTexture
#define SC_USE_UV_TRANSFORM_cropTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_cropTexture
#define SC_SOFTWARE_WRAP_MODE_U_cropTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_cropTexture
#define SC_SOFTWARE_WRAP_MODE_V_cropTexture -1
#endif
constant int2 _2371=int2(SC_SOFTWARE_WRAP_MODE_U_cropTexture,SC_SOFTWARE_WRAP_MODE_V_cropTexture);
#ifndef SC_USE_UV_MIN_MAX_cropTexture
#define SC_USE_UV_MIN_MAX_cropTexture 0
#elif SC_USE_UV_MIN_MAX_cropTexture==1
#undef SC_USE_UV_MIN_MAX_cropTexture
#define SC_USE_UV_MIN_MAX_cropTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_cropTexture
#define SC_USE_CLAMP_TO_BORDER_cropTexture 0
#elif SC_USE_CLAMP_TO_BORDER_cropTexture==1
#undef SC_USE_CLAMP_TO_BORDER_cropTexture
#define SC_USE_CLAMP_TO_BORDER_cropTexture 1
#endif
#ifndef cropTextureUV
#define cropTextureUV 0
#endif
#ifndef confidenceTextureUV
#define confidenceTextureUV 0
#endif

struct main_frag_out
{
float gl_FragDepth [[depth(any)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float4 varPackedTex [[user(locn6)]];
};

float2 confidenceTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.confidenceTextureDims.xy;
}

int confidenceTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (confidenceTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 cropTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.cropTextureDims.xy;
}

int cropTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (cropTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj,texture2d<float> confidenceTexture,texture2d<float> cropTexture,sampler confidenceTextureSmpSC,sampler cropTextureSmpSC,float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float2 pos=float2((userUniformsObj.screenToCropTransform*float3(in.varPackedTex.xy,1.0)).xy);
float fragDepth=1.0;
float _2299=pos.x;
bool _2300=0.0<=_2299;
bool _2306;
if (_2300)
{
_2306=pos.x<=1.0;
}
else
{
_2306=_2300;
}
bool _2312;
if (_2306)
{
_2312=0.0<=pos.y;
}
else
{
_2312=_2306;
}
bool _2318;
if (_2312)
{
_2318=pos.y<=1.0;
}
else
{
_2318=_2312;
}
if (_2318)
{
float2 param=confidenceTextureGetDims2D(userUniformsObj);
int param_1=confidenceTextureLayout;
int param_2=confidenceTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_3=pos;
bool param_4=(int(SC_USE_UV_TRANSFORM_confidenceTexture)!=0);
float3x3 param_5=userUniformsObj.confidenceTextureTransform;
int2 param_6=_2329;
bool param_7=(int(SC_USE_UV_MIN_MAX_confidenceTexture)!=0);
float4 param_8=userUniformsObj.confidenceTextureUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_confidenceTexture)!=0);
float4 param_10=userUniformsObj.confidenceTextureBorderColor;
float param_11=0.0;
float4 _2353=sc_SampleTextureBiasOrLevel(confidenceTexture,confidenceTextureSmpSC,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
float4 _2322=_2353;
float4 confidenceTextureSample=_2353;
float confidence=confidenceTextureSample.x;
if (confidence>=userUniformsObj.minimumConfidence)
{
float2 param_12=cropTextureGetDims2D(userUniformsObj);
int param_13=cropTextureLayout;
int param_14=cropTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_15=pos;
bool param_16=(int(SC_USE_UV_TRANSFORM_cropTexture)!=0);
float3x3 param_17=userUniformsObj.cropTextureTransform;
int2 param_18=_2371;
bool param_19=(int(SC_USE_UV_MIN_MAX_cropTexture)!=0);
float4 param_20=userUniformsObj.cropTextureUvMinMax;
bool param_21=(int(SC_USE_CLAMP_TO_BORDER_cropTexture)!=0);
float4 param_22=userUniformsObj.cropTextureBorderColor;
float param_23=0.0;
float4 _2395=sc_SampleTextureBiasOrLevel(cropTexture,cropTextureSmpSC,param_12,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23);
float4 _2365=_2395;
float4 cropTextureSample=_2395;
float depth=cropTextureSample.x;
float param_24=depth;
float2 param_25=userUniformsObj.depthProjectionMatrixTerms;
float _2406=depthViewToScreenSpace(param_24,param_25);
fragDepth=_2406;
}
}
out.gl_FragDepth=fragDepth;
return out;
}

} // FRAGMENT SHADER
