#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE0 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include "std2_vs.metal"
#include "std2_fs.metal"
#include "std2_texture.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN(100)
//SG_REFLECTION_END


struct UserUniforms
{
float4 sc_OITAlpha0Size;
float4 sc_OITAlpha0Dims;
float4 sc_OITAlpha0View;
float3x3 sc_OITAlpha0Transform;
float4 sc_OITAlpha0UvMinMax;
float4 sc_OITAlpha0BorderColor;
float4 sc_OITAlpha1Size;
float4 sc_OITAlpha1Dims;
float4 sc_OITAlpha1View;
float3x3 sc_OITAlpha1Transform;
float4 sc_OITAlpha1UvMinMax;
float4 sc_OITAlpha1BorderColor;
};

#ifndef sc_OITAlpha0HasSwappedViews
#define sc_OITAlpha0HasSwappedViews 0
#elif sc_OITAlpha0HasSwappedViews==1
#undef sc_OITAlpha0HasSwappedViews
#define sc_OITAlpha0HasSwappedViews 1
#endif
#ifndef sc_OITAlpha0Layout
#define sc_OITAlpha0Layout 0
#endif
#ifndef sc_OITAlpha1HasSwappedViews
#define sc_OITAlpha1HasSwappedViews 0
#elif sc_OITAlpha1HasSwappedViews==1
#undef sc_OITAlpha1HasSwappedViews
#define sc_OITAlpha1HasSwappedViews 1
#endif
#ifndef sc_OITAlpha1Layout
#define sc_OITAlpha1Layout 0
#endif
#ifndef sc_OITAlpha0UV
#define sc_OITAlpha0UV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_sc_OITAlpha0
#define SC_USE_UV_TRANSFORM_sc_OITAlpha0 0
#elif SC_USE_UV_TRANSFORM_sc_OITAlpha0==1
#undef SC_USE_UV_TRANSFORM_sc_OITAlpha0
#define SC_USE_UV_TRANSFORM_sc_OITAlpha0 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_sc_OITAlpha0
#define SC_SOFTWARE_WRAP_MODE_U_sc_OITAlpha0 -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_sc_OITAlpha0
#define SC_SOFTWARE_WRAP_MODE_V_sc_OITAlpha0 -1
#endif
#ifndef SC_USE_UV_MIN_MAX_sc_OITAlpha0
#define SC_USE_UV_MIN_MAX_sc_OITAlpha0 0
#elif SC_USE_UV_MIN_MAX_sc_OITAlpha0==1
#undef SC_USE_UV_MIN_MAX_sc_OITAlpha0
#define SC_USE_UV_MIN_MAX_sc_OITAlpha0 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_sc_OITAlpha0
#define SC_USE_CLAMP_TO_BORDER_sc_OITAlpha0 0
#elif SC_USE_CLAMP_TO_BORDER_sc_OITAlpha0==1
#undef SC_USE_CLAMP_TO_BORDER_sc_OITAlpha0
#define SC_USE_CLAMP_TO_BORDER_sc_OITAlpha0 1
#endif
#ifndef sc_OITAlpha1UV
#define sc_OITAlpha1UV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_sc_OITAlpha1
#define SC_USE_UV_TRANSFORM_sc_OITAlpha1 0
#elif SC_USE_UV_TRANSFORM_sc_OITAlpha1==1
#undef SC_USE_UV_TRANSFORM_sc_OITAlpha1
#define SC_USE_UV_TRANSFORM_sc_OITAlpha1 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_sc_OITAlpha1
#define SC_SOFTWARE_WRAP_MODE_U_sc_OITAlpha1 -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_sc_OITAlpha1
#define SC_SOFTWARE_WRAP_MODE_V_sc_OITAlpha1 -1
#endif
#ifndef SC_USE_UV_MIN_MAX_sc_OITAlpha1
#define SC_USE_UV_MIN_MAX_sc_OITAlpha1 0
#elif SC_USE_UV_MIN_MAX_sc_OITAlpha1==1
#undef SC_USE_UV_MIN_MAX_sc_OITAlpha1
#define SC_USE_UV_MIN_MAX_sc_OITAlpha1 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_sc_OITAlpha1
#define SC_USE_CLAMP_TO_BORDER_sc_OITAlpha1 0
#elif SC_USE_CLAMP_TO_BORDER_sc_OITAlpha1==1
#undef SC_USE_CLAMP_TO_BORDER_sc_OITAlpha1
#define SC_USE_CLAMP_TO_BORDER_sc_OITAlpha1 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant LibraryUniforms& libraryUniformsObj,uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
float2 _2655=(v.position.xy*0.5)+float2(0.5);
out.varPackedTex=float4(_2655.x,_2655.y,out.varPackedTex.z,out.varPackedTex.w);
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN(100)
//sampler sampler sc_OITAlpha0SmpSC 0:47052
//sampler sampler sc_OITAlpha1SmpSC 0:48428
//texture texture2D sc_OITAlpha0 0:34685:0:47052
//texture texture2D sc_OITAlpha1 0:39444:0:48428
//ubo float UserUniforms 0:35568:256 {
//float4 sc_OITAlpha0Size 0
//float4 sc_OITAlpha0Dims 16
//float4 sc_OITAlpha0View 32
//float3x3 sc_OITAlpha0Transform 48
//float4 sc_OITAlpha0UvMinMax 96
//float4 sc_OITAlpha0BorderColor 112
//float4 sc_OITAlpha1Size 128
//float4 sc_OITAlpha1Dims 144
//float4 sc_OITAlpha1View 160
//float3x3 sc_OITAlpha1Transform 176
//float4 sc_OITAlpha1UvMinMax 224
//float4 sc_OITAlpha1BorderColor 240
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 sc_OITAlpha0Size;
float4 sc_OITAlpha0Dims;
float4 sc_OITAlpha0View;
float3x3 sc_OITAlpha0Transform;
float4 sc_OITAlpha0UvMinMax;
float4 sc_OITAlpha0BorderColor;
float4 sc_OITAlpha1Size;
float4 sc_OITAlpha1Dims;
float4 sc_OITAlpha1View;
float3x3 sc_OITAlpha1Transform;
float4 sc_OITAlpha1UvMinMax;
float4 sc_OITAlpha1BorderColor;
};

#ifndef sc_OITAlpha0HasSwappedViews
#define sc_OITAlpha0HasSwappedViews 0
#elif sc_OITAlpha0HasSwappedViews==1
#undef sc_OITAlpha0HasSwappedViews
#define sc_OITAlpha0HasSwappedViews 1
#endif
#ifndef sc_OITAlpha0Layout
#define sc_OITAlpha0Layout 0
#endif
#ifndef sc_OITAlpha1HasSwappedViews
#define sc_OITAlpha1HasSwappedViews 0
#elif sc_OITAlpha1HasSwappedViews==1
#undef sc_OITAlpha1HasSwappedViews
#define sc_OITAlpha1HasSwappedViews 1
#endif
#ifndef sc_OITAlpha1Layout
#define sc_OITAlpha1Layout 0
#endif
#ifndef SC_USE_UV_TRANSFORM_sc_OITAlpha0
#define SC_USE_UV_TRANSFORM_sc_OITAlpha0 0
#elif SC_USE_UV_TRANSFORM_sc_OITAlpha0==1
#undef SC_USE_UV_TRANSFORM_sc_OITAlpha0
#define SC_USE_UV_TRANSFORM_sc_OITAlpha0 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_sc_OITAlpha0
#define SC_SOFTWARE_WRAP_MODE_U_sc_OITAlpha0 -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_sc_OITAlpha0
#define SC_SOFTWARE_WRAP_MODE_V_sc_OITAlpha0 -1
#endif
constant int2 _2340=int2(SC_SOFTWARE_WRAP_MODE_U_sc_OITAlpha0,SC_SOFTWARE_WRAP_MODE_V_sc_OITAlpha0);
#ifndef SC_USE_UV_MIN_MAX_sc_OITAlpha0
#define SC_USE_UV_MIN_MAX_sc_OITAlpha0 0
#elif SC_USE_UV_MIN_MAX_sc_OITAlpha0==1
#undef SC_USE_UV_MIN_MAX_sc_OITAlpha0
#define SC_USE_UV_MIN_MAX_sc_OITAlpha0 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_sc_OITAlpha0
#define SC_USE_CLAMP_TO_BORDER_sc_OITAlpha0 0
#elif SC_USE_CLAMP_TO_BORDER_sc_OITAlpha0==1
#undef SC_USE_CLAMP_TO_BORDER_sc_OITAlpha0
#define SC_USE_CLAMP_TO_BORDER_sc_OITAlpha0 1
#endif
constant int2 _2426=int2(SC_SOFTWARE_WRAP_MODE_U_sc_OITAlpha0,SC_SOFTWARE_WRAP_MODE_V_sc_OITAlpha0);
#ifndef SC_USE_UV_TRANSFORM_sc_OITAlpha1
#define SC_USE_UV_TRANSFORM_sc_OITAlpha1 0
#elif SC_USE_UV_TRANSFORM_sc_OITAlpha1==1
#undef SC_USE_UV_TRANSFORM_sc_OITAlpha1
#define SC_USE_UV_TRANSFORM_sc_OITAlpha1 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_sc_OITAlpha1
#define SC_SOFTWARE_WRAP_MODE_U_sc_OITAlpha1 -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_sc_OITAlpha1
#define SC_SOFTWARE_WRAP_MODE_V_sc_OITAlpha1 -1
#endif
constant int2 _2464=int2(SC_SOFTWARE_WRAP_MODE_U_sc_OITAlpha1,SC_SOFTWARE_WRAP_MODE_V_sc_OITAlpha1);
#ifndef SC_USE_UV_MIN_MAX_sc_OITAlpha1
#define SC_USE_UV_MIN_MAX_sc_OITAlpha1 0
#elif SC_USE_UV_MIN_MAX_sc_OITAlpha1==1
#undef SC_USE_UV_MIN_MAX_sc_OITAlpha1
#define SC_USE_UV_MIN_MAX_sc_OITAlpha1 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_sc_OITAlpha1
#define SC_USE_CLAMP_TO_BORDER_sc_OITAlpha1 0
#elif SC_USE_CLAMP_TO_BORDER_sc_OITAlpha1==1
#undef SC_USE_CLAMP_TO_BORDER_sc_OITAlpha1
#define SC_USE_CLAMP_TO_BORDER_sc_OITAlpha1 1
#endif
#ifndef sc_OITAlpha0UV
#define sc_OITAlpha0UV 0
#endif
#ifndef sc_OITAlpha1UV
#define sc_OITAlpha1UV 0
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float4 varPackedTex [[user(locn6)]];
};

// Implementation of the GLSL mod() function,which is slightly different than Metal fmod()
template<typename Tx,typename Ty>
Tx mod(Tx x,Ty y)
{
return x-y*floor(x/y);
}

// Implementation of an array copy function to cover GLSL's ability to copy an array via assignment.
template<typename T,uint N>
void spvArrayCopyFromStack1(thread T (&dst)[N],thread const T (&src)[N])
{
for (uint i=0; i<N; dst[i]=src[i],i++);
}

template<typename T,uint N>
void spvArrayCopyFromConstant1(thread T (&dst)[N],constant T (&src)[N])
{
for (uint i=0; i<N; dst[i]=src[i],i++);
}

float2 sc_OITAlpha0GetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.sc_OITAlpha0Dims.xy;
}

int sc_OITAlpha0GetStereoViewIndex(thread int& varStereoViewID)
{
#if (sc_OITAlpha0HasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 sc_OITAlpha1GetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.sc_OITAlpha1Dims.xy;
}

int sc_OITAlpha1GetStereoViewIndex(thread int& varStereoViewID)
{
#if (sc_OITAlpha1HasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

void unpackValues(thread float& channel,thread const int& passIndex,thread int (&values)[((int(sc_OITMaxLayers8)!=0) ? 2 : 1)*4])
{
channel=floor((channel*255.0)+0.5);
int i=((passIndex+1)*4)-1;
for (int snapLoopIndex=0; snapLoopIndex==0; snapLoopIndex+=0)
{
if (i>=(passIndex*4))
{
values[i]=(values[i]*4)+int(floor(mod(channel,4.0)));
channel=floor(channel/4.0);
i--;
continue;
}
else
{
break;
}
}
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj,texture2d<float> sc_OITAlpha0,texture2d<float> sc_OITAlpha1,sampler sc_OITAlpha0SmpSC,sampler sc_OITAlpha1SmpSC,float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
#if (sc_OITMaxLayersVisualizeLayerCount)
{
float2 param=sc_OITAlpha0GetDims2D(userUniformsObj);
int param_1=sc_OITAlpha0Layout;
int param_2=sc_OITAlpha0GetStereoViewIndex(in.varStereoViewID);
float2 param_3=in.varPackedTex.xy;
bool param_4=(int(SC_USE_UV_TRANSFORM_sc_OITAlpha0)!=0);
float3x3 param_5=userUniformsObj.sc_OITAlpha0Transform;
int2 param_6=_2340;
bool param_7=(int(SC_USE_UV_MIN_MAX_sc_OITAlpha0)!=0);
float4 param_8=userUniformsObj.sc_OITAlpha0UvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_sc_OITAlpha0)!=0);
float4 param_10=userUniformsObj.sc_OITAlpha0BorderColor;
float param_11=0.0;
float4 _2365=sc_SampleTextureBiasOrLevel(sc_OITAlpha0,sc_OITAlpha0SmpSC,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
float4 _2333=_2365;
float4 sc_OITAlpha0Sample=_2365;
float4 alphaSample=sc_OITAlpha0Sample;
float4 result=float4(0.0);
if (alphaSample.x==0.0)
{
result=float4(0.0,0.0,0.0,1.0);
}
else
{
if (alphaSample.x<=0.0156863)
{
result=float4(0.0,1.0,0.0,1.0);
}
else
{
if (alphaSample.x<=0.0313726)
{
result=float4(1.0,1.0,0.0,1.0);
}
else
{
result=float4(1.0,0.0,0.0,1.0);
}
}
}
float4 param_12=result;
sc_writeFragData0(param_12,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}
#endif
int alphas[((int(sc_OITMaxLayers8)!=0) ? 2 : 1)*4];
int i=0;
for (int snapLoopIndex=0; snapLoopIndex==0; snapLoopIndex+=0)
{
if (i<(((int(sc_OITMaxLayers8)!=0) ? 2 : 1)*4))
{
alphas[i]=0;
i++;
continue;
}
else
{
break;
}
}
float4 alphaSample_1;
int pass=0;
for (int snapLoopIndex=0; snapLoopIndex==0; snapLoopIndex+=0)
{
if (pass<((int(sc_OITMaxLayers8)!=0) ? 2 : 1))
{
if (pass==0)
{
float2 param_13=sc_OITAlpha0GetDims2D(userUniformsObj);
int param_14=sc_OITAlpha0Layout;
int param_15=sc_OITAlpha0GetStereoViewIndex(in.varStereoViewID);
float2 param_16=in.varPackedTex.xy;
bool param_17=(int(SC_USE_UV_TRANSFORM_sc_OITAlpha0)!=0);
float3x3 param_18=userUniformsObj.sc_OITAlpha0Transform;
int2 param_19=_2426;
bool param_20=(int(SC_USE_UV_MIN_MAX_sc_OITAlpha0)!=0);
float4 param_21=userUniformsObj.sc_OITAlpha0UvMinMax;
bool param_22=(int(SC_USE_CLAMP_TO_BORDER_sc_OITAlpha0)!=0);
float4 param_23=userUniformsObj.sc_OITAlpha0BorderColor;
float param_24=0.0;
float4 _2447=sc_SampleTextureBiasOrLevel(sc_OITAlpha0,sc_OITAlpha0SmpSC,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23,param_24);
float4 _2423=_2447;
float4 sc_OITAlpha0Sample_1=_2447;
alphaSample_1=sc_OITAlpha0Sample_1;
}
else
{
if ((int(sc_OITMaxLayers8)!=0)&&(pass==1))
{
float2 param_25=sc_OITAlpha1GetDims2D(userUniformsObj);
int param_26=sc_OITAlpha1Layout;
int param_27=sc_OITAlpha1GetStereoViewIndex(in.varStereoViewID);
float2 param_28=in.varPackedTex.xy;
bool param_29=(int(SC_USE_UV_TRANSFORM_sc_OITAlpha1)!=0);
float3x3 param_30=userUniformsObj.sc_OITAlpha1Transform;
int2 param_31=_2464;
bool param_32=(int(SC_USE_UV_MIN_MAX_sc_OITAlpha1)!=0);
float4 param_33=userUniformsObj.sc_OITAlpha1UvMinMax;
bool param_34=(int(SC_USE_CLAMP_TO_BORDER_sc_OITAlpha1)!=0);
float4 param_35=userUniformsObj.sc_OITAlpha1BorderColor;
float param_36=0.0;
float4 _2489=sc_SampleTextureBiasOrLevel(sc_OITAlpha1,sc_OITAlpha1SmpSC,param_25,param_26,param_27,param_28,param_29,param_30,param_31,param_32,param_33,param_34,param_35,param_36);
float4 _2457=_2489;
float4 sc_OITAlpha1Sample=_2489;
alphaSample_1=sc_OITAlpha1Sample;
}
}
float param_37=alphaSample_1.w;
int param_38=pass;
int param_39[((int(sc_OITMaxLayers8)!=0) ? 2 : 1)*4];
spvArrayCopyFromStack1(param_39,alphas);
unpackValues(param_37,param_38,param_39);
spvArrayCopyFromStack1(alphas,param_39);
float param_40=alphaSample_1.z;
int param_41=pass;
int param_42[((int(sc_OITMaxLayers8)!=0) ? 2 : 1)*4];
spvArrayCopyFromStack1(param_42,alphas);
unpackValues(param_40,param_41,param_42);
spvArrayCopyFromStack1(alphas,param_42);
float param_43=alphaSample_1.y;
int param_44=pass;
int param_45[((int(sc_OITMaxLayers8)!=0) ? 2 : 1)*4];
spvArrayCopyFromStack1(param_45,alphas);
unpackValues(param_43,param_44,param_45);
spvArrayCopyFromStack1(alphas,param_45);
float param_46=alphaSample_1.x;
int param_47=pass;
int param_48[((int(sc_OITMaxLayers8)!=0) ? 2 : 1)*4];
spvArrayCopyFromStack1(param_48,alphas);
unpackValues(param_46,param_47,param_48);
spvArrayCopyFromStack1(alphas,param_48);
pass++;
continue;
}
else
{
break;
}
}
float alphas_normalized[((int(sc_OITMaxLayers8)!=0) ? 2 : 1)*4];
int i_1=0;
for (int snapLoopIndex=0; snapLoopIndex==0; snapLoopIndex+=0)
{
if (i_1<(((int(sc_OITMaxLayers8)!=0) ? 2 : 1)*4))
{
alphas_normalized[i_1]=float(alphas[i_1])/255.0;
i_1++;
continue;
}
else
{
break;
}
}
float backgroundAlpha=1.0;
int i_2=0;
for (int snapLoopIndex=0; snapLoopIndex==0; snapLoopIndex+=0)
{
if (i_2<(((int(sc_OITMaxLayers8)!=0) ? 2 : 1)*4))
{
backgroundAlpha=(1.0-alphas_normalized[i_2])*backgroundAlpha;
i_2++;
continue;
}
else
{
break;
}
}
float4 param_49=float4(backgroundAlpha,backgroundAlpha,backgroundAlpha,1.0);
sc_writeFragData0(param_49,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
