#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE0 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include "std2_vs.metal"
#include "std2_fs.metal"
#include "std2_texture.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN(100)
//attribute vec4 color 15
//attribute vec2 inputTextureCoordinate0 16
//attribute vec2 inputTextureCoordinate1 17
//attribute vec2 inputTextureCoordinate2 18
//attribute vec2 inputTextureCoordinate3 19
//SG_REFLECTION_END


struct UserUniforms
{
float4 particlesTexture0Size;
float4 particlesTexture0Dims;
float4 particlesTexture0View;
float3x3 particlesTexture0Transform;
float4 particlesTexture0UvMinMax;
float4 particlesTexture0BorderColor;
float4 particlesTexture1Size;
float4 particlesTexture1Dims;
float4 particlesTexture1View;
float3x3 particlesTexture1Transform;
float4 particlesTexture1UvMinMax;
float4 particlesTexture1BorderColor;
float4 particlesTexture2Size;
float4 particlesTexture2Dims;
float4 particlesTexture2View;
float3x3 particlesTexture2Transform;
float4 particlesTexture2UvMinMax;
float4 particlesTexture2BorderColor;
float4 particlesTexture3Size;
float4 particlesTexture3Dims;
float4 particlesTexture3View;
float3x3 particlesTexture3Transform;
float4 particlesTexture3UvMinMax;
float4 particlesTexture3BorderColor;
};

#ifndef particlesTexture0HasSwappedViews
#define particlesTexture0HasSwappedViews 0
#elif particlesTexture0HasSwappedViews==1
#undef particlesTexture0HasSwappedViews
#define particlesTexture0HasSwappedViews 1
#endif
#ifndef particlesTexture0Layout
#define particlesTexture0Layout 0
#endif
#ifndef particlesTexture1HasSwappedViews
#define particlesTexture1HasSwappedViews 0
#elif particlesTexture1HasSwappedViews==1
#undef particlesTexture1HasSwappedViews
#define particlesTexture1HasSwappedViews 1
#endif
#ifndef particlesTexture1Layout
#define particlesTexture1Layout 0
#endif
#ifndef particlesTexture2HasSwappedViews
#define particlesTexture2HasSwappedViews 0
#elif particlesTexture2HasSwappedViews==1
#undef particlesTexture2HasSwappedViews
#define particlesTexture2HasSwappedViews 1
#endif
#ifndef particlesTexture2Layout
#define particlesTexture2Layout 0
#endif
#ifndef particlesTexture3HasSwappedViews
#define particlesTexture3HasSwappedViews 0
#elif particlesTexture3HasSwappedViews==1
#undef particlesTexture3HasSwappedViews
#define particlesTexture3HasSwappedViews 1
#endif
#ifndef particlesTexture3Layout
#define particlesTexture3Layout 0
#endif
#ifndef NUM_COLORS
#define NUM_COLORS 0
#endif
#ifndef NUM_TEXTURES
#define NUM_TEXTURES 0
#endif
#ifndef ALPHATEST
#define ALPHATEST 0
#elif ALPHATEST==1
#undef ALPHATEST
#define ALPHATEST 1
#endif
#ifndef NUM_STAGES
#define NUM_STAGES 0
#endif
#ifndef STAGE0_RGB_OP
#define STAGE0_RGB_OP 0
#endif
#ifndef STAGE0_ALPHA_OP
#define STAGE0_ALPHA_OP 0
#endif
#ifndef STAGE0_RGB_ARG1
#define STAGE0_RGB_ARG1 0
#endif
#ifndef STAGE0_ALPHA_ARG1
#define STAGE0_ALPHA_ARG1 0
#endif
#ifndef STAGE0_RGB_ARG2
#define STAGE0_RGB_ARG2 0
#endif
#ifndef STAGE0_ALPHA_ARG2
#define STAGE0_ALPHA_ARG2 0
#endif
#ifndef STAGE1_RGB_OP
#define STAGE1_RGB_OP 0
#endif
#ifndef STAGE1_ALPHA_OP
#define STAGE1_ALPHA_OP 0
#endif
#ifndef STAGE1_RGB_ARG1
#define STAGE1_RGB_ARG1 0
#endif
#ifndef STAGE1_ALPHA_ARG1
#define STAGE1_ALPHA_ARG1 0
#endif
#ifndef STAGE1_RGB_ARG2
#define STAGE1_RGB_ARG2 0
#endif
#ifndef STAGE1_ALPHA_ARG2
#define STAGE1_ALPHA_ARG2 0
#endif
#ifndef STAGE2_RGB_OP
#define STAGE2_RGB_OP 0
#endif
#ifndef STAGE2_ALPHA_OP
#define STAGE2_ALPHA_OP 0
#endif
#ifndef STAGE2_RGB_ARG1
#define STAGE2_RGB_ARG1 0
#endif
#ifndef STAGE2_ALPHA_ARG1
#define STAGE2_ALPHA_ARG1 0
#endif
#ifndef STAGE2_RGB_ARG2
#define STAGE2_RGB_ARG2 0
#endif
#ifndef STAGE2_ALPHA_ARG2
#define STAGE2_ALPHA_ARG2 0
#endif
#ifndef STAGE3_RGB_OP
#define STAGE3_RGB_OP 0
#endif
#ifndef STAGE3_ALPHA_OP
#define STAGE3_ALPHA_OP 0
#endif
#ifndef STAGE3_RGB_ARG1
#define STAGE3_RGB_ARG1 0
#endif
#ifndef STAGE3_ALPHA_ARG1
#define STAGE3_ALPHA_ARG1 0
#endif
#ifndef STAGE3_RGB_ARG2
#define STAGE3_RGB_ARG2 0
#endif
#ifndef STAGE3_ALPHA_ARG2
#define STAGE3_ALPHA_ARG2 0
#endif
#ifndef particlesTexture0UV
#define particlesTexture0UV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_particlesTexture0
#define SC_USE_UV_TRANSFORM_particlesTexture0 0
#elif SC_USE_UV_TRANSFORM_particlesTexture0==1
#undef SC_USE_UV_TRANSFORM_particlesTexture0
#define SC_USE_UV_TRANSFORM_particlesTexture0 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_particlesTexture0
#define SC_SOFTWARE_WRAP_MODE_U_particlesTexture0 -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_particlesTexture0
#define SC_SOFTWARE_WRAP_MODE_V_particlesTexture0 -1
#endif
#ifndef SC_USE_UV_MIN_MAX_particlesTexture0
#define SC_USE_UV_MIN_MAX_particlesTexture0 0
#elif SC_USE_UV_MIN_MAX_particlesTexture0==1
#undef SC_USE_UV_MIN_MAX_particlesTexture0
#define SC_USE_UV_MIN_MAX_particlesTexture0 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_particlesTexture0
#define SC_USE_CLAMP_TO_BORDER_particlesTexture0 0
#elif SC_USE_CLAMP_TO_BORDER_particlesTexture0==1
#undef SC_USE_CLAMP_TO_BORDER_particlesTexture0
#define SC_USE_CLAMP_TO_BORDER_particlesTexture0 1
#endif
#ifndef particlesTexture1UV
#define particlesTexture1UV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_particlesTexture1
#define SC_USE_UV_TRANSFORM_particlesTexture1 0
#elif SC_USE_UV_TRANSFORM_particlesTexture1==1
#undef SC_USE_UV_TRANSFORM_particlesTexture1
#define SC_USE_UV_TRANSFORM_particlesTexture1 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_particlesTexture1
#define SC_SOFTWARE_WRAP_MODE_U_particlesTexture1 -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_particlesTexture1
#define SC_SOFTWARE_WRAP_MODE_V_particlesTexture1 -1
#endif
#ifndef SC_USE_UV_MIN_MAX_particlesTexture1
#define SC_USE_UV_MIN_MAX_particlesTexture1 0
#elif SC_USE_UV_MIN_MAX_particlesTexture1==1
#undef SC_USE_UV_MIN_MAX_particlesTexture1
#define SC_USE_UV_MIN_MAX_particlesTexture1 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_particlesTexture1
#define SC_USE_CLAMP_TO_BORDER_particlesTexture1 0
#elif SC_USE_CLAMP_TO_BORDER_particlesTexture1==1
#undef SC_USE_CLAMP_TO_BORDER_particlesTexture1
#define SC_USE_CLAMP_TO_BORDER_particlesTexture1 1
#endif
#ifndef particlesTexture2UV
#define particlesTexture2UV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_particlesTexture2
#define SC_USE_UV_TRANSFORM_particlesTexture2 0
#elif SC_USE_UV_TRANSFORM_particlesTexture2==1
#undef SC_USE_UV_TRANSFORM_particlesTexture2
#define SC_USE_UV_TRANSFORM_particlesTexture2 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_particlesTexture2
#define SC_SOFTWARE_WRAP_MODE_U_particlesTexture2 -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_particlesTexture2
#define SC_SOFTWARE_WRAP_MODE_V_particlesTexture2 -1
#endif
#ifndef SC_USE_UV_MIN_MAX_particlesTexture2
#define SC_USE_UV_MIN_MAX_particlesTexture2 0
#elif SC_USE_UV_MIN_MAX_particlesTexture2==1
#undef SC_USE_UV_MIN_MAX_particlesTexture2
#define SC_USE_UV_MIN_MAX_particlesTexture2 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_particlesTexture2
#define SC_USE_CLAMP_TO_BORDER_particlesTexture2 0
#elif SC_USE_CLAMP_TO_BORDER_particlesTexture2==1
#undef SC_USE_CLAMP_TO_BORDER_particlesTexture2
#define SC_USE_CLAMP_TO_BORDER_particlesTexture2 1
#endif
#ifndef particlesTexture3UV
#define particlesTexture3UV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_particlesTexture3
#define SC_USE_UV_TRANSFORM_particlesTexture3 0
#elif SC_USE_UV_TRANSFORM_particlesTexture3==1
#undef SC_USE_UV_TRANSFORM_particlesTexture3
#define SC_USE_UV_TRANSFORM_particlesTexture3 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_particlesTexture3
#define SC_SOFTWARE_WRAP_MODE_U_particlesTexture3 -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_particlesTexture3
#define SC_SOFTWARE_WRAP_MODE_V_particlesTexture3 -1
#endif
#ifndef SC_USE_UV_MIN_MAX_particlesTexture3
#define SC_USE_UV_MIN_MAX_particlesTexture3 0
#elif SC_USE_UV_MIN_MAX_particlesTexture3==1
#undef SC_USE_UV_MIN_MAX_particlesTexture3
#define SC_USE_UV_MIN_MAX_particlesTexture3 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_particlesTexture3
#define SC_USE_CLAMP_TO_BORDER_particlesTexture3 0
#elif SC_USE_CLAMP_TO_BORDER_particlesTexture3==1
#undef SC_USE_CLAMP_TO_BORDER_particlesTexture3
#define SC_USE_CLAMP_TO_BORDER_particlesTexture3 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float4 varColor [[user(locn10)]];
float2 varTex2 [[user(locn11)]];
float2 varTex3 [[user(locn12)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
float4 color [[attribute(15)]];
float2 inputTextureCoordinate0 [[attribute(16)]];
float2 inputTextureCoordinate1 [[attribute(17)]];
float2 inputTextureCoordinate2 [[attribute(18)]];
float2 inputTextureCoordinate3 [[attribute(19)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant LibraryUniforms& libraryUniformsObj,uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
#if (NUM_COLORS>0)
{
out.varColor=in.color;
}
#endif
#if (NUM_TEXTURES>0)
{
float2 _2958=float2(in.inputTextureCoordinate0.x,1.0-in.inputTextureCoordinate0.y);
out.varPackedTex=float4(_2958.x,_2958.y,out.varPackedTex.z,out.varPackedTex.w);
}
#endif
#if (NUM_TEXTURES>1)
{
float2 _2970=float2(in.inputTextureCoordinate1.x,1.0-in.inputTextureCoordinate1.y);
out.varPackedTex=float4(out.varPackedTex.x,out.varPackedTex.y,_2970.x,_2970.y);
}
#endif
#if (NUM_TEXTURES>2)
{
out.varTex2=float2(in.inputTextureCoordinate2.x,1.0-in.inputTextureCoordinate2.y);
}
#endif
#if (NUM_TEXTURES>3)
{
out.varTex3=float2(in.inputTextureCoordinate3.x,1.0-in.inputTextureCoordinate3.y);
}
#endif
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN(100)
//sampler sampler particlesTexture0SmpSC 0:59146
//sampler sampler particlesTexture1SmpSC 0:48980
//sampler sampler particlesTexture2SmpSC 0:48840
//sampler sampler particlesTexture3SmpSC 0:37858
//texture texture2D particlesTexture0 0:51199:0:59146
//texture texture2D particlesTexture1 0:42757:0:48980
//texture texture2D particlesTexture2 0:43736:0:48840
//texture texture2D particlesTexture3 0:41651:0:37858
//ubo float UserUniforms 0:35568:512 {
//float4 particlesTexture0Size 0
//float4 particlesTexture0Dims 16
//float4 particlesTexture0View 32
//float3x3 particlesTexture0Transform 48
//float4 particlesTexture0UvMinMax 96
//float4 particlesTexture0BorderColor 112
//float4 particlesTexture1Size 128
//float4 particlesTexture1Dims 144
//float4 particlesTexture1View 160
//float3x3 particlesTexture1Transform 176
//float4 particlesTexture1UvMinMax 224
//float4 particlesTexture1BorderColor 240
//float4 particlesTexture2Size 256
//float4 particlesTexture2Dims 272
//float4 particlesTexture2View 288
//float3x3 particlesTexture2Transform 304
//float4 particlesTexture2UvMinMax 352
//float4 particlesTexture2BorderColor 368
//float4 particlesTexture3Size 384
//float4 particlesTexture3Dims 400
//float4 particlesTexture3View 416
//float3x3 particlesTexture3Transform 432
//float4 particlesTexture3UvMinMax 480
//float4 particlesTexture3BorderColor 496
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 particlesTexture0Size;
float4 particlesTexture0Dims;
float4 particlesTexture0View;
float3x3 particlesTexture0Transform;
float4 particlesTexture0UvMinMax;
float4 particlesTexture0BorderColor;
float4 particlesTexture1Size;
float4 particlesTexture1Dims;
float4 particlesTexture1View;
float3x3 particlesTexture1Transform;
float4 particlesTexture1UvMinMax;
float4 particlesTexture1BorderColor;
float4 particlesTexture2Size;
float4 particlesTexture2Dims;
float4 particlesTexture2View;
float3x3 particlesTexture2Transform;
float4 particlesTexture2UvMinMax;
float4 particlesTexture2BorderColor;
float4 particlesTexture3Size;
float4 particlesTexture3Dims;
float4 particlesTexture3View;
float3x3 particlesTexture3Transform;
float4 particlesTexture3UvMinMax;
float4 particlesTexture3BorderColor;
};

#ifndef particlesTexture0HasSwappedViews
#define particlesTexture0HasSwappedViews 0
#elif particlesTexture0HasSwappedViews==1
#undef particlesTexture0HasSwappedViews
#define particlesTexture0HasSwappedViews 1
#endif
#ifndef particlesTexture0Layout
#define particlesTexture0Layout 0
#endif
#ifndef particlesTexture1HasSwappedViews
#define particlesTexture1HasSwappedViews 0
#elif particlesTexture1HasSwappedViews==1
#undef particlesTexture1HasSwappedViews
#define particlesTexture1HasSwappedViews 1
#endif
#ifndef particlesTexture1Layout
#define particlesTexture1Layout 0
#endif
#ifndef particlesTexture2HasSwappedViews
#define particlesTexture2HasSwappedViews 0
#elif particlesTexture2HasSwappedViews==1
#undef particlesTexture2HasSwappedViews
#define particlesTexture2HasSwappedViews 1
#endif
#ifndef particlesTexture2Layout
#define particlesTexture2Layout 0
#endif
#ifndef particlesTexture3HasSwappedViews
#define particlesTexture3HasSwappedViews 0
#elif particlesTexture3HasSwappedViews==1
#undef particlesTexture3HasSwappedViews
#define particlesTexture3HasSwappedViews 1
#endif
#ifndef particlesTexture3Layout
#define particlesTexture3Layout 0
#endif
#ifndef NUM_STAGES
#define NUM_STAGES 0
#endif
#ifndef STAGE0_RGB_ARG1
#define STAGE0_RGB_ARG1 0
#endif
#ifndef STAGE0_ALPHA_ARG1
#define STAGE0_ALPHA_ARG1 0
#endif
#ifndef STAGE0_RGB_ARG2
#define STAGE0_RGB_ARG2 0
#endif
#ifndef STAGE0_ALPHA_ARG2
#define STAGE0_ALPHA_ARG2 0
#endif
#ifndef SC_USE_UV_TRANSFORM_particlesTexture0
#define SC_USE_UV_TRANSFORM_particlesTexture0 0
#elif SC_USE_UV_TRANSFORM_particlesTexture0==1
#undef SC_USE_UV_TRANSFORM_particlesTexture0
#define SC_USE_UV_TRANSFORM_particlesTexture0 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_particlesTexture0
#define SC_SOFTWARE_WRAP_MODE_U_particlesTexture0 -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_particlesTexture0
#define SC_SOFTWARE_WRAP_MODE_V_particlesTexture0 -1
#endif
constant int2 _2599=int2(SC_SOFTWARE_WRAP_MODE_U_particlesTexture0,SC_SOFTWARE_WRAP_MODE_V_particlesTexture0);
#ifndef SC_USE_UV_MIN_MAX_particlesTexture0
#define SC_USE_UV_MIN_MAX_particlesTexture0 0
#elif SC_USE_UV_MIN_MAX_particlesTexture0==1
#undef SC_USE_UV_MIN_MAX_particlesTexture0
#define SC_USE_UV_MIN_MAX_particlesTexture0 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_particlesTexture0
#define SC_USE_CLAMP_TO_BORDER_particlesTexture0 0
#elif SC_USE_CLAMP_TO_BORDER_particlesTexture0==1
#undef SC_USE_CLAMP_TO_BORDER_particlesTexture0
#define SC_USE_CLAMP_TO_BORDER_particlesTexture0 1
#endif
#ifndef STAGE0_RGB_OP
#define STAGE0_RGB_OP 0
#endif
#ifndef STAGE0_ALPHA_OP
#define STAGE0_ALPHA_OP 0
#endif
#ifndef STAGE1_RGB_ARG1
#define STAGE1_RGB_ARG1 0
#endif
#ifndef STAGE1_ALPHA_ARG1
#define STAGE1_ALPHA_ARG1 0
#endif
#ifndef STAGE1_RGB_ARG2
#define STAGE1_RGB_ARG2 0
#endif
#ifndef STAGE1_ALPHA_ARG2
#define STAGE1_ALPHA_ARG2 0
#endif
#ifndef SC_USE_UV_TRANSFORM_particlesTexture1
#define SC_USE_UV_TRANSFORM_particlesTexture1 0
#elif SC_USE_UV_TRANSFORM_particlesTexture1==1
#undef SC_USE_UV_TRANSFORM_particlesTexture1
#define SC_USE_UV_TRANSFORM_particlesTexture1 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_particlesTexture1
#define SC_SOFTWARE_WRAP_MODE_U_particlesTexture1 -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_particlesTexture1
#define SC_SOFTWARE_WRAP_MODE_V_particlesTexture1 -1
#endif
constant int2 _2877=int2(SC_SOFTWARE_WRAP_MODE_U_particlesTexture1,SC_SOFTWARE_WRAP_MODE_V_particlesTexture1);
#ifndef SC_USE_UV_MIN_MAX_particlesTexture1
#define SC_USE_UV_MIN_MAX_particlesTexture1 0
#elif SC_USE_UV_MIN_MAX_particlesTexture1==1
#undef SC_USE_UV_MIN_MAX_particlesTexture1
#define SC_USE_UV_MIN_MAX_particlesTexture1 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_particlesTexture1
#define SC_USE_CLAMP_TO_BORDER_particlesTexture1 0
#elif SC_USE_CLAMP_TO_BORDER_particlesTexture1==1
#undef SC_USE_CLAMP_TO_BORDER_particlesTexture1
#define SC_USE_CLAMP_TO_BORDER_particlesTexture1 1
#endif
#ifndef STAGE1_RGB_OP
#define STAGE1_RGB_OP 0
#endif
#ifndef STAGE1_ALPHA_OP
#define STAGE1_ALPHA_OP 0
#endif
#ifndef STAGE2_RGB_ARG1
#define STAGE2_RGB_ARG1 0
#endif
#ifndef STAGE2_ALPHA_ARG1
#define STAGE2_ALPHA_ARG1 0
#endif
#ifndef STAGE2_RGB_ARG2
#define STAGE2_RGB_ARG2 0
#endif
#ifndef STAGE2_ALPHA_ARG2
#define STAGE2_ALPHA_ARG2 0
#endif
#ifndef SC_USE_UV_TRANSFORM_particlesTexture2
#define SC_USE_UV_TRANSFORM_particlesTexture2 0
#elif SC_USE_UV_TRANSFORM_particlesTexture2==1
#undef SC_USE_UV_TRANSFORM_particlesTexture2
#define SC_USE_UV_TRANSFORM_particlesTexture2 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_particlesTexture2
#define SC_SOFTWARE_WRAP_MODE_U_particlesTexture2 -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_particlesTexture2
#define SC_SOFTWARE_WRAP_MODE_V_particlesTexture2 -1
#endif
constant int2 _3151=int2(SC_SOFTWARE_WRAP_MODE_U_particlesTexture2,SC_SOFTWARE_WRAP_MODE_V_particlesTexture2);
#ifndef SC_USE_UV_MIN_MAX_particlesTexture2
#define SC_USE_UV_MIN_MAX_particlesTexture2 0
#elif SC_USE_UV_MIN_MAX_particlesTexture2==1
#undef SC_USE_UV_MIN_MAX_particlesTexture2
#define SC_USE_UV_MIN_MAX_particlesTexture2 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_particlesTexture2
#define SC_USE_CLAMP_TO_BORDER_particlesTexture2 0
#elif SC_USE_CLAMP_TO_BORDER_particlesTexture2==1
#undef SC_USE_CLAMP_TO_BORDER_particlesTexture2
#define SC_USE_CLAMP_TO_BORDER_particlesTexture2 1
#endif
#ifndef STAGE2_RGB_OP
#define STAGE2_RGB_OP 0
#endif
#ifndef STAGE2_ALPHA_OP
#define STAGE2_ALPHA_OP 0
#endif
#ifndef STAGE3_RGB_ARG1
#define STAGE3_RGB_ARG1 0
#endif
#ifndef STAGE3_ALPHA_ARG1
#define STAGE3_ALPHA_ARG1 0
#endif
#ifndef STAGE3_RGB_ARG2
#define STAGE3_RGB_ARG2 0
#endif
#ifndef STAGE3_ALPHA_ARG2
#define STAGE3_ALPHA_ARG2 0
#endif
#ifndef SC_USE_UV_TRANSFORM_particlesTexture3
#define SC_USE_UV_TRANSFORM_particlesTexture3 0
#elif SC_USE_UV_TRANSFORM_particlesTexture3==1
#undef SC_USE_UV_TRANSFORM_particlesTexture3
#define SC_USE_UV_TRANSFORM_particlesTexture3 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_particlesTexture3
#define SC_SOFTWARE_WRAP_MODE_U_particlesTexture3 -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_particlesTexture3
#define SC_SOFTWARE_WRAP_MODE_V_particlesTexture3 -1
#endif
constant int2 _3424=int2(SC_SOFTWARE_WRAP_MODE_U_particlesTexture3,SC_SOFTWARE_WRAP_MODE_V_particlesTexture3);
#ifndef SC_USE_UV_MIN_MAX_particlesTexture3
#define SC_USE_UV_MIN_MAX_particlesTexture3 0
#elif SC_USE_UV_MIN_MAX_particlesTexture3==1
#undef SC_USE_UV_MIN_MAX_particlesTexture3
#define SC_USE_UV_MIN_MAX_particlesTexture3 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_particlesTexture3
#define SC_USE_CLAMP_TO_BORDER_particlesTexture3 0
#elif SC_USE_CLAMP_TO_BORDER_particlesTexture3==1
#undef SC_USE_CLAMP_TO_BORDER_particlesTexture3
#define SC_USE_CLAMP_TO_BORDER_particlesTexture3 1
#endif
#ifndef STAGE3_RGB_OP
#define STAGE3_RGB_OP 0
#endif
#ifndef STAGE3_ALPHA_OP
#define STAGE3_ALPHA_OP 0
#endif
#ifndef ALPHATEST
#define ALPHATEST 0
#elif ALPHATEST==1
#undef ALPHATEST
#define ALPHATEST 1
#endif
#ifndef NUM_COLORS
#define NUM_COLORS 0
#endif
#ifndef NUM_TEXTURES
#define NUM_TEXTURES 0
#endif
#ifndef particlesTexture0UV
#define particlesTexture0UV 0
#endif
#ifndef particlesTexture1UV
#define particlesTexture1UV 0
#endif
#ifndef particlesTexture2UV
#define particlesTexture2UV 0
#endif
#ifndef particlesTexture3UV
#define particlesTexture3UV 0
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float4 varPackedTex [[user(locn6)]];
float4 varColor [[user(locn10)]];
float2 varTex2 [[user(locn11)]];
float2 varTex3 [[user(locn12)]];
};

float2 particlesTexture0GetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.particlesTexture0Dims.xy;
}

int particlesTexture0GetStereoViewIndex(thread int& varStereoViewID)
{
#if (particlesTexture0HasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 particlesTexture1GetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.particlesTexture1Dims.xy;
}

int particlesTexture1GetStereoViewIndex(thread int& varStereoViewID)
{
#if (particlesTexture1HasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 particlesTexture2GetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.particlesTexture2Dims.xy;
}

int particlesTexture2GetStereoViewIndex(thread int& varStereoViewID)
{
#if (particlesTexture2HasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 particlesTexture3GetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.particlesTexture3Dims.xy;
}

int particlesTexture3GetStereoViewIndex(thread int& varStereoViewID)
{
#if (particlesTexture3HasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj,texture2d<float> particlesTexture3,texture2d<float> particlesTexture1,texture2d<float> particlesTexture2,texture2d<float> particlesTexture0,sampler particlesTexture3SmpSC,sampler particlesTexture2SmpSC,sampler particlesTexture1SmpSC,sampler particlesTexture0SmpSC,float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float4 color;
#if (NUM_STAGES==0)
{
color=in.varColor;
}
#endif
float4 colorTex;
float4 arg1;
float4 arg2;
#if (NUM_STAGES>0)
{
#if ((((STAGE0_RGB_ARG1==2)||(STAGE0_ALPHA_ARG1==2))||(STAGE0_RGB_ARG2==2))||(STAGE0_ALPHA_ARG2==2))
{
float2 param=particlesTexture0GetDims2D(userUniformsObj);
int param_1=particlesTexture0Layout;
int param_2=particlesTexture0GetStereoViewIndex(in.varStereoViewID);
float2 param_3=in.varPackedTex.xy;
bool param_4=(int(SC_USE_UV_TRANSFORM_particlesTexture0)!=0);
float3x3 param_5=userUniformsObj.particlesTexture0Transform;
int2 param_6=_2599;
bool param_7=(int(SC_USE_UV_MIN_MAX_particlesTexture0)!=0);
float4 param_8=userUniformsObj.particlesTexture0UvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_particlesTexture0)!=0);
float4 param_10=userUniformsObj.particlesTexture0BorderColor;
float param_11=0.0;
float4 _2625=sc_SampleTextureBiasOrLevel(particlesTexture0,particlesTexture0SmpSC,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
float4 _2592=_2625;
float4 particlesTexture0Sample=_2625;
colorTex=particlesTexture0Sample;
}
#endif
#if (STAGE0_RGB_ARG1==0)
{
arg1=float4(color.xyz.x,color.xyz.y,color.xyz.z,arg1.w);
}
#else
{
#if (STAGE0_RGB_ARG1==1)
{
arg1=float4(in.varColor.xyz.x,in.varColor.xyz.y,in.varColor.xyz.z,arg1.w);
}
#else
{
#if (STAGE0_RGB_ARG1==2)
{
arg1=float4(colorTex.xyz.x,colorTex.xyz.y,colorTex.xyz.z,arg1.w);
}
#endif
}
#endif
}
#endif
#if (STAGE0_ALPHA_ARG1==0)
{
arg1.w=color.w;
}
#else
{
#if (STAGE0_ALPHA_ARG1==1)
{
arg1.w=in.varColor.w;
}
#else
{
#if (STAGE0_ALPHA_ARG1==2)
{
arg1.w=colorTex.w;
}
#endif
}
#endif
}
#endif
#if (STAGE0_RGB_ARG2==0)
{
arg2=float4(color.xyz.x,color.xyz.y,color.xyz.z,arg2.w);
}
#else
{
#if (STAGE0_RGB_ARG2==1)
{
arg2=float4(in.varColor.xyz.x,in.varColor.xyz.y,in.varColor.xyz.z,arg2.w);
}
#else
{
#if (STAGE0_RGB_ARG2==2)
{
arg2=float4(colorTex.xyz.x,colorTex.xyz.y,colorTex.xyz.z,arg2.w);
}
#endif
}
#endif
}
#endif
#if (STAGE0_ALPHA_ARG2==0)
{
arg2.w=color.w;
}
#else
{
#if (STAGE0_ALPHA_ARG2==1)
{
arg2.w=in.varColor.w;
}
#else
{
#if (STAGE0_ALPHA_ARG2==2)
{
arg2.w=colorTex.w;
}
#endif
}
#endif
}
#endif
#if (STAGE0_RGB_OP==0)
{
color=float4(arg1.xyz.x,arg1.xyz.y,arg1.xyz.z,color.w);
}
#else
{
#if (STAGE0_RGB_OP==1)
{
float3 _2732=arg1.xyz+arg2.xyz;
color=float4(_2732.x,_2732.y,_2732.z,color.w);
}
#else
{
#if (STAGE0_RGB_OP==2)
{
float3 _2743=arg1.xyz-arg2.xyz;
color=float4(_2743.x,_2743.y,_2743.z,color.w);
}
#else
{
#if (STAGE0_RGB_OP==3)
{
float3 _2754=arg1.xyz*arg2.xyz;
color=float4(_2754.x,_2754.y,_2754.z,color.w);
}
#else
{
#if (STAGE0_RGB_OP==4)
{
float3 _2765=arg1.xyz*arg2.xyz;
color=float4(_2765.x,_2765.y,_2765.z,color.w);
float3 _2772=color.xyz+color.xyz;
color=float4(_2772.x,_2772.y,_2772.z,color.w);
}
#else
{
float3 _2780=arg1.xyz*arg2.xyz;
color=float4(_2780.x,_2780.y,_2780.z,color.w);
float3 _2786=color.xyz*4.0;
color=float4(_2786.x,_2786.y,_2786.z,color.w);
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
#if (STAGE0_ALPHA_OP==0)
{
color.w=arg1.w;
}
#else
{
#if (STAGE0_ALPHA_OP==1)
{
color.w=arg1.w+arg2.w;
}
#else
{
#if (STAGE0_ALPHA_OP==2)
{
color.w=arg1.w-arg2.w;
}
#else
{
#if (STAGE0_ALPHA_OP==3)
{
color.w=arg1.w*arg2.w;
}
#else
{
#if (STAGE0_ALPHA_OP==4)
{
color.w=arg1.w*arg2.w;
color.w+=color.w;
}
#else
{
color.w=arg1.w*arg2.w;
color.w*=4.0;
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
#if (NUM_STAGES>1)
{
#if ((((STAGE1_RGB_ARG1==2)||(STAGE1_ALPHA_ARG1==2))||(STAGE1_RGB_ARG2==2))||(STAGE1_ALPHA_ARG2==2))
{
float2 param_12=particlesTexture1GetDims2D(userUniformsObj);
int param_13=particlesTexture1Layout;
int param_14=particlesTexture1GetStereoViewIndex(in.varStereoViewID);
float2 param_15=in.varPackedTex.zw;
bool param_16=(int(SC_USE_UV_TRANSFORM_particlesTexture1)!=0);
float3x3 param_17=userUniformsObj.particlesTexture1Transform;
int2 param_18=_2877;
bool param_19=(int(SC_USE_UV_MIN_MAX_particlesTexture1)!=0);
float4 param_20=userUniformsObj.particlesTexture1UvMinMax;
bool param_21=(int(SC_USE_CLAMP_TO_BORDER_particlesTexture1)!=0);
float4 param_22=userUniformsObj.particlesTexture1BorderColor;
float param_23=0.0;
float4 _2902=sc_SampleTextureBiasOrLevel(particlesTexture1,particlesTexture1SmpSC,param_12,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23);
float4 _2870=_2902;
float4 particlesTexture1Sample=_2902;
colorTex=particlesTexture1Sample;
}
#endif
#if (STAGE1_RGB_ARG1==0)
{
arg1=float4(color.xyz.x,color.xyz.y,color.xyz.z,arg1.w);
}
#else
{
#if (STAGE1_RGB_ARG1==1)
{
arg1=float4(in.varColor.xyz.x,in.varColor.xyz.y,in.varColor.xyz.z,arg1.w);
}
#else
{
#if (STAGE1_RGB_ARG1==2)
{
arg1=float4(colorTex.xyz.x,colorTex.xyz.y,colorTex.xyz.z,arg1.w);
}
#endif
}
#endif
}
#endif
#if (STAGE1_ALPHA_ARG1==0)
{
arg1.w=color.w;
}
#else
{
#if (STAGE1_ALPHA_ARG1==1)
{
arg1.w=in.varColor.w;
}
#else
{
#if (STAGE1_ALPHA_ARG1==2)
{
arg1.w=colorTex.w;
}
#endif
}
#endif
}
#endif
#if (STAGE1_RGB_ARG2==0)
{
arg2=float4(color.xyz.x,color.xyz.y,color.xyz.z,arg2.w);
}
#else
{
#if (STAGE1_RGB_ARG2==1)
{
arg2=float4(in.varColor.xyz.x,in.varColor.xyz.y,in.varColor.xyz.z,arg2.w);
}
#else
{
#if (STAGE1_RGB_ARG2==2)
{
arg2=float4(colorTex.xyz.x,colorTex.xyz.y,colorTex.xyz.z,arg2.w);
}
#endif
}
#endif
}
#endif
#if (STAGE1_ALPHA_ARG2==0)
{
arg2.w=color.w;
}
#else
{
#if (STAGE1_ALPHA_ARG2==1)
{
arg2.w=in.varColor.w;
}
#else
{
#if (STAGE1_ALPHA_ARG2==2)
{
arg2.w=colorTex.w;
}
#endif
}
#endif
}
#endif
#if (STAGE1_RGB_OP==0)
{
color=float4(arg1.xyz.x,arg1.xyz.y,arg1.xyz.z,color.w);
}
#else
{
#if (STAGE1_RGB_OP==1)
{
float3 _3006=arg1.xyz+arg2.xyz;
color=float4(_3006.x,_3006.y,_3006.z,color.w);
}
#else
{
#if (STAGE1_RGB_OP==2)
{
float3 _3017=arg1.xyz-arg2.xyz;
color=float4(_3017.x,_3017.y,_3017.z,color.w);
}
#else
{
#if (STAGE1_RGB_OP==3)
{
float3 _3028=arg1.xyz*arg2.xyz;
color=float4(_3028.x,_3028.y,_3028.z,color.w);
}
#else
{
#if (STAGE1_RGB_OP==4)
{
float3 _3039=arg1.xyz*arg2.xyz;
color=float4(_3039.x,_3039.y,_3039.z,color.w);
float3 _3046=color.xyz+color.xyz;
color=float4(_3046.x,_3046.y,_3046.z,color.w);
}
#else
{
float3 _3054=arg1.xyz*arg2.xyz;
color=float4(_3054.x,_3054.y,_3054.z,color.w);
float3 _3059=color.xyz*4.0;
color=float4(_3059.x,_3059.y,_3059.z,color.w);
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
#if (STAGE1_ALPHA_OP==0)
{
color.w=arg1.w;
}
#else
{
#if (STAGE1_ALPHA_OP==1)
{
color.w=arg1.w+arg2.w;
}
#else
{
#if (STAGE1_ALPHA_OP==2)
{
color.w=arg1.w-arg2.w;
}
#else
{
#if (STAGE1_ALPHA_OP==3)
{
color.w=arg1.w*arg2.w;
}
#else
{
#if (STAGE1_ALPHA_OP==4)
{
color.w=arg1.w*arg2.w;
color.w+=color.w;
}
#else
{
color.w=arg1.w*arg2.w;
color.w*=4.0;
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
#if (NUM_STAGES>2)
{
#if ((((STAGE2_RGB_ARG1==2)||(STAGE2_ALPHA_ARG1==2))||(STAGE2_RGB_ARG2==2))||(STAGE2_ALPHA_ARG2==2))
{
float2 param_24=particlesTexture2GetDims2D(userUniformsObj);
int param_25=particlesTexture2Layout;
int param_26=particlesTexture2GetStereoViewIndex(in.varStereoViewID);
float2 param_27=in.varTex2;
bool param_28=(int(SC_USE_UV_TRANSFORM_particlesTexture2)!=0);
float3x3 param_29=userUniformsObj.particlesTexture2Transform;
int2 param_30=_3151;
bool param_31=(int(SC_USE_UV_MIN_MAX_particlesTexture2)!=0);
float4 param_32=userUniformsObj.particlesTexture2UvMinMax;
bool param_33=(int(SC_USE_CLAMP_TO_BORDER_particlesTexture2)!=0);
float4 param_34=userUniformsObj.particlesTexture2BorderColor;
float param_35=0.0;
float4 _3175=sc_SampleTextureBiasOrLevel(particlesTexture2,particlesTexture2SmpSC,param_24,param_25,param_26,param_27,param_28,param_29,param_30,param_31,param_32,param_33,param_34,param_35);
float4 _3143=_3175;
float4 particlesTexture2Sample=_3175;
colorTex=particlesTexture2Sample;
}
#endif
#if (STAGE2_RGB_ARG1==0)
{
arg1=float4(color.xyz.x,color.xyz.y,color.xyz.z,arg1.w);
}
#else
{
#if (STAGE2_RGB_ARG1==1)
{
arg1=float4(in.varColor.xyz.x,in.varColor.xyz.y,in.varColor.xyz.z,arg1.w);
}
#else
{
#if (STAGE2_RGB_ARG1==2)
{
arg1=float4(colorTex.xyz.x,colorTex.xyz.y,colorTex.xyz.z,arg1.w);
}
#endif
}
#endif
}
#endif
#if (STAGE2_ALPHA_ARG1==0)
{
arg1.w=color.w;
}
#else
{
#if (STAGE2_ALPHA_ARG1==1)
{
arg1.w=in.varColor.w;
}
#else
{
#if (STAGE2_ALPHA_ARG1==2)
{
arg1.w=colorTex.w;
}
#endif
}
#endif
}
#endif
#if (STAGE2_RGB_ARG2==0)
{
arg2=float4(color.xyz.x,color.xyz.y,color.xyz.z,arg2.w);
}
#else
{
#if (STAGE2_RGB_ARG2==1)
{
arg2=float4(in.varColor.xyz.x,in.varColor.xyz.y,in.varColor.xyz.z,arg2.w);
}
#else
{
#if (STAGE2_RGB_ARG2==2)
{
arg2=float4(colorTex.xyz.x,colorTex.xyz.y,colorTex.xyz.z,arg2.w);
}
#endif
}
#endif
}
#endif
#if (STAGE2_ALPHA_ARG2==0)
{
arg2.w=color.w;
}
#else
{
#if (STAGE2_ALPHA_ARG2==1)
{
arg2.w=in.varColor.w;
}
#else
{
#if (STAGE2_ALPHA_ARG2==2)
{
arg2.w=colorTex.w;
}
#endif
}
#endif
}
#endif
#if (STAGE2_RGB_OP==0)
{
color=float4(arg1.xyz.x,arg1.xyz.y,arg1.xyz.z,color.w);
}
#else
{
#if (STAGE2_RGB_OP==1)
{
float3 _3279=arg1.xyz+arg2.xyz;
color=float4(_3279.x,_3279.y,_3279.z,color.w);
}
#else
{
#if (STAGE2_RGB_OP==2)
{
float3 _3290=arg1.xyz-arg2.xyz;
color=float4(_3290.x,_3290.y,_3290.z,color.w);
}
#else
{
#if (STAGE2_RGB_OP==3)
{
float3 _3301=arg1.xyz*arg2.xyz;
color=float4(_3301.x,_3301.y,_3301.z,color.w);
}
#else
{
#if (STAGE2_RGB_OP==4)
{
float3 _3312=arg1.xyz*arg2.xyz;
color=float4(_3312.x,_3312.y,_3312.z,color.w);
float3 _3319=color.xyz+color.xyz;
color=float4(_3319.x,_3319.y,_3319.z,color.w);
}
#else
{
float3 _3327=arg1.xyz*arg2.xyz;
color=float4(_3327.x,_3327.y,_3327.z,color.w);
float3 _3332=color.xyz*4.0;
color=float4(_3332.x,_3332.y,_3332.z,color.w);
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
#if (STAGE2_ALPHA_OP==0)
{
color.w=arg1.w;
}
#else
{
#if (STAGE2_ALPHA_OP==1)
{
color.w=arg1.w+arg2.w;
}
#else
{
#if (STAGE2_ALPHA_OP==2)
{
color.w=arg1.w-arg2.w;
}
#else
{
#if (STAGE2_ALPHA_OP==3)
{
color.w=arg1.w*arg2.w;
}
#else
{
#if (STAGE2_ALPHA_OP==4)
{
color.w=arg1.w*arg2.w;
color.w+=color.w;
}
#else
{
color.w=arg1.w*arg2.w;
color.w*=4.0;
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
#if (NUM_STAGES>3)
{
#if ((((STAGE3_RGB_ARG1==2)||(STAGE3_ALPHA_ARG1==2))||(STAGE3_RGB_ARG2==2))||(STAGE3_ALPHA_ARG2==2))
{
float2 param_36=particlesTexture3GetDims2D(userUniformsObj);
int param_37=particlesTexture3Layout;
int param_38=particlesTexture3GetStereoViewIndex(in.varStereoViewID);
float2 param_39=in.varTex3;
bool param_40=(int(SC_USE_UV_TRANSFORM_particlesTexture3)!=0);
float3x3 param_41=userUniformsObj.particlesTexture3Transform;
int2 param_42=_3424;
bool param_43=(int(SC_USE_UV_MIN_MAX_particlesTexture3)!=0);
float4 param_44=userUniformsObj.particlesTexture3UvMinMax;
bool param_45=(int(SC_USE_CLAMP_TO_BORDER_particlesTexture3)!=0);
float4 param_46=userUniformsObj.particlesTexture3BorderColor;
float param_47=0.0;
float4 _3448=sc_SampleTextureBiasOrLevel(particlesTexture3,particlesTexture3SmpSC,param_36,param_37,param_38,param_39,param_40,param_41,param_42,param_43,param_44,param_45,param_46,param_47);
float4 _3416=_3448;
float4 particlesTexture3Sample=_3448;
colorTex=particlesTexture3Sample;
}
#endif
#if (STAGE3_RGB_ARG1==0)
{
arg1=float4(color.xyz.x,color.xyz.y,color.xyz.z,arg1.w);
}
#else
{
#if (STAGE3_RGB_ARG1==1)
{
arg1=float4(in.varColor.xyz.x,in.varColor.xyz.y,in.varColor.xyz.z,arg1.w);
}
#else
{
#if (STAGE3_RGB_ARG1==2)
{
arg1=float4(colorTex.xyz.x,colorTex.xyz.y,colorTex.xyz.z,arg1.w);
}
#endif
}
#endif
}
#endif
#if (STAGE3_ALPHA_ARG1==0)
{
arg1.w=color.w;
}
#else
{
#if (STAGE3_ALPHA_ARG1==1)
{
arg1.w=in.varColor.w;
}
#else
{
#if (STAGE3_ALPHA_ARG1==2)
{
arg1.w=colorTex.w;
}
#endif
}
#endif
}
#endif
#if (STAGE3_RGB_ARG2==0)
{
arg2=float4(color.xyz.x,color.xyz.y,color.xyz.z,arg2.w);
}
#else
{
#if (STAGE3_RGB_ARG2==1)
{
arg2=float4(in.varColor.xyz.x,in.varColor.xyz.y,in.varColor.xyz.z,arg2.w);
}
#else
{
#if (STAGE3_RGB_ARG2==2)
{
arg2=float4(colorTex.xyz.x,colorTex.xyz.y,colorTex.xyz.z,arg2.w);
}
#endif
}
#endif
}
#endif
#if (STAGE3_ALPHA_ARG2==0)
{
arg2.w=color.w;
}
#else
{
#if (STAGE3_ALPHA_ARG2==1)
{
arg2.w=in.varColor.w;
}
#else
{
#if (STAGE3_ALPHA_ARG2==2)
{
arg2.w=colorTex.w;
}
#endif
}
#endif
}
#endif
#if (STAGE3_RGB_OP==0)
{
color=float4(arg1.xyz.x,arg1.xyz.y,arg1.xyz.z,color.w);
}
#else
{
#if (STAGE3_RGB_OP==1)
{
float3 _3552=arg1.xyz+arg2.xyz;
color=float4(_3552.x,_3552.y,_3552.z,color.w);
}
#else
{
#if (STAGE3_RGB_OP==2)
{
float3 _3563=arg1.xyz-arg2.xyz;
color=float4(_3563.x,_3563.y,_3563.z,color.w);
}
#else
{
#if (STAGE3_RGB_OP==3)
{
float3 _3574=arg1.xyz*arg2.xyz;
color=float4(_3574.x,_3574.y,_3574.z,color.w);
}
#else
{
#if (STAGE3_RGB_OP==4)
{
float3 _3585=arg1.xyz*arg2.xyz;
color=float4(_3585.x,_3585.y,_3585.z,color.w);
float3 _3592=color.xyz+color.xyz;
color=float4(_3592.x,_3592.y,_3592.z,color.w);
}
#else
{
float3 _3600=arg1.xyz*arg2.xyz;
color=float4(_3600.x,_3600.y,_3600.z,color.w);
float3 _3605=color.xyz*4.0;
color=float4(_3605.x,_3605.y,_3605.z,color.w);
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
#if (STAGE3_ALPHA_OP==0)
{
color.w=arg1.w;
}
#else
{
#if (STAGE3_ALPHA_OP==1)
{
color.w=arg1.w+arg2.w;
}
#else
{
#if (STAGE3_ALPHA_OP==2)
{
color.w=arg1.w-arg2.w;
}
#else
{
#if (STAGE3_ALPHA_OP==3)
{
color.w=arg1.w*arg2.w;
}
#else
{
#if (STAGE3_ALPHA_OP==4)
{
color.w=arg1.w*arg2.w;
color.w+=color.w;
}
#else
{
color.w=arg1.w*arg2.w;
color.w*=4.0;
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
bool _3678;
#if (ALPHATEST)
{
_3678=color.w==0.0;
}
#else
{
_3678=(int(ALPHATEST)!=0);
}
#endif
if (_3678)
{
discard_fragment();
}
float4 param_48=color;
sc_writeFragData0(param_48,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
