#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include "std2_vs.metal"
#include "std2_fs.metal"
#include "std2_texture.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN(100)
//SG_REFLECTION_END


struct UserUniforms
{
float4 segmentationMaskSize;
float4 segmentationMaskDims;
float4 segmentationMaskView;
float3x3 segmentationMaskTransform;
float4 segmentationMaskUvMinMax;
float4 segmentationMaskBorderColor;
float4 mainTextureSize;
float4 mainTextureDims;
float4 mainTextureView;
float3x3 mainTextureTransform;
float4 mainTextureUvMinMax;
float4 mainTextureBorderColor;
};

#ifndef segmentationMaskHasSwappedViews
#define segmentationMaskHasSwappedViews 0
#elif segmentationMaskHasSwappedViews==1
#undef segmentationMaskHasSwappedViews
#define segmentationMaskHasSwappedViews 1
#endif
#ifndef segmentationMaskLayout
#define segmentationMaskLayout 0
#endif
#ifndef mainTextureHasSwappedViews
#define mainTextureHasSwappedViews 0
#elif mainTextureHasSwappedViews==1
#undef mainTextureHasSwappedViews
#define mainTextureHasSwappedViews 1
#endif
#ifndef mainTextureLayout
#define mainTextureLayout 0
#endif
#ifndef RG_RB_GB
#define RG_RB_GB 0
#elif RG_RB_GB==1
#undef RG_RB_GB
#define RG_RB_GB 1
#endif
#ifndef RR_GG_BB
#define RR_GG_BB 0
#elif RR_GG_BB==1
#undef RR_GG_BB
#define RR_GG_BB 1
#endif
#ifndef R_G_B
#define R_G_B 0
#elif R_G_B==1
#undef R_G_B
#define R_G_B 1
#endif
#ifndef RY_GY_BY_Y
#define RY_GY_BY_Y 0
#elif RY_GY_BY_Y==1
#undef RY_GY_BY_Y
#define RY_GY_BY_Y 1
#endif
#ifndef GRAY_SCALE
#define GRAY_SCALE 0
#elif GRAY_SCALE==1
#undef GRAY_SCALE
#define GRAY_SCALE 1
#endif
#ifndef segmentationMaskUV
#define segmentationMaskUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_segmentationMask
#define SC_USE_UV_TRANSFORM_segmentationMask 0
#elif SC_USE_UV_TRANSFORM_segmentationMask==1
#undef SC_USE_UV_TRANSFORM_segmentationMask
#define SC_USE_UV_TRANSFORM_segmentationMask 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_segmentationMask
#define SC_SOFTWARE_WRAP_MODE_U_segmentationMask -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_segmentationMask
#define SC_SOFTWARE_WRAP_MODE_V_segmentationMask -1
#endif
#ifndef SC_USE_UV_MIN_MAX_segmentationMask
#define SC_USE_UV_MIN_MAX_segmentationMask 0
#elif SC_USE_UV_MIN_MAX_segmentationMask==1
#undef SC_USE_UV_MIN_MAX_segmentationMask
#define SC_USE_UV_MIN_MAX_segmentationMask 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_segmentationMask
#define SC_USE_CLAMP_TO_BORDER_segmentationMask 0
#elif SC_USE_CLAMP_TO_BORDER_segmentationMask==1
#undef SC_USE_CLAMP_TO_BORDER_segmentationMask
#define SC_USE_CLAMP_TO_BORDER_segmentationMask 1
#endif
#ifndef mainTextureUV
#define mainTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_mainTexture
#define SC_USE_UV_TRANSFORM_mainTexture 0
#elif SC_USE_UV_TRANSFORM_mainTexture==1
#undef SC_USE_UV_TRANSFORM_mainTexture
#define SC_USE_UV_TRANSFORM_mainTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_mainTexture
#define SC_SOFTWARE_WRAP_MODE_U_mainTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_mainTexture
#define SC_SOFTWARE_WRAP_MODE_V_mainTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_mainTexture
#define SC_USE_UV_MIN_MAX_mainTexture 0
#elif SC_USE_UV_MIN_MAX_mainTexture==1
#undef SC_USE_UV_MIN_MAX_mainTexture
#define SC_USE_UV_MIN_MAX_mainTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_mainTexture
#define SC_USE_CLAMP_TO_BORDER_mainTexture 0
#elif SC_USE_CLAMP_TO_BORDER_mainTexture==1
#undef SC_USE_CLAMP_TO_BORDER_mainTexture
#define SC_USE_CLAMP_TO_BORDER_mainTexture 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant LibraryUniforms& libraryUniformsObj,uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
float2 texPos=(v.position.xy*0.5)+float2(0.5);
float2 _2662=float2(texPos.x,1.0-texPos.y);
out.varPackedTex=float4(out.varPackedTex.x,out.varPackedTex.y,_2662.x,_2662.y);
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN(100)
//sampler sampler segmentationMaskSmpSC 0:52186
//sampler sampler mainTextureSmpSC 0:43517
//texture texture2D segmentationMask 0:39540:0:52186
//texture texture2D mainTexture 0:61325:0:43517
//ubo float UserUniforms 0:35568:256 {
//float4 segmentationMaskSize 0
//float4 segmentationMaskDims 16
//float4 segmentationMaskView 32
//float3x3 segmentationMaskTransform 48
//float4 segmentationMaskUvMinMax 96
//float4 segmentationMaskBorderColor 112
//float4 mainTextureSize 128
//float4 mainTextureDims 144
//float4 mainTextureView 160
//float3x3 mainTextureTransform 176
//float4 mainTextureUvMinMax 224
//float4 mainTextureBorderColor 240
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 segmentationMaskSize;
float4 segmentationMaskDims;
float4 segmentationMaskView;
float3x3 segmentationMaskTransform;
float4 segmentationMaskUvMinMax;
float4 segmentationMaskBorderColor;
float4 mainTextureSize;
float4 mainTextureDims;
float4 mainTextureView;
float3x3 mainTextureTransform;
float4 mainTextureUvMinMax;
float4 mainTextureBorderColor;
};

#ifndef segmentationMaskHasSwappedViews
#define segmentationMaskHasSwappedViews 0
#elif segmentationMaskHasSwappedViews==1
#undef segmentationMaskHasSwappedViews
#define segmentationMaskHasSwappedViews 1
#endif
#ifndef segmentationMaskLayout
#define segmentationMaskLayout 0
#endif
#ifndef mainTextureHasSwappedViews
#define mainTextureHasSwappedViews 0
#elif mainTextureHasSwappedViews==1
#undef mainTextureHasSwappedViews
#define mainTextureHasSwappedViews 1
#endif
#ifndef mainTextureLayout
#define mainTextureLayout 0
#endif
#ifndef SC_USE_UV_TRANSFORM_mainTexture
#define SC_USE_UV_TRANSFORM_mainTexture 0
#elif SC_USE_UV_TRANSFORM_mainTexture==1
#undef SC_USE_UV_TRANSFORM_mainTexture
#define SC_USE_UV_TRANSFORM_mainTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_mainTexture
#define SC_SOFTWARE_WRAP_MODE_U_mainTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_mainTexture
#define SC_SOFTWARE_WRAP_MODE_V_mainTexture -1
#endif
constant int2 _2307=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
#ifndef SC_USE_UV_MIN_MAX_mainTexture
#define SC_USE_UV_MIN_MAX_mainTexture 0
#elif SC_USE_UV_MIN_MAX_mainTexture==1
#undef SC_USE_UV_MIN_MAX_mainTexture
#define SC_USE_UV_MIN_MAX_mainTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_mainTexture
#define SC_USE_CLAMP_TO_BORDER_mainTexture 0
#elif SC_USE_CLAMP_TO_BORDER_mainTexture==1
#undef SC_USE_CLAMP_TO_BORDER_mainTexture
#define SC_USE_CLAMP_TO_BORDER_mainTexture 1
#endif
#ifndef GRAY_SCALE
#define GRAY_SCALE 0
#elif GRAY_SCALE==1
#undef GRAY_SCALE
#define GRAY_SCALE 1
#endif
#ifndef RG_RB_GB
#define RG_RB_GB 0
#elif RG_RB_GB==1
#undef RG_RB_GB
#define RG_RB_GB 1
#endif
#ifndef RR_GG_BB
#define RR_GG_BB 0
#elif RR_GG_BB==1
#undef RR_GG_BB
#define RR_GG_BB 1
#endif
#ifndef R_G_B
#define R_G_B 0
#elif R_G_B==1
#undef R_G_B
#define R_G_B 1
#endif
#ifndef RY_GY_BY_Y
#define RY_GY_BY_Y 0
#elif RY_GY_BY_Y==1
#undef RY_GY_BY_Y
#define RY_GY_BY_Y 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_segmentationMask
#define SC_SOFTWARE_WRAP_MODE_U_segmentationMask -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_segmentationMask
#define SC_SOFTWARE_WRAP_MODE_V_segmentationMask -1
#endif
constant int2 _2390=int2(SC_SOFTWARE_WRAP_MODE_U_segmentationMask,SC_SOFTWARE_WRAP_MODE_V_segmentationMask);
#ifndef SC_USE_UV_MIN_MAX_segmentationMask
#define SC_USE_UV_MIN_MAX_segmentationMask 0
#elif SC_USE_UV_MIN_MAX_segmentationMask==1
#undef SC_USE_UV_MIN_MAX_segmentationMask
#define SC_USE_UV_MIN_MAX_segmentationMask 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_segmentationMask
#define SC_USE_CLAMP_TO_BORDER_segmentationMask 0
#elif SC_USE_CLAMP_TO_BORDER_segmentationMask==1
#undef SC_USE_CLAMP_TO_BORDER_segmentationMask
#define SC_USE_CLAMP_TO_BORDER_segmentationMask 1
#endif
constant int2 _2432=int2(SC_SOFTWARE_WRAP_MODE_U_segmentationMask,SC_SOFTWARE_WRAP_MODE_V_segmentationMask);
#ifndef segmentationMaskUV
#define segmentationMaskUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_segmentationMask
#define SC_USE_UV_TRANSFORM_segmentationMask 0
#elif SC_USE_UV_TRANSFORM_segmentationMask==1
#undef SC_USE_UV_TRANSFORM_segmentationMask
#define SC_USE_UV_TRANSFORM_segmentationMask 1
#endif
#ifndef mainTextureUV
#define mainTextureUV 0
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float4 varPackedTex [[user(locn6)]];
};

float2 mainTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.mainTextureDims.xy;
}

int mainTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (mainTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float grayscale(thread const float3& color)
{
return dot(color,float3(0.2126,0.7152,0.0722));
}

float2 segmentationMaskGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.segmentationMaskDims.xy;
}

int segmentationMaskGetStereoViewIndex(thread int& varStereoViewID)
{
#if (segmentationMaskHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj,texture2d<float> segmentationMask,texture2d<float> mainTexture,sampler mainTextureSmpSC,sampler segmentationMaskSmpSC,float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float2 param=in.varPackedTex.xy;
float2 param_1=mainTextureGetDims2D(userUniformsObj);
int param_2=mainTextureLayout;
int param_3=mainTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_4=sc_PlatformFlipUV(param);
bool param_5=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_6=userUniformsObj.mainTextureTransform;
int2 param_7=_2307;
bool param_8=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_9=userUniformsObj.mainTextureUvMinMax;
bool param_10=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_11=userUniformsObj.mainTextureBorderColor;
float param_12=0.0;
float4 _2331=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11,param_12);
float4 _2295=_2331;
float4 mainTextureSample=_2331;
float3 color=mainTextureSample.xyz;
float4 result=float4(0.0);
#if (GRAY_SCALE)
{
float3 param_13=color;
color=float3(grayscale(param_13));
}
#endif
#if (RG_RB_GB)
{
result=float4(color.xxy*color.yzz,1.0);
}
#else
{
#if (RR_GG_BB)
{
result=float4(color*color,1.0);
}
#else
{
#if (R_G_B)
{
result=float4(color,1.0);
}
#else
{
#if (RY_GY_BY_Y)
{
float2 param_14=segmentationMaskGetDims2D(userUniformsObj);
int param_15=segmentationMaskLayout;
int param_16=segmentationMaskGetStereoViewIndex(in.varStereoViewID);
float2 param_17=in.varPackedTex.zw;
bool param_18=false;
float3x3 param_19=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_20=_2390;
bool param_21=(int(SC_USE_UV_MIN_MAX_segmentationMask)!=0);
float4 param_22=userUniformsObj.segmentationMaskUvMinMax;
bool param_23=(int(SC_USE_CLAMP_TO_BORDER_segmentationMask)!=0);
float4 param_24=userUniformsObj.segmentationMaskBorderColor;
float param_25=0.0;
float4 _2413=sc_SampleTextureBiasOrLevel(segmentationMask,segmentationMaskSmpSC,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23,param_24,param_25);
float4 _2380=_2413;
float4 segmentationMaskSample=_2413;
float mask=segmentationMaskSample.x;
result=float4(color*mask,mask);
}
#else
{
#if (GRAY_SCALE)
{
float2 param_26=segmentationMaskGetDims2D(userUniformsObj);
int param_27=segmentationMaskLayout;
int param_28=segmentationMaskGetStereoViewIndex(in.varStereoViewID);
float2 param_29=in.varPackedTex.zw;
bool param_30=false;
float3x3 param_31=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_32=_2432;
bool param_33=(int(SC_USE_UV_MIN_MAX_segmentationMask)!=0);
float4 param_34=userUniformsObj.segmentationMaskUvMinMax;
bool param_35=(int(SC_USE_CLAMP_TO_BORDER_segmentationMask)!=0);
float4 param_36=userUniformsObj.segmentationMaskBorderColor;
float param_37=0.0;
float4 _2451=sc_SampleTextureBiasOrLevel(segmentationMask,segmentationMaskSmpSC,param_26,param_27,param_28,param_29,param_30,param_31,param_32,param_33,param_34,param_35,param_36,param_37);
float4 _2429=_2451;
float4 segmentationMaskSample_1=_2451;
float mask_1=segmentationMaskSample_1.x;
result=float4(color.x,mask_1,color.x*mask_1,color.x*color.x);
}
#else
{
result=float4(1.0,0.0,1.0,1.0);
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
float4 param_38=result;
sc_writeFragData0(param_38,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
