#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE0 1

#include "std2.metal"
#include "std2_vs.metal"
#include "std2_fs.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN(100)
//SG_REFLECTION_END


struct UserUniforms
{
float4 lookupTextureSize;
float4 lookupTextureDims;
float4 lookupTextureView;
float3x3 lookupTextureTransform;
float4 lookupTextureUvMinMax;
float4 lookupTextureBorderColor;
float4 maskTextureSize;
float4 maskTextureDims;
float4 maskTextureView;
float3x3 maskTextureTransform;
float4 maskTextureUvMinMax;
float4 maskTextureBorderColor;
float softSkinRadius;
float softSkinIntensity;
float teethWhiteningIntensity;
float eyeWhiteningIntensity;
float sharpenEyeIntensity;
};

#ifndef lookupTextureHasSwappedViews
#define lookupTextureHasSwappedViews 0
#elif lookupTextureHasSwappedViews==1
#undef lookupTextureHasSwappedViews
#define lookupTextureHasSwappedViews 1
#endif
#ifndef lookupTextureLayout
#define lookupTextureLayout 0
#endif
#ifndef maskTextureHasSwappedViews
#define maskTextureHasSwappedViews 0
#elif maskTextureHasSwappedViews==1
#undef maskTextureHasSwappedViews
#define maskTextureHasSwappedViews 1
#endif
#ifndef maskTextureLayout
#define maskTextureLayout 0
#endif
#ifndef SOFT_SKIN
#define SOFT_SKIN 0
#elif SOFT_SKIN==1
#undef SOFT_SKIN
#define SOFT_SKIN 1
#endif
#ifndef EYE_SHARPEN
#define EYE_SHARPEN 0
#elif EYE_SHARPEN==1
#undef EYE_SHARPEN
#define EYE_SHARPEN 1
#endif
#ifndef EYE_WHITENING
#define EYE_WHITENING 0
#elif EYE_WHITENING==1
#undef EYE_WHITENING
#define EYE_WHITENING 1
#endif
#ifndef TEETH_WHITENING
#define TEETH_WHITENING 0
#elif TEETH_WHITENING==1
#undef TEETH_WHITENING
#define TEETH_WHITENING 1
#endif
#ifndef ADD_NOISE
#define ADD_NOISE 1
#elif ADD_NOISE==1
#undef ADD_NOISE
#define ADD_NOISE 1
#endif
#ifndef lookupTextureUV
#define lookupTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_lookupTexture
#define SC_USE_UV_TRANSFORM_lookupTexture 0
#elif SC_USE_UV_TRANSFORM_lookupTexture==1
#undef SC_USE_UV_TRANSFORM_lookupTexture
#define SC_USE_UV_TRANSFORM_lookupTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_lookupTexture
#define SC_SOFTWARE_WRAP_MODE_U_lookupTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_lookupTexture
#define SC_SOFTWARE_WRAP_MODE_V_lookupTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_lookupTexture
#define SC_USE_UV_MIN_MAX_lookupTexture 0
#elif SC_USE_UV_MIN_MAX_lookupTexture==1
#undef SC_USE_UV_MIN_MAX_lookupTexture
#define SC_USE_UV_MIN_MAX_lookupTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_lookupTexture
#define SC_USE_CLAMP_TO_BORDER_lookupTexture 0
#elif SC_USE_CLAMP_TO_BORDER_lookupTexture==1
#undef SC_USE_CLAMP_TO_BORDER_lookupTexture
#define SC_USE_CLAMP_TO_BORDER_lookupTexture 1
#endif
#ifndef maskTextureUV
#define maskTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_maskTexture
#define SC_USE_UV_TRANSFORM_maskTexture 0
#elif SC_USE_UV_TRANSFORM_maskTexture==1
#undef SC_USE_UV_TRANSFORM_maskTexture
#define SC_USE_UV_TRANSFORM_maskTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_maskTexture
#define SC_SOFTWARE_WRAP_MODE_U_maskTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_maskTexture
#define SC_SOFTWARE_WRAP_MODE_V_maskTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_maskTexture
#define SC_USE_UV_MIN_MAX_maskTexture 0
#elif SC_USE_UV_MIN_MAX_maskTexture==1
#undef SC_USE_UV_MIN_MAX_maskTexture
#define SC_USE_UV_MIN_MAX_maskTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_maskTexture
#define SC_USE_CLAMP_TO_BORDER_maskTexture 0
#elif SC_USE_CLAMP_TO_BORDER_maskTexture==1
#undef SC_USE_CLAMP_TO_BORDER_maskTexture
#define SC_USE_CLAMP_TO_BORDER_maskTexture 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float4 varCustomTex0 [[user(locn10)]];
float4 varCustomTex1 [[user(locn11)]];
float4 varCustomTex2 [[user(locn12)]];
float4 varCustomTex3 [[user(locn13)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant LibraryUniforms& libraryUniformsObj,uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
float2 _2658=((v.position.xy/float2(v.position.w))*0.5)+float2(0.5);
out.varPackedTex=float4(_2658.x,_2658.y,out.varPackedTex.z,out.varPackedTex.w);
#if (SOFT_SKIN)
{
float2 _2670=out.varPackedTex.xy+float2(-0.00694444,-0.00390625);
out.varCustomTex0=float4(_2670.x,_2670.y,out.varCustomTex0.z,out.varCustomTex0.w);
float2 _2678=out.varPackedTex.xy+float2(-0.00694444,0.00546875);
out.varCustomTex1=float4(_2678.x,_2678.y,out.varCustomTex1.z,out.varCustomTex1.w);
float2 _2686=out.varPackedTex.xy+float2(0.00972222,-0.00390625);
out.varCustomTex2=float4(_2686.x,_2686.y,out.varCustomTex2.z,out.varCustomTex2.w);
float2 _2693=out.varPackedTex.xy+float2(0.00972222,0.00546875);
out.varCustomTex3=float4(_2693.x,_2693.y,out.varCustomTex3.z,out.varCustomTex3.w);
}
#endif
#if (EYE_SHARPEN)
{
float2 delta=float2(libraryUniformsObj.sc_Camera.aspect/1280.0,0.00078125);
float2 _2715=out.varPackedTex.xy+float2(-delta.x,-delta.y);
out.varCustomTex0=float4(out.varCustomTex0.x,out.varCustomTex0.y,_2715.x,_2715.y);
float2 _2726=out.varPackedTex.xy+float2(delta.x,-delta.y);
out.varCustomTex1=float4(out.varCustomTex1.x,out.varCustomTex1.y,_2726.x,_2726.y);
float2 _2737=out.varPackedTex.xy+float2(-delta.x,delta.y);
out.varCustomTex2=float4(out.varCustomTex2.x,out.varCustomTex2.y,_2737.x,_2737.y);
float2 _2747=out.varPackedTex.xy+float2(delta.x,delta.y);
out.varCustomTex3=float4(out.varCustomTex3.x,out.varCustomTex3.y,_2747.x,_2747.y);
}
#endif
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN(100)
//sampler sampler lookupTextureSmpSC 0:51753
//sampler sampler maskTextureSmpSC 0:35243
//texture texture2D lookupTexture 0:48377:0:51753
//texture texture2D maskTexture 0:38610:0:35243
//ubo float UserUniforms 0:35568:276 {
//float4 lookupTextureSize 0
//float4 lookupTextureDims 16
//float4 lookupTextureView 32
//float3x3 lookupTextureTransform 48
//float4 lookupTextureUvMinMax 96
//float4 lookupTextureBorderColor 112
//float4 maskTextureSize 128
//float4 maskTextureDims 144
//float4 maskTextureView 160
//float3x3 maskTextureTransform 176
//float4 maskTextureUvMinMax 224
//float4 maskTextureBorderColor 240
//float softSkinRadius 256
//float softSkinIntensity 260
//float teethWhiteningIntensity 264
//float eyeWhiteningIntensity 268
//float sharpenEyeIntensity 272
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 lookupTextureSize;
float4 lookupTextureDims;
float4 lookupTextureView;
float3x3 lookupTextureTransform;
float4 lookupTextureUvMinMax;
float4 lookupTextureBorderColor;
float4 maskTextureSize;
float4 maskTextureDims;
float4 maskTextureView;
float3x3 maskTextureTransform;
float4 maskTextureUvMinMax;
float4 maskTextureBorderColor;
float softSkinRadius;
float softSkinIntensity;
float teethWhiteningIntensity;
float eyeWhiteningIntensity;
float sharpenEyeIntensity;
};

#ifndef lookupTextureHasSwappedViews
#define lookupTextureHasSwappedViews 0
#elif lookupTextureHasSwappedViews==1
#undef lookupTextureHasSwappedViews
#define lookupTextureHasSwappedViews 1
#endif
#ifndef lookupTextureLayout
#define lookupTextureLayout 0
#endif
#ifndef maskTextureHasSwappedViews
#define maskTextureHasSwappedViews 0
#elif maskTextureHasSwappedViews==1
#undef maskTextureHasSwappedViews
#define maskTextureHasSwappedViews 1
#endif
#ifndef maskTextureLayout
#define maskTextureLayout 0
#endif
#ifndef SC_USE_UV_TRANSFORM_lookupTexture
#define SC_USE_UV_TRANSFORM_lookupTexture 0
#elif SC_USE_UV_TRANSFORM_lookupTexture==1
#undef SC_USE_UV_TRANSFORM_lookupTexture
#define SC_USE_UV_TRANSFORM_lookupTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_lookupTexture
#define SC_SOFTWARE_WRAP_MODE_U_lookupTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_lookupTexture
#define SC_SOFTWARE_WRAP_MODE_V_lookupTexture -1
#endif
constant int2 _2383=int2(SC_SOFTWARE_WRAP_MODE_U_lookupTexture,SC_SOFTWARE_WRAP_MODE_V_lookupTexture);
#ifndef SC_USE_UV_MIN_MAX_lookupTexture
#define SC_USE_UV_MIN_MAX_lookupTexture 0
#elif SC_USE_UV_MIN_MAX_lookupTexture==1
#undef SC_USE_UV_MIN_MAX_lookupTexture
#define SC_USE_UV_MIN_MAX_lookupTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_lookupTexture
#define SC_USE_CLAMP_TO_BORDER_lookupTexture 0
#elif SC_USE_CLAMP_TO_BORDER_lookupTexture==1
#undef SC_USE_CLAMP_TO_BORDER_lookupTexture
#define SC_USE_CLAMP_TO_BORDER_lookupTexture 1
#endif
constant int2 _2421=int2(SC_SOFTWARE_WRAP_MODE_U_lookupTexture,SC_SOFTWARE_WRAP_MODE_V_lookupTexture);
#ifndef ADD_NOISE
#define ADD_NOISE 1
#elif ADD_NOISE==1
#undef ADD_NOISE
#define ADD_NOISE 1
#endif
#ifndef SC_USE_UV_TRANSFORM_maskTexture
#define SC_USE_UV_TRANSFORM_maskTexture 0
#elif SC_USE_UV_TRANSFORM_maskTexture==1
#undef SC_USE_UV_TRANSFORM_maskTexture
#define SC_USE_UV_TRANSFORM_maskTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_maskTexture
#define SC_SOFTWARE_WRAP_MODE_U_maskTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_maskTexture
#define SC_SOFTWARE_WRAP_MODE_V_maskTexture -1
#endif
constant int2 _2658=int2(SC_SOFTWARE_WRAP_MODE_U_maskTexture,SC_SOFTWARE_WRAP_MODE_V_maskTexture);
#ifndef SC_USE_UV_MIN_MAX_maskTexture
#define SC_USE_UV_MIN_MAX_maskTexture 0
#elif SC_USE_UV_MIN_MAX_maskTexture==1
#undef SC_USE_UV_MIN_MAX_maskTexture
#define SC_USE_UV_MIN_MAX_maskTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_maskTexture
#define SC_USE_CLAMP_TO_BORDER_maskTexture 0
#elif SC_USE_CLAMP_TO_BORDER_maskTexture==1
#undef SC_USE_CLAMP_TO_BORDER_maskTexture
#define SC_USE_CLAMP_TO_BORDER_maskTexture 1
#endif
#ifndef SOFT_SKIN
#define SOFT_SKIN 0
#elif SOFT_SKIN==1
#undef SOFT_SKIN
#define SOFT_SKIN 1
#endif
#ifndef EYE_SHARPEN
#define EYE_SHARPEN 0
#elif EYE_SHARPEN==1
#undef EYE_SHARPEN
#define EYE_SHARPEN 1
#endif
#ifndef EYE_WHITENING
#define EYE_WHITENING 0
#elif EYE_WHITENING==1
#undef EYE_WHITENING
#define EYE_WHITENING 1
#endif
#ifndef TEETH_WHITENING
#define TEETH_WHITENING 0
#elif TEETH_WHITENING==1
#undef TEETH_WHITENING
#define TEETH_WHITENING 1
#endif
#ifndef lookupTextureUV
#define lookupTextureUV 0
#endif
#ifndef maskTextureUV
#define maskTextureUV 0
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float4 varPackedTex [[user(locn6)]];
float4 varCustomTex0 [[user(locn10)]];
float4 varCustomTex1 [[user(locn11)]];
float4 varCustomTex2 [[user(locn12)]];
float4 varCustomTex3 [[user(locn13)]];
};

float2 maskTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.maskTextureDims.xy;
}

int maskTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (maskTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float getLuminance(thread const float4& color)
{
return dot(color,float4(0.299,0.587,0.114,0.0));
}

float4 getLuminance4(thread const float4x4& color)
{
return float4(0.299,0.587,0.114,0.0)*color;
}

float4 getWeight(thread const float& intens,thread const float4& nextIntens,constant UserUniforms& userUniformsObj)
{
float4 lg=log(nextIntens/float4(intens+1e-06));
lg*=lg;
return exp(lg*((-1.0)/((2.0*userUniformsObj.softSkinRadius)*userUniformsObj.softSkinRadius)));
}

float rand(thread const float2& co)
{
return fract(sin(dot(co,float2(12.9898,78.233)))*43758.5);
}

float4 softSkin(thread const float4& originalColor,thread const float& factor,thread int& varStereoViewID,constant LibraryUniforms& libraryUniformsObj,thread texture2d<float> sc_ScreenTexture,thread sampler sc_ScreenTextureSmpSC,constant UserUniforms& userUniformsObj,thread float4& varCustomTex0,thread float4& varCustomTex1,thread float4& varCustomTex2,thread float4& varCustomTex3,thread float4& varPackedTex)
{
float4 screenColor=originalColor;
float4 param=screenColor;
float intens=getLuminance(param);
float sum=1.0;
float2 param_1=varCustomTex0.xy;
float4x4 nextColor;
nextColor[0]=sc_ScreenTextureSampleView(param_1,varStereoViewID,libraryUniformsObj,sc_ScreenTexture,sc_ScreenTextureSmpSC);
float2 param_2=varCustomTex1.xy;
nextColor[1]=sc_ScreenTextureSampleView(param_2,varStereoViewID,libraryUniformsObj,sc_ScreenTexture,sc_ScreenTextureSmpSC);
float2 param_3=varCustomTex2.xy;
nextColor[2]=sc_ScreenTextureSampleView(param_3,varStereoViewID,libraryUniformsObj,sc_ScreenTexture,sc_ScreenTextureSmpSC);
float2 param_4=varCustomTex3.xy;
nextColor[3]=sc_ScreenTextureSampleView(param_4,varStereoViewID,libraryUniformsObj,sc_ScreenTexture,sc_ScreenTextureSmpSC);
float4x4 param_5=nextColor;
float4 nextIntens=getLuminance4(param_5);
float param_6=intens;
float4 param_7=nextIntens;
float4 curr=getWeight(param_6,param_7,userUniformsObj)*0.367879;
sum+=dot(curr,float4(1.0));
screenColor+=(nextColor*curr);
#if (ADD_NOISE)
{
float2 param_8=varPackedTex.xy;
float _noise=(rand(param_8)-0.5)/30.0;
screenColor=(screenColor/float4(sum))+float4(_noise,_noise,_noise,1.0);
}
#else
{
screenColor/=float4(sum);
}
#endif
screenColor=mix(originalColor,screenColor,float4(factor));
return screenColor;
}

float4 sharpen(thread const float4& originalColor,thread const float& factor,thread int& varStereoViewID,constant LibraryUniforms& libraryUniformsObj,thread texture2d<float> sc_ScreenTexture,thread sampler sc_ScreenTextureSmpSC,thread float4& varCustomTex0,thread float4& varCustomTex1,thread float4& varCustomTex2,thread float4& varCustomTex3)
{
float4 accum=originalColor*5.0;
float2 param=varCustomTex0.zw;
accum-=sc_ScreenTextureSampleView(param,varStereoViewID,libraryUniformsObj,sc_ScreenTexture,sc_ScreenTextureSmpSC);
float2 param_1=varCustomTex1.zw;
accum-=sc_ScreenTextureSampleView(param_1,varStereoViewID,libraryUniformsObj,sc_ScreenTexture,sc_ScreenTextureSmpSC);
float2 param_2=varCustomTex2.zw;
accum-=sc_ScreenTextureSampleView(param_2,varStereoViewID,libraryUniformsObj,sc_ScreenTexture,sc_ScreenTextureSmpSC);
float2 param_3=varCustomTex3.zw;
accum-=sc_ScreenTextureSampleView(param_3,varStereoViewID,libraryUniformsObj,sc_ScreenTexture,sc_ScreenTextureSmpSC);
float4 result=mix(originalColor,accum,float4(factor));
return fast::clamp(result,float4(0.0),float4(1.0));
}

float2 lookupTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.lookupTextureDims.xy;
}

int lookupTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (lookupTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float4 mapColor(thread const float4& orgColor,thread int& varStereoViewID,constant UserUniforms& userUniformsObj,thread texture2d<float> lookupTexture,thread sampler lookupTextureSmpSC)
{
float bValue=(orgColor.z*255.0)/4.0;
float2 mulB=fast::clamp(float2(floor(bValue))+float2(0.0,1.0),float2(0.0),float2(63.0));
float2 row=floor((mulB/float2(8.0))+float2(1e-06));
float4 row_col=float4(row,mulB-(row*8.0));
float4 lookup=((orgColor.yyxx*0.123047)+(row_col*0.125))+float4(0.000976562);
float b1w=bValue-mulB.x;
float3 sampled1=float3(0.0);
float2 param=lookupTextureGetDims2D(userUniformsObj);
int param_1=lookupTextureLayout;
int param_2=lookupTextureGetStereoViewIndex(varStereoViewID);
float2 param_3=float2(lookup.z,1.0-lookup.x);
bool param_4=(int(SC_USE_UV_TRANSFORM_lookupTexture)!=0);
float3x3 param_5=userUniformsObj.lookupTextureTransform;
int2 param_6=_2383;
bool param_7=(int(SC_USE_UV_MIN_MAX_lookupTexture)!=0);
float4 param_8=userUniformsObj.lookupTextureUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_lookupTexture)!=0);
float4 param_10=userUniformsObj.lookupTextureBorderColor;
float param_11=0.0;
float4 _2407=sc_SampleTextureBiasOrLevel(lookupTexture,lookupTextureSmpSC,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
float4 _2371=_2407;
float4 lookupTextureSample=_2407;
sampled1=lookupTextureSample.xyz;
float3 sampled2=float3(0.0);
float2 param_12=lookupTextureGetDims2D(userUniformsObj);
int param_13=lookupTextureLayout;
int param_14=lookupTextureGetStereoViewIndex(varStereoViewID);
float2 param_15=float2(lookup.w,1.0-lookup.y);
bool param_16=(int(SC_USE_UV_TRANSFORM_lookupTexture)!=0);
float3x3 param_17=userUniformsObj.lookupTextureTransform;
int2 param_18=_2421;
bool param_19=(int(SC_USE_UV_MIN_MAX_lookupTexture)!=0);
float4 param_20=userUniformsObj.lookupTextureUvMinMax;
bool param_21=(int(SC_USE_CLAMP_TO_BORDER_lookupTexture)!=0);
float4 param_22=userUniformsObj.lookupTextureBorderColor;
float param_23=0.0;
float4 _2440=sc_SampleTextureBiasOrLevel(lookupTexture,lookupTextureSmpSC,param_12,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23);
float4 _2412=_2440;
float4 lookupTextureSample_1=_2440;
sampled2=lookupTextureSample_1.xyz;
float3 res=mix(sampled1,sampled2,float3(b1w));
return float4(res,orgColor.w);
}

float4 whitening(thread const float4& originalColor,thread const float& factor,thread int& varStereoViewID,constant UserUniforms& userUniformsObj,thread texture2d<float> lookupTexture,thread sampler lookupTextureSmpSC)
{
float4 param=originalColor;
float4 color=mapColor(param,varStereoViewID,userUniformsObj,lookupTexture,lookupTextureSmpSC);
return mix(originalColor,color,float4(factor));
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj,constant LibraryUniforms& libraryUniformsObj,texture2d<float> sc_ScreenTexture,texture2d<float> maskTexture,texture2d<float> lookupTexture,sampler sc_ScreenTextureSmpSC,sampler maskTextureSmpSC,sampler lookupTextureSmpSC,float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float4 originalColor=getFramebufferColor(in.varStereoViewID,libraryUniformsObj,sc_ScreenTexture,sc_ScreenTextureSmpSC,FragColor,gl_FragCoord);
float4 res=originalColor;
float4 maskColor=float4(0.0);
float whiteningAlpha=0.0;
float2 param=maskTextureGetDims2D(userUniformsObj);
int param_1=maskTextureLayout;
int param_2=maskTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_3=in.varPackedTex.zw;
bool param_4=(int(SC_USE_UV_TRANSFORM_maskTexture)!=0);
float3x3 param_5=userUniformsObj.maskTextureTransform;
int2 param_6=_2658;
bool param_7=(int(SC_USE_UV_MIN_MAX_maskTexture)!=0);
float4 param_8=userUniformsObj.maskTextureUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_maskTexture)!=0);
float4 param_10=userUniformsObj.maskTextureBorderColor;
float param_11=0.0;
float4 _2683=sc_SampleTextureBiasOrLevel(maskTexture,maskTextureSmpSC,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
float4 _2651=_2683;
float4 maskTextureSample=_2683;
maskColor=maskTextureSample;
#if (SOFT_SKIN)
{
float4 param_12=res;
float param_13=maskColor.x*userUniformsObj.softSkinIntensity;
res=softSkin(param_12,param_13,in.varStereoViewID,libraryUniformsObj,sc_ScreenTexture,sc_ScreenTextureSmpSC,userUniformsObj,in.varCustomTex0,in.varCustomTex1,in.varCustomTex2,in.varCustomTex3,in.varPackedTex);
}
#endif
#if (EYE_SHARPEN)
{
float4 param_14=res;
float param_15=maskColor.z*userUniformsObj.sharpenEyeIntensity;
res=sharpen(param_14,param_15,in.varStereoViewID,libraryUniformsObj,sc_ScreenTexture,sc_ScreenTextureSmpSC,in.varCustomTex0,in.varCustomTex1,in.varCustomTex2,in.varCustomTex3);
}
#endif
#if (EYE_WHITENING)
{
whiteningAlpha+=(maskColor.z*userUniformsObj.eyeWhiteningIntensity);
}
#endif
#if (TEETH_WHITENING)
{
whiteningAlpha+=(maskColor.y*userUniformsObj.teethWhiteningIntensity);
}
#endif
#if (EYE_WHITENING||TEETH_WHITENING)
{
float4 param_16=res;
float param_17=whiteningAlpha;
res=whitening(param_16,param_17,in.varStereoViewID,userUniformsObj,lookupTexture,lookupTextureSmpSC);
}
#endif
float4 param_18=res;
sc_writeFragData0(param_18,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
