#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include "std2.metal"
#include "std2_fs.metal"
#include "std2_texture.metal"
#include "std2_vs.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN(100)
//ubo float UserUniforms 0:35568:512 {
//float4 inputTextureSize 0
//float4 inputTextureDims 16
//float4 inputTextureView 32
//float3x3 inputTextureTransform 48
//float4 inputTextureUvMinMax 96
//float4 inputTextureBorderColor 112
//float4 edgesTexSize 128
//float4 edgesTexDims 144
//float4 edgesTexView 160
//float3x3 edgesTexTransform 176
//float4 edgesTexUvMinMax 224
//float4 edgesTexBorderColor 240
//float4 areaTexSize 256
//float4 areaTexDims 272
//float4 areaTexView 288
//float3x3 areaTexTransform 304
//float4 areaTexUvMinMax 352
//float4 areaTexBorderColor 368
//float4 searchTexSize 384
//float4 searchTexDims 400
//float4 searchTexView 416
//float3x3 searchTexTransform 432
//float4 searchTexUvMinMax 480
//float4 searchTexBorderColor 496
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 inputTextureSize;
float4 inputTextureDims;
float4 inputTextureView;
float3x3 inputTextureTransform;
float4 inputTextureUvMinMax;
float4 inputTextureBorderColor;
float4 edgesTexSize;
float4 edgesTexDims;
float4 edgesTexView;
float3x3 edgesTexTransform;
float4 edgesTexUvMinMax;
float4 edgesTexBorderColor;
float4 areaTexSize;
float4 areaTexDims;
float4 areaTexView;
float3x3 areaTexTransform;
float4 areaTexUvMinMax;
float4 areaTexBorderColor;
float4 searchTexSize;
float4 searchTexDims;
float4 searchTexView;
float3x3 searchTexTransform;
float4 searchTexUvMinMax;
float4 searchTexBorderColor;
};

#ifndef inputTextureHasSwappedViews
#define inputTextureHasSwappedViews 0
#elif inputTextureHasSwappedViews==1
#undef inputTextureHasSwappedViews
#define inputTextureHasSwappedViews 1
#endif
#ifndef inputTextureLayout
#define inputTextureLayout 0
#endif
#ifndef edgesTexHasSwappedViews
#define edgesTexHasSwappedViews 0
#elif edgesTexHasSwappedViews==1
#undef edgesTexHasSwappedViews
#define edgesTexHasSwappedViews 1
#endif
#ifndef edgesTexLayout
#define edgesTexLayout 0
#endif
#ifndef areaTexHasSwappedViews
#define areaTexHasSwappedViews 0
#elif areaTexHasSwappedViews==1
#undef areaTexHasSwappedViews
#define areaTexHasSwappedViews 1
#endif
#ifndef areaTexLayout
#define areaTexLayout 0
#endif
#ifndef searchTexHasSwappedViews
#define searchTexHasSwappedViews 0
#elif searchTexHasSwappedViews==1
#undef searchTexHasSwappedViews
#define searchTexHasSwappedViews 1
#endif
#ifndef searchTexLayout
#define searchTexLayout 0
#endif
#ifndef SMAA_QUALITY
#define SMAA_QUALITY 0
#endif
#ifndef inputTextureUV
#define inputTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_inputTexture
#define SC_USE_UV_TRANSFORM_inputTexture 0
#elif SC_USE_UV_TRANSFORM_inputTexture==1
#undef SC_USE_UV_TRANSFORM_inputTexture
#define SC_USE_UV_TRANSFORM_inputTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_inputTexture
#define SC_SOFTWARE_WRAP_MODE_U_inputTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_inputTexture
#define SC_SOFTWARE_WRAP_MODE_V_inputTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_inputTexture
#define SC_USE_UV_MIN_MAX_inputTexture 0
#elif SC_USE_UV_MIN_MAX_inputTexture==1
#undef SC_USE_UV_MIN_MAX_inputTexture
#define SC_USE_UV_MIN_MAX_inputTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_inputTexture
#define SC_USE_CLAMP_TO_BORDER_inputTexture 0
#elif SC_USE_CLAMP_TO_BORDER_inputTexture==1
#undef SC_USE_CLAMP_TO_BORDER_inputTexture
#define SC_USE_CLAMP_TO_BORDER_inputTexture 1
#endif
#ifndef edgesTexUV
#define edgesTexUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_edgesTex
#define SC_USE_UV_TRANSFORM_edgesTex 0
#elif SC_USE_UV_TRANSFORM_edgesTex==1
#undef SC_USE_UV_TRANSFORM_edgesTex
#define SC_USE_UV_TRANSFORM_edgesTex 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_edgesTex
#define SC_SOFTWARE_WRAP_MODE_U_edgesTex -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_edgesTex
#define SC_SOFTWARE_WRAP_MODE_V_edgesTex -1
#endif
#ifndef SC_USE_UV_MIN_MAX_edgesTex
#define SC_USE_UV_MIN_MAX_edgesTex 0
#elif SC_USE_UV_MIN_MAX_edgesTex==1
#undef SC_USE_UV_MIN_MAX_edgesTex
#define SC_USE_UV_MIN_MAX_edgesTex 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_edgesTex
#define SC_USE_CLAMP_TO_BORDER_edgesTex 0
#elif SC_USE_CLAMP_TO_BORDER_edgesTex==1
#undef SC_USE_CLAMP_TO_BORDER_edgesTex
#define SC_USE_CLAMP_TO_BORDER_edgesTex 1
#endif
#ifndef areaTexUV
#define areaTexUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_areaTex
#define SC_USE_UV_TRANSFORM_areaTex 0
#elif SC_USE_UV_TRANSFORM_areaTex==1
#undef SC_USE_UV_TRANSFORM_areaTex
#define SC_USE_UV_TRANSFORM_areaTex 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_areaTex
#define SC_SOFTWARE_WRAP_MODE_U_areaTex -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_areaTex
#define SC_SOFTWARE_WRAP_MODE_V_areaTex -1
#endif
#ifndef SC_USE_UV_MIN_MAX_areaTex
#define SC_USE_UV_MIN_MAX_areaTex 0
#elif SC_USE_UV_MIN_MAX_areaTex==1
#undef SC_USE_UV_MIN_MAX_areaTex
#define SC_USE_UV_MIN_MAX_areaTex 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_areaTex
#define SC_USE_CLAMP_TO_BORDER_areaTex 0
#elif SC_USE_CLAMP_TO_BORDER_areaTex==1
#undef SC_USE_CLAMP_TO_BORDER_areaTex
#define SC_USE_CLAMP_TO_BORDER_areaTex 1
#endif
#ifndef searchTexUV
#define searchTexUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_searchTex
#define SC_USE_UV_TRANSFORM_searchTex 0
#elif SC_USE_UV_TRANSFORM_searchTex==1
#undef SC_USE_UV_TRANSFORM_searchTex
#define SC_USE_UV_TRANSFORM_searchTex 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_searchTex
#define SC_SOFTWARE_WRAP_MODE_U_searchTex -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_searchTex
#define SC_SOFTWARE_WRAP_MODE_V_searchTex -1
#endif
#ifndef SC_USE_UV_MIN_MAX_searchTex
#define SC_USE_UV_MIN_MAX_searchTex 0
#elif SC_USE_UV_MIN_MAX_searchTex==1
#undef SC_USE_UV_MIN_MAX_searchTex
#define SC_USE_UV_MIN_MAX_searchTex 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_searchTex
#define SC_USE_CLAMP_TO_BORDER_searchTex 0
#elif SC_USE_CLAMP_TO_BORDER_searchTex==1
#undef SC_USE_CLAMP_TO_BORDER_searchTex
#define SC_USE_CLAMP_TO_BORDER_searchTex 1
#endif
#ifndef DEBUG_MODE
#define DEBUG_MODE 0
#endif
#ifndef SMAA_AREATEX_MAX_DISTANCE
#define SMAA_AREATEX_MAX_DISTANCE 16
#endif
#ifndef SMAA_AREATEX_MAX_DISTANCE_DIAG
#define SMAA_AREATEX_MAX_DISTANCE_DIAG 20
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float4 varOffset0 [[user(locn10)]];
float4 varOffset1 [[user(locn11)]];
float4 varOffset2 [[user(locn12)]];
float2 varPixCoord [[user(locn13)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

int smaaMaxSearchSteps(thread const int& smaaQuality)
{
switch (smaaQuality)
{
case 0:
case 1:
{
return 0;
}
case 2:
case 3:
case 4:
{
return 25;
}
default:
{
return 0;
}
}
}

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant UserUniforms& userUniformsObj,constant LibraryUniforms& libraryUniformsObj,uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
float2 _3025=(v.position.xy*0.5)+float2(0.5);
out.varPackedTex=float4(_3025.x,_3025.y,out.varPackedTex.z,out.varPackedTex.w);
float4 smaaRTMetrics=float4(1.0/userUniformsObj.inputTextureSize.x,1.0/userUniformsObj.inputTextureSize.y,userUniformsObj.inputTextureSize.x,userUniformsObj.inputTextureSize.y);
out.varPixCoord=out.varPackedTex.xy*smaaRTMetrics.zw;
out.varOffset0=(smaaRTMetrics.xyxy*float4(-0.25,0.125,1.25,0.125))+out.varPackedTex.xyxy;
out.varOffset1=(smaaRTMetrics.xyxy*float4(-0.125,0.25,-0.125,-1.25))+out.varPackedTex.xyxy;
int param_1=SMAA_QUALITY;
out.varOffset2=((smaaRTMetrics.xxyy*float4(-2.0,2.0,2.0,-2.0))*float(smaaMaxSearchSteps(param_1)))+float4(out.varOffset0.xz,out.varOffset1.yw);
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN(100)
//sampler sampler inputTextureSmpSC 0:43245
//sampler sampler edgesTexSmpSC 0:54671
//sampler sampler areaTexSmpSC 0:39260
//sampler sampler searchTexSmpSC 0:52426
//texture texture2D inputTexture 0:37488:0:43245
//texture texture2D edgesTex 0:62370:0:54671
//texture texture2D areaTex 0:59209:0:39260
//texture texture2D searchTex 0:35225:0:52426
//ubo float UserUniforms 0:35568:512 {
//float4 inputTextureSize 0
//float4 inputTextureDims 16
//float4 inputTextureView 32
//float3x3 inputTextureTransform 48
//float4 inputTextureUvMinMax 96
//float4 inputTextureBorderColor 112
//float4 edgesTexSize 128
//float4 edgesTexDims 144
//float4 edgesTexView 160
//float3x3 edgesTexTransform 176
//float4 edgesTexUvMinMax 224
//float4 edgesTexBorderColor 240
//float4 areaTexSize 256
//float4 areaTexDims 272
//float4 areaTexView 288
//float3x3 areaTexTransform 304
//float4 areaTexUvMinMax 352
//float4 areaTexBorderColor 368
//float4 searchTexSize 384
//float4 searchTexDims 400
//float4 searchTexView 416
//float3x3 searchTexTransform 432
//float4 searchTexUvMinMax 480
//float4 searchTexBorderColor 496
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 inputTextureSize;
float4 inputTextureDims;
float4 inputTextureView;
float3x3 inputTextureTransform;
float4 inputTextureUvMinMax;
float4 inputTextureBorderColor;
float4 edgesTexSize;
float4 edgesTexDims;
float4 edgesTexView;
float3x3 edgesTexTransform;
float4 edgesTexUvMinMax;
float4 edgesTexBorderColor;
float4 areaTexSize;
float4 areaTexDims;
float4 areaTexView;
float3x3 areaTexTransform;
float4 areaTexUvMinMax;
float4 areaTexBorderColor;
float4 searchTexSize;
float4 searchTexDims;
float4 searchTexView;
float3x3 searchTexTransform;
float4 searchTexUvMinMax;
float4 searchTexBorderColor;
};

#ifndef inputTextureHasSwappedViews
#define inputTextureHasSwappedViews 0
#elif inputTextureHasSwappedViews==1
#undef inputTextureHasSwappedViews
#define inputTextureHasSwappedViews 1
#endif
#ifndef inputTextureLayout
#define inputTextureLayout 0
#endif
#ifndef edgesTexHasSwappedViews
#define edgesTexHasSwappedViews 0
#elif edgesTexHasSwappedViews==1
#undef edgesTexHasSwappedViews
#define edgesTexHasSwappedViews 1
#endif
#ifndef edgesTexLayout
#define edgesTexLayout 0
#endif
#ifndef areaTexHasSwappedViews
#define areaTexHasSwappedViews 0
#elif areaTexHasSwappedViews==1
#undef areaTexHasSwappedViews
#define areaTexHasSwappedViews 1
#endif
#ifndef areaTexLayout
#define areaTexLayout 0
#endif
#ifndef searchTexHasSwappedViews
#define searchTexHasSwappedViews 0
#elif searchTexHasSwappedViews==1
#undef searchTexHasSwappedViews
#define searchTexHasSwappedViews 1
#endif
#ifndef searchTexLayout
#define searchTexLayout 0
#endif
#ifndef SMAA_QUALITY
#define SMAA_QUALITY 0
#endif
#ifndef SC_USE_UV_TRANSFORM_edgesTex
#define SC_USE_UV_TRANSFORM_edgesTex 0
#elif SC_USE_UV_TRANSFORM_edgesTex==1
#undef SC_USE_UV_TRANSFORM_edgesTex
#define SC_USE_UV_TRANSFORM_edgesTex 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_edgesTex
#define SC_SOFTWARE_WRAP_MODE_U_edgesTex -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_edgesTex
#define SC_SOFTWARE_WRAP_MODE_V_edgesTex -1
#endif
constant int2 _2839=int2(SC_SOFTWARE_WRAP_MODE_U_edgesTex,SC_SOFTWARE_WRAP_MODE_V_edgesTex);
#ifndef SC_USE_UV_MIN_MAX_edgesTex
#define SC_USE_UV_MIN_MAX_edgesTex 0
#elif SC_USE_UV_MIN_MAX_edgesTex==1
#undef SC_USE_UV_MIN_MAX_edgesTex
#define SC_USE_UV_MIN_MAX_edgesTex 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_edgesTex
#define SC_USE_CLAMP_TO_BORDER_edgesTex 0
#elif SC_USE_CLAMP_TO_BORDER_edgesTex==1
#undef SC_USE_CLAMP_TO_BORDER_edgesTex
#define SC_USE_CLAMP_TO_BORDER_edgesTex 1
#endif
constant int2 _2939=int2(SC_SOFTWARE_WRAP_MODE_U_edgesTex,SC_SOFTWARE_WRAP_MODE_V_edgesTex);
#ifndef SMAA_AREATEX_MAX_DISTANCE_DIAG
#define SMAA_AREATEX_MAX_DISTANCE_DIAG 20
#endif
#ifndef SC_USE_UV_TRANSFORM_areaTex
#define SC_USE_UV_TRANSFORM_areaTex 0
#elif SC_USE_UV_TRANSFORM_areaTex==1
#undef SC_USE_UV_TRANSFORM_areaTex
#define SC_USE_UV_TRANSFORM_areaTex 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_areaTex
#define SC_SOFTWARE_WRAP_MODE_U_areaTex -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_areaTex
#define SC_SOFTWARE_WRAP_MODE_V_areaTex -1
#endif
constant int2 _3036=int2(SC_SOFTWARE_WRAP_MODE_U_areaTex,SC_SOFTWARE_WRAP_MODE_V_areaTex);
#ifndef SC_USE_UV_MIN_MAX_areaTex
#define SC_USE_UV_MIN_MAX_areaTex 0
#elif SC_USE_UV_MIN_MAX_areaTex==1
#undef SC_USE_UV_MIN_MAX_areaTex
#define SC_USE_UV_MIN_MAX_areaTex 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_areaTex
#define SC_USE_CLAMP_TO_BORDER_areaTex 0
#elif SC_USE_CLAMP_TO_BORDER_areaTex==1
#undef SC_USE_CLAMP_TO_BORDER_areaTex
#define SC_USE_CLAMP_TO_BORDER_areaTex 1
#endif
constant int2 _3153=int2(SC_SOFTWARE_WRAP_MODE_U_edgesTex,SC_SOFTWARE_WRAP_MODE_V_edgesTex);
constant int2 _3191=int2(SC_SOFTWARE_WRAP_MODE_U_edgesTex,SC_SOFTWARE_WRAP_MODE_V_edgesTex);
constant int2 _3264=int2(SC_SOFTWARE_WRAP_MODE_U_edgesTex,SC_SOFTWARE_WRAP_MODE_V_edgesTex);
constant int2 _3357=int2(SC_SOFTWARE_WRAP_MODE_U_edgesTex,SC_SOFTWARE_WRAP_MODE_V_edgesTex);
constant int2 _3394=int2(SC_SOFTWARE_WRAP_MODE_U_edgesTex,SC_SOFTWARE_WRAP_MODE_V_edgesTex);
constant int2 _3429=int2(SC_SOFTWARE_WRAP_MODE_U_edgesTex,SC_SOFTWARE_WRAP_MODE_V_edgesTex);
#ifndef SC_USE_UV_TRANSFORM_searchTex
#define SC_USE_UV_TRANSFORM_searchTex 0
#elif SC_USE_UV_TRANSFORM_searchTex==1
#undef SC_USE_UV_TRANSFORM_searchTex
#define SC_USE_UV_TRANSFORM_searchTex 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_searchTex
#define SC_SOFTWARE_WRAP_MODE_U_searchTex -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_searchTex
#define SC_SOFTWARE_WRAP_MODE_V_searchTex -1
#endif
constant int2 _3558=int2(SC_SOFTWARE_WRAP_MODE_U_searchTex,SC_SOFTWARE_WRAP_MODE_V_searchTex);
#ifndef SC_USE_UV_MIN_MAX_searchTex
#define SC_USE_UV_MIN_MAX_searchTex 0
#elif SC_USE_UV_MIN_MAX_searchTex==1
#undef SC_USE_UV_MIN_MAX_searchTex
#define SC_USE_UV_MIN_MAX_searchTex 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_searchTex
#define SC_USE_CLAMP_TO_BORDER_searchTex 0
#elif SC_USE_CLAMP_TO_BORDER_searchTex==1
#undef SC_USE_CLAMP_TO_BORDER_searchTex
#define SC_USE_CLAMP_TO_BORDER_searchTex 1
#endif
constant int2 _3626=int2(SC_SOFTWARE_WRAP_MODE_U_edgesTex,SC_SOFTWARE_WRAP_MODE_V_edgesTex);
constant int2 _3713=int2(SC_SOFTWARE_WRAP_MODE_U_edgesTex,SC_SOFTWARE_WRAP_MODE_V_edgesTex);
constant int2 _3797=int2(SC_SOFTWARE_WRAP_MODE_U_edgesTex,SC_SOFTWARE_WRAP_MODE_V_edgesTex);
constant int2 _3882=int2(SC_SOFTWARE_WRAP_MODE_U_edgesTex,SC_SOFTWARE_WRAP_MODE_V_edgesTex);
#ifndef SMAA_AREATEX_MAX_DISTANCE
#define SMAA_AREATEX_MAX_DISTANCE 16
#endif
constant int2 _3986=int2(SC_SOFTWARE_WRAP_MODE_U_areaTex,SC_SOFTWARE_WRAP_MODE_V_areaTex);
constant int2 _4064=int2(SC_SOFTWARE_WRAP_MODE_U_edgesTex,SC_SOFTWARE_WRAP_MODE_V_edgesTex);
constant int2 _4105=int2(SC_SOFTWARE_WRAP_MODE_U_edgesTex,SC_SOFTWARE_WRAP_MODE_V_edgesTex);
constant int2 _4146=int2(SC_SOFTWARE_WRAP_MODE_U_edgesTex,SC_SOFTWARE_WRAP_MODE_V_edgesTex);
constant int2 _4188=int2(SC_SOFTWARE_WRAP_MODE_U_edgesTex,SC_SOFTWARE_WRAP_MODE_V_edgesTex);
constant int2 _4276=int2(SC_SOFTWARE_WRAP_MODE_U_edgesTex,SC_SOFTWARE_WRAP_MODE_V_edgesTex);
constant int2 _4317=int2(SC_SOFTWARE_WRAP_MODE_U_edgesTex,SC_SOFTWARE_WRAP_MODE_V_edgesTex);
constant int2 _4358=int2(SC_SOFTWARE_WRAP_MODE_U_edgesTex,SC_SOFTWARE_WRAP_MODE_V_edgesTex);
constant int2 _4400=int2(SC_SOFTWARE_WRAP_MODE_U_edgesTex,SC_SOFTWARE_WRAP_MODE_V_edgesTex);
#ifndef DEBUG_MODE
#define DEBUG_MODE 0
#endif
#ifndef SC_USE_UV_TRANSFORM_inputTexture
#define SC_USE_UV_TRANSFORM_inputTexture 0
#elif SC_USE_UV_TRANSFORM_inputTexture==1
#undef SC_USE_UV_TRANSFORM_inputTexture
#define SC_USE_UV_TRANSFORM_inputTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_inputTexture
#define SC_SOFTWARE_WRAP_MODE_U_inputTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_inputTexture
#define SC_SOFTWARE_WRAP_MODE_V_inputTexture -1
#endif
constant int2 _4547=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
#ifndef SC_USE_UV_MIN_MAX_inputTexture
#define SC_USE_UV_MIN_MAX_inputTexture 0
#elif SC_USE_UV_MIN_MAX_inputTexture==1
#undef SC_USE_UV_MIN_MAX_inputTexture
#define SC_USE_UV_MIN_MAX_inputTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_inputTexture
#define SC_USE_CLAMP_TO_BORDER_inputTexture 0
#elif SC_USE_CLAMP_TO_BORDER_inputTexture==1
#undef SC_USE_CLAMP_TO_BORDER_inputTexture
#define SC_USE_CLAMP_TO_BORDER_inputTexture 1
#endif
constant int2 _4579=int2(SC_SOFTWARE_WRAP_MODE_U_edgesTex,SC_SOFTWARE_WRAP_MODE_V_edgesTex);
constant int2 _4612=int2(SC_SOFTWARE_WRAP_MODE_U_edgesTex,SC_SOFTWARE_WRAP_MODE_V_edgesTex);
constant int2 _4691=int2(SC_SOFTWARE_WRAP_MODE_U_edgesTex,SC_SOFTWARE_WRAP_MODE_V_edgesTex);
constant int2 _4752=int2(SC_SOFTWARE_WRAP_MODE_U_edgesTex,SC_SOFTWARE_WRAP_MODE_V_edgesTex);
constant int2 _4838=int2(SC_SOFTWARE_WRAP_MODE_U_edgesTex,SC_SOFTWARE_WRAP_MODE_V_edgesTex);
constant int2 _4898=int2(SC_SOFTWARE_WRAP_MODE_U_edgesTex,SC_SOFTWARE_WRAP_MODE_V_edgesTex);
#ifndef inputTextureUV
#define inputTextureUV 0
#endif
#ifndef edgesTexUV
#define edgesTexUV 0
#endif
#ifndef areaTexUV
#define areaTexUV 0
#endif
#ifndef searchTexUV
#define searchTexUV 0
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float4 varPackedTex [[user(locn6)]];
float4 varOffset0 [[user(locn10)]];
float4 varOffset1 [[user(locn11)]];
float4 varOffset2 [[user(locn12)]];
float2 varPixCoord [[user(locn13)]];
};

float2 inputTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.inputTextureDims.xy;
}

int inputTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (inputTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 edgesTexGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.edgesTexDims.xy;
}

int edgesTexGetStereoViewIndex(thread int& varStereoViewID)
{
#if (edgesTexHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

int smaaMaxSearchStepsDiag(thread const int& smaaQuality)
{
switch (smaaQuality)
{
case 0:
case 1:
{
return 0;
}
case 2:
{
return 8;
}
case 3:
case 4:
{
return 16;
}
default:
{
return 0;
}
}
}

float2 SMAASearchDiag1(thread const float2& texcoord,thread const float2& dir,thread float2& e,thread int& varStereoViewID,constant UserUniforms& userUniformsObj,thread texture2d<float> edgesTex,thread sampler edgesTexSmpSC)
{
float4 coord=float4(texcoord,-1.0,1.0);
float4 smaaRTMetrics=float4(1.0/userUniformsObj.inputTextureSize.x,1.0/userUniformsObj.inputTextureSize.y,userUniformsObj.inputTextureSize.x,userUniformsObj.inputTextureSize.y);
float3 t=float3(smaaRTMetrics.xy,1.0);
for (int snapLoopIndex=0; snapLoopIndex==0; snapLoopIndex+=0)
{
float _2806=coord.z;
int param=SMAA_QUALITY;
int _2809=smaaMaxSearchStepsDiag(param);
bool _2812=_2806<float(_2809-1);
bool _2819;
if (_2812)
{
_2819=coord.w>0.9;
}
else
{
_2819=_2812;
}
if (_2819)
{
float3 _2828=(t*float3(dir,1.0))+coord.xyz;
coord=float4(_2828.x,_2828.y,_2828.z,coord.w);
float2 param_1=edgesTexGetDims2D(userUniformsObj);
int param_2=edgesTexLayout;
int param_3=edgesTexGetStereoViewIndex(varStereoViewID);
float2 param_4=coord.xy;
bool param_5=(int(SC_USE_UV_TRANSFORM_edgesTex)!=0);
float3x3 param_6=userUniformsObj.edgesTexTransform;
int2 param_7=_2839;
bool param_8=(int(SC_USE_UV_MIN_MAX_edgesTex)!=0);
float4 param_9=userUniformsObj.edgesTexUvMinMax;
bool param_10=(int(SC_USE_CLAMP_TO_BORDER_edgesTex)!=0);
float4 param_11=userUniformsObj.edgesTexBorderColor;
float param_12=0.0;
float4 _2865=sc_SampleTextureBiasOrLevel(edgesTex,edgesTexSmpSC,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11,param_12);
float4 _2832=_2865;
float4 edgesTexSample=_2865;
e=edgesTexSample.xy;
coord.w=dot(e,float2(0.5));
continue;
}
else
{
break;
}
}
return coord.zw;
}

float2 calcSampleOffset(thread const float2& coord,thread const float2& offset,thread const float2& metric)
{
return float2(coord+(metric*offset));
}

float4 SMAADecodeDiagBilinearAccess(thread float4& e)
{
float2 _2769=e.xz*abs((e.xz*5.0)-float2(3.75));
e=float4(_2769.x,e.y,_2769.y,e.w);
return round(e);
}

void SMAAMovc(thread const float2& cond,thread float2& variable,thread const float2& value)
{
if (cond.x>0.0)
{
variable.x=value.x;
}
if (cond.y>0.0)
{
variable.y=value.y;
}
}

float2 areaTexGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.areaTexDims.xy;
}

int areaTexGetStereoViewIndex(thread int& varStereoViewID)
{
#if (areaTexHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 SMAAAreaDiag(thread const float2& dist,thread const float2& e,thread const float& offset,thread int& varStereoViewID,constant UserUniforms& userUniformsObj,thread texture2d<float> areaTex,thread sampler areaTexSmpSC)
{
float2 texcoord=(float2(float(SMAA_AREATEX_MAX_DISTANCE_DIAG),float(SMAA_AREATEX_MAX_DISTANCE_DIAG))*e)+dist;
float2 SMAA_AREATEX_PIXEL_SIZE=float2(0.00625,0.00178571);
float SMAA_AREATEX_SUBTEX_SIZE=0.142857;
float4 smaaRTMetrics=float4(1.0/userUniformsObj.inputTextureSize.x,1.0/userUniformsObj.inputTextureSize.y,userUniformsObj.inputTextureSize.x,userUniformsObj.inputTextureSize.y);
texcoord=(SMAA_AREATEX_PIXEL_SIZE*texcoord)+(SMAA_AREATEX_PIXEL_SIZE*0.5);
texcoord.x+=0.5;
texcoord.y+=(SMAA_AREATEX_SUBTEX_SIZE*offset);
texcoord.y=1.0-texcoord.y;
float2 param=texcoord;
float2 param_1=float2(0.0);
float2 param_2=smaaRTMetrics.xy;
float2 param_3=areaTexGetDims2D(userUniformsObj);
int param_4=areaTexLayout;
int param_5=areaTexGetStereoViewIndex(varStereoViewID);
float2 param_6=calcSampleOffset(param,param_1,param_2);
bool param_7=(int(SC_USE_UV_TRANSFORM_areaTex)!=0);
float3x3 param_8=userUniformsObj.areaTexTransform;
int2 param_9=_3036;
bool param_10=(int(SC_USE_UV_MIN_MAX_areaTex)!=0);
float4 param_11=userUniformsObj.areaTexUvMinMax;
bool param_12=(int(SC_USE_CLAMP_TO_BORDER_areaTex)!=0);
float4 param_13=userUniformsObj.areaTexBorderColor;
float param_14=0.0;
float4 _3058=sc_SampleTextureBiasOrLevel(areaTex,areaTexSmpSC,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11,param_12,param_13,param_14);
float4 _3022=_3058;
float4 areaTexSample=_3058;
return areaTexSample.xy;
}

float2 SMAADecodeDiagBilinearAccess(thread float2& e)
{
e.x*=abs((5.0*e.x)-3.75);
return round(e);
}

float2 SMAASearchDiag2(thread const float2& texcoord,thread const float2& dir,thread float2& e,thread int& varStereoViewID,constant UserUniforms& userUniformsObj,thread texture2d<float> edgesTex,thread sampler edgesTexSmpSC)
{
float4 coord=float4(texcoord,-1.0,1.0);
float4 smaaRTMetrics=float4(1.0/userUniformsObj.inputTextureSize.x,1.0/userUniformsObj.inputTextureSize.y,userUniformsObj.inputTextureSize.x,userUniformsObj.inputTextureSize.y);
coord.x+=(0.25*smaaRTMetrics.x);
float3 t=float3(smaaRTMetrics.xy,1.0);
for (int snapLoopIndex=0; snapLoopIndex==0; snapLoopIndex+=0)
{
float _2912=coord.z;
int param=SMAA_QUALITY;
int _2914=smaaMaxSearchStepsDiag(param);
bool _2917=_2912<float(_2914-1);
bool _2923;
if (_2917)
{
_2923=coord.w>0.9;
}
else
{
_2923=_2917;
}
if (_2923)
{
float3 _2932=(t*float3(dir,1.0))+coord.xyz;
coord=float4(_2932.x,_2932.y,_2932.z,coord.w);
float2 param_1=edgesTexGetDims2D(userUniformsObj);
int param_2=edgesTexLayout;
int param_3=edgesTexGetStereoViewIndex(varStereoViewID);
float2 param_4=coord.xy;
bool param_5=(int(SC_USE_UV_TRANSFORM_edgesTex)!=0);
float3x3 param_6=userUniformsObj.edgesTexTransform;
int2 param_7=_2939;
bool param_8=(int(SC_USE_UV_MIN_MAX_edgesTex)!=0);
float4 param_9=userUniformsObj.edgesTexUvMinMax;
bool param_10=(int(SC_USE_CLAMP_TO_BORDER_edgesTex)!=0);
float4 param_11=userUniformsObj.edgesTexBorderColor;
float param_12=0.0;
float4 _2960=sc_SampleTextureBiasOrLevel(edgesTex,edgesTexSmpSC,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11,param_12);
float4 _2936=_2960;
float4 edgesTexSample=_2960;
e=edgesTexSample.xy;
float2 param_13=e;
float2 _2965=SMAADecodeDiagBilinearAccess(param_13);
e=_2965;
coord.w=dot(e,float2(0.5));
continue;
}
else
{
break;
}
}
return coord.zw;
}

float2 SMAACalculateDiagWeights(thread const float2& texcoord,thread const float2& e,thread const float4& subsampleIndices,thread int& varStereoViewID,constant UserUniforms& userUniformsObj,thread texture2d<float> edgesTex,thread sampler edgesTexSmpSC,thread texture2d<float> areaTex,thread sampler areaTexSmpSC)
{
float2 weights=float2(0.0);
float4 smaaRTMetrics=float4(1.0/userUniformsObj.inputTextureSize.x,1.0/userUniformsObj.inputTextureSize.y,userUniformsObj.inputTextureSize.x,userUniformsObj.inputTextureSize.y);
float4 d;
float2 end;
if (e.x>0.0)
{
float2 param=texcoord;
float2 param_1=float2(-1.0);
float2 param_2;
float2 _3088=SMAASearchDiag1(param,param_1,param_2,varStereoViewID,userUniformsObj,edgesTex,edgesTexSmpSC);
end=param_2;
d=float4(_3088.x,d.y,_3088.y,d.w);
d.x+=float(end.y>0.9);
}
else
{
d=float4(float2(0.0).x,d.y,float2(0.0).y,d.w);
}
float2 param_3=texcoord;
float2 param_4=float2(1.0);
float2 param_5;
float2 _3108=SMAASearchDiag1(param_3,param_4,param_5,varStereoViewID,userUniformsObj,edgesTex,edgesTexSmpSC);
end=param_5;
d=float4(d.x,_3108.x,d.z,_3108.y);
if ((d.x+d.y)>2.0)
{
float4 coords=(float4((-d.x)+0.25,-d.x,d.y,d.y+0.25)*smaaRTMetrics.xyxy)+texcoord.xyxy;
float2 param_6=coords.xy;
float2 param_7=float2(-1.0,0.0);
float2 param_8=smaaRTMetrics.xy;
float2 param_9=edgesTexGetDims2D(userUniformsObj);
int param_10=edgesTexLayout;
int param_11=edgesTexGetStereoViewIndex(varStereoViewID);
float2 param_12=calcSampleOffset(param_6,param_7,param_8);
bool param_13=(int(SC_USE_UV_TRANSFORM_edgesTex)!=0);
float3x3 param_14=userUniformsObj.edgesTexTransform;
int2 param_15=_3153;
bool param_16=(int(SC_USE_UV_MIN_MAX_edgesTex)!=0);
float4 param_17=userUniformsObj.edgesTexUvMinMax;
bool param_18=(int(SC_USE_CLAMP_TO_BORDER_edgesTex)!=0);
float4 param_19=userUniformsObj.edgesTexBorderColor;
float param_20=0.0;
float4 _3172=sc_SampleTextureBiasOrLevel(edgesTex,edgesTexSmpSC,param_9,param_10,param_11,param_12,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20);
float4 _3141=_3172;
float4 edgesTexSample=_3172;
float4 c;
c=float4(edgesTexSample.xy.x,edgesTexSample.xy.y,c.z,c.w);
float2 param_21=coords.zw;
float2 param_22=float2(1.0,0.0);
float2 param_23=smaaRTMetrics.xy;
float2 param_24=edgesTexGetDims2D(userUniformsObj);
int param_25=edgesTexLayout;
int param_26=edgesTexGetStereoViewIndex(varStereoViewID);
float2 param_27=calcSampleOffset(param_21,param_22,param_23);
bool param_28=(int(SC_USE_UV_TRANSFORM_edgesTex)!=0);
float3x3 param_29=userUniformsObj.edgesTexTransform;
int2 param_30=_3191;
bool param_31=(int(SC_USE_UV_MIN_MAX_edgesTex)!=0);
float4 param_32=userUniformsObj.edgesTexUvMinMax;
bool param_33=(int(SC_USE_CLAMP_TO_BORDER_edgesTex)!=0);
float4 param_34=userUniformsObj.edgesTexBorderColor;
float param_35=0.0;
float4 _3210=sc_SampleTextureBiasOrLevel(edgesTex,edgesTexSmpSC,param_24,param_25,param_26,param_27,param_28,param_29,param_30,param_31,param_32,param_33,param_34,param_35);
float4 _3179=_3210;
float4 edgesTexSample_1=_3210;
c=float4(c.x,c.y,edgesTexSample_1.xy.x,edgesTexSample_1.xy.y);
float4 param_36=c;
float4 _3217=SMAADecodeDiagBilinearAccess(param_36);
c=float4(_3217.y,_3217.x,_3217.w,_3217.z);
float2 cc=(float2(2.0)*c.xz)+c.yw;
float2 param_37=float2(step(float2(0.9),d.zw));
float2 param_38=cc;
float2 param_39=float2(0.0);
SMAAMovc(param_37,param_38,param_39);
cc=param_38;
float2 param_40=d.xy;
float2 param_41=cc;
float param_42=subsampleIndices.z;
weights+=SMAAAreaDiag(param_40,param_41,param_42,varStereoViewID,userUniformsObj,areaTex,areaTexSmpSC);
}
float rTexSample=0.0;
float2 param_43=texcoord;
float2 param_44=float2(1.0,0.0);
float2 param_45=smaaRTMetrics.xy;
float2 param_46=edgesTexGetDims2D(userUniformsObj);
int param_47=edgesTexLayout;
int param_48=edgesTexGetStereoViewIndex(varStereoViewID);
float2 param_49=calcSampleOffset(param_43,param_44,param_45);
bool param_50=(int(SC_USE_UV_TRANSFORM_edgesTex)!=0);
float3x3 param_51=userUniformsObj.edgesTexTransform;
int2 param_52=_3264;
bool param_53=(int(SC_USE_UV_MIN_MAX_edgesTex)!=0);
float4 param_54=userUniformsObj.edgesTexUvMinMax;
bool param_55=(int(SC_USE_CLAMP_TO_BORDER_edgesTex)!=0);
float4 param_56=userUniformsObj.edgesTexBorderColor;
float param_57=0.0;
float4 _3283=sc_SampleTextureBiasOrLevel(edgesTex,edgesTexSmpSC,param_46,param_47,param_48,param_49,param_50,param_51,param_52,param_53,param_54,param_55,param_56,param_57);
float4 _3254=_3283;
float4 edgesTexSample_2=_3283;
rTexSample=edgesTexSample_2.x;
float2 param_58=texcoord;
float2 param_59=float2(-1.0,1.0);
float2 param_60;
float2 _3291=SMAASearchDiag2(param_58,param_59,param_60,varStereoViewID,userUniformsObj,edgesTex,edgesTexSmpSC);
end=param_60;
d=float4(_3291.x,d.y,_3291.y,d.w);
if (rTexSample>0.0)
{
float2 param_61=texcoord;
float2 param_62=float2(1.0,-1.0);
float2 param_63;
float2 _3304=SMAASearchDiag2(param_61,param_62,param_63,varStereoViewID,userUniformsObj,edgesTex,edgesTexSmpSC);
end=param_63;
d=float4(d.x,_3304.x,d.z,_3304.y);
d.y+=float(end.y>0.9);
}
else
{
d=float4(d.x,float2(0.0).x,d.z,float2(0.0).y);
}
if ((d.x+d.y)>2.0)
{
float4 coords_1=(float4(-d.x,-d.x,d.y,d.y)*smaaRTMetrics.xyxy)+texcoord.xyxy;
float2 param_64=coords_1.xy;
float2 param_65=float2(-1.0,0.0);
float2 param_66=smaaRTMetrics.xy;
float2 param_67=edgesTexGetDims2D(userUniformsObj);
int param_68=edgesTexLayout;
int param_69=edgesTexGetStereoViewIndex(varStereoViewID);
float2 param_70=calcSampleOffset(param_64,param_65,param_66);
bool param_71=(int(SC_USE_UV_TRANSFORM_edgesTex)!=0);
float3x3 param_72=userUniformsObj.edgesTexTransform;
int2 param_73=_3357;
bool param_74=(int(SC_USE_UV_MIN_MAX_edgesTex)!=0);
float4 param_75=userUniformsObj.edgesTexUvMinMax;
bool param_76=(int(SC_USE_CLAMP_TO_BORDER_edgesTex)!=0);
float4 param_77=userUniformsObj.edgesTexBorderColor;
float param_78=0.0;
float4 _3376=sc_SampleTextureBiasOrLevel(edgesTex,edgesTexSmpSC,param_67,param_68,param_69,param_70,param_71,param_72,param_73,param_74,param_75,param_76,param_77,param_78);
float4 _3346=_3376;
float4 edgesTexSample_3=_3376;
float4 c_1;
c_1.x=edgesTexSample_3.y;
float2 param_79=coords_1.xy;
float2 param_80=float2(0.0,-1.0);
float2 param_81=smaaRTMetrics.xy;
float2 param_82=edgesTexGetDims2D(userUniformsObj);
int param_83=edgesTexLayout;
int param_84=edgesTexGetStereoViewIndex(varStereoViewID);
float2 param_85=calcSampleOffset(param_79,param_80,param_81);
bool param_86=(int(SC_USE_UV_TRANSFORM_edgesTex)!=0);
float3x3 param_87=userUniformsObj.edgesTexTransform;
int2 param_88=_3394;
bool param_89=(int(SC_USE_UV_MIN_MAX_edgesTex)!=0);
float4 param_90=userUniformsObj.edgesTexUvMinMax;
bool param_91=(int(SC_USE_CLAMP_TO_BORDER_edgesTex)!=0);
float4 param_92=userUniformsObj.edgesTexBorderColor;
float param_93=0.0;
float4 _3413=sc_SampleTextureBiasOrLevel(edgesTex,edgesTexSmpSC,param_82,param_83,param_84,param_85,param_86,param_87,param_88,param_89,param_90,param_91,param_92,param_93);
float4 _3382=_3413;
float4 edgesTexSample_4=_3413;
c_1.y=edgesTexSample_4.x;
float2 param_94=coords_1.zw;
float2 param_95=float2(1.0,0.0);
float2 param_96=smaaRTMetrics.xy;
float2 param_97=edgesTexGetDims2D(userUniformsObj);
int param_98=edgesTexLayout;
int param_99=edgesTexGetStereoViewIndex(varStereoViewID);
float2 param_100=calcSampleOffset(param_94,param_95,param_96);
bool param_101=(int(SC_USE_UV_TRANSFORM_edgesTex)!=0);
float3x3 param_102=userUniformsObj.edgesTexTransform;
int2 param_103=_3429;
bool param_104=(int(SC_USE_UV_MIN_MAX_edgesTex)!=0);
float4 param_105=userUniformsObj.edgesTexUvMinMax;
bool param_106=(int(SC_USE_CLAMP_TO_BORDER_edgesTex)!=0);
float4 param_107=userUniformsObj.edgesTexBorderColor;
float param_108=0.0;
float4 _3448=sc_SampleTextureBiasOrLevel(edgesTex,edgesTexSmpSC,param_97,param_98,param_99,param_100,param_101,param_102,param_103,param_104,param_105,param_106,param_107,param_108);
float4 _3418=_3448;
float4 edgesTexSample_5=_3448;
c_1=float4(c_1.x,c_1.y,edgesTexSample_5.yx.x,edgesTexSample_5.yx.y);
float2 cc_1=(float2(2.0)*c_1.xz)+c_1.yw;
float2 param_109=float2(step(float2(0.9),d.zw));
float2 param_110=cc_1;
float2 param_111=float2(0.0);
SMAAMovc(param_109,param_110,param_111);
cc_1=param_110;
float2 param_112=d.xy;
float2 param_113=cc_1;
float param_114=subsampleIndices.w;
weights+=SMAAAreaDiag(param_112,param_113,param_114,varStereoViewID,userUniformsObj,areaTex,areaTexSmpSC).yx;
}
return weights;
}

bool smaaDisableDetection(thread const int& smaaQuality)
{
if (((smaaQuality==0)||(smaaQuality==1))||(smaaQuality==4))
{
return true;
}
return false;
}

float2 searchTexGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.searchTexDims.xy;
}

int searchTexGetStereoViewIndex(thread int& varStereoViewID)
{
#if (searchTexHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float SMAASearchLength(thread const float2& e,thread const float& offset,thread int& varStereoViewID,constant UserUniforms& userUniformsObj,thread texture2d<float> searchTex,thread sampler searchTexSmpSC)
{
float2 SMAA_SEARCHTEX_SIZE=float2(66.0,33.0);
float2 SMAA_SEARCHTEX_PACKED_SIZE=float2(64.0,16.0);
float4 smaaRTMetrics=float4(1.0/userUniformsObj.inputTextureSize.x,1.0/userUniformsObj.inputTextureSize.y,userUniformsObj.inputTextureSize.x,userUniformsObj.inputTextureSize.y);
float2 scale=SMAA_SEARCHTEX_SIZE*float2(0.5,-1.0);
float2 bias0=SMAA_SEARCHTEX_SIZE*float2(offset,1.0);
scale+=float2(-1.0,1.0);
bias0+=float2(0.5,-0.5);
scale*=(float2(1.0)/SMAA_SEARCHTEX_PACKED_SIZE);
bias0*=(float2(1.0)/SMAA_SEARCHTEX_PACKED_SIZE);
float2 lookup=(scale*e)+bias0;
lookup.y=1.0-lookup.y;
float2 param=lookup;
float2 param_1=float2(0.0);
float2 param_2=smaaRTMetrics.xy;
float2 param_3=searchTexGetDims2D(userUniformsObj);
int param_4=searchTexLayout;
int param_5=searchTexGetStereoViewIndex(varStereoViewID);
float2 param_6=calcSampleOffset(param,param_1,param_2);
bool param_7=(int(SC_USE_UV_TRANSFORM_searchTex)!=0);
float3x3 param_8=userUniformsObj.searchTexTransform;
int2 param_9=_3558;
bool param_10=(int(SC_USE_UV_MIN_MAX_searchTex)!=0);
float4 param_11=userUniformsObj.searchTexUvMinMax;
bool param_12=(int(SC_USE_CLAMP_TO_BORDER_searchTex)!=0);
float4 param_13=userUniformsObj.searchTexBorderColor;
float param_14=0.0;
float4 _3581=sc_SampleTextureBiasOrLevel(searchTex,searchTexSmpSC,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11,param_12,param_13,param_14);
float4 _3544=_3581;
float4 searchTexSample=_3581;
return searchTexSample.x;
}

float SMAASearchXLeft(thread float2& texcoord,thread const float& end,thread int& varStereoViewID,constant UserUniforms& userUniformsObj,thread texture2d<float> edgesTex,thread sampler edgesTexSmpSC,thread texture2d<float> searchTex,thread sampler searchTexSmpSC)
{
float2 e=float2(0.0,1.0);
float4 smaaRTMetrics=float4(1.0/userUniformsObj.inputTextureSize.x,1.0/userUniformsObj.inputTextureSize.y,userUniformsObj.inputTextureSize.x,userUniformsObj.inputTextureSize.y);
for (int snapLoopIndex=0; snapLoopIndex==0; snapLoopIndex+=0)
{
float _3606=texcoord.x;
float _3607=end;
bool _3608=_3606>_3607;
bool _3615;
if (_3608)
{
_3615=e.y>0.8281;
}
else
{
_3615=_3608;
}
bool _3621;
if (_3615)
{
_3621=e.x==0.0;
}
else
{
_3621=_3615;
}
if (_3621)
{
float2 param=edgesTexGetDims2D(userUniformsObj);
int param_1=edgesTexLayout;
int param_2=edgesTexGetStereoViewIndex(varStereoViewID);
float2 param_3=texcoord;
bool param_4=(int(SC_USE_UV_TRANSFORM_edgesTex)!=0);
float3x3 param_5=userUniformsObj.edgesTexTransform;
int2 param_6=_3626;
bool param_7=(int(SC_USE_UV_MIN_MAX_edgesTex)!=0);
float4 param_8=userUniformsObj.edgesTexUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_edgesTex)!=0);
float4 param_10=userUniformsObj.edgesTexBorderColor;
float param_11=0.0;
float4 _3646=sc_SampleTextureBiasOrLevel(edgesTex,edgesTexSmpSC,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
float4 _3623=_3646;
float4 edgesTexSample=_3646;
e=edgesTexSample.xy;
texcoord=(float2(-2.0,-0.0)*smaaRTMetrics.xy)+texcoord;
continue;
}
else
{
break;
}
}
float2 param_12=e;
float param_13=0.0;
float offset=((-2.00787)*SMAASearchLength(param_12,param_13,varStereoViewID,userUniformsObj,searchTex,searchTexSmpSC))+3.25;
return (smaaRTMetrics.x*offset)+texcoord.x;
}

float SMAASearchXRight(thread float2& texcoord,thread const float& end,thread int& varStereoViewID,constant UserUniforms& userUniformsObj,thread texture2d<float> edgesTex,thread sampler edgesTexSmpSC,thread texture2d<float> searchTex,thread sampler searchTexSmpSC)
{
float2 e=float2(0.0,1.0);
float4 smaaRTMetrics=float4(1.0/userUniformsObj.inputTextureSize.x,1.0/userUniformsObj.inputTextureSize.y,userUniformsObj.inputTextureSize.x,userUniformsObj.inputTextureSize.y);
for (int snapLoopIndex=0; snapLoopIndex==0; snapLoopIndex+=0)
{
float _3694=texcoord.x;
float _3695=end;
bool _3696=_3694<_3695;
bool _3702;
if (_3696)
{
_3702=e.y>0.8281;
}
else
{
_3702=_3696;
}
bool _3708;
if (_3702)
{
_3708=e.x==0.0;
}
else
{
_3708=_3702;
}
if (_3708)
{
float2 param=edgesTexGetDims2D(userUniformsObj);
int param_1=edgesTexLayout;
int param_2=edgesTexGetStereoViewIndex(varStereoViewID);
float2 param_3=texcoord;
bool param_4=(int(SC_USE_UV_TRANSFORM_edgesTex)!=0);
float3x3 param_5=userUniformsObj.edgesTexTransform;
int2 param_6=_3713;
bool param_7=(int(SC_USE_UV_MIN_MAX_edgesTex)!=0);
float4 param_8=userUniformsObj.edgesTexUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_edgesTex)!=0);
float4 param_10=userUniformsObj.edgesTexBorderColor;
float param_11=0.0;
float4 _3733=sc_SampleTextureBiasOrLevel(edgesTex,edgesTexSmpSC,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
float4 _3710=_3733;
float4 edgesTexSample=_3733;
e=edgesTexSample.xy;
texcoord=(float2(2.0,0.0)*smaaRTMetrics.xy)+texcoord;
continue;
}
else
{
break;
}
}
float2 param_12=e;
float param_13=0.5;
float offset=((-2.00787)*SMAASearchLength(param_12,param_13,varStereoViewID,userUniformsObj,searchTex,searchTexSmpSC))+3.25;
return ((-smaaRTMetrics.x)*offset)+texcoord.x;
}

float2 SMAAArea(thread const float2& dist,thread const float& e1,thread const float& e2,thread const float& offset,thread int& varStereoViewID,constant UserUniforms& userUniformsObj,thread texture2d<float> areaTex,thread sampler areaTexSmpSC)
{
float2 texcoord=(float2(float(SMAA_AREATEX_MAX_DISTANCE),float(SMAA_AREATEX_MAX_DISTANCE))*round(float2(e1,e2)*4.0))+dist;
float2 SMAA_AREATEX_PIXEL_SIZE=float2(0.00625,0.00178571);
float SMAA_AREATEX_SUBTEX_SIZE=0.142857;
float4 smaaRTMetrics=float4(1.0/userUniformsObj.inputTextureSize.x,1.0/userUniformsObj.inputTextureSize.y,userUniformsObj.inputTextureSize.x,userUniformsObj.inputTextureSize.y);
texcoord=(SMAA_AREATEX_PIXEL_SIZE*texcoord)+(SMAA_AREATEX_PIXEL_SIZE*0.5);
texcoord.y=(SMAA_AREATEX_SUBTEX_SIZE*offset)+texcoord.y;
texcoord.y=1.0-texcoord.y;
float2 param=texcoord;
float2 param_1=float2(0.0);
float2 param_2=smaaRTMetrics.xy;
float2 param_3=areaTexGetDims2D(userUniformsObj);
int param_4=areaTexLayout;
int param_5=areaTexGetStereoViewIndex(varStereoViewID);
float2 param_6=calcSampleOffset(param,param_1,param_2);
bool param_7=(int(SC_USE_UV_TRANSFORM_areaTex)!=0);
float3x3 param_8=userUniformsObj.areaTexTransform;
int2 param_9=_3986;
bool param_10=(int(SC_USE_UV_MIN_MAX_areaTex)!=0);
float4 param_11=userUniformsObj.areaTexUvMinMax;
bool param_12=(int(SC_USE_CLAMP_TO_BORDER_areaTex)!=0);
float4 param_13=userUniformsObj.areaTexBorderColor;
float param_14=0.0;
float4 _4005=sc_SampleTextureBiasOrLevel(areaTex,areaTexSmpSC,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11,param_12,param_13,param_14);
float4 _3976=_4005;
float4 areaTexSample=_4005;
return areaTexSample.xy;
}

int smaaMaxSearchSteps(thread const int& smaaQuality)
{
switch (smaaQuality)
{
case 0:
case 1:
{
return 0;
}
case 2:
case 3:
case 4:
{
return 25;
}
default:
{
return 0;
}
}
}

float4 DebugColor(thread const float4& weights,thread const float& e1,thread const float& e2,thread const float2& dist)
{
#if ((DEBUG_MODE==1)||(DEBUG_MODE==2))
{
float debugCross=0.0;
#if (DEBUG_MODE==1)
{
debugCross=e1*4.0;
}
#else
{
debugCross=e2*4.0;
}
#endif
if (debugCross<0.5)
{
return float4(1.0,0.0,0.0,1.0);
}
else
{
if (debugCross<1.5)
{
return float4(0.0,1.0,0.0,1.0);
}
else
{
if (debugCross<3.5)
{
return float4(0.0,0.0,1.0,1.0);
}
else
{
if (debugCross<4.5)
{
return float4(1.0,1.0,0.0,1.0);
}
else
{
return float4(0.5,0.5,0.5,1.0);
}
}
}
}
}
#endif
#if (DEBUG_MODE==3)
{
if (dist.x==0.0)
{
return float4(1.0,0.0,0.0,1.0);
}
int param=SMAA_QUALITY;
return float4(dist.x/float(smaaMaxSearchSteps(param)));
}
#else
{
#if (DEBUG_MODE==4)
{
if (dist.y==0.0)
{
return float4(1.0,0.0,0.0,1.0);
}
int param_1=SMAA_QUALITY;
return float4(dist.y/float(smaaMaxSearchSteps(param_1)));
}
#endif
}
#endif
return weights;
}

int smaaCornerRounding(thread const int& smaaQuality)
{
switch (smaaQuality)
{
case 0:
case 1:
case 2:
{
return 0;
}
case 3:
case 4:
{
return 15;
}
default:
{
return 0;
}
}
}

void SMAADetectHorizontalCornerPattern(thread float2& weights,thread const float4& texcoord,thread const float2& d,thread int& varStereoViewID,constant UserUniforms& userUniformsObj,thread texture2d<float> edgesTex,thread sampler edgesTexSmpSC)
{
int param=SMAA_QUALITY;
if (!smaaDisableDetection(param))
{
int param_1=SMAA_QUALITY;
float SMAA_CORNER_ROUNDING_NORM=float(smaaCornerRounding(param_1))/100.0;
float2 leftRight=step(d,d.yx);
float2 rounding=leftRight*(1.0-SMAA_CORNER_ROUNDING_NORM);
float4 smaaRTMetrics=float4(1.0/userUniformsObj.inputTextureSize.x,1.0/userUniformsObj.inputTextureSize.y,userUniformsObj.inputTextureSize.x,userUniformsObj.inputTextureSize.y);
rounding/=float2(leftRight.x+leftRight.y);
float2 factor=float2(1.0);
float2 param_2=texcoord.xy;
float2 param_3=float2(0.0,-1.0);
float2 param_4=smaaRTMetrics.xy;
float2 param_5=edgesTexGetDims2D(userUniformsObj);
int param_6=edgesTexLayout;
int param_7=edgesTexGetStereoViewIndex(varStereoViewID);
float2 param_8=calcSampleOffset(param_2,param_3,param_4);
bool param_9=(int(SC_USE_UV_TRANSFORM_edgesTex)!=0);
float3x3 param_10=userUniformsObj.edgesTexTransform;
int2 param_11=_4064;
bool param_12=(int(SC_USE_UV_MIN_MAX_edgesTex)!=0);
float4 param_13=userUniformsObj.edgesTexUvMinMax;
bool param_14=(int(SC_USE_CLAMP_TO_BORDER_edgesTex)!=0);
float4 param_15=userUniformsObj.edgesTexBorderColor;
float param_16=0.0;
float4 _4083=sc_SampleTextureBiasOrLevel(edgesTex,edgesTexSmpSC,param_5,param_6,param_7,param_8,param_9,param_10,param_11,param_12,param_13,param_14,param_15,param_16);
float4 _4053=_4083;
float4 edgesTexSample=_4083;
factor.x-=(rounding.x*edgesTexSample.x);
float2 param_17=texcoord.zw;
float2 param_18=float2(0.0,-1.0);
float2 param_19=smaaRTMetrics.xy;
float2 param_20=edgesTexGetDims2D(userUniformsObj);
int param_21=edgesTexLayout;
int param_22=edgesTexGetStereoViewIndex(varStereoViewID);
float2 param_23=calcSampleOffset(param_17,param_18,param_19);
bool param_24=(int(SC_USE_UV_TRANSFORM_edgesTex)!=0);
float3x3 param_25=userUniformsObj.edgesTexTransform;
int2 param_26=_4105;
bool param_27=(int(SC_USE_UV_MIN_MAX_edgesTex)!=0);
float4 param_28=userUniformsObj.edgesTexUvMinMax;
bool param_29=(int(SC_USE_CLAMP_TO_BORDER_edgesTex)!=0);
float4 param_30=userUniformsObj.edgesTexBorderColor;
float param_31=0.0;
float4 _4124=sc_SampleTextureBiasOrLevel(edgesTex,edgesTexSmpSC,param_20,param_21,param_22,param_23,param_24,param_25,param_26,param_27,param_28,param_29,param_30,param_31);
float4 _4094=_4124;
float4 edgesTexSample_1=_4124;
factor.x-=(rounding.y*edgesTexSample_1.x);
float2 param_32=texcoord.xy;
float2 param_33=float2(0.0,2.0);
float2 param_34=smaaRTMetrics.xy;
float2 param_35=edgesTexGetDims2D(userUniformsObj);
int param_36=edgesTexLayout;
int param_37=edgesTexGetStereoViewIndex(varStereoViewID);
float2 param_38=calcSampleOffset(param_32,param_33,param_34);
bool param_39=(int(SC_USE_UV_TRANSFORM_edgesTex)!=0);
float3x3 param_40=userUniformsObj.edgesTexTransform;
int2 param_41=_4146;
bool param_42=(int(SC_USE_UV_MIN_MAX_edgesTex)!=0);
float4 param_43=userUniformsObj.edgesTexUvMinMax;
bool param_44=(int(SC_USE_CLAMP_TO_BORDER_edgesTex)!=0);
float4 param_45=userUniformsObj.edgesTexBorderColor;
float param_46=0.0;
float4 _4165=sc_SampleTextureBiasOrLevel(edgesTex,edgesTexSmpSC,param_35,param_36,param_37,param_38,param_39,param_40,param_41,param_42,param_43,param_44,param_45,param_46);
float4 _4135=_4165;
float4 edgesTexSample_2=_4165;
factor.y-=(rounding.x*edgesTexSample_2.x);
float2 param_47=texcoord.zw;
float2 param_48=float2(1.0,2.0);
float2 param_49=smaaRTMetrics.xy;
float2 param_50=edgesTexGetDims2D(userUniformsObj);
int param_51=edgesTexLayout;
int param_52=edgesTexGetStereoViewIndex(varStereoViewID);
float2 param_53=calcSampleOffset(param_47,param_48,param_49);
bool param_54=(int(SC_USE_UV_TRANSFORM_edgesTex)!=0);
float3x3 param_55=userUniformsObj.edgesTexTransform;
int2 param_56=_4188;
bool param_57=(int(SC_USE_UV_MIN_MAX_edgesTex)!=0);
float4 param_58=userUniformsObj.edgesTexUvMinMax;
bool param_59=(int(SC_USE_CLAMP_TO_BORDER_edgesTex)!=0);
float4 param_60=userUniformsObj.edgesTexBorderColor;
float param_61=0.0;
float4 _4207=sc_SampleTextureBiasOrLevel(edgesTex,edgesTexSmpSC,param_50,param_51,param_52,param_53,param_54,param_55,param_56,param_57,param_58,param_59,param_60,param_61);
float4 _4176=_4207;
float4 edgesTexSample_3=_4207;
factor.y-=(rounding.y*edgesTexSample_3.x);
weights*=fast::clamp(factor,float2(0.0),float2(1.0));
}
}

float SMAASearchYUp(thread float2& texcoord,thread const float& end,thread int& varStereoViewID,constant UserUniforms& userUniformsObj,thread texture2d<float> edgesTex,thread sampler edgesTexSmpSC,thread texture2d<float> searchTex,thread sampler searchTexSmpSC)
{
float2 e=float2(1.0,0.0);
float4 smaaRTMetrics=float4(1.0/userUniformsObj.inputTextureSize.x,1.0/userUniformsObj.inputTextureSize.y,userUniformsObj.inputTextureSize.x,userUniformsObj.inputTextureSize.y);
for (int snapLoopIndex=0; snapLoopIndex==0; snapLoopIndex+=0)
{
float _3778=texcoord.y;
float _3779=end;
bool _3780=_3778<_3779;
bool _3786;
if (_3780)
{
_3786=e.x>0.8281;
}
else
{
_3786=_3780;
}
bool _3792;
if (_3786)
{
_3792=e.y==0.0;
}
else
{
_3792=_3786;
}
if (_3792)
{
float2 param=edgesTexGetDims2D(userUniformsObj);
int param_1=edgesTexLayout;
int param_2=edgesTexGetStereoViewIndex(varStereoViewID);
float2 param_3=texcoord;
bool param_4=(int(SC_USE_UV_TRANSFORM_edgesTex)!=0);
float3x3 param_5=userUniformsObj.edgesTexTransform;
int2 param_6=_3797;
bool param_7=(int(SC_USE_UV_MIN_MAX_edgesTex)!=0);
float4 param_8=userUniformsObj.edgesTexUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_edgesTex)!=0);
float4 param_10=userUniformsObj.edgesTexBorderColor;
float param_11=0.0;
float4 _3817=sc_SampleTextureBiasOrLevel(edgesTex,edgesTexSmpSC,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
float4 _3794=_3817;
float4 edgesTexSample=_3817;
e=edgesTexSample.xy;
texcoord=(float2(0.0,2.0)*smaaRTMetrics.xy)+texcoord;
continue;
}
else
{
break;
}
}
float2 param_12=e.yx;
float param_13=0.0;
float offset=-(((-2.00787)*SMAASearchLength(param_12,param_13,varStereoViewID,userUniformsObj,searchTex,searchTexSmpSC))+3.25);
return (smaaRTMetrics.y*offset)+texcoord.y;
}

float SMAASearchYDown(thread float2& texcoord,thread const float& end,thread int& varStereoViewID,constant UserUniforms& userUniformsObj,thread texture2d<float> edgesTex,thread sampler edgesTexSmpSC,thread texture2d<float> searchTex,thread sampler searchTexSmpSC)
{
float4 smaaRTMetrics=float4(1.0/userUniformsObj.inputTextureSize.x,1.0/userUniformsObj.inputTextureSize.y,userUniformsObj.inputTextureSize.x,userUniformsObj.inputTextureSize.y);
float2 e=float2(1.0,0.0);
for (int snapLoopIndex=0; snapLoopIndex==0; snapLoopIndex+=0)
{
float _3863=texcoord.y;
float _3864=end;
bool _3865=_3863>_3864;
bool _3871;
if (_3865)
{
_3871=e.x>0.8281;
}
else
{
_3871=_3865;
}
bool _3877;
if (_3871)
{
_3877=e.y==0.0;
}
else
{
_3877=_3871;
}
if (_3877)
{
float2 param=edgesTexGetDims2D(userUniformsObj);
int param_1=edgesTexLayout;
int param_2=edgesTexGetStereoViewIndex(varStereoViewID);
float2 param_3=texcoord;
bool param_4=(int(SC_USE_UV_TRANSFORM_edgesTex)!=0);
float3x3 param_5=userUniformsObj.edgesTexTransform;
int2 param_6=_3882;
bool param_7=(int(SC_USE_UV_MIN_MAX_edgesTex)!=0);
float4 param_8=userUniformsObj.edgesTexUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_edgesTex)!=0);
float4 param_10=userUniformsObj.edgesTexBorderColor;
float param_11=0.0;
float4 _3902=sc_SampleTextureBiasOrLevel(edgesTex,edgesTexSmpSC,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
float4 _3879=_3902;
float4 edgesTexSample=_3902;
e=edgesTexSample.xy;
texcoord=(float2(-0.0,-2.0)*smaaRTMetrics.xy)+texcoord;
continue;
}
else
{
break;
}
}
float2 param_12=e.yx;
float param_13=0.5;
float offset=-(((-2.00787)*SMAASearchLength(param_12,param_13,varStereoViewID,userUniformsObj,searchTex,searchTexSmpSC))+3.25);
return ((-smaaRTMetrics.y)*offset)+texcoord.y;
}

void SMAADetectVerticalCornerPattern(thread float2& weights,thread const float4& texcoord,thread const float2& d,thread int& varStereoViewID,constant UserUniforms& userUniformsObj,thread texture2d<float> edgesTex,thread sampler edgesTexSmpSC)
{
int param=SMAA_QUALITY;
if (!smaaDisableDetection(param))
{
int param_1=SMAA_QUALITY;
float SMAA_CORNER_ROUNDING_NORM=float(smaaCornerRounding(param_1))/100.0;
float2 leftRight=step(d,d.yx);
float2 rounding=leftRight*(1.0-SMAA_CORNER_ROUNDING_NORM);
float4 smaaRTMetrics=float4(1.0/userUniformsObj.inputTextureSize.x,1.0/userUniformsObj.inputTextureSize.y,userUniformsObj.inputTextureSize.x,userUniformsObj.inputTextureSize.y);
rounding/=float2(leftRight.x+leftRight.y);
float2 factor=float2(1.0);
float2 param_2=texcoord.xy;
float2 param_3=float2(1.0,0.0);
float2 param_4=smaaRTMetrics.xy;
float2 param_5=edgesTexGetDims2D(userUniformsObj);
int param_6=edgesTexLayout;
int param_7=edgesTexGetStereoViewIndex(varStereoViewID);
float2 param_8=calcSampleOffset(param_2,param_3,param_4);
bool param_9=(int(SC_USE_UV_TRANSFORM_edgesTex)!=0);
float3x3 param_10=userUniformsObj.edgesTexTransform;
int2 param_11=_4276;
bool param_12=(int(SC_USE_UV_MIN_MAX_edgesTex)!=0);
float4 param_13=userUniformsObj.edgesTexUvMinMax;
bool param_14=(int(SC_USE_CLAMP_TO_BORDER_edgesTex)!=0);
float4 param_15=userUniformsObj.edgesTexBorderColor;
float param_16=0.0;
float4 _4295=sc_SampleTextureBiasOrLevel(edgesTex,edgesTexSmpSC,param_5,param_6,param_7,param_8,param_9,param_10,param_11,param_12,param_13,param_14,param_15,param_16);
float4 _4265=_4295;
float4 edgesTexSample=_4295;
factor.x-=(rounding.x*edgesTexSample.y);
float2 param_17=texcoord.zw;
float2 param_18=float2(1.0,-1.0);
float2 param_19=smaaRTMetrics.xy;
float2 param_20=edgesTexGetDims2D(userUniformsObj);
int param_21=edgesTexLayout;
int param_22=edgesTexGetStereoViewIndex(varStereoViewID);
float2 param_23=calcSampleOffset(param_17,param_18,param_19);
bool param_24=(int(SC_USE_UV_TRANSFORM_edgesTex)!=0);
float3x3 param_25=userUniformsObj.edgesTexTransform;
int2 param_26=_4317;
bool param_27=(int(SC_USE_UV_MIN_MAX_edgesTex)!=0);
float4 param_28=userUniformsObj.edgesTexUvMinMax;
bool param_29=(int(SC_USE_CLAMP_TO_BORDER_edgesTex)!=0);
float4 param_30=userUniformsObj.edgesTexBorderColor;
float param_31=0.0;
float4 _4336=sc_SampleTextureBiasOrLevel(edgesTex,edgesTexSmpSC,param_20,param_21,param_22,param_23,param_24,param_25,param_26,param_27,param_28,param_29,param_30,param_31);
float4 _4306=_4336;
float4 edgesTexSample_1=_4336;
factor.x-=(rounding.y*edgesTexSample_1.y);
float2 param_32=texcoord.xy;
float2 param_33=float2(2.0,0.0);
float2 param_34=smaaRTMetrics.xy;
float2 param_35=edgesTexGetDims2D(userUniformsObj);
int param_36=edgesTexLayout;
int param_37=edgesTexGetStereoViewIndex(varStereoViewID);
float2 param_38=calcSampleOffset(param_32,param_33,param_34);
bool param_39=(int(SC_USE_UV_TRANSFORM_edgesTex)!=0);
float3x3 param_40=userUniformsObj.edgesTexTransform;
int2 param_41=_4358;
bool param_42=(int(SC_USE_UV_MIN_MAX_edgesTex)!=0);
float4 param_43=userUniformsObj.edgesTexUvMinMax;
bool param_44=(int(SC_USE_CLAMP_TO_BORDER_edgesTex)!=0);
float4 param_45=userUniformsObj.edgesTexBorderColor;
float param_46=0.0;
float4 _4377=sc_SampleTextureBiasOrLevel(edgesTex,edgesTexSmpSC,param_35,param_36,param_37,param_38,param_39,param_40,param_41,param_42,param_43,param_44,param_45,param_46);
float4 _4347=_4377;
float4 edgesTexSample_2=_4377;
factor.y-=(rounding.x*edgesTexSample_2.y);
float2 param_47=texcoord.zw;
float2 param_48=float2(-2.0,-1.0);
float2 param_49=smaaRTMetrics.xy;
float2 param_50=edgesTexGetDims2D(userUniformsObj);
int param_51=edgesTexLayout;
int param_52=edgesTexGetStereoViewIndex(varStereoViewID);
float2 param_53=calcSampleOffset(param_47,param_48,param_49);
bool param_54=(int(SC_USE_UV_TRANSFORM_edgesTex)!=0);
float3x3 param_55=userUniformsObj.edgesTexTransform;
int2 param_56=_4400;
bool param_57=(int(SC_USE_UV_MIN_MAX_edgesTex)!=0);
float4 param_58=userUniformsObj.edgesTexUvMinMax;
bool param_59=(int(SC_USE_CLAMP_TO_BORDER_edgesTex)!=0);
float4 param_60=userUniformsObj.edgesTexBorderColor;
float param_61=0.0;
float4 _4419=sc_SampleTextureBiasOrLevel(edgesTex,edgesTexSmpSC,param_50,param_51,param_52,param_53,param_54,param_55,param_56,param_57,param_58,param_59,param_60,param_61);
float4 _4388=_4419;
float4 edgesTexSample_3=_4419;
factor.y-=(rounding.y*edgesTexSample_3.y);
weights*=fast::clamp(factor,float2(0.0),float2(1.0));
}
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj,texture2d<float> searchTex,texture2d<float> inputTexture,texture2d<float> areaTex,texture2d<float> edgesTex,sampler areaTexSmpSC,sampler inputTextureSmpSC,sampler searchTexSmpSC,sampler edgesTexSmpSC,float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float4 weights=float4(0.0);
float4 subsampleIndices=float4(0.0);
float4 smaaRTMetrics=float4(1.0/userUniformsObj.inputTextureSize.x,1.0/userUniformsObj.inputTextureSize.y,userUniformsObj.inputTextureSize.x,userUniformsObj.inputTextureSize.y);
#if (DEBUG_MODE==5)
{
float2 param=inputTextureGetDims2D(userUniformsObj);
int param_1=inputTextureLayout;
int param_2=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_3=in.varPackedTex.xy;
bool param_4=(int(SC_USE_UV_TRANSFORM_inputTexture)!=0);
float3x3 param_5=userUniformsObj.inputTextureTransform;
int2 param_6=_4547;
bool param_7=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_8=userUniformsObj.inputTextureUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_10=userUniformsObj.inputTextureBorderColor;
float param_11=0.0;
float4 _4570=sc_SampleTextureBiasOrLevel(inputTexture,inputTextureSmpSC,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
float4 _4540=_4570;
float4 inputTextureSample=_4570;
float4 param_12=inputTextureSample;
sc_writeFragData0(param_12,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}
#endif
float2 param_13=edgesTexGetDims2D(userUniformsObj);
int param_14=edgesTexLayout;
int param_15=edgesTexGetStereoViewIndex(in.varStereoViewID);
float2 param_16=in.varPackedTex.xy;
bool param_17=(int(SC_USE_UV_TRANSFORM_edgesTex)!=0);
float3x3 param_18=userUniformsObj.edgesTexTransform;
int2 param_19=_4579;
bool param_20=(int(SC_USE_UV_MIN_MAX_edgesTex)!=0);
float4 param_21=userUniformsObj.edgesTexUvMinMax;
bool param_22=(int(SC_USE_CLAMP_TO_BORDER_edgesTex)!=0);
float4 param_23=userUniformsObj.edgesTexBorderColor;
float param_24=0.0;
float4 _4600=sc_SampleTextureBiasOrLevel(edgesTex,edgesTexSmpSC,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23,param_24);
float4 _4576=_4600;
float4 edgesTexSample=_4600;
float2 e=edgesTexSample.xy;
#if (DEBUG_MODE==6)
{
float2 param_25=edgesTexGetDims2D(userUniformsObj);
int param_26=edgesTexLayout;
int param_27=edgesTexGetStereoViewIndex(in.varStereoViewID);
float2 param_28=in.varPackedTex.xy;
bool param_29=(int(SC_USE_UV_TRANSFORM_edgesTex)!=0);
float3x3 param_30=userUniformsObj.edgesTexTransform;
int2 param_31=_4612;
bool param_32=(int(SC_USE_UV_MIN_MAX_edgesTex)!=0);
float4 param_33=userUniformsObj.edgesTexUvMinMax;
bool param_34=(int(SC_USE_CLAMP_TO_BORDER_edgesTex)!=0);
float4 param_35=userUniformsObj.edgesTexBorderColor;
float param_36=0.0;
float4 _4633=sc_SampleTextureBiasOrLevel(edgesTex,edgesTexSmpSC,param_25,param_26,param_27,param_28,param_29,param_30,param_31,param_32,param_33,param_34,param_35,param_36);
float4 _4609=_4633;
float4 edgesTexSample_1=_4633;
float4 param_37=edgesTexSample_1;
sc_writeFragData0(param_37,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}
#endif
if (e.y>0.0)
{
float2 param_38=in.varPackedTex.xy;
float2 param_39=e;
float4 param_40=subsampleIndices;
float2 _4650=SMAACalculateDiagWeights(param_38,param_39,param_40,in.varStereoViewID,userUniformsObj,edgesTex,edgesTexSmpSC,areaTex,areaTexSmpSC);
weights=float4(_4650.x,_4650.y,weights.z,weights.w);
float _4654=weights.x;
float _4656=weights.y;
bool _4658=_4654==(-_4656);
bool _4664;
if (!_4658)
{
int param_41=SMAA_QUALITY;
_4664=smaaDisableDetection(param_41);
}
else
{
_4664=_4658;
}
if (_4664)
{
float2 param_42=in.varOffset0.xy;
float param_43=in.varOffset2.x;
float _4676=SMAASearchXLeft(param_42,param_43,in.varStereoViewID,userUniformsObj,edgesTex,edgesTexSmpSC,searchTex,searchTexSmpSC);
float3 coords;
coords.x=_4676;
coords.y=in.varOffset1.y;
float2 d;
d.x=coords.x;
float e1=0.0;
float2 param_44=edgesTexGetDims2D(userUniformsObj);
int param_45=edgesTexLayout;
int param_46=edgesTexGetStereoViewIndex(in.varStereoViewID);
float2 param_47=coords.xy;
bool param_48=(int(SC_USE_UV_TRANSFORM_edgesTex)!=0);
float3x3 param_49=userUniformsObj.edgesTexTransform;
int2 param_50=_4691;
bool param_51=(int(SC_USE_UV_MIN_MAX_edgesTex)!=0);
float4 param_52=userUniformsObj.edgesTexUvMinMax;
bool param_53=(int(SC_USE_CLAMP_TO_BORDER_edgesTex)!=0);
float4 param_54=userUniformsObj.edgesTexBorderColor;
float param_55=0.0;
float4 _4712=sc_SampleTextureBiasOrLevel(edgesTex,edgesTexSmpSC,param_44,param_45,param_46,param_47,param_48,param_49,param_50,param_51,param_52,param_53,param_54,param_55);
float4 _4688=_4712;
float4 edgesTexSample_2=_4712;
e1=edgesTexSample_2.x;
float2 param_56=in.varOffset0.zw;
float param_57=in.varOffset2.y;
float _4721=SMAASearchXRight(param_56,param_57,in.varStereoViewID,userUniformsObj,edgesTex,edgesTexSmpSC,searchTex,searchTexSmpSC);
coords.z=_4721;
d.y=coords.z;
d=abs(round((smaaRTMetrics.zz*d)-in.varPixCoord.xx));
float2 sqrt_d=sqrt(d);
float e2=0.0;
float2 param_58=coords.zy;
float2 param_59=float2(1.0,0.0);
float2 param_60=smaaRTMetrics.xy;
float2 param_61=edgesTexGetDims2D(userUniformsObj);
int param_62=edgesTexLayout;
int param_63=edgesTexGetStereoViewIndex(in.varStereoViewID);
float2 param_64=calcSampleOffset(param_58,param_59,param_60);
bool param_65=(int(SC_USE_UV_TRANSFORM_edgesTex)!=0);
float3x3 param_66=userUniformsObj.edgesTexTransform;
int2 param_67=_4752;
bool param_68=(int(SC_USE_UV_MIN_MAX_edgesTex)!=0);
float4 param_69=userUniformsObj.edgesTexUvMinMax;
bool param_70=(int(SC_USE_CLAMP_TO_BORDER_edgesTex)!=0);
float4 param_71=userUniformsObj.edgesTexBorderColor;
float param_72=0.0;
float4 _4771=sc_SampleTextureBiasOrLevel(edgesTex,edgesTexSmpSC,param_61,param_62,param_63,param_64,param_65,param_66,param_67,param_68,param_69,param_70,param_71,param_72);
float4 _4741=_4771;
float4 edgesTexSample_3=_4771;
e2=edgesTexSample_3.x;
float2 param_73=sqrt_d;
float param_74=e1;
float param_75=e2;
float param_76=subsampleIndices.y;
float2 _4783=SMAAArea(param_73,param_74,param_75,param_76,in.varStereoViewID,userUniformsObj,areaTex,areaTexSmpSC);
weights=float4(_4783.x,_4783.y,weights.z,weights.w);
float4 param_77=weights;
float param_78=e1;
float param_79=e2;
float2 param_80=d;
weights=DebugColor(param_77,param_78,param_79,param_80);
coords.y=in.varPackedTex.y;
float2 param_81=weights.xy;
float4 param_82=coords.xyzy;
float2 param_83=d;
SMAADetectHorizontalCornerPattern(param_81,param_82,param_83,in.varStereoViewID,userUniformsObj,edgesTex,edgesTexSmpSC);
weights=float4(param_81.x,param_81.y,weights.z,weights.w);
}
else
{
e.x=0.0;
}
}
if (e.x>0.0)
{
float2 param_84=in.varOffset1.xy;
float param_85=in.varOffset2.z;
float _4824=SMAASearchYUp(param_84,param_85,in.varStereoViewID,userUniformsObj,edgesTex,edgesTexSmpSC,searchTex,searchTexSmpSC);
float3 coords_1;
coords_1.y=_4824;
coords_1.x=in.varOffset0.x;
float2 d_1;
d_1.x=coords_1.y;
float e1_1=0.0;
float2 param_86=edgesTexGetDims2D(userUniformsObj);
int param_87=edgesTexLayout;
int param_88=edgesTexGetStereoViewIndex(in.varStereoViewID);
float2 param_89=coords_1.xy;
bool param_90=(int(SC_USE_UV_TRANSFORM_edgesTex)!=0);
float3x3 param_91=userUniformsObj.edgesTexTransform;
int2 param_92=_4838;
bool param_93=(int(SC_USE_UV_MIN_MAX_edgesTex)!=0);
float4 param_94=userUniformsObj.edgesTexUvMinMax;
bool param_95=(int(SC_USE_CLAMP_TO_BORDER_edgesTex)!=0);
float4 param_96=userUniformsObj.edgesTexBorderColor;
float param_97=0.0;
float4 _4859=sc_SampleTextureBiasOrLevel(edgesTex,edgesTexSmpSC,param_86,param_87,param_88,param_89,param_90,param_91,param_92,param_93,param_94,param_95,param_96,param_97);
float4 _4835=_4859;
float4 edgesTexSample_4=_4859;
e1_1=edgesTexSample_4.y;
float2 param_98=in.varOffset1.zw;
float param_99=in.varOffset2.w;
float _4868=SMAASearchYDown(param_98,param_99,in.varStereoViewID,userUniformsObj,edgesTex,edgesTexSmpSC,searchTex,searchTexSmpSC);
coords_1.z=_4868;
d_1.y=coords_1.z;
d_1=abs(round((smaaRTMetrics.ww*d_1)-in.varPixCoord.yy));
float2 sqrt_d_1=sqrt(d_1);
float e2_1=0.0;
float2 param_100=coords_1.xz;
float2 param_101=float2(0.0,-1.0);
float2 param_102=smaaRTMetrics.xy;
float2 param_103=edgesTexGetDims2D(userUniformsObj);
int param_104=edgesTexLayout;
int param_105=edgesTexGetStereoViewIndex(in.varStereoViewID);
float2 param_106=calcSampleOffset(param_100,param_101,param_102);
bool param_107=(int(SC_USE_UV_TRANSFORM_edgesTex)!=0);
float3x3 param_108=userUniformsObj.edgesTexTransform;
int2 param_109=_4898;
bool param_110=(int(SC_USE_UV_MIN_MAX_edgesTex)!=0);
float4 param_111=userUniformsObj.edgesTexUvMinMax;
bool param_112=(int(SC_USE_CLAMP_TO_BORDER_edgesTex)!=0);
float4 param_113=userUniformsObj.edgesTexBorderColor;
float param_114=0.0;
float4 _4917=sc_SampleTextureBiasOrLevel(edgesTex,edgesTexSmpSC,param_103,param_104,param_105,param_106,param_107,param_108,param_109,param_110,param_111,param_112,param_113,param_114);
float4 _4887=_4917;
float4 edgesTexSample_5=_4917;
e2_1=edgesTexSample_5.y;
float2 param_115=sqrt_d_1;
float param_116=e1_1;
float param_117=e2_1;
float param_118=subsampleIndices.x;
float2 _4929=SMAAArea(param_115,param_116,param_117,param_118,in.varStereoViewID,userUniformsObj,areaTex,areaTexSmpSC);
weights=float4(weights.x,weights.y,_4929.x,_4929.y);
float4 param_119=weights;
float param_120=e1_1;
float param_121=e2_1;
float2 param_122=d_1;
weights=DebugColor(param_119,param_120,param_121,param_122);
coords_1.x=in.varPackedTex.x;
float2 param_123=weights.zw;
float4 param_124=coords_1.xyxz;
float2 param_125=d_1;
SMAADetectVerticalCornerPattern(param_123,param_124,param_125,in.varStereoViewID,userUniformsObj,edgesTex,edgesTexSmpSC);
weights=float4(weights.x,weights.y,param_123.x,param_123.y);
}
float4 param_126=weights;
sc_writeFragData0(param_126,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
