#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE0 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include "std2.metal"
#include "std2_texture.metal"
#include "std2_fs.metal"
#include "std2_vs.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN(100)
//ubo float UserUniforms 0:35568:128 {
//float4 inputTextureSize 0
//float4 inputTextureDims 16
//float4 inputTextureView 32
//float3x3 inputTextureTransform 48
//float4 inputTextureUvMinMax 96
//float4 inputTextureBorderColor 112
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 inputTextureSize;
float4 inputTextureDims;
float4 inputTextureView;
float3x3 inputTextureTransform;
float4 inputTextureUvMinMax;
float4 inputTextureBorderColor;
};

#ifndef inputTextureHasSwappedViews
#define inputTextureHasSwappedViews 0
#elif inputTextureHasSwappedViews==1
#undef inputTextureHasSwappedViews
#define inputTextureHasSwappedViews 1
#endif
#ifndef inputTextureLayout
#define inputTextureLayout 0
#endif
#ifndef inputTextureUV
#define inputTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_inputTexture
#define SC_USE_UV_TRANSFORM_inputTexture 0
#elif SC_USE_UV_TRANSFORM_inputTexture==1
#undef SC_USE_UV_TRANSFORM_inputTexture
#define SC_USE_UV_TRANSFORM_inputTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_inputTexture
#define SC_SOFTWARE_WRAP_MODE_U_inputTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_inputTexture
#define SC_SOFTWARE_WRAP_MODE_V_inputTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_inputTexture
#define SC_USE_UV_MIN_MAX_inputTexture 0
#elif SC_USE_UV_MIN_MAX_inputTexture==1
#undef SC_USE_UV_MIN_MAX_inputTexture
#define SC_USE_UV_MIN_MAX_inputTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_inputTexture
#define SC_USE_CLAMP_TO_BORDER_inputTexture 0
#elif SC_USE_CLAMP_TO_BORDER_inputTexture==1
#undef SC_USE_CLAMP_TO_BORDER_inputTexture
#define SC_USE_CLAMP_TO_BORDER_inputTexture 1
#endif
#ifndef SMAA_QUALITY
#define SMAA_QUALITY 0
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float2 varTexCoords [[user(locn10)]];
float4 varOffset0 [[user(locn11)]];
float4 varOffset1 [[user(locn12)]];
float4 varOffset2 [[user(locn13)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant UserUniforms& userUniformsObj,constant LibraryUniforms& libraryUniformsObj,uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
out.varTexCoords=(v.position.xy*0.5)+float2(0.5);
float4 smaaRTMetrics=float4(1.0/userUniformsObj.inputTextureSize.x,1.0/userUniformsObj.inputTextureSize.y,userUniformsObj.inputTextureSize.x,userUniformsObj.inputTextureSize.y);
out.varOffset0=(smaaRTMetrics.xyxy*float4(-1.0,0.0,0.0,1.0))+out.varTexCoords.xyxy;
out.varOffset1=(smaaRTMetrics.xyxy*float4(1.0,0.0,0.0,-1.0))+out.varTexCoords.xyxy;
out.varOffset2=(smaaRTMetrics.xyxy*float4(-2.0,0.0,0.0,2.0))+out.varTexCoords.xyxy;
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN(100)
//sampler sampler inputTextureSmpSC 0:43245
//texture texture2D inputTexture 0:37488:0:43245
//ubo float UserUniforms 0:35568:128 {
//float4 inputTextureSize 0
//float4 inputTextureDims 16
//float4 inputTextureView 32
//float3x3 inputTextureTransform 48
//float4 inputTextureUvMinMax 96
//float4 inputTextureBorderColor 112
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 inputTextureSize;
float4 inputTextureDims;
float4 inputTextureView;
float3x3 inputTextureTransform;
float4 inputTextureUvMinMax;
float4 inputTextureBorderColor;
};

#ifndef inputTextureHasSwappedViews
#define inputTextureHasSwappedViews 0
#elif inputTextureHasSwappedViews==1
#undef inputTextureHasSwappedViews
#define inputTextureHasSwappedViews 1
#endif
#ifndef inputTextureLayout
#define inputTextureLayout 0
#endif
#ifndef SC_USE_UV_TRANSFORM_inputTexture
#define SC_USE_UV_TRANSFORM_inputTexture 0
#elif SC_USE_UV_TRANSFORM_inputTexture==1
#undef SC_USE_UV_TRANSFORM_inputTexture
#define SC_USE_UV_TRANSFORM_inputTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_inputTexture
#define SC_SOFTWARE_WRAP_MODE_U_inputTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_inputTexture
#define SC_SOFTWARE_WRAP_MODE_V_inputTexture -1
#endif
constant int2 _2186=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
#ifndef SC_USE_UV_MIN_MAX_inputTexture
#define SC_USE_UV_MIN_MAX_inputTexture 0
#elif SC_USE_UV_MIN_MAX_inputTexture==1
#undef SC_USE_UV_MIN_MAX_inputTexture
#define SC_USE_UV_MIN_MAX_inputTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_inputTexture
#define SC_USE_CLAMP_TO_BORDER_inputTexture 0
#elif SC_USE_CLAMP_TO_BORDER_inputTexture==1
#undef SC_USE_CLAMP_TO_BORDER_inputTexture
#define SC_USE_CLAMP_TO_BORDER_inputTexture 1
#endif
constant int2 _2222=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2253=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
#ifndef SMAA_QUALITY
#define SMAA_QUALITY 0
#endif
constant int2 _2314=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2345=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2392=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2423=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
#ifndef inputTextureUV
#define inputTextureUV 0
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float2 varTexCoords [[user(locn10)]];
float4 varOffset0 [[user(locn11)]];
float4 varOffset1 [[user(locn12)]];
float4 varOffset2 [[user(locn13)]];
};

float2 inputTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.inputTextureDims.xy;
}

int inputTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (inputTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float getThreshHold(thread const int& smaaQuality)
{
if (smaaQuality==0)
{
return 0.15;
}
else
{
if (smaaQuality==1)
{
return 0.1;
}
else
{
if (smaaQuality==2)
{
return 0.1;
}
else
{
if (smaaQuality==3)
{
return 0.05;
}
else
{
return 0.0;
}
}
}
}
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj,texture2d<float> inputTexture,sampler inputTextureSmpSC,float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float3 weights=float3(0.2126,0.7152,0.0722);
float L=0.0;
float2 param=inputTextureGetDims2D(userUniformsObj);
int param_1=inputTextureLayout;
int param_2=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_3=in.varTexCoords;
bool param_4=(int(SC_USE_UV_TRANSFORM_inputTexture)!=0);
float3x3 param_5=userUniformsObj.inputTextureTransform;
int2 param_6=_2186;
bool param_7=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_8=userUniformsObj.inputTextureUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_10=userUniformsObj.inputTextureBorderColor;
float param_11=0.0;
float4 _2211=sc_SampleTextureBiasOrLevel(inputTexture,inputTextureSmpSC,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
float4 _2179=_2211;
float4 inputTextureSample=_2211;
L=dot(inputTextureSample.xyz,weights);
float Lleft=0.0;
float2 param_12=inputTextureGetDims2D(userUniformsObj);
int param_13=inputTextureLayout;
int param_14=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_15=in.varOffset0.xy;
bool param_16=(int(SC_USE_UV_TRANSFORM_inputTexture)!=0);
float3x3 param_17=userUniformsObj.inputTextureTransform;
int2 param_18=_2222;
bool param_19=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_20=userUniformsObj.inputTextureUvMinMax;
bool param_21=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_22=userUniformsObj.inputTextureBorderColor;
float param_23=0.0;
float4 _2243=sc_SampleTextureBiasOrLevel(inputTexture,inputTextureSmpSC,param_12,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23);
float4 _2218=_2243;
float4 inputTextureSample_1=_2243;
Lleft=dot(inputTextureSample_1.xyz,weights);
float Ltop=0.0;
float2 param_24=inputTextureGetDims2D(userUniformsObj);
int param_25=inputTextureLayout;
int param_26=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_27=in.varOffset0.zw;
bool param_28=(int(SC_USE_UV_TRANSFORM_inputTexture)!=0);
float3x3 param_29=userUniformsObj.inputTextureTransform;
int2 param_30=_2253;
bool param_31=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_32=userUniformsObj.inputTextureUvMinMax;
bool param_33=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_34=userUniformsObj.inputTextureBorderColor;
float param_35=0.0;
float4 _2274=sc_SampleTextureBiasOrLevel(inputTexture,inputTextureSmpSC,param_24,param_25,param_26,param_27,param_28,param_29,param_30,param_31,param_32,param_33,param_34,param_35);
float4 _2250=_2274;
float4 inputTextureSample_2=_2274;
Ltop=dot(inputTextureSample_2.xyz,weights);
float2 _2286=abs(float2(L)-float2(Lleft,Ltop));
float4 delta;
delta=float4(_2286.x,_2286.y,delta.z,delta.w);
int param_36=SMAA_QUALITY;
float2 threshold=float2(getThreshHold(param_36));
float2 edges=step(threshold,delta.xy);
if (dot(edges,float2(1.0))==0.0)
{
float4 param_37=float4(0.0);
sc_writeFragData0(param_37,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}
float Lright=0.0;
float2 param_38=inputTextureGetDims2D(userUniformsObj);
int param_39=inputTextureLayout;
int param_40=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_41=in.varOffset1.xy;
bool param_42=(int(SC_USE_UV_TRANSFORM_inputTexture)!=0);
float3x3 param_43=userUniformsObj.inputTextureTransform;
int2 param_44=_2314;
bool param_45=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_46=userUniformsObj.inputTextureUvMinMax;
bool param_47=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_48=userUniformsObj.inputTextureBorderColor;
float param_49=0.0;
float4 _2335=sc_SampleTextureBiasOrLevel(inputTexture,inputTextureSmpSC,param_38,param_39,param_40,param_41,param_42,param_43,param_44,param_45,param_46,param_47,param_48,param_49);
float4 _2310=_2335;
float4 inputTextureSample_3=_2335;
Lright=dot(inputTextureSample_3.xyz,weights);
float Lbottom=0.0;
float2 param_50=inputTextureGetDims2D(userUniformsObj);
int param_51=inputTextureLayout;
int param_52=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_53=in.varOffset1.zw;
bool param_54=(int(SC_USE_UV_TRANSFORM_inputTexture)!=0);
float3x3 param_55=userUniformsObj.inputTextureTransform;
int2 param_56=_2345;
bool param_57=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_58=userUniformsObj.inputTextureUvMinMax;
bool param_59=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_60=userUniformsObj.inputTextureBorderColor;
float param_61=0.0;
float4 _2366=sc_SampleTextureBiasOrLevel(inputTexture,inputTextureSmpSC,param_50,param_51,param_52,param_53,param_54,param_55,param_56,param_57,param_58,param_59,param_60,param_61);
float4 _2342=_2366;
float4 inputTextureSample_4=_2366;
Lbottom=dot(inputTextureSample_4.xyz,weights);
float2 _2377=abs(float2(L)-float2(Lright,Lbottom));
delta=float4(delta.x,delta.y,_2377.x,_2377.y);
float2 maxDelta=fast::max(delta.xy,delta.zw);
float Lleftleft=0.0;
float2 param_62=inputTextureGetDims2D(userUniformsObj);
int param_63=inputTextureLayout;
int param_64=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_65=in.varOffset2.xy;
bool param_66=(int(SC_USE_UV_TRANSFORM_inputTexture)!=0);
float3x3 param_67=userUniformsObj.inputTextureTransform;
int2 param_68=_2392;
bool param_69=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_70=userUniformsObj.inputTextureUvMinMax;
bool param_71=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_72=userUniformsObj.inputTextureBorderColor;
float param_73=0.0;
float4 _2413=sc_SampleTextureBiasOrLevel(inputTexture,inputTextureSmpSC,param_62,param_63,param_64,param_65,param_66,param_67,param_68,param_69,param_70,param_71,param_72,param_73);
float4 _2388=_2413;
float4 inputTextureSample_5=_2413;
Lleftleft=dot(inputTextureSample_5.xyz,weights);
float Ltoptop=0.0;
float2 param_74=inputTextureGetDims2D(userUniformsObj);
int param_75=inputTextureLayout;
int param_76=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_77=in.varOffset2.zw;
bool param_78=(int(SC_USE_UV_TRANSFORM_inputTexture)!=0);
float3x3 param_79=userUniformsObj.inputTextureTransform;
int2 param_80=_2423;
bool param_81=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_82=userUniformsObj.inputTextureUvMinMax;
bool param_83=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_84=userUniformsObj.inputTextureBorderColor;
float param_85=0.0;
float4 _2444=sc_SampleTextureBiasOrLevel(inputTexture,inputTextureSmpSC,param_74,param_75,param_76,param_77,param_78,param_79,param_80,param_81,param_82,param_83,param_84,param_85);
float4 _2420=_2444;
float4 inputTextureSample_6=_2444;
Ltoptop=dot(inputTextureSample_6.xyz,weights);
float2 _2456=abs(float2(Lleft,Ltop)-float2(Lleftleft,Ltoptop));
delta=float4(delta.x,delta.y,_2456.x,_2456.y);
maxDelta=fast::max(maxDelta,delta.zw);
float finalDelta=fast::max(maxDelta.x,maxDelta.y);
edges*=step(float2(finalDelta),delta.xy*2.0);
float4 param_86=float4(edges.x,edges.y,0.0,0.0);
sc_writeFragData0(param_86,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
