#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE0 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include "std2.metal"
#include "std2_fs.metal"
#include "std2_texture.metal"
#include "std2_vs.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN(100)
//ubo float UserUniforms 0:35568:264 {
//float4 blendTexSize 0
//float4 blendTexDims 16
//float4 blendTexView 32
//float3x3 blendTexTransform 48
//float4 blendTexUvMinMax 96
//float4 blendTexBorderColor 112
//float4 inputTexSize 128
//float4 inputTexDims 144
//float4 inputTexView 160
//float3x3 inputTexTransform 176
//float4 inputTexUvMinMax 224
//float4 inputTexBorderColor 240
//float2 inputRTSize 256
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 blendTexSize;
float4 blendTexDims;
float4 blendTexView;
float3x3 blendTexTransform;
float4 blendTexUvMinMax;
float4 blendTexBorderColor;
float4 inputTexSize;
float4 inputTexDims;
float4 inputTexView;
float3x3 inputTexTransform;
float4 inputTexUvMinMax;
float4 inputTexBorderColor;
float2 inputRTSize;
};

#ifndef blendTexHasSwappedViews
#define blendTexHasSwappedViews 0
#elif blendTexHasSwappedViews==1
#undef blendTexHasSwappedViews
#define blendTexHasSwappedViews 1
#endif
#ifndef blendTexLayout
#define blendTexLayout 0
#endif
#ifndef inputTexHasSwappedViews
#define inputTexHasSwappedViews 0
#elif inputTexHasSwappedViews==1
#undef inputTexHasSwappedViews
#define inputTexHasSwappedViews 1
#endif
#ifndef inputTexLayout
#define inputTexLayout 0
#endif
#ifndef SMAA_REPROJECTION
#define SMAA_REPROJECTION 0
#elif SMAA_REPROJECTION==1
#undef SMAA_REPROJECTION
#define SMAA_REPROJECTION 1
#endif
#ifndef blendTexUV
#define blendTexUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_blendTex
#define SC_USE_UV_TRANSFORM_blendTex 0
#elif SC_USE_UV_TRANSFORM_blendTex==1
#undef SC_USE_UV_TRANSFORM_blendTex
#define SC_USE_UV_TRANSFORM_blendTex 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_blendTex
#define SC_SOFTWARE_WRAP_MODE_U_blendTex -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_blendTex
#define SC_SOFTWARE_WRAP_MODE_V_blendTex -1
#endif
#ifndef SC_USE_UV_MIN_MAX_blendTex
#define SC_USE_UV_MIN_MAX_blendTex 0
#elif SC_USE_UV_MIN_MAX_blendTex==1
#undef SC_USE_UV_MIN_MAX_blendTex
#define SC_USE_UV_MIN_MAX_blendTex 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_blendTex
#define SC_USE_CLAMP_TO_BORDER_blendTex 0
#elif SC_USE_CLAMP_TO_BORDER_blendTex==1
#undef SC_USE_CLAMP_TO_BORDER_blendTex
#define SC_USE_CLAMP_TO_BORDER_blendTex 1
#endif
#ifndef inputTexUV
#define inputTexUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_inputTex
#define SC_USE_UV_TRANSFORM_inputTex 0
#elif SC_USE_UV_TRANSFORM_inputTex==1
#undef SC_USE_UV_TRANSFORM_inputTex
#define SC_USE_UV_TRANSFORM_inputTex 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_inputTex
#define SC_SOFTWARE_WRAP_MODE_U_inputTex -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_inputTex
#define SC_SOFTWARE_WRAP_MODE_V_inputTex -1
#endif
#ifndef SC_USE_UV_MIN_MAX_inputTex
#define SC_USE_UV_MIN_MAX_inputTex 0
#elif SC_USE_UV_MIN_MAX_inputTex==1
#undef SC_USE_UV_MIN_MAX_inputTex
#define SC_USE_UV_MIN_MAX_inputTex 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_inputTex
#define SC_USE_CLAMP_TO_BORDER_inputTex 0
#elif SC_USE_CLAMP_TO_BORDER_inputTex==1
#undef SC_USE_CLAMP_TO_BORDER_inputTex
#define SC_USE_CLAMP_TO_BORDER_inputTex 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float4 smaaRTMetrics [[user(locn10)]];
float2 varTexCoords [[user(locn11)]];
float4 varOffset0 [[user(locn12)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant UserUniforms& userUniformsObj,constant LibraryUniforms& libraryUniformsObj,uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
out.varTexCoords=(v.position.xy*0.5)+float2(0.5);
out.smaaRTMetrics=float4(1.0/userUniformsObj.inputRTSize.x,1.0/userUniformsObj.inputRTSize.y,userUniformsObj.inputRTSize.x,userUniformsObj.inputRTSize.y);
out.varOffset0=(out.smaaRTMetrics.xyxy*float4(1.0,0.0,0.0,-1.0))+out.varTexCoords.xyxy;
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN(100)
//sampler sampler blendTexSmpSC 0:44879
//sampler sampler inputTexSmpSC 0:42441
//texture texture2D blendTex 0:35692:0:44879
//texture texture2D inputTex 0:37167:0:42441
//ubo float UserUniforms 0:35568:264 {
//float4 blendTexSize 0
//float4 blendTexDims 16
//float4 blendTexView 32
//float3x3 blendTexTransform 48
//float4 blendTexUvMinMax 96
//float4 blendTexBorderColor 112
//float4 inputTexSize 128
//float4 inputTexDims 144
//float4 inputTexView 160
//float3x3 inputTexTransform 176
//float4 inputTexUvMinMax 224
//float4 inputTexBorderColor 240
//float2 inputRTSize 256
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 blendTexSize;
float4 blendTexDims;
float4 blendTexView;
float3x3 blendTexTransform;
float4 blendTexUvMinMax;
float4 blendTexBorderColor;
float4 inputTexSize;
float4 inputTexDims;
float4 inputTexView;
float3x3 inputTexTransform;
float4 inputTexUvMinMax;
float4 inputTexBorderColor;
float2 inputRTSize;
};

#ifndef blendTexHasSwappedViews
#define blendTexHasSwappedViews 0
#elif blendTexHasSwappedViews==1
#undef blendTexHasSwappedViews
#define blendTexHasSwappedViews 1
#endif
#ifndef blendTexLayout
#define blendTexLayout 0
#endif
#ifndef inputTexHasSwappedViews
#define inputTexHasSwappedViews 0
#elif inputTexHasSwappedViews==1
#undef inputTexHasSwappedViews
#define inputTexHasSwappedViews 1
#endif
#ifndef inputTexLayout
#define inputTexLayout 0
#endif
#ifndef SC_USE_UV_TRANSFORM_blendTex
#define SC_USE_UV_TRANSFORM_blendTex 0
#elif SC_USE_UV_TRANSFORM_blendTex==1
#undef SC_USE_UV_TRANSFORM_blendTex
#define SC_USE_UV_TRANSFORM_blendTex 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_blendTex
#define SC_SOFTWARE_WRAP_MODE_U_blendTex -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_blendTex
#define SC_SOFTWARE_WRAP_MODE_V_blendTex -1
#endif
constant int2 _2346=int2(SC_SOFTWARE_WRAP_MODE_U_blendTex,SC_SOFTWARE_WRAP_MODE_V_blendTex);
#ifndef SC_USE_UV_MIN_MAX_blendTex
#define SC_USE_UV_MIN_MAX_blendTex 0
#elif SC_USE_UV_MIN_MAX_blendTex==1
#undef SC_USE_UV_MIN_MAX_blendTex
#define SC_USE_UV_MIN_MAX_blendTex 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_blendTex
#define SC_USE_CLAMP_TO_BORDER_blendTex 0
#elif SC_USE_CLAMP_TO_BORDER_blendTex==1
#undef SC_USE_CLAMP_TO_BORDER_blendTex
#define SC_USE_CLAMP_TO_BORDER_blendTex 1
#endif
constant int2 _2380=int2(SC_SOFTWARE_WRAP_MODE_U_blendTex,SC_SOFTWARE_WRAP_MODE_V_blendTex);
constant int2 _2410=int2(SC_SOFTWARE_WRAP_MODE_U_blendTex,SC_SOFTWARE_WRAP_MODE_V_blendTex);
#ifndef SC_USE_UV_TRANSFORM_inputTex
#define SC_USE_UV_TRANSFORM_inputTex 0
#elif SC_USE_UV_TRANSFORM_inputTex==1
#undef SC_USE_UV_TRANSFORM_inputTex
#define SC_USE_UV_TRANSFORM_inputTex 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_inputTex
#define SC_SOFTWARE_WRAP_MODE_U_inputTex -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_inputTex
#define SC_SOFTWARE_WRAP_MODE_V_inputTex -1
#endif
constant int2 _2449=int2(SC_SOFTWARE_WRAP_MODE_U_inputTex,SC_SOFTWARE_WRAP_MODE_V_inputTex);
#ifndef SC_USE_UV_MIN_MAX_inputTex
#define SC_USE_UV_MIN_MAX_inputTex 0
#elif SC_USE_UV_MIN_MAX_inputTex==1
#undef SC_USE_UV_MIN_MAX_inputTex
#define SC_USE_UV_MIN_MAX_inputTex 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_inputTex
#define SC_USE_CLAMP_TO_BORDER_inputTex 0
#elif SC_USE_CLAMP_TO_BORDER_inputTex==1
#undef SC_USE_CLAMP_TO_BORDER_inputTex
#define SC_USE_CLAMP_TO_BORDER_inputTex 1
#endif
#ifndef SMAA_REPROJECTION
#define SMAA_REPROJECTION 0
#elif SMAA_REPROJECTION==1
#undef SMAA_REPROJECTION
#define SMAA_REPROJECTION 1
#endif
constant int2 _2556=int2(SC_SOFTWARE_WRAP_MODE_U_inputTex,SC_SOFTWARE_WRAP_MODE_V_inputTex);
constant int2 _2586=int2(SC_SOFTWARE_WRAP_MODE_U_inputTex,SC_SOFTWARE_WRAP_MODE_V_inputTex);
#ifndef blendTexUV
#define blendTexUV 0
#endif
#ifndef inputTexUV
#define inputTexUV 0
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float4 smaaRTMetrics [[user(locn10)]];
float2 varTexCoords [[user(locn11)]];
float4 varOffset0 [[user(locn12)]];
};

float2 blendTexGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.blendTexDims.xy;
}

int blendTexGetStereoViewIndex(thread int& varStereoViewID)
{
#if (blendTexHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 inputTexGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.inputTexDims.xy;
}

int inputTexGetStereoViewIndex(thread int& varStereoViewID)
{
#if (inputTexHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

void SMAAMovc(thread const float2& cond,thread float2& variable,thread const float2& value)
{
if (cond.x>0.0)
{
variable.x=value.x;
}
if (cond.y>0.0)
{
variable.y=value.y;
}
}

void SMAAMovc(thread const float4& cond,thread float4& variable,thread const float4& value)
{
float2 param=cond.xy;
float2 param_1=variable.xy;
float2 param_2=value.xy;
SMAAMovc(param,param_1,param_2);
variable=float4(param_1.x,param_1.y,variable.z,variable.w);
float2 param_3=cond.zw;
float2 param_4=variable.zw;
float2 param_5=value.zw;
SMAAMovc(param_3,param_4,param_5);
variable=float4(variable.x,variable.y,param_4.x,param_4.y);
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj,texture2d<float> blendTex,texture2d<float> inputTex,sampler inputTexSmpSC,sampler blendTexSmpSC,float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float4 a=float4(0.0);
float4 color=float4(0.0);
float2 param=blendTexGetDims2D(userUniformsObj);
int param_1=blendTexLayout;
int param_2=blendTexGetStereoViewIndex(in.varStereoViewID);
float2 param_3=in.varOffset0.xy;
bool param_4=(int(SC_USE_UV_TRANSFORM_blendTex)!=0);
float3x3 param_5=userUniformsObj.blendTexTransform;
int2 param_6=_2346;
bool param_7=(int(SC_USE_UV_MIN_MAX_blendTex)!=0);
float4 param_8=userUniformsObj.blendTexUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_blendTex)!=0);
float4 param_10=userUniformsObj.blendTexBorderColor;
float param_11=0.0;
float4 _2372=sc_SampleTextureBiasOrLevel(blendTex,blendTexSmpSC,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
float4 _2339=_2372;
float4 blendTexSample=_2372;
a.x=blendTexSample.w;
float2 param_12=blendTexGetDims2D(userUniformsObj);
int param_13=blendTexLayout;
int param_14=blendTexGetStereoViewIndex(in.varStereoViewID);
float2 param_15=in.varOffset0.zw;
bool param_16=(int(SC_USE_UV_TRANSFORM_blendTex)!=0);
float3x3 param_17=userUniformsObj.blendTexTransform;
int2 param_18=_2380;
bool param_19=(int(SC_USE_UV_MIN_MAX_blendTex)!=0);
float4 param_20=userUniformsObj.blendTexUvMinMax;
bool param_21=(int(SC_USE_CLAMP_TO_BORDER_blendTex)!=0);
float4 param_22=userUniformsObj.blendTexBorderColor;
float param_23=0.0;
float4 _2401=sc_SampleTextureBiasOrLevel(blendTex,blendTexSmpSC,param_12,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23);
float4 _2377=_2401;
float4 blendTexSample_1=_2401;
a.y=blendTexSample_1.y;
float2 param_24=blendTexGetDims2D(userUniformsObj);
int param_25=blendTexLayout;
int param_26=blendTexGetStereoViewIndex(in.varStereoViewID);
float2 param_27=in.varTexCoords;
bool param_28=(int(SC_USE_UV_TRANSFORM_blendTex)!=0);
float3x3 param_29=userUniformsObj.blendTexTransform;
int2 param_30=_2410;
bool param_31=(int(SC_USE_UV_MIN_MAX_blendTex)!=0);
float4 param_32=userUniformsObj.blendTexUvMinMax;
bool param_33=(int(SC_USE_CLAMP_TO_BORDER_blendTex)!=0);
float4 param_34=userUniformsObj.blendTexBorderColor;
float param_35=0.0;
float4 _2430=sc_SampleTextureBiasOrLevel(blendTex,blendTexSmpSC,param_24,param_25,param_26,param_27,param_28,param_29,param_30,param_31,param_32,param_33,param_34,param_35);
float4 _2406=_2430;
float4 blendTexSample_2=_2430;
a=float4(a.x,a.y,blendTexSample_2.xz.y,blendTexSample_2.xz.x);
if (dot(a,float4(1.0))<1e-05)
{
float2 param_36=inputTexGetDims2D(userUniformsObj);
int param_37=inputTexLayout;
int param_38=inputTexGetStereoViewIndex(in.varStereoViewID);
float2 param_39=in.varTexCoords;
bool param_40=(int(SC_USE_UV_TRANSFORM_inputTex)!=0);
float3x3 param_41=userUniformsObj.inputTexTransform;
int2 param_42=_2449;
bool param_43=(int(SC_USE_UV_MIN_MAX_inputTex)!=0);
float4 param_44=userUniformsObj.inputTexUvMinMax;
bool param_45=(int(SC_USE_CLAMP_TO_BORDER_inputTex)!=0);
float4 param_46=userUniformsObj.inputTexBorderColor;
float param_47=0.0;
float4 _2473=sc_SampleTextureBiasOrLevel(inputTex,inputTexSmpSC,param_36,param_37,param_38,param_39,param_40,param_41,param_42,param_43,param_44,param_45,param_46,param_47);
float4 _2442=_2473;
float4 inputTexSample=_2473;
#if (SMAA_REPROJECTION)
{
}
#endif
color=inputTexSample;
}
else
{
float h=float(fast::max(a.x,a.z)>fast::max(a.y,a.w));
float4 blendingOffset=float4(0.0,a.y,0.0,a.w);
float2 blendingWeight=a.yw;
float4 param_48=float4(h,h,h,h);
float4 param_49=blendingOffset;
float4 param_50=float4(a.x,0.0,a.z,0.0);
SMAAMovc(param_48,param_49,param_50);
blendingOffset=param_49;
float2 param_51=float2(h,h);
float2 param_52=blendingWeight;
float2 param_53=a.xz;
SMAAMovc(param_51,param_52,param_53);
blendingWeight=param_52;
blendingWeight/=float2(dot(blendingWeight,float2(1.0)));
float4 blendingCoord=(blendingOffset*float4(in.smaaRTMetrics.x,-in.smaaRTMetrics.y,-in.smaaRTMetrics.x,in.smaaRTMetrics.y))+in.varTexCoords.xyxy;
float2 param_54=inputTexGetDims2D(userUniformsObj);
int param_55=inputTexLayout;
int param_56=inputTexGetStereoViewIndex(in.varStereoViewID);
float2 param_57=blendingCoord.xy;
bool param_58=(int(SC_USE_UV_TRANSFORM_inputTex)!=0);
float3x3 param_59=userUniformsObj.inputTexTransform;
int2 param_60=_2556;
bool param_61=(int(SC_USE_UV_MIN_MAX_inputTex)!=0);
float4 param_62=userUniformsObj.inputTexUvMinMax;
bool param_63=(int(SC_USE_CLAMP_TO_BORDER_inputTex)!=0);
float4 param_64=userUniformsObj.inputTexBorderColor;
float param_65=0.0;
float4 _2577=sc_SampleTextureBiasOrLevel(inputTex,inputTexSmpSC,param_54,param_55,param_56,param_57,param_58,param_59,param_60,param_61,param_62,param_63,param_64,param_65);
float4 _2553=_2577;
float4 inputTexSample_1=_2577;
color=inputTexSample_1*blendingWeight.x;
float2 param_66=inputTexGetDims2D(userUniformsObj);
int param_67=inputTexLayout;
int param_68=inputTexGetStereoViewIndex(in.varStereoViewID);
float2 param_69=blendingCoord.zw;
bool param_70=(int(SC_USE_UV_TRANSFORM_inputTex)!=0);
float3x3 param_71=userUniformsObj.inputTexTransform;
int2 param_72=_2586;
bool param_73=(int(SC_USE_UV_MIN_MAX_inputTex)!=0);
float4 param_74=userUniformsObj.inputTexUvMinMax;
bool param_75=(int(SC_USE_CLAMP_TO_BORDER_inputTex)!=0);
float4 param_76=userUniformsObj.inputTexBorderColor;
float param_77=0.0;
float4 _2607=sc_SampleTextureBiasOrLevel(inputTex,inputTexSmpSC,param_66,param_67,param_68,param_69,param_70,param_71,param_72,param_73,param_74,param_75,param_76,param_77);
float4 _2583=_2607;
float4 inputTexSample_2=_2607;
color+=(inputTexSample_2*blendingWeight.y);
#if (SMAA_REPROJECTION)
{
}
#endif
}
float4 param_78=color;
sc_writeFragData0(param_78,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
