#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define SC_USE_USER_DEFINED_VS_MAIN 1;
#define STD_DISABLE_VERTEX_NORMAL 1;
#define STD_DISABLE_VERTEX_TANGENT 1;

#include "std2.metal"
#include "std2_fs.metal"
#include "std2_vs.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN(100)
//attribute float passIdentifierAttr 15
//attribute float sdfOffsetAttr 16
//SG_REFLECTION_END


struct UserUniforms
{
float4 mainTextureSize;
float4 mainTextureDims;
float4 mainTextureView;
float3x3 mainTextureTransform;
float4 mainTextureUvMinMax;
float4 mainTextureBorderColor;
float4 colorTextureSize;
float4 colorTextureDims;
float4 colorTextureView;
float3x3 colorTextureTransform;
float4 colorTextureUvMinMax;
float4 colorTextureBorderColor;
float4 mainFillTextureSize;
float4 mainFillTextureDims;
float4 mainFillTextureView;
float3x3 mainFillTextureTransform;
float4 mainFillTextureUvMinMax;
float4 mainFillTextureBorderColor;
float4 shadowFillTextureSize;
float4 shadowFillTextureDims;
float4 shadowFillTextureView;
float3x3 shadowFillTextureTransform;
float4 shadowFillTextureUvMinMax;
float4 shadowFillTextureBorderColor;
float4 outlineFillTextureSize;
float4 outlineFillTextureDims;
float4 outlineFillTextureView;
float3x3 outlineFillTextureTransform;
float4 outlineFillTextureUvMinMax;
float4 outlineFillTextureBorderColor;
float4 backgroundFillTextureSize;
float4 backgroundFillTextureDims;
float4 backgroundFillTextureView;
float3x3 backgroundFillTextureTransform;
float4 backgroundFillTextureUvMinMax;
float4 backgroundFillTextureBorderColor;
float4 mainColor;
float4 shadowColor;
float4 outlineColor;
float4 backgroundColor;
float backgroundCornerRadius;
float2 backgroundSize;
float multisampleBlend;
};

#ifndef mainTextureHasSwappedViews
#define mainTextureHasSwappedViews 0
#elif mainTextureHasSwappedViews==1
#undef mainTextureHasSwappedViews
#define mainTextureHasSwappedViews 1
#endif
#ifndef mainTextureLayout
#define mainTextureLayout 0
#endif
#ifndef colorTextureHasSwappedViews
#define colorTextureHasSwappedViews 0
#elif colorTextureHasSwappedViews==1
#undef colorTextureHasSwappedViews
#define colorTextureHasSwappedViews 1
#endif
#ifndef colorTextureLayout
#define colorTextureLayout 0
#endif
#ifndef mainFillTextureHasSwappedViews
#define mainFillTextureHasSwappedViews 0
#elif mainFillTextureHasSwappedViews==1
#undef mainFillTextureHasSwappedViews
#define mainFillTextureHasSwappedViews 1
#endif
#ifndef mainFillTextureLayout
#define mainFillTextureLayout 0
#endif
#ifndef shadowFillTextureHasSwappedViews
#define shadowFillTextureHasSwappedViews 0
#elif shadowFillTextureHasSwappedViews==1
#undef shadowFillTextureHasSwappedViews
#define shadowFillTextureHasSwappedViews 1
#endif
#ifndef shadowFillTextureLayout
#define shadowFillTextureLayout 0
#endif
#ifndef outlineFillTextureHasSwappedViews
#define outlineFillTextureHasSwappedViews 0
#elif outlineFillTextureHasSwappedViews==1
#undef outlineFillTextureHasSwappedViews
#define outlineFillTextureHasSwappedViews 1
#endif
#ifndef outlineFillTextureLayout
#define outlineFillTextureLayout 0
#endif
#ifndef backgroundFillTextureHasSwappedViews
#define backgroundFillTextureHasSwappedViews 0
#elif backgroundFillTextureHasSwappedViews==1
#undef backgroundFillTextureHasSwappedViews
#define backgroundFillTextureHasSwappedViews 1
#endif
#ifndef backgroundFillTextureLayout
#define backgroundFillTextureLayout 0
#endif
#ifndef MAIN_FILL_COLOR
#define MAIN_FILL_COLOR 0
#elif MAIN_FILL_COLOR==1
#undef MAIN_FILL_COLOR
#define MAIN_FILL_COLOR 1
#endif
#ifndef MAIN_FILL_TEXTURE
#define MAIN_FILL_TEXTURE 0
#elif MAIN_FILL_TEXTURE==1
#undef MAIN_FILL_TEXTURE
#define MAIN_FILL_TEXTURE 1
#endif
#ifndef ENABLE_SHADOW
#define ENABLE_SHADOW 0
#elif ENABLE_SHADOW==1
#undef ENABLE_SHADOW
#define ENABLE_SHADOW 1
#endif
#ifndef SHADOW_FILL_COLOR
#define SHADOW_FILL_COLOR 0
#elif SHADOW_FILL_COLOR==1
#undef SHADOW_FILL_COLOR
#define SHADOW_FILL_COLOR 1
#endif
#ifndef SHADOW_FILL_TEXTURE
#define SHADOW_FILL_TEXTURE 0
#elif SHADOW_FILL_TEXTURE==1
#undef SHADOW_FILL_TEXTURE
#define SHADOW_FILL_TEXTURE 1
#endif
#ifndef ENABLE_OUTLINE
#define ENABLE_OUTLINE 0
#elif ENABLE_OUTLINE==1
#undef ENABLE_OUTLINE
#define ENABLE_OUTLINE 1
#endif
#ifndef ENABLE_SDF
#define ENABLE_SDF 0
#elif ENABLE_SDF==1
#undef ENABLE_SDF
#define ENABLE_SDF 1
#endif
#ifndef OUTLINE_FILL_COLOR
#define OUTLINE_FILL_COLOR 0
#elif OUTLINE_FILL_COLOR==1
#undef OUTLINE_FILL_COLOR
#define OUTLINE_FILL_COLOR 1
#endif
#ifndef OUTLINE_FILL_TEXTURE
#define OUTLINE_FILL_TEXTURE 0
#elif OUTLINE_FILL_TEXTURE==1
#undef OUTLINE_FILL_TEXTURE
#define OUTLINE_FILL_TEXTURE 1
#endif
#ifndef ENABLE_BACKGROUND
#define ENABLE_BACKGROUND 0
#elif ENABLE_BACKGROUND==1
#undef ENABLE_BACKGROUND
#define ENABLE_BACKGROUND 1
#endif
#ifndef BACKGROUND_FILL_COLOR
#define BACKGROUND_FILL_COLOR 0
#elif BACKGROUND_FILL_COLOR==1
#undef BACKGROUND_FILL_COLOR
#define BACKGROUND_FILL_COLOR 1
#endif
#ifndef BACKGROUND_FILL_TEXTURE
#define BACKGROUND_FILL_TEXTURE 0
#elif BACKGROUND_FILL_TEXTURE==1
#undef BACKGROUND_FILL_TEXTURE
#define BACKGROUND_FILL_TEXTURE 1
#endif
#ifndef mainTextureUV
#define mainTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_mainTexture
#define SC_USE_UV_TRANSFORM_mainTexture 0
#elif SC_USE_UV_TRANSFORM_mainTexture==1
#undef SC_USE_UV_TRANSFORM_mainTexture
#define SC_USE_UV_TRANSFORM_mainTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_mainTexture
#define SC_SOFTWARE_WRAP_MODE_U_mainTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_mainTexture
#define SC_SOFTWARE_WRAP_MODE_V_mainTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_mainTexture
#define SC_USE_UV_MIN_MAX_mainTexture 0
#elif SC_USE_UV_MIN_MAX_mainTexture==1
#undef SC_USE_UV_MIN_MAX_mainTexture
#define SC_USE_UV_MIN_MAX_mainTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_mainTexture
#define SC_USE_CLAMP_TO_BORDER_mainTexture 0
#elif SC_USE_CLAMP_TO_BORDER_mainTexture==1
#undef SC_USE_CLAMP_TO_BORDER_mainTexture
#define SC_USE_CLAMP_TO_BORDER_mainTexture 1
#endif
#ifndef colorTextureUV
#define colorTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_colorTexture
#define SC_USE_UV_TRANSFORM_colorTexture 0
#elif SC_USE_UV_TRANSFORM_colorTexture==1
#undef SC_USE_UV_TRANSFORM_colorTexture
#define SC_USE_UV_TRANSFORM_colorTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_colorTexture
#define SC_SOFTWARE_WRAP_MODE_U_colorTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_colorTexture
#define SC_SOFTWARE_WRAP_MODE_V_colorTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_colorTexture
#define SC_USE_UV_MIN_MAX_colorTexture 0
#elif SC_USE_UV_MIN_MAX_colorTexture==1
#undef SC_USE_UV_MIN_MAX_colorTexture
#define SC_USE_UV_MIN_MAX_colorTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_colorTexture
#define SC_USE_CLAMP_TO_BORDER_colorTexture 0
#elif SC_USE_CLAMP_TO_BORDER_colorTexture==1
#undef SC_USE_CLAMP_TO_BORDER_colorTexture
#define SC_USE_CLAMP_TO_BORDER_colorTexture 1
#endif
#ifndef mainFillTextureUV
#define mainFillTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_mainFillTexture
#define SC_USE_UV_TRANSFORM_mainFillTexture 0
#elif SC_USE_UV_TRANSFORM_mainFillTexture==1
#undef SC_USE_UV_TRANSFORM_mainFillTexture
#define SC_USE_UV_TRANSFORM_mainFillTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_mainFillTexture
#define SC_SOFTWARE_WRAP_MODE_U_mainFillTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_mainFillTexture
#define SC_SOFTWARE_WRAP_MODE_V_mainFillTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_mainFillTexture
#define SC_USE_UV_MIN_MAX_mainFillTexture 0
#elif SC_USE_UV_MIN_MAX_mainFillTexture==1
#undef SC_USE_UV_MIN_MAX_mainFillTexture
#define SC_USE_UV_MIN_MAX_mainFillTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_mainFillTexture
#define SC_USE_CLAMP_TO_BORDER_mainFillTexture 0
#elif SC_USE_CLAMP_TO_BORDER_mainFillTexture==1
#undef SC_USE_CLAMP_TO_BORDER_mainFillTexture
#define SC_USE_CLAMP_TO_BORDER_mainFillTexture 1
#endif
#ifndef shadowFillTextureUV
#define shadowFillTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_shadowFillTexture
#define SC_USE_UV_TRANSFORM_shadowFillTexture 0
#elif SC_USE_UV_TRANSFORM_shadowFillTexture==1
#undef SC_USE_UV_TRANSFORM_shadowFillTexture
#define SC_USE_UV_TRANSFORM_shadowFillTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_shadowFillTexture
#define SC_SOFTWARE_WRAP_MODE_U_shadowFillTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_shadowFillTexture
#define SC_SOFTWARE_WRAP_MODE_V_shadowFillTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_shadowFillTexture
#define SC_USE_UV_MIN_MAX_shadowFillTexture 0
#elif SC_USE_UV_MIN_MAX_shadowFillTexture==1
#undef SC_USE_UV_MIN_MAX_shadowFillTexture
#define SC_USE_UV_MIN_MAX_shadowFillTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_shadowFillTexture
#define SC_USE_CLAMP_TO_BORDER_shadowFillTexture 0
#elif SC_USE_CLAMP_TO_BORDER_shadowFillTexture==1
#undef SC_USE_CLAMP_TO_BORDER_shadowFillTexture
#define SC_USE_CLAMP_TO_BORDER_shadowFillTexture 1
#endif
#ifndef outlineFillTextureUV
#define outlineFillTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_outlineFillTexture
#define SC_USE_UV_TRANSFORM_outlineFillTexture 0
#elif SC_USE_UV_TRANSFORM_outlineFillTexture==1
#undef SC_USE_UV_TRANSFORM_outlineFillTexture
#define SC_USE_UV_TRANSFORM_outlineFillTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_outlineFillTexture
#define SC_SOFTWARE_WRAP_MODE_U_outlineFillTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_outlineFillTexture
#define SC_SOFTWARE_WRAP_MODE_V_outlineFillTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_outlineFillTexture
#define SC_USE_UV_MIN_MAX_outlineFillTexture 0
#elif SC_USE_UV_MIN_MAX_outlineFillTexture==1
#undef SC_USE_UV_MIN_MAX_outlineFillTexture
#define SC_USE_UV_MIN_MAX_outlineFillTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_outlineFillTexture
#define SC_USE_CLAMP_TO_BORDER_outlineFillTexture 0
#elif SC_USE_CLAMP_TO_BORDER_outlineFillTexture==1
#undef SC_USE_CLAMP_TO_BORDER_outlineFillTexture
#define SC_USE_CLAMP_TO_BORDER_outlineFillTexture 1
#endif
#ifndef backgroundFillTextureUV
#define backgroundFillTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_backgroundFillTexture
#define SC_USE_UV_TRANSFORM_backgroundFillTexture 0
#elif SC_USE_UV_TRANSFORM_backgroundFillTexture==1
#undef SC_USE_UV_TRANSFORM_backgroundFillTexture
#define SC_USE_UV_TRANSFORM_backgroundFillTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_backgroundFillTexture
#define SC_SOFTWARE_WRAP_MODE_U_backgroundFillTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_backgroundFillTexture
#define SC_SOFTWARE_WRAP_MODE_V_backgroundFillTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_backgroundFillTexture
#define SC_USE_UV_MIN_MAX_backgroundFillTexture 0
#elif SC_USE_UV_MIN_MAX_backgroundFillTexture==1
#undef SC_USE_UV_MIN_MAX_backgroundFillTexture
#define SC_USE_UV_MIN_MAX_backgroundFillTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_backgroundFillTexture
#define SC_USE_CLAMP_TO_BORDER_backgroundFillTexture 0
#elif SC_USE_CLAMP_TO_BORDER_backgroundFillTexture==1
#undef SC_USE_CLAMP_TO_BORDER_backgroundFillTexture
#define SC_USE_CLAMP_TO_BORDER_backgroundFillTexture 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float varPassIdentifier [[user(locn10)]];
float varSdfOffset [[user(locn11)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
float passIdentifierAttr [[attribute(15)]];
float sdfOffsetAttr [[attribute(16)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant LibraryUniforms& libraryUniformsObj,uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
out.varPassIdentifier=in.passIdentifierAttr;
out.varSdfOffset=in.sdfOffsetAttr;
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN(100)
//sampler sampler mainTextureSmpSC 0:43517
//sampler sampler colorTextureSmpSC 0:39314
//sampler sampler mainFillTextureSmpSC 0:52327
//sampler sampler shadowFillTextureSmpSC 0:40286
//sampler sampler outlineFillTextureSmpSC 0:48899
//sampler sampler backgroundFillTextureSmpSC 0:47597
//texture texture2D mainTexture 0:61325:0:43517
//texture texture2D colorTexture 0:51974:0:39314
//texture texture2D mainFillTexture 0:33230:0:52327
//texture texture2D shadowFillTexture 0:64307:0:40286
//texture texture2D outlineFillTexture 0:53734:0:48899
//texture texture2D backgroundFillTexture 0:61801:0:47597
//ubo float UserUniforms 0:35568:852 {
//float4 mainTextureSize 0
//float4 mainTextureDims 16
//float4 mainTextureView 32
//float3x3 mainTextureTransform 48
//float4 mainTextureUvMinMax 96
//float4 mainTextureBorderColor 112
//float4 colorTextureSize 128
//float4 colorTextureDims 144
//float4 colorTextureView 160
//float3x3 colorTextureTransform 176
//float4 colorTextureUvMinMax 224
//float4 colorTextureBorderColor 240
//float4 mainFillTextureSize 256
//float4 mainFillTextureDims 272
//float4 mainFillTextureView 288
//float3x3 mainFillTextureTransform 304
//float4 mainFillTextureUvMinMax 352
//float4 mainFillTextureBorderColor 368
//float4 shadowFillTextureSize 384
//float4 shadowFillTextureDims 400
//float4 shadowFillTextureView 416
//float3x3 shadowFillTextureTransform 432
//float4 shadowFillTextureUvMinMax 480
//float4 shadowFillTextureBorderColor 496
//float4 outlineFillTextureSize 512
//float4 outlineFillTextureDims 528
//float4 outlineFillTextureView 544
//float3x3 outlineFillTextureTransform 560
//float4 outlineFillTextureUvMinMax 608
//float4 outlineFillTextureBorderColor 624
//float4 backgroundFillTextureSize 640
//float4 backgroundFillTextureDims 656
//float4 backgroundFillTextureView 672
//float3x3 backgroundFillTextureTransform 688
//float4 backgroundFillTextureUvMinMax 736
//float4 backgroundFillTextureBorderColor 752
//float4 mainColor 768
//float4 shadowColor 784
//float4 outlineColor 800
//float4 backgroundColor 816
//float backgroundCornerRadius 832
//float2 backgroundSize 840
//float multisampleBlend 848
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 mainTextureSize;
float4 mainTextureDims;
float4 mainTextureView;
float3x3 mainTextureTransform;
float4 mainTextureUvMinMax;
float4 mainTextureBorderColor;
float4 colorTextureSize;
float4 colorTextureDims;
float4 colorTextureView;
float3x3 colorTextureTransform;
float4 colorTextureUvMinMax;
float4 colorTextureBorderColor;
float4 mainFillTextureSize;
float4 mainFillTextureDims;
float4 mainFillTextureView;
float3x3 mainFillTextureTransform;
float4 mainFillTextureUvMinMax;
float4 mainFillTextureBorderColor;
float4 shadowFillTextureSize;
float4 shadowFillTextureDims;
float4 shadowFillTextureView;
float3x3 shadowFillTextureTransform;
float4 shadowFillTextureUvMinMax;
float4 shadowFillTextureBorderColor;
float4 outlineFillTextureSize;
float4 outlineFillTextureDims;
float4 outlineFillTextureView;
float3x3 outlineFillTextureTransform;
float4 outlineFillTextureUvMinMax;
float4 outlineFillTextureBorderColor;
float4 backgroundFillTextureSize;
float4 backgroundFillTextureDims;
float4 backgroundFillTextureView;
float3x3 backgroundFillTextureTransform;
float4 backgroundFillTextureUvMinMax;
float4 backgroundFillTextureBorderColor;
float4 mainColor;
float4 shadowColor;
float4 outlineColor;
float4 backgroundColor;
float backgroundCornerRadius;
float2 backgroundSize;
float multisampleBlend;
};

#ifndef mainTextureHasSwappedViews
#define mainTextureHasSwappedViews 0
#elif mainTextureHasSwappedViews==1
#undef mainTextureHasSwappedViews
#define mainTextureHasSwappedViews 1
#endif
#ifndef mainTextureLayout
#define mainTextureLayout 0
#endif
#ifndef colorTextureHasSwappedViews
#define colorTextureHasSwappedViews 0
#elif colorTextureHasSwappedViews==1
#undef colorTextureHasSwappedViews
#define colorTextureHasSwappedViews 1
#endif
#ifndef colorTextureLayout
#define colorTextureLayout 0
#endif
#ifndef mainFillTextureHasSwappedViews
#define mainFillTextureHasSwappedViews 0
#elif mainFillTextureHasSwappedViews==1
#undef mainFillTextureHasSwappedViews
#define mainFillTextureHasSwappedViews 1
#endif
#ifndef mainFillTextureLayout
#define mainFillTextureLayout 0
#endif
#ifndef shadowFillTextureHasSwappedViews
#define shadowFillTextureHasSwappedViews 0
#elif shadowFillTextureHasSwappedViews==1
#undef shadowFillTextureHasSwappedViews
#define shadowFillTextureHasSwappedViews 1
#endif
#ifndef shadowFillTextureLayout
#define shadowFillTextureLayout 0
#endif
#ifndef outlineFillTextureHasSwappedViews
#define outlineFillTextureHasSwappedViews 0
#elif outlineFillTextureHasSwappedViews==1
#undef outlineFillTextureHasSwappedViews
#define outlineFillTextureHasSwappedViews 1
#endif
#ifndef outlineFillTextureLayout
#define outlineFillTextureLayout 0
#endif
#ifndef backgroundFillTextureHasSwappedViews
#define backgroundFillTextureHasSwappedViews 0
#elif backgroundFillTextureHasSwappedViews==1
#undef backgroundFillTextureHasSwappedViews
#define backgroundFillTextureHasSwappedViews 1
#endif
#ifndef backgroundFillTextureLayout
#define backgroundFillTextureLayout 0
#endif
#ifndef SC_USE_UV_TRANSFORM_mainTexture
#define SC_USE_UV_TRANSFORM_mainTexture 0
#elif SC_USE_UV_TRANSFORM_mainTexture==1
#undef SC_USE_UV_TRANSFORM_mainTexture
#define SC_USE_UV_TRANSFORM_mainTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_mainTexture
#define SC_SOFTWARE_WRAP_MODE_U_mainTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_mainTexture
#define SC_SOFTWARE_WRAP_MODE_V_mainTexture -1
#endif
constant int2 _2954=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
#ifndef SC_USE_UV_MIN_MAX_mainTexture
#define SC_USE_UV_MIN_MAX_mainTexture 0
#elif SC_USE_UV_MIN_MAX_mainTexture==1
#undef SC_USE_UV_MIN_MAX_mainTexture
#define SC_USE_UV_MIN_MAX_mainTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_mainTexture
#define SC_USE_CLAMP_TO_BORDER_mainTexture 0
#elif SC_USE_CLAMP_TO_BORDER_mainTexture==1
#undef SC_USE_CLAMP_TO_BORDER_mainTexture
#define SC_USE_CLAMP_TO_BORDER_mainTexture 1
#endif
constant int2 _2993=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3027=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3061=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
#ifndef MAIN_FILL_COLOR
#define MAIN_FILL_COLOR 0
#elif MAIN_FILL_COLOR==1
#undef MAIN_FILL_COLOR
#define MAIN_FILL_COLOR 1
#endif
#ifndef MAIN_FILL_TEXTURE
#define MAIN_FILL_TEXTURE 0
#elif MAIN_FILL_TEXTURE==1
#undef MAIN_FILL_TEXTURE
#define MAIN_FILL_TEXTURE 1
#endif
#ifndef SC_USE_UV_TRANSFORM_mainFillTexture
#define SC_USE_UV_TRANSFORM_mainFillTexture 0
#elif SC_USE_UV_TRANSFORM_mainFillTexture==1
#undef SC_USE_UV_TRANSFORM_mainFillTexture
#define SC_USE_UV_TRANSFORM_mainFillTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_mainFillTexture
#define SC_SOFTWARE_WRAP_MODE_U_mainFillTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_mainFillTexture
#define SC_SOFTWARE_WRAP_MODE_V_mainFillTexture -1
#endif
constant int2 _3200=int2(SC_SOFTWARE_WRAP_MODE_U_mainFillTexture,SC_SOFTWARE_WRAP_MODE_V_mainFillTexture);
#ifndef SC_USE_UV_MIN_MAX_mainFillTexture
#define SC_USE_UV_MIN_MAX_mainFillTexture 0
#elif SC_USE_UV_MIN_MAX_mainFillTexture==1
#undef SC_USE_UV_MIN_MAX_mainFillTexture
#define SC_USE_UV_MIN_MAX_mainFillTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_mainFillTexture
#define SC_USE_CLAMP_TO_BORDER_mainFillTexture 0
#elif SC_USE_CLAMP_TO_BORDER_mainFillTexture==1
#undef SC_USE_CLAMP_TO_BORDER_mainFillTexture
#define SC_USE_CLAMP_TO_BORDER_mainFillTexture 1
#endif
#ifndef ENABLE_SHADOW
#define ENABLE_SHADOW 0
#elif ENABLE_SHADOW==1
#undef ENABLE_SHADOW
#define ENABLE_SHADOW 1
#endif
#ifndef SHADOW_FILL_COLOR
#define SHADOW_FILL_COLOR 0
#elif SHADOW_FILL_COLOR==1
#undef SHADOW_FILL_COLOR
#define SHADOW_FILL_COLOR 1
#endif
#ifndef SHADOW_FILL_TEXTURE
#define SHADOW_FILL_TEXTURE 0
#elif SHADOW_FILL_TEXTURE==1
#undef SHADOW_FILL_TEXTURE
#define SHADOW_FILL_TEXTURE 1
#endif
#ifndef SC_USE_UV_TRANSFORM_shadowFillTexture
#define SC_USE_UV_TRANSFORM_shadowFillTexture 0
#elif SC_USE_UV_TRANSFORM_shadowFillTexture==1
#undef SC_USE_UV_TRANSFORM_shadowFillTexture
#define SC_USE_UV_TRANSFORM_shadowFillTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_shadowFillTexture
#define SC_SOFTWARE_WRAP_MODE_U_shadowFillTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_shadowFillTexture
#define SC_SOFTWARE_WRAP_MODE_V_shadowFillTexture -1
#endif
constant int2 _3254=int2(SC_SOFTWARE_WRAP_MODE_U_shadowFillTexture,SC_SOFTWARE_WRAP_MODE_V_shadowFillTexture);
#ifndef SC_USE_UV_MIN_MAX_shadowFillTexture
#define SC_USE_UV_MIN_MAX_shadowFillTexture 0
#elif SC_USE_UV_MIN_MAX_shadowFillTexture==1
#undef SC_USE_UV_MIN_MAX_shadowFillTexture
#define SC_USE_UV_MIN_MAX_shadowFillTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_shadowFillTexture
#define SC_USE_CLAMP_TO_BORDER_shadowFillTexture 0
#elif SC_USE_CLAMP_TO_BORDER_shadowFillTexture==1
#undef SC_USE_CLAMP_TO_BORDER_shadowFillTexture
#define SC_USE_CLAMP_TO_BORDER_shadowFillTexture 1
#endif
#ifndef ENABLE_OUTLINE
#define ENABLE_OUTLINE 0
#elif ENABLE_OUTLINE==1
#undef ENABLE_OUTLINE
#define ENABLE_OUTLINE 1
#endif
#ifndef ENABLE_SDF
#define ENABLE_SDF 0
#elif ENABLE_SDF==1
#undef ENABLE_SDF
#define ENABLE_SDF 1
#endif
#ifndef OUTLINE_FILL_COLOR
#define OUTLINE_FILL_COLOR 0
#elif OUTLINE_FILL_COLOR==1
#undef OUTLINE_FILL_COLOR
#define OUTLINE_FILL_COLOR 1
#endif
#ifndef OUTLINE_FILL_TEXTURE
#define OUTLINE_FILL_TEXTURE 0
#elif OUTLINE_FILL_TEXTURE==1
#undef OUTLINE_FILL_TEXTURE
#define OUTLINE_FILL_TEXTURE 1
#endif
#ifndef SC_USE_UV_TRANSFORM_outlineFillTexture
#define SC_USE_UV_TRANSFORM_outlineFillTexture 0
#elif SC_USE_UV_TRANSFORM_outlineFillTexture==1
#undef SC_USE_UV_TRANSFORM_outlineFillTexture
#define SC_USE_UV_TRANSFORM_outlineFillTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_outlineFillTexture
#define SC_SOFTWARE_WRAP_MODE_U_outlineFillTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_outlineFillTexture
#define SC_SOFTWARE_WRAP_MODE_V_outlineFillTexture -1
#endif
constant int2 _3316=int2(SC_SOFTWARE_WRAP_MODE_U_outlineFillTexture,SC_SOFTWARE_WRAP_MODE_V_outlineFillTexture);
#ifndef SC_USE_UV_MIN_MAX_outlineFillTexture
#define SC_USE_UV_MIN_MAX_outlineFillTexture 0
#elif SC_USE_UV_MIN_MAX_outlineFillTexture==1
#undef SC_USE_UV_MIN_MAX_outlineFillTexture
#define SC_USE_UV_MIN_MAX_outlineFillTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_outlineFillTexture
#define SC_USE_CLAMP_TO_BORDER_outlineFillTexture 0
#elif SC_USE_CLAMP_TO_BORDER_outlineFillTexture==1
#undef SC_USE_CLAMP_TO_BORDER_outlineFillTexture
#define SC_USE_CLAMP_TO_BORDER_outlineFillTexture 1
#endif
#ifndef ENABLE_BACKGROUND
#define ENABLE_BACKGROUND 0
#elif ENABLE_BACKGROUND==1
#undef ENABLE_BACKGROUND
#define ENABLE_BACKGROUND 1
#endif
#ifndef BACKGROUND_FILL_COLOR
#define BACKGROUND_FILL_COLOR 0
#elif BACKGROUND_FILL_COLOR==1
#undef BACKGROUND_FILL_COLOR
#define BACKGROUND_FILL_COLOR 1
#endif
#ifndef BACKGROUND_FILL_TEXTURE
#define BACKGROUND_FILL_TEXTURE 0
#elif BACKGROUND_FILL_TEXTURE==1
#undef BACKGROUND_FILL_TEXTURE
#define BACKGROUND_FILL_TEXTURE 1
#endif
#ifndef SC_USE_UV_TRANSFORM_backgroundFillTexture
#define SC_USE_UV_TRANSFORM_backgroundFillTexture 0
#elif SC_USE_UV_TRANSFORM_backgroundFillTexture==1
#undef SC_USE_UV_TRANSFORM_backgroundFillTexture
#define SC_USE_UV_TRANSFORM_backgroundFillTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_backgroundFillTexture
#define SC_SOFTWARE_WRAP_MODE_U_backgroundFillTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_backgroundFillTexture
#define SC_SOFTWARE_WRAP_MODE_V_backgroundFillTexture -1
#endif
constant int2 _3419=int2(SC_SOFTWARE_WRAP_MODE_U_backgroundFillTexture,SC_SOFTWARE_WRAP_MODE_V_backgroundFillTexture);
#ifndef SC_USE_UV_MIN_MAX_backgroundFillTexture
#define SC_USE_UV_MIN_MAX_backgroundFillTexture 0
#elif SC_USE_UV_MIN_MAX_backgroundFillTexture==1
#undef SC_USE_UV_MIN_MAX_backgroundFillTexture
#define SC_USE_UV_MIN_MAX_backgroundFillTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_backgroundFillTexture
#define SC_USE_CLAMP_TO_BORDER_backgroundFillTexture 0
#elif SC_USE_CLAMP_TO_BORDER_backgroundFillTexture==1
#undef SC_USE_CLAMP_TO_BORDER_backgroundFillTexture
#define SC_USE_CLAMP_TO_BORDER_backgroundFillTexture 1
#endif
#ifndef SC_USE_UV_TRANSFORM_colorTexture
#define SC_USE_UV_TRANSFORM_colorTexture 0
#elif SC_USE_UV_TRANSFORM_colorTexture==1
#undef SC_USE_UV_TRANSFORM_colorTexture
#define SC_USE_UV_TRANSFORM_colorTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_colorTexture
#define SC_SOFTWARE_WRAP_MODE_U_colorTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_colorTexture
#define SC_SOFTWARE_WRAP_MODE_V_colorTexture -1
#endif
constant int2 _3469=int2(SC_SOFTWARE_WRAP_MODE_U_colorTexture,SC_SOFTWARE_WRAP_MODE_V_colorTexture);
#ifndef SC_USE_UV_MIN_MAX_colorTexture
#define SC_USE_UV_MIN_MAX_colorTexture 0
#elif SC_USE_UV_MIN_MAX_colorTexture==1
#undef SC_USE_UV_MIN_MAX_colorTexture
#define SC_USE_UV_MIN_MAX_colorTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_colorTexture
#define SC_USE_CLAMP_TO_BORDER_colorTexture 0
#elif SC_USE_CLAMP_TO_BORDER_colorTexture==1
#undef SC_USE_CLAMP_TO_BORDER_colorTexture
#define SC_USE_CLAMP_TO_BORDER_colorTexture 1
#endif
constant int2 _3519=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3573=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
#ifndef mainTextureUV
#define mainTextureUV 0
#endif
#ifndef colorTextureUV
#define colorTextureUV 0
#endif
#ifndef mainFillTextureUV
#define mainFillTextureUV 0
#endif
#ifndef shadowFillTextureUV
#define shadowFillTextureUV 0
#endif
#ifndef outlineFillTextureUV
#define outlineFillTextureUV 0
#endif
#ifndef backgroundFillTextureUV
#define backgroundFillTextureUV 0
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float4 varPackedTex [[user(locn6)]];
float varPassIdentifier [[user(locn10)]];
float varSdfOffset [[user(locn11)]];
};

bool isPass(thread const float& pass,thread const float& identifier)
{
float _2236=identifier;
float _2237=pass;
bool _2240=_2236>(_2237-0.05);
bool _2247;
if (_2240)
{
_2247=identifier<(pass+0.05);
}
else
{
_2247=_2240;
}
if (_2247)
{
return true;
}
return false;
}

float2 mainFillTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.mainFillTextureDims.xy;
}

int mainFillTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (mainFillTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 shadowFillTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.shadowFillTextureDims.xy;
}

int shadowFillTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (shadowFillTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 outlineFillTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.outlineFillTextureDims.xy;
}

int outlineFillTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (outlineFillTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float getCornerFade(thread const float2& corner,constant UserUniforms& userUniformsObj,thread float4& varPackedTex)
{
if (length(abs(corner-varPackedTex.xy))>userUniformsObj.backgroundCornerRadius)
{
return 1.0;
}
float2 squareCorner=abs(float2(corner.x-userUniformsObj.backgroundCornerRadius,corner.y-userUniformsObj.backgroundCornerRadius));
float radiusPercentage=length(abs(squareCorner-varPackedTex.xy))/userUniformsObj.backgroundCornerRadius;
if (radiusPercentage<0.98)
{
return 1.0;
}
if (radiusPercentage>1.0)
{
return 0.0;
}
return smoothstep(1.0,0.98,radiusPercentage);
}

float2 backgroundFillTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.backgroundFillTextureDims.xy;
}

int backgroundFillTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (backgroundFillTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 colorTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.colorTextureDims.xy;
}

int colorTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (colorTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 mainTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.mainTextureDims.xy;
}

int mainTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (mainTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float calculateSdfOpacity(thread const float& _distance,thread const float& sdfEdge)
{
float w=fwidth(_distance);
return smoothstep(sdfEdge-w,sdfEdge+w,_distance);
}

float calculateSdfOpacityMultisampled(thread const float& dist,thread const float& sdfEdge,thread const float& multisampleBlend,thread int& varStereoViewID,constant UserUniforms& userUniformsObj,thread texture2d<float> mainTexture,thread sampler mainTextureSmpSC,thread float4& varPackedTex)
{
float param=dist;
float param_1=sdfEdge;
float opacity=calculateSdfOpacity(param,param_1);
if (multisampleBlend>0.0)
{
float dscale=0.353553;
float2 duv=(dfdx(varPackedTex.xy)+dfdy(varPackedTex.xy))*dscale;
float4 box=float4(varPackedTex.xy-duv,varPackedTex.xy+duv);
float multisampleOpacity=opacity;
float singleSampleOpacity=opacity;
float2 param_2=mainTextureGetDims2D(userUniformsObj);
int param_3=mainTextureLayout;
int param_4=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_5=box.xw;
bool param_6=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_7=userUniformsObj.mainTextureTransform;
int2 param_8=_2954;
bool param_9=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_10=userUniformsObj.mainTextureUvMinMax;
bool param_11=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_12=userUniformsObj.mainTextureBorderColor;
float param_13=0.0;
float4 _2980=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11,param_12,param_13);
float4 _2948=_2980;
float4 mainTextureSample=_2980;
float param_14=mainTextureSample.x;
float param_15=sdfEdge;
multisampleOpacity+=calculateSdfOpacity(param_14,param_15);
float2 param_16=mainTextureGetDims2D(userUniformsObj);
int param_17=mainTextureLayout;
int param_18=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_19=box.xy;
bool param_20=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_21=userUniformsObj.mainTextureTransform;
int2 param_22=_2993;
bool param_23=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_24=userUniformsObj.mainTextureUvMinMax;
bool param_25=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_26=userUniformsObj.mainTextureBorderColor;
float param_27=0.0;
float4 _3014=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23,param_24,param_25,param_26,param_27);
float4 _2990=_3014;
float4 mainTextureSample_1=_3014;
float param_28=mainTextureSample_1.x;
float param_29=sdfEdge;
multisampleOpacity+=calculateSdfOpacity(param_28,param_29);
float2 param_30=mainTextureGetDims2D(userUniformsObj);
int param_31=mainTextureLayout;
int param_32=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_33=box.zy;
bool param_34=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_35=userUniformsObj.mainTextureTransform;
int2 param_36=_3027;
bool param_37=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_38=userUniformsObj.mainTextureUvMinMax;
bool param_39=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_40=userUniformsObj.mainTextureBorderColor;
float param_41=0.0;
float4 _3048=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_30,param_31,param_32,param_33,param_34,param_35,param_36,param_37,param_38,param_39,param_40,param_41);
float4 _3024=_3048;
float4 mainTextureSample_2=_3048;
float param_42=mainTextureSample_2.x;
float param_43=sdfEdge;
multisampleOpacity+=calculateSdfOpacity(param_42,param_43);
float2 param_44=mainTextureGetDims2D(userUniformsObj);
int param_45=mainTextureLayout;
int param_46=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_47=box.zw;
bool param_48=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_49=userUniformsObj.mainTextureTransform;
int2 param_50=_3061;
bool param_51=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_52=userUniformsObj.mainTextureUvMinMax;
bool param_53=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_54=userUniformsObj.mainTextureBorderColor;
float param_55=0.0;
float4 _3082=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_44,param_45,param_46,param_47,param_48,param_49,param_50,param_51,param_52,param_53,param_54,param_55);
float4 _3058=_3082;
float4 mainTextureSample_3=_3082;
float param_56=mainTextureSample_3.x;
float param_57=sdfEdge;
multisampleOpacity+=calculateSdfOpacity(param_56,param_57);
multisampleOpacity*=0.2;
opacity=mix(singleSampleOpacity,multisampleOpacity,multisampleBlend);
}
return opacity;
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj,texture2d<float> mainFillTexture,texture2d<float> colorTexture,texture2d<float> outlineFillTexture,texture2d<float> mainTexture,texture2d<float> backgroundFillTexture,texture2d<float> shadowFillTexture,sampler colorTextureSmpSC,sampler shadowFillTextureSmpSC,sampler mainTextureSmpSC,sampler backgroundFillTextureSmpSC,sampler outlineFillTextureSmpSC,sampler mainFillTextureSmpSC,float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float4 fillColor=float4(1.0);
float2 fillUv=in.varPackedTex.zw;
fillUv.x=fract(fillUv.x);
fillUv.y=fract(fillUv.y);
float sdfEdge=0.5;
float param=0.0;
float param_1=in.varPassIdentifier;
bool _3170=isPass(param,param_1);
bool _3179;
if (!_3170)
{
float param_2=0.1;
float param_3=in.varPassIdentifier;
_3179=isPass(param_2,param_3);
}
else
{
_3179=_3170;
}
if (_3179)
{
#if (MAIN_FILL_COLOR)
{
fillColor=userUniformsObj.mainColor;
}
#else
{
#if (MAIN_FILL_TEXTURE)
{
float2 param_4=mainFillTextureGetDims2D(userUniformsObj);
int param_5=mainFillTextureLayout;
int param_6=mainFillTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_7=fillUv;
bool param_8=(int(SC_USE_UV_TRANSFORM_mainFillTexture)!=0);
float3x3 param_9=userUniformsObj.mainFillTextureTransform;
int2 param_10=_3200;
bool param_11=(int(SC_USE_UV_MIN_MAX_mainFillTexture)!=0);
float4 param_12=userUniformsObj.mainFillTextureUvMinMax;
bool param_13=(int(SC_USE_CLAMP_TO_BORDER_mainFillTexture)!=0);
float4 param_14=userUniformsObj.mainFillTextureBorderColor;
float param_15=0.0;
float4 _3224=sc_SampleTextureBiasOrLevel(mainFillTexture,mainFillTextureSmpSC,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11,param_12,param_13,param_14,param_15);
float4 _3193=_3224;
float4 mainFillTextureSample=_3224;
fillColor=mainFillTextureSample;
}
#endif
}
#endif
}
else
{
bool _3234;
#if (ENABLE_SHADOW)
{
float param_16=0.2;
float param_17=in.varPassIdentifier;
_3234=isPass(param_16,param_17);
}
#else
{
_3234=(int(ENABLE_SHADOW)!=0);
}
#endif
if (_3234)
{
#if (SHADOW_FILL_COLOR)
{
fillColor=userUniformsObj.shadowColor;
}
#else
{
#if (SHADOW_FILL_TEXTURE)
{
float2 param_18=shadowFillTextureGetDims2D(userUniformsObj);
int param_19=shadowFillTextureLayout;
int param_20=shadowFillTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_21=fillUv;
bool param_22=(int(SC_USE_UV_TRANSFORM_shadowFillTexture)!=0);
float3x3 param_23=userUniformsObj.shadowFillTextureTransform;
int2 param_24=_3254;
bool param_25=(int(SC_USE_UV_MIN_MAX_shadowFillTexture)!=0);
float4 param_26=userUniformsObj.shadowFillTextureUvMinMax;
bool param_27=(int(SC_USE_CLAMP_TO_BORDER_shadowFillTexture)!=0);
float4 param_28=userUniformsObj.shadowFillTextureBorderColor;
float param_29=0.0;
float4 _3278=sc_SampleTextureBiasOrLevel(shadowFillTexture,shadowFillTextureSmpSC,param_18,param_19,param_20,param_21,param_22,param_23,param_24,param_25,param_26,param_27,param_28,param_29);
float4 _3247=_3278;
float4 shadowFillTextureSample=_3278;
fillColor=shadowFillTextureSample;
}
#endif
}
#endif
}
else
{
bool _3289;
#if (ENABLE_OUTLINE)
{
float param_30=0.3;
float param_31=in.varPassIdentifier;
_3289=isPass(param_30,param_31);
}
#else
{
_3289=(int(ENABLE_OUTLINE)!=0);
}
#endif
if (_3289)
{
#if (ENABLE_SDF)
{
sdfEdge-=in.varSdfOffset;
}
#endif
#if (OUTLINE_FILL_COLOR)
{
fillColor=userUniformsObj.outlineColor;
}
#else
{
#if (OUTLINE_FILL_TEXTURE)
{
float2 param_32=outlineFillTextureGetDims2D(userUniformsObj);
int param_33=outlineFillTextureLayout;
int param_34=outlineFillTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_35=fillUv;
bool param_36=(int(SC_USE_UV_TRANSFORM_outlineFillTexture)!=0);
float3x3 param_37=userUniformsObj.outlineFillTextureTransform;
int2 param_38=_3316;
bool param_39=(int(SC_USE_UV_MIN_MAX_outlineFillTexture)!=0);
float4 param_40=userUniformsObj.outlineFillTextureUvMinMax;
bool param_41=(int(SC_USE_CLAMP_TO_BORDER_outlineFillTexture)!=0);
float4 param_42=userUniformsObj.outlineFillTextureBorderColor;
float param_43=0.0;
float4 _3340=sc_SampleTextureBiasOrLevel(outlineFillTexture,outlineFillTextureSmpSC,param_32,param_33,param_34,param_35,param_36,param_37,param_38,param_39,param_40,param_41,param_42,param_43);
float4 _3309=_3340;
float4 outlineFillTextureSample=_3340;
fillColor=outlineFillTextureSample;
}
#endif
}
#endif
}
else
{
bool _3351;
#if (ENABLE_BACKGROUND)
{
float param_44=0.4;
float param_45=in.varPassIdentifier;
_3351=isPass(param_44,param_45);
}
#else
{
_3351=(int(ENABLE_BACKGROUND)!=0);
}
#endif
if (_3351)
{
float cornerFade=1.0;
float2 param_46=float2(0.0);
cornerFade*=getCornerFade(param_46,userUniformsObj,in.varPackedTex);
float2 param_47=float2(userUniformsObj.backgroundSize.x,0.0);
cornerFade*=getCornerFade(param_47,userUniformsObj,in.varPackedTex);
float2 param_48=float2(userUniformsObj.backgroundSize.x,userUniformsObj.backgroundSize.y);
cornerFade*=getCornerFade(param_48,userUniformsObj,in.varPackedTex);
float2 param_49=float2(0.0,userUniformsObj.backgroundSize.y);
cornerFade*=getCornerFade(param_49,userUniformsObj,in.varPackedTex);
if (cornerFade<0.005)
{
discard_fragment();
}
#if (BACKGROUND_FILL_COLOR)
{
float4 param_50=float4(userUniformsObj.backgroundColor.xyz,userUniformsObj.backgroundColor.w*cornerFade);
sc_writeFragData0(param_50,FragColor);
}
#else
{
#if (BACKGROUND_FILL_TEXTURE)
{
float2 param_51=backgroundFillTextureGetDims2D(userUniformsObj);
int param_52=backgroundFillTextureLayout;
int param_53=backgroundFillTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_54=fillUv;
bool param_55=(int(SC_USE_UV_TRANSFORM_backgroundFillTexture)!=0);
float3x3 param_56=userUniformsObj.backgroundFillTextureTransform;
int2 param_57=_3419;
bool param_58=(int(SC_USE_UV_MIN_MAX_backgroundFillTexture)!=0);
float4 param_59=userUniformsObj.backgroundFillTextureUvMinMax;
bool param_60=(int(SC_USE_CLAMP_TO_BORDER_backgroundFillTexture)!=0);
float4 param_61=userUniformsObj.backgroundFillTextureBorderColor;
float param_62=0.0;
float4 _3441=sc_SampleTextureBiasOrLevel(backgroundFillTexture,backgroundFillTextureSmpSC,param_51,param_52,param_53,param_54,param_55,param_56,param_57,param_58,param_59,param_60,param_61,param_62);
float4 _3412=_3441;
float4 backgroundFillTextureSample=_3441;
float4 param_63=float4(backgroundFillTextureSample.xyz,backgroundFillTextureSample.w*cornerFade);
sc_writeFragData0(param_63,FragColor);
}
#endif
}
#endif
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}
}
}
}
float param_64=0.1;
float param_65=in.varPassIdentifier;
if (isPass(param_64,param_65))
{
float2 param_66=colorTextureGetDims2D(userUniformsObj);
int param_67=colorTextureLayout;
int param_68=colorTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_69=in.varPackedTex.xy;
bool param_70=(int(SC_USE_UV_TRANSFORM_colorTexture)!=0);
float3x3 param_71=userUniformsObj.colorTextureTransform;
int2 param_72=_3469;
bool param_73=(int(SC_USE_UV_MIN_MAX_colorTexture)!=0);
float4 param_74=userUniformsObj.colorTextureUvMinMax;
bool param_75=(int(SC_USE_CLAMP_TO_BORDER_colorTexture)!=0);
float4 param_76=userUniformsObj.colorTextureBorderColor;
float param_77=0.0;
float4 _3494=sc_SampleTextureBiasOrLevel(colorTexture,colorTextureSmpSC,param_66,param_67,param_68,param_69,param_70,param_71,param_72,param_73,param_74,param_75,param_76,param_77);
float4 _3462=_3494;
float4 colorTextureSample=_3494;
float preMultipliedAlpha=colorTextureSample.w*fillColor.w;
float4 param_78=float4(colorTextureSample.xyz*preMultipliedAlpha,preMultipliedAlpha);
sc_writeFragData0(param_78,FragColor);
}
else
{
#if (ENABLE_SDF)
{
float2 param_79=mainTextureGetDims2D(userUniformsObj);
int param_80=mainTextureLayout;
int param_81=mainTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_82=in.varPackedTex.xy;
bool param_83=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_84=userUniformsObj.mainTextureTransform;
int2 param_85=_3519;
bool param_86=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_87=userUniformsObj.mainTextureUvMinMax;
bool param_88=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_89=userUniformsObj.mainTextureBorderColor;
float param_90=0.0;
float4 _3540=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_79,param_80,param_81,param_82,param_83,param_84,param_85,param_86,param_87,param_88,param_89,param_90);
float4 _3516=_3540;
float4 mainTextureSample=_3540;
float param_91=mainTextureSample.x;
float param_92=sdfEdge;
float param_93=userUniformsObj.multisampleBlend;
float sdfOpacity=calculateSdfOpacityMultisampled(param_91,param_92,param_93,in.varStereoViewID,userUniformsObj,mainTexture,mainTextureSmpSC,in.varPackedTex);
float preMultipliedAlpha_1=fillColor.w*sdfOpacity;
float4 param_94=float4(fillColor.xyz*preMultipliedAlpha_1,preMultipliedAlpha_1);
sc_writeFragData0(param_94,FragColor);
}
#else
{
float2 param_95=mainTextureGetDims2D(userUniformsObj);
int param_96=mainTextureLayout;
int param_97=mainTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_98=in.varPackedTex.xy;
bool param_99=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_100=userUniformsObj.mainTextureTransform;
int2 param_101=_3573;
bool param_102=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_103=userUniformsObj.mainTextureUvMinMax;
bool param_104=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_105=userUniformsObj.mainTextureBorderColor;
float param_106=0.0;
float4 _3594=sc_SampleTextureBiasOrLevel(mainTexture,mainTextureSmpSC,param_95,param_96,param_97,param_98,param_99,param_100,param_101,param_102,param_103,param_104,param_105,param_106);
float4 _3570=_3594;
float4 mainTextureSample_1=_3594;
float preMultipliedAlpha_2=mainTextureSample_1.x*fillColor.w;
float4 param_107=float4(fillColor.xyz*preMultipliedAlpha_2,preMultipliedAlpha_2);
sc_writeFragData0(param_107,FragColor);
}
#endif
}
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
